c-- sir code for data command                            Release 97.01
      subroutine datasir(ier)
c--
c          struttura del buffer vet/ivet
c
c     h   k   l   fo sigma  fasi
c     1   2   3   4    5     6
c----------------------------------------------------------------------
c   lista 7
c     h+k+l    e       fo   e'+e'p    phi'+phi+code  sigma
c       1      2       3       4            5          6
c   scompattati in
c     h   k   l   e   fo    e'   e'p  fasi  sigma
c     1   2   3   4    5     6    7     8     9
c----------------------------------------------------------------------
c
      character*80 fileh,name
      character*80 formt
      character cff
c   implementation  common
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
c  partial structure procedure common
      common /frgmt/ mmold,mzold,ihmax(3),knowo,sumn,sumd,ntype(80)
c     erlangen
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
c     sapi
      common/rsc/ibgr,mg,mig(8),scl,bts(9),scsa(9),ip(8,3,5)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common / ureq1/ jpatt,jpunt(1501),ksacc,jseteq,jumpp,jmpsie,nsec
c     symmetry
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
c     scratch file reflexion arrays
      common /buffer/ vet(6,85) ,nrpb,idumb(4)
c     atomic scattering factors
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
c     known molecular (group) information
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
c     spherical scattering factors
      common/at/gis(270),giw(270),list
c     miscellaneous
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
c     wilson plot parameters
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
c     work area common       (500000 integer words)
      common/ylimi/nfl,lfl,dummy(5)
      common/xdata/ dumx(500000)
c     sin/cos table & trigonometric constants
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/bigcom/ maxstr,maxpsi
cel   gestione degli elettroni
      common /neutro/ neutro,neuwei,vetint(500),nsyn
      dimension MatOr(3,3)
c-----------------
      nfl=1
      lfl=500000
c-----------------
      write(cff,'(i1)') kff
      write(lo,10) cff,itle
   10 format(///,a1,78('+'),//,
     1 39h SIR97 : Data routine                  ,26x,14hRelease  97.01
     2 ,//,1h ,20a4,/,1h ,78('+'),//)
c     set up initial values
      nsym=0
      nref=0
      rhomax=0.0
      itype=1
      iform=2
c
      call scrper(' Reading data ',0,-1)
c
      kop=kopen(iscra,name,nlen,itype,ierr)
      call dirdat(fileh,formt,npc,ier,iy,ifMatOr,MatOr)
      if (ier.lt.0) go to 900
      anat=float(nat)/(pts*float((icent+1)*nsym))
      aa=s3s2*s3s2*pts
c  s3s2p is related to the number of atoms in the primitive cell
      s3s2p=aa*sqrt(1.0/aa)
      s3s2=s3s2p
      is3s2=1./(s3s2p*s3s2p)+0.5
c
      a1=cos(cx(4)*pi/180.0)
      a2=cos(cx(5)*pi/180.0)
      a3=cos(cx(6)*pi/180.0)
      arg=1.0-a1*a1
     1       -a2*a2
     2       -a3*a3
     3       +a1*a2*a3*2.0
      v=cx(1)*cx(2)*cx(3)*sqrt(arg)
      atvol = v / float(nat)
c
      write(lo,370) anat,is3s2,v,atvol
  370 format(/,19x,'Number of atoms in asymmetric unit = ',f8.2,/,
     1 11x,'Equivalent number of equal atoms in primitive cell =',i6,/,
     2 30x,'Cell volume =',f8.2,/,
     2 26x,'Volume per atom =',f8.2,/)
      nasu=int(anat+0.5)
c
c-- if reflections aren't supplied finish
c
      if (jfile.eq.ln) go to 900
c
c     calculate number of reflexions for (sem)invariant searching
cnuovo
*     mn = nint( 4.0 * anat + 130 )
*     if (lsys.le.2) mn = mn + 100
*     mm = min0(mn,maxstr)
cvecchio
      mn = int(4.5*anat+100.5)
c     if (icent.eq.1) mn = mn + 50
      if (nsym.eq.1) mn = mn + 50
      mn = min0(mn,maxstr)
      mm=mn+min0(maxstr-mn,100)/2
      if (neutro.ne.2) then
c-- read reflexion data from cards
          call datain(fileh,formt,nrefp,npc,ier,ifMatOr,MatOr)
          if (ier.lt.0) go to 900
      endif
c ----
c ---- create list 7 ( e's )
c ----
      npseud=0
      call prepl7(npseud,iy)
c ----
c ---- create list 25 ( atomic groups )
c ----
c     if (ngp.gt.0) call frm25
c ----
      call crea6
      if (ier.lt.0) return
      call xdump
  900 close(iscra)
c
c     call prova6(ier)
c
      return
      end
c------------------------------------------------------------
c     read reflexions
c
      subroutine datain(fileh,formt,nrefp,npc,ier,ifMatOr,MatOr)
      character*80 fileh
      character*80 formt
      character*120 line,buff
      character*200 Msg
      common /msgerr/ Msg
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
cel-
      common /elettroni/ lproj, zeff(8), rminimo, kminimo, kaminimo
cel-
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /uno/ mxbg,indmb
      common /buffer/ vet(6,85) ,nrpb,idumb(4)
      common/xdata/ibig(500000)
      common /gian/ indbig(112500)
      common/screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
c  if ibig dimension has to be changed, alter mxbg accordingly
      dimension kh(12),kk(12),kl(12),f(12),phyr(12),sigma(12)
      integer phy(12),vsym(24),ib(3),ibrav(6,13),jnbl(128),knbl(128)
      dimension ivet(6,85) ,kv(3)
      dimension MatOr(3,3)
      dimension sigv(10,4),isigv(10,2),isigp(10,2)
      equivalence (vet(1,1),ivet(1,1))
      data phyr/12*0.0/
      data ibrav/4*1,3,1,0,3*1,0,-1,1,0,6*1,0,3*1,5*2,3,4*0,1,11*0,1,
     ,5*0,2,5*0,1,5*0,1,11*0,2,0/
c
      value=0.0
      do 1 i=1,10
      value=value+0.5
      sigv(i,1)=value
      sigv(i,2)=0.0
    1 continue
c
      ngt63=0
      mxbg=500000
      nex=0
      npq=0
      neq=0
c  ksym=number of translational matrices different from ( 0.0 0.0 0.0 )
      ksym=0
      do 20 i=2,nsym
      ifl=0
      do 10 j=1,3
      if (abs(ts(j,i)).gt.0.00001) ifl=1
   10 continue
      if (ifl.eq.0) go to 20
      ksym=ksym+1
      vsym(ksym)=i
   20 continue
      klatt=latt-1
      if (jfile.ge.0) then
          if (jfile.ne.ln) then
              itype=2
              iform=1
              if (jopen(jfile,fileh,nlen,itype,iform,ios)
     *                                  .lt.0) go to 9000
          endif
      endif
      if (jfile.eq.ln) go to 5900
      jfile=iabs(jfile)
      nref=0
      nrefp=0
      do 7035 i=1,3
 7035 ihx(i)=-100
      if (npc.gt.0) then
          iffsq=1
          nn=npc
      else
          iffsq=-1
          nn=-npc
      endif
c
      call scrper(' Reading reflexions ',0,-1)
c
      nneg=0
      nrec=0
      nnn=0
cel---------------------------------------------------
cel  this is the default value of lproj
      lproj=0
      lproh=0
      lprok=0
      lprol=0
cel---------------------------------------------------
      nuobs=0
      nrmax=0
      rhm=-99.9
      nline=1
      read(jfile,'(a80)',end=7000) line
      buff=line
      call shift(buff,nchar)
      if (buff(1:1).eq.'>') go to 30
      if (knw.eq.0) read(line,formt,end=60,err=8000,iostat=ios)
     *                  (kh(i),kk(i),kl(i),f(i),sigma(i),
     *                   i=1,nn)
      if (knw.eq.1) read(line,formt,end=60,err=8000,iostat=ios)
     *                  (kh(i),kk(i),kl(i),f(i),sigma(i),phyr(i),
     *                   i=1,nn)
      go to 32
   30 nline=nline+1
      if (knw.eq.0) read(jfile,formt,end=60,err=8000,iostat=ios)
     *                  (kh(i),kk(i),kl(i),f(i),sigma(i),
     *                   i=1,nn)
      if (knw.eq.1) read(jfile,formt,end=60,err=8000,iostat=ios)
     *                  (kh(i),kk(i),kl(i),f(i),sigma(i),phyr(i),
     *                   i=1,nn)
   32 do 50 i=1,nn
cel--------------------------------------------------------------
         if (kh(i).ne.0) lproh = 1
         if (kk(i).ne.0) lprok = 1
         if (kl(i).ne.0) lprol = 1
cel--------------------------------------------------------------
         if (ifMatOr.eq.1) then
            iih = MatOr(1,1)*kh(i) + MatOr(1,2)*kk(i) + MatOr(1,3)*kl(i)
            iik = MatOr(2,1)*kh(i) + MatOr(2,2)*kk(i) + MatOr(2,3)*kl(i)
            iil = MatOr(3,1)*kh(i) + MatOr(3,2)*kk(i) + MatOr(3,3)*kl(i)
            kh(i) = iih
            kk(i) = iik
            kl(i) = iil
         endif
         if (ksigma.eq.0) sigma(i) = 0.0
         if (sigma(i).lt.0.0) go to 6000
c - del herald  28/01/1998
         if (sigma(i).lt.0.001) sigma(i)=1.0
c
         if (icent.eq.1.and.knw.eq.1) then
             aaaa=phyr(i)
             phyr(i)=dtor*phyr(i)
             phyr(i)=cos(phyr(i))
             if (phyr(i).gt.0) then
                 phyr(i)=0.0
             else
                 phyr(i)=180.0
             endif
         endif
         phy(i)=phyr(i)
         if (f(i).lt.0.0) then
             nneg=nneg+1
             f(i)=0.0
             if (sigma(i).lt.0.1) sigma(i)=0.1
         endif
         if (kh(i).eq.0.and.kk(i).eq.0.and.kl(i).eq.0) go to 60
         nref=nref+1
         if (iabs(kh(i)).gt.63.or.
     *       iabs(kk(i)).gt.63.or.
     *       iabs(kl(i)).gt.63) then
             ngt63=ngt63+1
            go to 50
         endif
         call extin(jex,kh(i),kk(i),kl(i),ibrav,klatt,ksym,vsym)
         if (jex.eq.1) then
             nex=nex+1
             if (nex.le.10) write(lo,35) kh(i),kk(i),kl(i),f(i),sigma(i)
             if(nex.eq.11) write(lo,36)
   35     format(' Syst. absent :',3i4,'   Fobs =',f10.3,
     *           '   Sigma(Fobs) =',f10.3)
   36     format(/,' .... and so on ')
          if (ksigma.gt.0.and.sigma(i).gt.0.0) then
              do 88 jsig=1,10
                 asig=sigv(jsig,1)
                 asigm=asig*sigma(i)
                 if (f(i).gt.asigm) sigv(jsig,2)=sigv(jsig,2)+1
   88         continue
          endif
         else
             call geneq(1,kh(i),kk(i),kl(i),idelt,jcode,isgnn,id1,rho)
             ireje=0
             if (rho.gt.th) then
                 ireje=1
                 nrmax=nrmax+1
             endif
             if (ireje.eq.0) then
                 if (rho.gt.rhm) rhm=rho
                 nrefp=nrefp+1
                 nnn=nnn+1
                 if (knw.ne.0) then
                     phy(i)=phy(i)+idelt
                     phy(i)=phy(i)*isgnn
                     phy(i)=mod(phy(i),360)
                     if (phy(i).le.0) phy(i)=phy(i)+360
                 endif
                 if (iffsq.eq.-1) then
                     fdi=sqrt(f(i))
                     sdi=sigma(i)
                     if (f(i).ge.sdi) then
                         if (fdi.gt.0.0) sdi=0.5*sdi/fdi
                     else
                         sdi=0.5*sdi
                     endif
                     f(i)=fdi
                     sigma(i)=sdi
                 endif
                 phy(i)=phy(i)*32+jcode
                 ivet(1,nnn)=kh(i)
                 ivet(2,nnn)=kk(i)
                 ivet(3,nnn)=kl(i)
                 vet(4,nnn)=f(i)
                 vet(5,nnn)=sigma(i)
                 ivet(6,nnn)=phy(i)
                 if (nnn.eq.nrpb) then
                     nrec=nrec+1
                     write(iscra,rec=nrec)
     *                    ((vet(j1,j2),j1=1,6),j2=1,nrpb)
                     nnn=0
                 endif
         endif
      endif
   50 continue
      go to 30
   60 nrec=nrec+1
      write(iscra,rec=nrec) ((vet(j1,j2),j1=1,6),j2=1,nrpb)
c
      if (ksigma.gt.0.and.nex.gt.0) then
          aref = nex 
          do 66 i=1,10
             isigv(i,1)=nint(sigv(i,2))
             isigp(i,1)=nint(100.0*sigv(i,2)/aref)
   66     continue
          write(lo,67) (isigv(i,1),isigp(i,1),sigv(i,1),i=1,10)
      endif
   67 format(//,10x,'Systematically absent reflections analisys',/,
     *          20x,'Number and percentage',
     1        /,17x,26hof  F's > param * sigma(F),
     2        //,17x,'number    percentage  param',/,
     4        10(10x,i13,i11,1h%,f9.2,3x,/ )   )
c
      call scrper(' Merging reflexions ',0,0)
c
c
c-- at this point the allowed reflections are on the scratch file(iscra)
c-- it is possible to eliminate symmetry equivalents and add (optionally
c-- unobserved reflections
c
c        set values for some constants
c
      nob=0
      nobi=0
      nnob=0
      lag=0
      ib(1)=1
      ib(2)=2**2
      ib(3)=2**12
      do 65 i=1,128
      knbl(i)=-1
   65 jnbl(i)=-1
c
      if (nrefp.gt.112500) then
          write(Msg,68) nrefp,rhomax
          call screrr(ier,Msg,1)
          go to 9040
      endif
   68 format('Maximum number of reflections too large.'
     *      ,' Actual value = ',i7,' max value = 125000.'
     *      ,' Try using  RHOMAX xx  '
     *      ,' where xx must be less than ',f7.4)
      kv(1)=(2*ihx(3)+1)*(2*ihx(2)+1)
      kv(2)=(2*ihx(3)+1)
      indmb=ihx(1)*kv(1)+ihx(2)*kv(2)+ihx(3)
      if(indmb.gt.mxbg) then
           write(lo,70) jrel,indmb,mxbg
   70      format(' available memory too small, a scratch file',/,
     *            ' on channel ',i3,' will be used temporarely.',/,
     *            ' required =',i5,'  available =',i5)
           itype=1
           iform=2
           jop=jopen(jrel,fileh,nlen,itype,iform,ier)
         endif
      do 80 i=1,mxbg
   80 ibig(i)=0
      nperc=10
      iperc0=nrefp/nperc
      iperc=iperc0
      jperc=0
      n01=0
      sig01=0.0
      sumsig=0.0
      nr=0
      do 232 nnn=1,nrec
      read(iscra,rec=nnn) ((vet(j1,j2),j1=1,6),j2=1,nrpb)
      do 230 i=1,nrpb
      nr=nr+1
      if (nr.gt.nrefp) go to 230
      if (nr.eq.iperc) then
          jperc=jperc+1
          iperc=iperc+iperc0
          call scrper(' ',jperc,nperc)
      endif
      lh=ivet(1,i)
      lk=ivet(2,i)
      ll=ivet(3,i)
      fo=vet(4,i)
c---prima modifica per controllare il valore di sigma
crocco
       sigmaroc=vet(5,i)
      if (sigmaroc.gt.0.0) then
                          sig01=sig01+sigmaroc
                          n01=n01+1
                        endif
      sumsig=sumsig+sigmaroc
      if (abs(sigmaroc).lt.0.001) sigmaroc=0.1
crocco
c        index of reflection in the big list
      inbl=lh*kv(1) + lk*kv(2) + ll
      if(inbl.le.mxbg) go to 170
      if (nob.eq.0) go to 160
      do 120 j=1,nobi
      if (inbl.eq.jnbl(j)) go to 210
120   continue
      if (nnob.eq.0) go to 160
      rewind jrel
      do 140 k=1,nnob
      read(jrel) knbl
      do 140 j=1,128
      if (inbl.eq.knbl(j)) go to 210
140   continue
160   continue
      jbig = 1
      if (nobi.lt.128) go to 166
      write(jrel) jnbl
      nobi=0
      nnob=nnob+1
      do 165 j=1,128
165   jnbl(j)=-1
166   nob=nob+1
      nobi=nobi+1
      jnbl(nobi)=inbl
      go to 220
170   lag=ibig(inbl)
c
c        lag=0    if ibig(inbl) is empty,
c        lag=code if ibig(inbl) was filled up
c
      indbig(nr)=0
      if (lag.ne.0) go to 210
      ibig(inbl)=nr
      go to 220
  210 continue
      neq=neq+1
      absv4=abs(vet(4,i))
      indbig(nr)=lag
      if (absv4.gt.0.00001) then
                              vet(4,i)=-absv4
                            else
                              vet(4,i)=-0.0001
                            endif
      go to 230
  220 continue
c-- npq contains the number of observed
c-- independent reflections
      npq=npq+1
  230 continue
      write(iscra,rec=nnn) ((vet(j1,j2),j1=1,6),j2=1,nrpb)
  232 continue
c---secondo controllo sui valori di sigma
crocco
      aref=float(nref)
      sumsig=sumsig/aref
      sumdsig=0.0
      do 793 nnn=1,nrec
      read(iscra,rec=nnn) ((vet(j1,j2),j1=1,6),j2=1,nrpb)
      do 794 i=1,nrpb
      sigma1=vet(5,i)
      if (ksigma.gt.0) then
                         dsig=abs(sumsig-sigma1)
                         sumdsig=sumdsig+dsig
                       endif
794   continue
793   continue
      sumdsig=sumdsig/aref
      if (sumdsig.lt.0.01) ksigma=0
      if (nint(sig01).eq.n01) ksigma=0
c
crocco
c
cel--------------------------------------------------------
      if(lproh.eq.0) then
          lproj=1
          write(lo,*) ' '
          write(lo,*) '                  X  Projection'
      endif
      if(lprok.eq.0) then
          lproj=2
          write(lo,*) ' '
          write(lo,*) '                  Y  Projection'
      endif
      if(lprol.eq.0) then
          lproj=3
          write(lo,*) ' '
          write(lo,*) '                  Z  Projection'
      endif
      if (lproj.ne.0) then
          if (lsys.eq.4) then            ! tetragonal
              if (lproj.ne.3) lproj = 0
          else if (lsys.eq.5) then       ! trigonal or exagonal
              if (lproj.ne.3) lproj = 0
          else if (lsys.eq.6) then       ! cubic
              lproj=0
          endif
      endif
cel---------------------------------------------------------
      ifat1=(2*ihx(3)+1)*(2*ihx(2)+1)
      ifat2=(2*ihx(3)+1)
      ifatx=ihx(1)*ifat1+ihx(2)*ifat2+ihx(3)
      if (ifMatOr.eq.1) then
          write(lo,290) ((MatOr(i,j),j=1,3),i=1,3)
      endif
      write(lo,300) nref
      if (nrmax.gt.0) write(lo,311) nrmax,th
      if (ngt63.gt.0) write(lo,312) ngt63
      if (nneg.gt.0) write(lo,313) nneg
      write(lo,320) npq
      if (nex.gt.0) write(lo,322) nex
      resol = 0.5 / sqrt(rhm)
      write(lo,330) ihx,rhm,resol,ifatx
  290 format(/,3x,23h                h'     ,3i4,'       h',/,
     *         3x,23hNew indices     k'   = ,3i4,'   *   k',/,
     *         3x,23h                l'     ,3i4,'       l')
  300 format(/,9x,i6,'  input reflections')
  311 format( 9x,i6,'  rejected reflections with s**2 .gt. ',f6.3)
  312 format( 9x,i6,'  rejected reflections with indices .gt. 63')
  313 format( 9x,i6,'  Fo(s) negative set to 0.0                ')
  320 format(   9x,i6, '  independent input reflections')
  322 format(   9x,i6, '  systematically absent reflections rejected')
  327 format(   9x,6x, '  Symmetry equivalent reflections merged:',
     *                 '  Rsym(F) =',f7.2,'%')
  330 format(   3x,3i4,'  maximum  h,k,l  values',
     *       /,8x,f7.4,'  maximum s**2 = (sin(theta)/lambda)**2',
     *       /,8x,f7.4,'  Angstrom resolution                  ',
     *       /,5x,i10, '  maximum super-index ( must be less'   ,
     *                   ' then 350000 )')
      nref=nrefp
      rhomax=rhm
      if (ifatx.gt.350000) go to 8020
c
c-- check for unobserved reflections
c
      call unobs(kv,ibrav,klatt,ksym,vsym)
c
c-- merge equivalent reflections    
c
      if (neq.gt.0) then
          call fomergenew(rfac1)
          write(lo,327) rfac1
      endif
      if (jfile.ne.ln) close(jfile)
 5900 continue

      knw = 0

      return
 6000 continue
c     write(lo,6100) kh(i),kk(i),kl(i),f(i),sigma(i)
      write(Msg,6100) kh(i),kk(i),kl(i),f(i),sigma(i)
      call screrr(ier,Msg,1)
 6100 format('Negative value of sigma(F) in input on line ',i5,':',
     *3i4,2f10.3)
      go to 9040
 7000 continue
c     write(lo,7010) jfile
      write(Msg,7015) jfile
      call screrr(ier,Msg,1)
 7010 format(' *** error ***    eof on channel ',i2)
 7015 format(' EOF on channel #',i2,'. Reflections expected')
      go to 9020
c
c se dos ed errore allora continua
c
 8000 if (kprog.lt.10 .and. ios.eq.6101) goto 60
c     write(lo,8010) jfile,ios,nline
      write(Msg,8015) jfile,ios,nline
      call screrr(ier,Msg,1)
 8010 format(' *** error ***   read error on channel ',i2,' code =',i5,/
     *       '                 line number ',i5,/)
 8015 format(' Read error on channel #',i2,' code =',i5,
     *       ' line number ',i5,'. Reflections expected')
      go to 9020
 8020 continue
      write(Msg,8035) rhomax
      call screrr(ier,Msg,1)
 8035 format('Maximum values of h,k,l are too large.'
     *      ,' Restart the program using in %DATA the directive '
     *      ,'   RHOMAX xx  '
     *      ,' where xx must be less than ',f7.4
     *      ,' in order to reduce the maximum values of h,k,l.')
      go to 9040
 9000 continue
      write(Msg,9015) ios,fileh(1:Lung(fileh))
      call screrr(ier,Msg,1)
 9015 format(' Open error, code =',i5,' file is ',a,
     *      '. Reflections expected')
 9020 continue
 9040 ier=-1
      return
      end
c--------------------------------------------------------------
      subroutine fomergenew(rfac)
c
c-- merge equivalent reflections
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /uno/ mxbg,indmb
      common /buffer/ vet(6,85) ,nrpb,idumb(4)
      common/xdata/bigmat(4,125000)
      common /gian/ indbig(112500)
      dimension ivet(6,85)
      equivalence (vet(1,1),ivet(1,1))
c
c-- fill bigmat with reflections
c-- equivalent reflections have the same equ-code ( in vet(2,i) )
c
      nrec=nref/nrpb
      if (mod(nref,nrpb).gt.0) nrec=nrec+1
      nr=0
      do 200 nnn=1,nrec
         read(iscra,rec=nnn) ((vet(j1,j2),j1=1,6),j2=1,nrpb)
         do 100 i=1,nrpb
            nr=nr+1
            if (nr.gt.nref) go to 100
            icode = indbig(nr)
            bigmat(1,nr)=vet(4,i)
            bigmat(2,nr)=vet(5,i)
            bigmat(3,nr)=icode
            bigmat(4,nr)=nr
            if (icode.gt.0) then
                bigmat(3,icode)=icode
                absv4=abs(bigmat(1,icode))
                if (absv4.gt.0.00001) then
                    bigmat(1,icode)=-absv4
                else
                    bigmat(1,icode)=-0.0001
                endif
            endif
  100    continue
  200 continue
      if (ksigma.eq.0) then
          do 250 i=1,nref
             bigmat(2,i)=1.0
  250     continue
      endif
c
c-- sort reflections respect to equ-code
c 
      lind=1
      nr2=nref
      iblk=4
      jump=3
      call sortz(lind,nr2,iblk,jump)
c
c-- merge equivalent reflections in bigmat
c
      icodeo=-1
      sumrn1 = 0.0
      sumrn2 = 0.0
      sumrd1 = 0.0
      sumrd2 = 0.0
      nne=0
      sumnu=0.0
      sumsi=0.0
      sumdel = 0.0
      sumden = 0.0
      do 400 i=1,nref
         icode = nint(bigmat(3,i))
         if (icode.ne.0) then
             if (icode.ne.icodeo.and.icodeo.gt.0) then
                fo = sumnu / sumsi
                sigma = sqrt( 1.0 / sumsi ) / float(nne)
*               sumdel = 0.0
*               sumden = 0.0
                do 300 j=ipunt,i-1
                   absfo = abs(bigmat(1,j))
                   sigma =     bigmat(2,j)
                   sigma2 = sigma * sigma
                   delta = abs( absfo - fo )
                   sumdel = sumdel + delta
                   sumden = sumden + absfo
  300           continue
                bigmat(1,ipunt) = fo
                bigmat(2,ipunt) = sigma
                nne=0
                sumnu=0.0
                sumsi=0.0
             endif 
             if (nne.eq.0) then
                 icodeo=icode
                 ipunt = i
             endif
             s2 = 1.0 / bigmat(2,i) 
             s2 =  s2 * s2 
             sumnu = sumnu + s2 * abs(bigmat(1,i))
             sumsi = sumsi + s2
             nne = nne + 1
         endif
  400 continue
      if (nne.ne.0) then
         fo = sumnu / sumsi
         sigma = sqrt( 1.0 / sumsi ) / float(nne)
*        sumdel = 0.0
*        sumden = 0.0
         do 500 j=ipunt,nref
            absfo = abs(bigmat(1,j))
            sigma =     bigmat(2,j)
            delta = abs( absfo - fo )
            sumdel = sumdel + delta
            sumden = sumden + absfo
  500    continue
         bigmat(1,ipunt) = fo
         bigmat(2,ipunt) = sigma
      endif
c
c-- sort reflections respect to serial code
c 
      lind=1
      nr2=nref
      iblk=4
      jump=4
      call sortz(lind,nr2,iblk,jump)
      nr = 0
      do 700 nnn = 1 , nrec
         read(iscra,rec=nnn) ((vet(j1,j2),j1=1,6),j2=1,nrpb)
         do 600 i = 1 , nrpb
            nr = nr + 1
            if (nr.gt.nref) go to 600
            vet(4,i) = bigmat(1,nr)
            vet(5,i) = bigmat(2,nr)
  600    continue
         write(iscra,rec=nnn) ((vet(j1,j2),j1=1,6),j2=1,nrpb)
  700 continue
c
      rfac = 100.0 * sumdel / sumden
c
      return
      end
c--------------------------------------------------------------
c     read directives for this modul
c
      subroutine dirdat(fileh,formt,npc,ier,iy,ifMatOr,MatOr)
      character * 200 Msg
      common /msgerr/ Msg
      character line*80,dire*80,diret*80,fileh*80,formt*80
      character blank,digit*12,card(100)*80,ibl2*2
      character specie(8)*2, Buff*12
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /chara/ blank,digit,card
      common /erl/ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common /frgmt/ mmold,mzold,ihmax(3),knowo,sumn,sumd,n(80)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common / ureq1/ jpatt,jpunt(1501),ksacc,jseteq,jumpp,jmpsie,nsec
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/gpt/nanew(8),naold(8),sn,sq
      common/at/gis(270),giw(270),list
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /genob/ irho
      common/bigcom/ maxstr,maxpsi
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /neutro/ neutro,neuwei,vetint(500),nsyn
      common /elettroni/ lproj, zeff(8), rminimo, kminimo, kaminimo
      common /anomalous/ nAnom,kfpfs(8),fpfs(2,8)
      common /sfact/ nSfCard, sfacm(8, 9), kSfac(8)
      dimension na(8),vet(40),ivet(40),wn(8),kshif(3)
      dimension MatOr(3,3)
      data ibl2 /'  '/
c
c-- set default values
c
c  irho = 1 genera i riflessi dello shell esterno
c  irho = 0 genera i riflessi non osservati fino al (sin theta)/lambda
c         max degli osservati
c  irho =-1 controlla l'esistenza di riflessi non-obs senza memorizzarli
c         sul file ad accesso diretto (default)
c
      ifMatOr = 0
      do 8 i=1,3
         do 5 j=1,3
            MatOr(i,j) = 0
    5    continue
         MatOr(i,i) = 1
    8 continue
      jpart=0
      jtran=0
cc
      nSfCard = 0
      nAnom = 0
      wave = 0.71069
      neutro=0
      irho=-1
      iffsq=-1
      iy=67543
      iprin=0
      do 10 i=1,10
      nag(i)=0
   10 ninf(i)=0
      do 15 i=1,80
   15 formt(i:i)=' '
      formt(1:11)='(3i4,2f8.2)'
      ishif=0
      do 20 i=1,3
   20 kshif(i)=0
      ksigma=1
      bt=0.0
      sc=-99.9
      knw=0
      mm=0
      mz=maxpsi
      th=1.980
      rhomin=0.0
      en=1.2
      er=0.3
      ngp=0
      llpse=0
      npc=1
      jjfile=ln
      do 30 i=1,200
      x(4,i)=1.0
      read(ibl2,'(a2)') nz(i)
      do 30 j=1,3
   30 x(j,i)=0.0
      lix1=0
      lix2=0
      lix3=0
      lix7=0
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 8200
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      ldiret = Lung(diret)
  105 call cutst(line,lenp,dire,lend)
      call lcase(dire)
c-- directives with alphanumeric parameters
      if (dire(1:4).eq.'spac') then
          if (lenp.le.1) go to 8000
          call lcase(line)
          lenp = 16
          call onebl(line,lenp,ier)
          if (ier.lt.0) go to 8000
          read(line,'(16a1)') nt
          call ti1983(nt)
          lix2=1
          go to 100
      endif
      if (dire(1:4).eq.'cont') then
          call lcase(line)
          call getcon(line,dire,nw,nalf,nk)
          if (nk.le.0) go to 8000
          lix3=1
          go to 100
      endif
      if (dire(1:4).eq.'sfac') then
          call lcase(line)
          call getsfac(line,dire,ic,icmax,ipdir,card,nsf)
          if (nsf.eq.0) then
              go to 8200
          elseif (nsf.lt.9) then
              goto 8000
          endif
          go to 100
      endif
      if (dire(1:4).eq.'anom') then
          nAnom = nAnom + 1
          call cutst(line,lenp,dire,lend)
          call lcase(dire)
          read(dire(1:2),'(a2)') kfpfs(nAnom)
          iopt=0
          call getnum(line,vet,ivet,iv,iopt)
          if (iopt.eq.-1) go to 8000
          if (iv.ne.2) go to 8000
          fpfs(1,nAnom)=vet(1)
          fpfs(2,nAnom)=vet(2)
          go to 100
      endif
      if (dire(1:4).eq.'wave') then
          if (lenp.le.1) go to 8000
               call lcase(line)
          if (line(1:2).eq.'cu') then
              wave = 1.54178
          else if (line(1:2).eq.'mo') then
              wave = 0.71069
          else
              iopt=0
              call getnum(line,vet,ivet,iv,iopt)
              if (iopt.eq.-1) go to 8000
              if (iv.ne.1) go to 8000
              wave = vet(1)
          endif
          go to 100
      endif
      if (dire(1:4).eq.'refl') then
          call cutst(line,lenp,fileh,lend)
          if (fileh(1:4).ne.'foll') then
              jjfile=jfile
          else
              jjfile=-ln
          endif
          if (lenp.gt.0) then
              iopt=0
              call getnum(line,vet,ivet,iv,iopt)
              if (iopt.eq.-1) go to 8000
              MatOr(1,1) = ivet(1)
              MatOr(1,2) = ivet(2)
              MatOr(1,3) = ivet(3)
              MatOr(2,1) = ivet(4)
              MatOr(2,2) = ivet(5)
              MatOr(2,3) = ivet(6)
              MatOr(3,1) = ivet(7)
              MatOr(3,2) = ivet(8)
              MatOr(3,3) = ivet(9)
              ifMatOr = 1
          endif
          go to 100
      endif
      if (dire(1:4).eq.'form') then
          k=index(diret,'(')
          if (k.eq.0) go to 8000
          formt=diret(k:)
          go to 100
      endif
      if (dire(1:4).eq.'fosq') then
          iffsq=-1
          go to 100
      endif
      if (dire(1:4).eq.'fobs') then
          iffsq=1
          go to 100
      endif
      if (dire(1:4).eq.'gene') then
          irho=0
          go to 100
      endif
c-- directives with alphanumeric parameters
      if (dire(1:4).eq.'frag') then
          ngp=ngp+1
          ninf(ngp)=3
          call getfrg(line,lenp,dire,diret,ic,icmax,ier)
          if (ier.eq.-1) go to 8000
          if (ier.eq. 1) go to 8200
          go to 105
      endif
      if (dire(1:4).eq.'nosi') then
          ksigma=0
          go to 100
      endif
cel---------------------------------------
      if (dire(1:4).eq.'elec') then
          neutro=2
          en = 1.0
*         th =99.99
          go to 100
      endif
*     if (dire(1:4).eq.'neut') then
*         neutro=1
*         go to 100
*     endif
cel---------------------------------------
c-- directives with numeric parameters
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 8000
      if (dire(1:4).eq.'cell') then
          if (iv.ne.6) go to 8000
          do 200 i=1,6
  200     cx(i)=vet(i)
          lix1=1
          call frm01(cx)
          go to 100
      endif
      if (dire(1:4).eq.'shif') then
          if (iv.ne.3) go to 8000
          ishif=1
          do 250 i=1,3
             ksh=ivet(i)
             if (ksh.ne.0) then
                 if (mod(24,ksh).ne.0) then
                     write(lo,230)
                     go to 8000
                 endif
             endif
             kshif(i)=ksh
  250     continue
          go to 100
      endif
  230   format(///' origin shift components must be integral multiples',
     * ' of 1/24 ')
      if (dire(1:4).eq.'rhom') then
          if (iv.ne.1) go to 8000
          th=vet(1)
          if (th.lt.0.0.or.th.gt.1.0) go to 8000
          go to 100
      endif
      if (dire(1:4).eq.'prin') then
          if (iv.ne.1) go to 8000
          iprin=ivet(1)
          go to 100
      endif
      if (dire(1:4).eq.'know') then
          if (iv.ne.0) go to 8000
          knw=1
          go to 100
      endif
      if (dire(1:4).eq.'reco') then
          if (iv.ne.1) go to 8000
          npc=ivet(1)
          go to 100
      endif
      write(Msg,6100) diret(1:ldiret)
 6100 format(' Wrong directive in DATA modulus:   ',a)
      call screrr(ier,Msg,1)
      ier=-1
      return
 8000 continue
      ier=-1
      write(Msg,'(22h Error in directive : ,a)') diret(1:ldiret)
      call screrr(ier,Msg,1)
      return
 8200 continue
      npc=npc*iffsq
      jfile=jjfile
      if (lix1.le.0) then
          write(Msg,8225)
          call screrr(ier,Msg,1)
          ier=-1
      else
          call yfl01
          write(lo,8230) (cx(i),i=1,6)
      endif
 8225 format(' No cell parameters supplied')
 8230 format(/,12h Direct cell,9x,3ha =,f8.3,8x,3hb =,f8.3,8x,
     1 3hc =,f8.3,/,
     2 17x,7halpha =,f8.3,5x,6hbeta =,f8.3,4x,7hgamma =,f8.3)
      if (lix2.le.0) then
c         write(lo,8240)
          write(Msg,8245)
          call screrr(ier,Msg,1)
          ier = -1
      else
          call insym(ishif,kshif)
          pop=pts*(float((icent+1)*nsym))
          call yfrm02
          call sc014(ix)
      endif
 8240 format(/,' *** error *** no space group symbol supplied')
 8245 format(' No space group symbol supplied')
c ---
c --- read scattering factors
c ---
      if (lix3.le.0) then
          write(Msg,8255)
          call screrr(ier,Msg,1)
          ier=-1
      else
          call yfrm03(wave,ier)
          if (ier.ge.0) call yfl03
      endif
 8255 format(' No cell content supplied')
c
c-- check on scattering factor coefficients
c
      do 8270 i=1,nk
         isum = nint(cl(i)*100.0)
         do 8260 j=1,4
            isum = isum + nint(al(j,i)*100.0) + nint(bs(j,i)*100.0)
 8260    continue
         if (isum.eq.0) then
             write(Buff,'(3a4)') (nomeat(j,i),j=1,3)
             j = Lung(Buff)
             write(Msg,8275) Buff(1:j)
             call screrr(ier,Msg,1)
             ier=-1
             return
         endif
 8270 continue
 8275 format(' Scattering factors for ',a,' not available.',
     *       ' Use SFAC directive.')
      call xdump
c
c-- checks on atomic species in SFAC and ANOMAULS directives
c
      if (nAnom.gt.0) then
          do 8310 j=1,nAnom
          do 8300 i=1,nk
          if (nalf(i).eq.kfpfs(j)) then
              kfpfs(j) = i
              go to 8310
         endif
 8300    continue
         write(Msg,8320) kfpfs(j)
         ier=-1
         call screrr(ier,Msg,1)
         return
 8310    continue
      endif
 8320 format('Atom type ',a2,' not expected.',
     *       ' Check ANOMALOUS directive')
      if (nSfCard.gt.0) then
          do 8340 j=1,nSfCard
          do 8330 i=1,nk
          if (nalf(i).eq.kSfac(j)) then
              kSfac(j) = i
              go to 8340
         endif
 8330    continue
         write(Msg,8350) kSfac(j)
         ier=-1
         call screrr(ier,Msg,1)
         return
 8340    continue
      endif
 8350 format('Atom type ',a2,' not expected.',
     *       ' Check SFAC directive')
c
      if (nAnom.gt.0 .or.  nSfCard.gt.0) then
          call Change03
          call yfl03
      endif
      if (ier.lt.0) return
c
cel-----------------------------------------------------------------
      if (neutro.eq.0) then
          write(lo,'(/,27x,30H  X-ray scattering factors    )')
      else if (neutro.eq.1) then
          write(lo,'(/,27x,30HNeutron scattering factors    )')
c
c-- ordina i fattori di scattering secondo 
c-- il valore che assumono a s=0
c
          call upd03
      else if (neutro.eq.2) then
c
c-- ordina i fattori di scattering secondo
c-- il valore di Z effettivo
c     read reflexion data from cards
          call datain(fileh,formt,nrefp,npc,ier,ifMatOr,MatOr)
          if (ier.lt.0) stop 666
          write(lo,'(/,27x,30HElectron scattering factors    )')
          call zeffettivo
          call upd03ele
      endif
cel----------------------------------------------------
c ---
      do 9010 i=1,nk
         write(specie(i),'(a2)') nalf(i)
         call ucase(specie(i)(1:1))
         na(i)=nw(i)
 9010 continue
      write(lo,9021)
 9021 format(/,15x,
     * 'Unit cell contents and scattering factor constants',/)
	if (neutro.eq.0) then
          write(lo,9020) 
     *    ((nomeat(j,i),j=1,3),specie(i),nw(i),no(i),i=1,nk)
	else
          write(lo,9022) 
     *    ((nomeat(j,i),j=1,3),specie(i),nw(i),no(i),zeff(i),i=1,nk)
	endif
 9020 format(/,12x,'Atom',6x,'Symbol',3x,'Number in cell',3x,
     *             'Atomic number',/,(10x,3a4,2x,a2,i13,i16))
 9022 format(/,12x,'Atom',6x,'Symbol',3x,'Number in cell',3x,
     *             'Atomic number',3x,'Z-eff.',/,
     *              (10x,3a4,2x,a2,i13,i16,f14.3))
      write(lo,9025) (specie(i),(al(ii,i),bs(ii,i),ii=1,4),cl(i),i=1,nk)
 9025 format(/,20x,'f = sum (  a(i) * exp(-b(i)*s2)  )  i=1,4 + c ',//,
     3 7x,'a(1)',4x,'b(1)',4x,'a(2)',4x,'b(2)',4x,'a(3)',4x,'b(3)',4x,
     4 'a(4)',4x,'b(4)',4x,' c',/,(1h ,a2,9f8.3))
      s3=0
      s2=0
      if (neutro.eq.0) then
          do 9060 i=1,nk
             ss=float(na(i))*no(i)*no(i)
             s2=s2+ss
             s3=s3+ss*no(i)
 9060     continue
      else if (neutro.eq.2) then
          do 9065 i=1,nk
             ss=float(na(i))*zeff(i)*zeff(i)
             s2=s2+ss
             s3=s3+ss*zeff(i)
 9065     continue
      endif
      s3s2=s3/sqrt(s2**3)
      do 9090 i=1,8
 9090 wn(i)=float(nw(i))
      if (ngp.gt.0) then
      nf=0
      nats=0
      do 9190 i=1,ngp
      ns=nf+1
      nf=nf+nag(i)
      write(lo,9100) i,nag(i)
 9100 format(/,27h fragment number          =,i3,/,
     1         27h no. of atoms in fragment =,i3,/,
     2 5x,'type',7x,'x',9x,'y',9x,'z',7x,'occ.   number in cell')
      do 9170 j=ns,nf
      do 9120 k=1,nk
      if(nz(j).eq.nalf(k)) goto 9140
 9120 continue
c     write(lo,9130) nz(j)
      write(Msg,9135) nz(j)
      call screrr(ier,Msg,1)
 9130 format('  *** error *** ',a2,
     *       ' type not present in the declared content')
 9135 format(2x,a2,' type not present in the declared content')
      ier=-1
      return
 9140 nz(j)=k
      k=nz(j)
      nz(j)=nz(j)*100+1
      nats=nats+1
 9170 continue
 9190 continue
      numset=0
      interp=0
      np(1) = 0
      np(2) = 0
      np(3) = 0
      call frm15(nats,interp)
      endif
c
      return
      end
c---------------------------------------------------------------------
      subroutine prepl7(npseud,iy)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,mxbg,iprin,iflag
      common /buffer/ vet(6,85) ,nrpb,idumb(4)
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /xdata/ store(500000)
      dimension ivet(6,85),vet2(6,85),ivet2(6,85),vat(9)
      equivalence (vet(1,1),ivet(1,1))
      equivalence (vet2(1,1),ivet2(1,1))
c
      sumsig=0.0
      sig01=0.0
      n01=0
      nrec=nref/nrpb
      if (mod(nref,nrpb).gt.0) nrec=nrec+1
c     set initial values
      do 100 nn=1,nrpb
  100 vet2(2,nn)=-9999.9
      nr=0
      nc=0
      nn2=0
      k2=0
      do 250 nnn=1,nrec
      read(iscra,rec=nnn) ((vet(j1,j2),j1=1,6),j2=1,nrpb)
      do 250 i=1,nrpb
      nr=nr+1
      if (nr.gt.nref) go to 255
      if (vet(4,i).lt.0.0) goto 250
      nc=nc+1
      lh=ivet(1,i)
      lk=ivet(2,i)
      ll=ivet(3,i)
      fo=vet(4,i)
      sigma=vet(5,i)
      icobs=1
      inp=(icobs*128*128+(lh+64)*128+(lk+64))*128+ll+64
c
c--   definizione di vet2-ivet2        vet2(6,85)
c       inp   e   fo   ed   fasi sigma
c        1    2    3    4     5    6
c
      k2=k2+1
      ivet2(1,k2)=inp
      vet2(2,k2)=nref-nc+1
      vet2(3,k2)=fo
      vet2(4,k2)=0.0
      ivet2(5,k2)=ivet(6,i)
      if (sigma.gt.0.0) then
                          sig01=sig01+sigma
                          n01=n01+1
                        endif
      sumsig=sumsig+sigma
      if (abs(sigma).lt.0.001) sigma=0.1
      vet2(6,k2)=sigma
      if(k2.eq.nrpb) then
                        nn2=nn2+1
                        write(iscra,rec=nn2)
     *                  ((vet2(j1,j2),j1=1,6),j2=1,nrpb)
                        k2=0
                        do 150 nn=1,nrpb
  150                   vet2(2,nn)=-9999.9
                      endif
  250 continue
  255 if(k2.gt.0) then
                    nn2=nn2+1
                    write(iscra,rec=nn2)
     *              ((vet2(j1,j2),j1=1,6),j2=1,nrpb)
                   endif
c
c---- fine ciclo su vet-ivet
c
      nref=nc
      nr2=nn2
      nrpb2=nrpb
      ksort=1
      kprint=0
      call smerge(nr2,nrpb2,nref,npseud,iy,mz,ksort)
c
c-- check sigma(F) values
c
      aref=float(nref)
      sumsig=sumsig/aref
      sumdsig=0.0
      do 400 i=1,nref
      call snr07(vat)
      if (ksigma.gt.0) then
                         dsig=abs(sumsig-vat(9))
                         sumdsig=sumdsig+dsig
                       endif
  400 continue
      sumdsig=sumdsig/aref
      if (sumdsig.lt.0.01) ksigma=0
      if (nint(sig01).eq.n01) ksigma=0
c
      if (ksigma.eq.0) write(lo,385)
  385 format(/,' *** warning ***  sigma(F) values are meaningless',/)
c
c-- write fosog in list 7
c
      fosog=0.0
      iy=-1
      call spb07(iy)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine smerge(nr2,nrpb2,nref,npseud,iy,mz,ksort)
c
c-- merge the sorted blocks of reflections in iscra
c-- create list 7
c     nr2 = number of disk blocks
c    nrpb2 = number of reflections per block
c    ksort = 0 do not sort reflections
c          = 1 sort reflections
c   lbuffe = buffer lenght
c     ntop = number of reflections to transfer from disk in buffer
c            for each disk block
c    nitem = number of values per reflection
c    inizb = starting address of the buffer
c    inizd = starting address in the buffer    for disk block
c    inizt = starting address in the buffer    for total counter
c    inizp = starting address in the buffer    for partial counter
c    inize = starting address in the buffer    for emax values
c    inizr = starting address in the buffer    for reflections
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,mxbg,iprin,iflag
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
*     common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
*    2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common/xdata/ buffer(500000)
*     common /data / buffer6(30000)
*     integer ibuff6(30000)
      dimension vet2(6,85),ivet2(6,85),vet(6),ivet(6),ibuffe(500000)
      equivalence (vet(1),ivet(1))
      equivalence (vet2(1,1),ivet2(1,1))
      equivalence (vet2(1,1),buffer(1))
      equivalence (buffer(1),ibuffe(1))
*     equivalence (buffer6(1),ibuff6(1))
c
c-- check if List 6 has to be created
c
*     if (sc.lt.0.0) then
*         n6d = nref
*         md6d = 7
*         m6dk = 300
*         iln = 6
*         in6 = 0
*         call sfr0r(iln)
*     endif
c-- create preamble block for list 7
      call ysfp07(nref,npseud,iy)
c
c-- reset pointers for list 7
      call ysfl07(idum1,idum2,idum3,idum4,idum5)
c
c-- initialize pointers and constants
      mxbg=240000
      n90=0
      nrf=0
      iweak=nref-mz+1
      nitem = 6
      lbuffe=mxbg
      inizd=1
      inizb=inizd+nitem*nrpb2
      inizt=inizb
      inizp=inizt+nr2
      inize=inizp+nr2
      inizr=inize+nr2
c
c-- initialize counters and array for max e values
c-- fill the buffer with the tops of disk blocks
      ntop= ( lbuffe - inizr ) / ( nr2 * nitem )
      ntop=min0(ntop,nrpb2)
      ib=inizr-1
      do 100 i=1,nr2
      ibuffe(inizt+i-1)=1
      ibuffe(inizp+i-1)=1
      read(iscra,rec=i) ((vet2(j1,j2),j1=1,nitem),j2=1,nrpb2)
      buffer(inize+i-1)=vet2(2,1)
      do 90 j2=1,ntop
      do 90 j1=1,nitem
      ib=ib+1
      buffer(ib)=vet2(j1,j2)
   90 continue
  100 continue
c
c-- compute imax = number of block containing the e-max
  110 imax=0
c
      if (ksort.eq.0) then
c-- imax correspond to the first reflection in the first available block
      imax=0
      do 115 i=1,nr2
      j=ibuffe(inizt+i-1)
      if (j.le.nrpb2.and.imax.eq.0) imax=i
  115 continue
                     else
c-- find out imax
      emax=-999.9
      do 120 i=1,nr2
      j=ibuffe(inizt+i-1)
      if (j.le.nrpb2) then
                        emx=buffer(inize+i-1)
                        if (emx.gt.emax) then
                                           emax=emx
                                           imax=i
                                         endif
                      endif
  120 continue
                      endif
      if (imax.eq.0) go to 200
c
c-- if the top of imax-th block is empty load the 'next' top
c
c-- itx  = value of the  total  counter for imax-th block
c-- ipx  = value of the partial counter for imax-th block
c--  ib  = address in buffer of the selected reflection
      itx=ibuffe(inizt+imax-1)
      ipx=ibuffe(inizp+imax-1)
      ib= inizr + ( (imax-1)*ntop + (ipx-1)  ) * nitem
      ivet(1)=ibuffe(ib  )
       vet(2)=buffer(ib+1)
       vet(3)=buffer(ib+2)
       vet(4)=buffer(ib+3)
      ivet(5)=ibuffe(ib+4)
       vet(6)=buffer(ib+5)
      call xslw07(vet)
c
c-- list 6
c
*     if (sc.lt.0.0) then
*         m6 = 1
*         call xslr(in)
*     endif
      itx=itx+1
      k1=inize+imax-1
      k2=inizp+imax-1
      k3=inizt+imax-1
      if (itx.le.nrpb2) then
                if (ipx.eq.ntop) then
                                   ipx=0
                                   read(iscra,rec=imax)
     *                             ((vet2(j1,j2),j1=1,nitem),j2=1,nrpb2)
                                   ib=inizr+(imax-1)*ntop*nitem-1
                                   ifin=itx+ntop-1
                                   ifin=min0(ifin,nrpb2)
                                   do 130 j2=itx,ifin
                                   do 130 j1=1,nitem
                                   ib=ib+1
                                   buffer(ib)=vet2(j1,j2)
  130                              continue
                                 endif
                          ipx=ipx+1
                          ib=inizr+((imax-1)*ntop+(ipx-1))*nitem
                          buffer(k1)=buffer(ib+1)
                          ibuffe(k2)=ipx
                          if (buffer(k1).lt.0.0) itx=nrpb2+1
                        else
                          buffer(k1)=-888.8
                        endif
      ibuffe(k3)=itx
      go to 110
  200 continue
c
c-- reset pointers for list 7
      call ysfl07(idum1,idum2,idum3,idum4,idum5)
      call xdump
      return
      end
c------------------------------------------------------------
c     read space group symbol as in international tables and
c     determine lattice multiplicity (pts) and crystal system (ksys)
      subroutine insym(ishif,kshif)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,mxbg,iprin,iflag
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /erl/ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      dimension ltc(7),kshif(3)
      data ltc/1hp,1ha,1hb,1hc,1hi,1hf,1hr/
c     -------
      call symm(lo,ishif,kshif)
c     determine lattice multiplicity
c     primitive
      pts=1.0
      do 250 i=1,7
      if(latt.eq.ltc(i)) go to 260
  250 continue
      stop
  260 latt=i
      if(latt.eq.7) go to 300
c     a, b, c or i centred
      if(latt.ne.1) pts=2.0
c     f centred
      if(latt.eq.6) pts=4.0
      go to 400
  300 do 310 i=1,nsym
c     primitive rhombohedral  (pts=1.0)
      if(iabs(is(1,1,i)).eq.3) go to 400
  310 continue
c     centred hexagonal
      pts=3.0
c     determine crystal system
  400 do 450 i=1,2
      do 440 j=1,nsym
      do 430 in=1,2
      if(iabs(is(in,1,j)).eq.4-i) go to 460
  430 continue
  440 continue
  450 continue
c     1 - triclinic, 2 - monoclinic, 3 - orthorhombic
      ksys=min0(nsym,3)
      go to 500
  460 if(i.eq.1) go to 480
c     tetragonal
      ksys=4
      if(nsym.eq.4.or.nsym.eq.8) go to 500
c     trigonal or rhombohedral indexed on hexagonal axes
      ksys=5
c     test for 6-fold axis - general form -x, -y, z + t
      do 470 j=2,nsym
      if(iabs(is(1,1,j)).gt.1.or.iabs(is(2,1,j)).gt.1) go to 470
      if(iabs(is(1,2,j)).eq.1.or.iabs(is(2,2,j)).eq.1) go to 470
c     hexagonal
      ksys=6
  470 continue
      go to 500
c     cubic
  480 ksys=8
c     primitive rhombohedral
      if(latt.eq.7) ksys=7
      if(ksys.eq.7) latt=1
  500 return
      end
c------------------------------------------------------------
      subroutine symm(ncwu,ishif,kshif)
      character oshift*33,oshp*5,texc(6)*12,buffer(24)*78
      character space*16
      common /ureq1/ jpatt,jpunt(1501),ksacc,jseteq,jumpp,jmpsie,nsec
      common /erl/ r,tmat(48,3),nt,isys,ngen,ngt,svet(10),jvet(8)
     *            ,dum(7)
      integer  svet,kshif(3)
      integer sys,nt(16),ges(3,3,36),net(3),in(3,4),is(3),get(3,34),
     *ntex(42),hbr(9),hs(15),ll(2,3,2),iss(59),lsh(2,78),s(3),lgt(
     *48),mst1(3,6),mst2(3,6),lf(216),q(3,4,5),txa(3,11),nsm(45),sem(3,3
     *,18),sc(3,3),lgn(3,45),atx(18),txb(5,7),tx(2,6,3),teb(2,9),t(48,3)
     *,ngt(48,48),r(48,3,3)
      equivalence (j2,in(2,2)),(j3,in(2,3)),(k2,in(3,2)),(k3,in(3,3)),
     *(i3,in(1,3)),(i2,in(1,2)),(i1,in(1,1)),(j1,in(2,1)),(k1,in(3,1))
     *,(i4,in(1,4)),(j4,in(2,4)),(k4,in(3,4))
      data sem/1,3*0,1,3*0,1,96,3*0,1,3*0,1,1,3*0,96,3*0,1,1,3*0,1,3*0,9
     *6,1,3*0,96,3*0,2*96,3*0,1,3*0,2*96,3*0,96,3*0,1,96,3*0,96,3*0,3*96
     *,3*0,1,3*0,2*96,3*0,96,5*0,96,6*0,3*96,8*0,1,6*0,64,128,32,6*0,128
     *,64,3*0,1,3*0,128,64,3*0,96,3*0,3*48,96,3*0,96,0,2*96,2*0,96,48,2*
     *0,96/,nsm/1,2,3,4,5,6,7,5,6,7,8,10,9,9,10,10,10,15,15,13,11,16,16,
     *13,13,16,11,11,12,12,12,8,8,8,8,8,11,10,10,11,11,11,11,12,12/,
     *q/4*0,2*12,9*0,12,0,12,9*0,2*12,11*0,3*12,0,3*12,4*0,3*12,6*0/
Corig data lsh/2,26,6,11,5,15,7,26,435,28,603,26,453,28,645,15,747,26,
      data lsh/2,26,6,11,5,15,7,26,435,28,603, 1,453,28,645,15,747,26,
     *771,15,2287,30,2383,32,2299,31,1622,11,899,9,1319,10,1209,10,1749,
     *11,954,9,1601,11,898,9,1221,10,1770,11,955,9,1307,10,2401,13,2547,
     *13,2421,13,5105,16,7303,15,7205,15,29187,12,29687,12,31662,12,1372
     *1,21,13202,11,13210,21,13691,22,17219,21,17221,15,17223,23,17227,
     *13,17229,15,17231,24,17721,24,14137,21,14147,11,14164,21,14170,
     *21,14638,3,14689,25,14692,26,15183,15,15160,21,15185,13,16229,15,
     *16228,11,16230,12,16729,15,15708,34,17122,3,17149,3,17102,21,171
     *29,21,17120,11,17148,11,17155,3,17132,3,17135,21,17112,11,17153,11
     *,17131,11,17603,3,17659,29,17662,15,5204,14,5104,14,5205,16/
      data mst1/3*1,0,2,2,3,0,3,4,4,0,5,6,7,9,10,11/,mst2/3*1,2,0,0,3,3,
     *0,0,4,4,7,5,8,11,0,12/,sys/2/,n,net,is,k/8*1/,id,il,lt,nrt/4
     **0/
      data lgn/1,0,0,2,0,0,2,0,0,2,0,0,2,0,0,2,0,0,2,0,0,3,4,0,3,4,0,
     *3,4,0,3,4,0,3,0,0,3,0,0,5,7,0,5,3,0,5,3,0,3,5,0,2,0,0,4,2,0,4,2,0,
     *4,2,0,4,2,0,5,0,0,5,0,0,7,10,0,7,4,0,7,4,0,7,10,0,2,5,0,5,14,0,
     *5,14,0,2,0,0,4,2,0,4,2,0,4,2,0,7,8,6,5,0,0,6,3,0,10,11,13,10,8,0,
     *10,8,0,14,19,22,8,5,0,26,37,5,14,5,0/,mcc,ngo,ncs,s,in,lgt/66*0/
      data lf/1,1,-2,1,-3,1,-4,1,2,1,3,1,4,1,2,-3,-4,1,3,-2,-4,1,4,-2,-3
     *,1,4,2,3,1,4,-15,-14,1,4,15,14,1,4,15,14,-2,-3,-13,-16,1,4,2,3,-13
     *,-16,-14,-15,1,4,13,16,-2,-3,-14,-15,1,4,2,3,13,16,14,15,1,3,5,1,3
     *,5,-9,-11,-7,1,3,5,-10,-8,-12,1,3,5,9,11,7,1,3,5,10,8,12,1,3,5,-4,
     *-2,-6,1,4,3,5,2,6,1,4,3,5,2,6,-9,-11,-7,-10,-8,-12,1,3,5,10,8,12,-
     *9,-11,-7,-4,-2,-6,1,3,5,9,11,7,-10,-8,-12,-4,-2,-6,1,4,3,5,2,6,9,1
     *1,7,10,8,12,1,4,2,3,5,9,7,12,8,10,6,11,1,4,2,3,5,9,7,12,8,10,6,11,
     *-13,-16,-14,-15,-17,-21,-19,-24,-20,-22,-18,-23,1,4,2,3,5,9,7,12,8
     *,10,6,11,13,16,14,15,17,21,19,24,20,22,18,23/,t  /144*0/
      data ges/1,3*0,1,3*0,1,1,3*0,-1,3*0,2*-1,3*0,1,3*0,2*-1,3*0,
     *-1,3*0,1,0,1,3*0,1,1,3*0,1,3*0,2*-1,3*0,-1,3*0,1,-1,3*0,-1,3*0,-1,
     *1,4*0,1,1,3*0,1,3*0,1,-1,3*0,-1,3*0,-1,1,3*0,-1,3*0,2*-1,3*0,
     *1,2*0,-1,0,-1,4*0,-1,0,-1,0,1,4*0,1,0,1,0,-1,4*0,1,0,1,0,1,4*0,
     *2*-1,4*0,-1,0,-1,0,-1,4*0,1,0,1,0,1,4*0,-1,0,1,0,1,4*0,1,0,-1,
     *3*0,-1,0,-1,0,-1,4*0,-1,0,1,0,1,4*0,1,0,-1,0,1,4*0,1,0,1,0,-1,0,0,
     *1,3*0,1,3*0,1,1,1,0,-1,4*0,1,0,1,0,2*-1,3*0,1,-1,3*0,-1,3*0,1,2*-1
     *,0,1,4*0,1,0,-1,0,1,1,3*0,1,0,1,0,1,4*0,-1,1,1,0,0,-1,3*0,-1,1,0,
     *0,2*-1,3*0,-1,0,-1,0,-1,4*0,3*-1,0,0,1,3*0,2*-1,0,0,1,1,3*0,-1/
      data iss/111,711,171,117,211,121,112,277,727,772,222,-389,411,477,
     *-373,-328,422,311,371,317,321,312,-589,611,677,-528,-573,622,231,-
     *363,432,-89,218,128,119,777,-289,418,484,-229,-283,684,618,737,731
     *,1,5,6,7,11,18,13,17,21,22,28,24,31,29/
      data texc/'triclinic   ','monoclinic  ','orthorhombic',
     *'tetragonal  ','hexagonal   ','cubic       '/
      data hbr/1hp,1ha,1hb,1hc,1hf,1hi,1hr,1hy,1h /
     *,hs/1hm,1ha,1hb,1hc,1hn,1hd,1h-,1h0,1h1,1h2,1h3,1h4,1h5,1h6,1h//
      data ntex/2h  ,2h  ,4*0,2h+1,2h/8,2h+1,2h/6,2*0,2h+1,2h/4,2*0,2h+1
     *,2h/3,2h+3,2h/8,4*0,2h+1,2h/2,6*0,2h+2,2h/3,2*0,2h+3,2h/4,2*0,2h+5
     *,2h/6/,teb/2h  ,2h-z,2h  ,2h-y,2h x,2h-y,2h  ,2h-x,0,0,2h  ,2h x,
     *2h y,2h-x,2h  ,2h y,2h  ,2h z/,txa/3*2h 0,2h g,3*2h 0,2h g,3*2h 0,
     *2
     *h g,2h 0,3*2h g,2h 0,3*2h g,2h 0,3*2h g,2h h,2h k,2h 0,2h h,2h k,2
     *h g,2h h,2h k,2h l/,txb/5*2h  ,2hh+,2hk=,2h2n,2*2h  ,2hh+,2hk+,2hl
     *=
     *,2h2n,2h  ,2h2h,2h+4,2hk+,2hg=,2h6n,2h2h,2h+k,2h=3,2hn ,2h  ,2hh+,
     *2hk+,2hl=,2h4n,2h  ,2h2h,2h+2,2hk+,2hg=,2h4n/,atx/11,21,31,41,51,6
     *1
     *,71,81,92,102,101,113,91,104,95,105,86,107/,get/3*0,12,3*0,12,3*0,
     *1
     *2,0,3*12,0,3*12,0,3*12,0,3*6,0,3*6,0,3*6,18,2*6,0,0,4,0,0,6,0,0,8,
     *0,0,12,0,0,16,0,0,18,0,0,20,18,6,0,18,12,6,18,6,3,18,6,9,0,18,0,0,
     *6,0,0,6,3,6,0,0,0,12,6,9,9,0,9,0,9,0,9,9,6,18,18,0,18,9/
      data oshift /'                                 '/
c--
c  13 format(2(i3,')',2(4a2,','),4a2))
   13 format(2(1h ,i3,') ',2(4a2,','),4a2,4x))
   15 format(//,' Seminvariant condition : ',3a2,4x,5a2)
   19 format (/,' Crystal family',29x,':  ',a12)
   20 format (/,' Space group (centrosymmetric)',14x,':  ',a16,a33)
   21 format (/,' Space group (noncentrosymmetric)',11x,':  ',a16,a33)
   27 format(/,' Symmetry-operations'/)
Cor32 format(2a60)
   32 format(a78)
c     read the symbol,determine bravais lattice and crystal family.
      i=hbr(8)
      do 98 i=1,7
   98 if(nt(1).eq.hbr(i)) nbr=i
c     standardization of the symbol
      do 99 i=1,3
      do 99 j=1,4
   99 in(i,j)=0
      do 100 i=3,16
      if(nt(i).ne.hbr(9)) goto 95
      k=0
      n=n+1
      goto 100
   95 if(nt(i).eq.hs(11).or.nt(i).eq.hs(14))sys=5
      do 96 j=1,15
   96 if(nt(i).eq.hs(j)) in(n,k)=j-8
  100 k=k+1
      if(i1.eq.4.or.i1.eq.-1.and.i2.eq.4) sys=4
      if(j1.eq.3) sys=6
      if(j1.eq.0.and.i1.eq.1.or.i1.eq.-1.and.i2.eq.1)sys=1
      if(sys.eq.2.and.j1.eq.0)goto 105
      if(sys.eq.2.and.i1.ne.1.and.j1.ne.1.and.k1.ne.1)sys=3
      goto 107
  105 do 106 i=1,4
      in(2,i)=in(1,i)
  106 in(1,i)=0
      i1=1
      k1=1
c     determination of code no. ngc for the point group
  107 do 97 i=1,3
      if(in(i,1).ne.0) is(i)=in(i,1)
      if(is(i).eq.-1) is(i)=-in(i,2)
      if(in(i,1).lt.-1) is(i)=7
      if(in(i,1).gt.-2) goto 94
      in(i,4)=in(i,1)
      in(i,1)=1
   94 if(in(i,2).ne.7) goto 97
      in(i,4)=in(i,3)
      in(i,3)=7
      in(i,2)=0
   97 continue
      if(k1.eq.2.and.(j1.eq.2.or.j1.eq.3))nrt=1
      m=100*is(1)+10*is(2)+is(3)+i3+j3+k3
      do 109 i=1,45
  109 if(m.eq.iss(i)) ngc=i
c     fix code no. ncs for centrosymmetry
      if(ngc.le.31) ncs=1
      nd=ngc
      if(nd.gt.31) nd=iss(ngc+14)
c     rotation parts
      do 110 i=1,216
      if(lf(i).eq.1) id=id+1
      if(id-nd) 110,112,120
  112 m=lf(i)*isign(1,lf(i))+24*(5/sys)*(sys/5)
      ngo=ngo+1
      do 111 k=1,3
      do 111 l=1,3
  111 r(ngo,k,l)=ges(k,l,m)*isign(1,lf(i))
  110 continue
c     multiplcation table
  120 do 90 i=1,ngo
      do 124 j=1,3
      do 124 k=1,3
  124 if(ncs.eq.0) r(ngo+i,j,k)=-r(i,j,k)
      do 90 j=1,ngo
      do 91 k=1,3
      do 91 l=1,3
   91 sc(k,l)=0
      do 92 k=1,3
      do 92 l=1,3
      do 92 m=1,3
   92 sc(k,l)=sc(k,l)+r(i,k,m)*r(j,m,l)
      do 93 k=1,ngo
      do 89 l=1,3
      do 89 m=1,3
      if(sc(l,m).ne.r(k,l,m)) goto 93
   89 continue
      ngt(i,j)=k
      if(ncs.eq.0)ngt(ngo+i,j)=k+ngo
      if(ncs.eq.0)ngt(i,ngo+j)=k+ngo
      if(ncs.eq.0)ngt(ngo+i,ngo+j)=k
      goto 90
   93 continue
   90 continue
      if(ncs.eq.0)ngo=ngo+ngo
c     select translation parts for generators
      if(ngc.eq.30.or.ngc.eq.31) il=1
      if(sys.eq.3) mcc=400*nbr+i4*49+j4*7+k4+399
      if(sys.ge.4)mcc=1000*nd+100*nbr+25*((k4+7)/2)+5*i4+j4+42+4*i2+j2*2
      if(sys.eq.5)mcc=3000+100*ngc+i2+j1+k1
      if(ngc.eq.11) mcc=i2*4+j2*2+k2
      do 122 i=1,3
      l=in(i,4)+8
      if(l.ge.7) goto 122
      il=il+1
      net(il)=mst1(i,l)
      if(sys.gt.3) net(il)=mst2(i,l)
  122 continue
      if(ngc.eq.30.and.k4.eq.-2) net(il)=13
      if(il.ge.2) goto 130
      do 123 i=1,3
      if(in(i,1).ne.2) goto 123
      il=il+1
      net(il)=1+i*in(i,2)
      if(sys.gt.3.and.in(i,1).ne.-1) net(il)=1+in(i,2)
      if(sys.eq.6) net(il)=1+5*in(i,2)
  123 continue
      if(i1.lt.3.or.i1.gt.6.or.i2.eq.0) goto 130
      il=il+1
      net(il)=13+(10*i2)/i1-(i2+i2)/i1
  130 n=net(3)
      if(ngc.eq.31)n=1+7*(i2/2)+i2/3+i2*(10*i2*i2-42*i2+43+mod(nbr,5))
      do 129 i=1,3
      m=net(i)
      id=lgn(i,ngc)
      if(id.eq.0) goto 128
      do 129 j=1,3
      t(id,j)=get(j,m)-nrt*(i/2)*(2/i)*(1-2*(sys/6))*get(j,n)
  129 if(nrt.eq.0.and.sys.lt.4.and.nbr.ne.5) s(j)=get(j,m)/2+s(j)
c     complete translation parts
  128 do 131 i=1,3
      if(lgn(i,ngc).eq.0) goto 131
      lt=lt+1
      lgt(lt)=lgn(i,ngc)
  131 continue
  135 if(lt.eq.ngo) goto 200
      n=0
      do 132 i=1,lt
      do 132 j=1,lt
      il=lgt(i)
      jl=lgt(j)
      kl=ngt(il,jl)
      do 133 m=1,ngo
      if(lgt(m).eq.kl) goto 132
  133 continue
      do 136 k=1,3
      do 134 l=1,3
  134 t(kl,k)=t(kl,k)+r(il,k,l)*t(jl,l)
      t(kl,k)=t(kl,k)+t(il,k)+48
  136 t(kl,k)=mod(t(kl,k),24)
      n=n+1
      lgt(lt+n)=kl
  132 continue
      lt=lt+n
      goto 135
c     selection of origin
  200 continue
      l=ishif+1
      if (l.eq.1) go to 219
      do 218 l=1,3
  218 s(l)=kshif(l)
      oshift(1:16)='( origin shift ='
      oshift(33:33)=')'
      iniz=18
      do 6923 l=1,3
         if (kshif(l).eq.0) then
                              oshp='  0  '
                            else
                              kk=24/kshif(l)
                              if (kk.le.9) then
                                             write(oshp,1000) kk
                                           else
                                             write(oshp,1100) kk
                                           endif
                            endif
         oshift(iniz:iniz+4)=oshp
         iniz=iniz+5
 6923  continue
 1000 format('1/',i1,'  ')
 1100 format('1/',i2,' ')
  219 n=0
      do 201 i=1,78
  201 if(mcc.eq.lsh(1,i)) n=lsh(2,i)
      if(n.eq.0) goto 210
      do 202 i=1,3
  202 s(i)=s(i)+get(i,n)
  210 do 211 i=1,ngo
      do 216 j=1,3
      t(i,j)=t(i,j)+r(i,j,1)*s(1)+r(i,j,2)*s(2)+r(i,j,3)*s(3)-s(j)+48
  216 t(i,j)=mod(t(i,j),24)
      if(nbr.eq.1.or.nbr.eq.7) goto 211
      nd=72
      do 214 l=1,4
      ne=0
      do 212 k=1,3
      is(k)=t(i,k)+q(k,l,nbr-1)
  212 ne=ne+mod(is(k),24)
      if(nd.le.ne) goto 214
      nd=ne
      do 213 k=1,3
  213 t(i,k)=mod(is(k),24)
  214 continue
  211 continue
      write(ncwu,19) texc(sys)
      write(space,'(16a1)') nt
      call ucase(space(1:1))
      if(ncs.eq.0) write(ncwu,20) space,oshift
      if(ncs.eq.1) write(ncwu,21) space,oshift
      write(ncwu,27)
      ne=(ngo+1)/2
      buffer(ne) = ' '
      do 424 n=1,ne
      id=2-(n+n-1)/ngo
      do 425 l=1,2
      is(l)=l+(n-1)*2
      i=is(l)
      do 425 j=1,3
      nd=r(i,j,1)+r(i,j,2)*3+r(i,j,3)*4+5
      tx(1,j,l)=teb(1,nd)
      tx(2,j,l)=teb(2,nd)
      do 425 k=1,2
      m=t(i,j)*2+k
  425 ll(k,j,l)=ntex(m)
      write(buffer(n),13)(is(m),(tx(1,j,m),tx(2,j,m),ll(1,j,m),ll(2,j,m)
     *,j=1,3),m=1,id)
  424 continue
      write(ncwu,32) (buffer(m),m=1,ne)
c     seminvariants
      nse=nsm(ngc)
      if(sys.eq.6.and.nbr.eq.5) nse=8
      if(nbr.eq.5.and.(ngc.eq.11.or.ngc.eq.29.or.ngc.eq.30)) nse=17
      if(nbr.eq.6.and.(ngc.eq.12.or.ngc.eq.16)) nse=18
      if(nbr.eq.7.and.(ngc.eq.37.or.ngc.eq.21.or.ngc.eq.40)) nse=14
      m=atx(nse)/10
      n=atx(nse)-10*m
      write(ncwu,15)(txa(i,m),i=1,3),(txb(j,n),j=1,5)
      do 426 jj=1,3
  426 jvet(jj)=txa(jj,m)
      do 427 jj=1,5
  427 jvet(jj+3)=txb(jj,n)
      isys=sys
      isv=1
      do 503 i=1,3
      do 503 j=1,3
      jsem=sem(i,j,nse)
      svet(isv)=jsem
      isv=isv+1
  503 continue
      svet(10)=3
      ngen=0
      do 504 i=1,3
      if (lgn(i,ngc).eq.0) go to 504
      ngen=ngen+1
  504 continue
c ---------------
c -------   calcola tmat
c
      do 505 i=1,ngo
      do 505 j=1,3
      tmat(i,j)=0.0
      if(t(i,j).eq.0) goto 505
      tmat(i,j)=float(t(i,j))/24.
  505 continue
      call modif(r,tmat,ngo,ncs,nt)
      call calmod(ngc,nbr,ncs,sem,nse)
      return
      end
c-----------------------------------------------------------------------
      subroutine modif(r,tmat,ngo,ncs,nt)
      common/sym/isba(2,3,24),tsba(3,24),nsym,dummy(2),icent,latt,s3s2,e
     *          ,s3s2p
      integer nt(16),r(48,3,3)
      dimension tmat(48,3)
      icent=1-ncs
      nsym=ngo
      if (icent.eq.1) nsym=nsym/2
      latt=nt(1)
      call musym(r,tmat,nsym,isba,tsba)
      return
      end
c-----------------------------------------------------------------------
      subroutine calmod(ngc,nbr,ncs,sem,nse)
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen,
     * irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      integer jmat(3,3),norv(3),sem(3,3,18)
      data jmat,norv/12*0/
c
      do 5 j=1,3
      nss(j)=0
      modul(j)=256
    5  continue
      do 10 j=1,3
      do 10 i=1,3
      isem=sem(i,j,nse)
      norv(j)=norv(j)+isem
      if(isem.lt.modul(j).and.isem.gt.1) modul(j)=isem
      jmat(i,j)=isem
   10 continue
      do 50 j=1,3
      if(modul(j).eq.0) goto 50
      do 40 i=1,3
   40 jmat(i,j)=jmat(i,j)/modul(j)
      modul(j)=192/modul(j)
   50 continue
      nori=3
      do 60 i=1,3
      j=3-i+1
      if(norv(j).gt.0) goto 70
      nori=nori-1
   60 continue
   70 continue
      do 80 i=1,3
      do 75 j=1,3
      if(sem(i,j,nse).ne.1) goto 75
      jmat(i,j)=1
   75 continue
      do 80 j=1,3
   80 nss(i)=nss(i)+jmat(i,j)
c --     nbr is the lattice code  p=1, a=2, b=3, c=4, f=5, i=6, r=7
      goto(100,600,1000,600,500,600,700),nbr
  100 if(ncs.eq.0) goto 1000
      if(ngc.ne.22.and.ngc.ne.23.and.ngc.ne.26) goto 1000
      nori=1
      nss(2)=4
      nss(3)=3
      modul(1)=6
      modul(2)=0
      goto 1000
  500 nori=1
      modul(2)=0
      modul(3)=0
      if(ngc.eq.10) goto 550
      nss(1)=1
      nss(2)=1
      modul(1)=2
      if(ncs.eq.1) modul(1)=4
      goto 1000
  550 nss(1)=0
      nss(2)=0
      modul(1)=0
      goto 1000
  600 nori=nori-1
      if(nori.gt.0) goto 620
      do 610 k=1,3
  610 modul(k)=1
      goto 1000
  620 continue
      do 630 k=1,2
      j1=2-k+1
      j2=j1
      if(nbr.eq.6.and.nori.eq.2) j1=k
      if(modul(j1).eq.0) goto 630
      nss(j1)=0
      modul(j2)=0
      goto 640
  630 continue
  640 if(nbr.eq.4) goto 650
      if(nbr.ne.6) goto 1000
      if(ngc.ne.12.and.ngc.ne.16) goto 650
      nori=1
      nss(1)=0
      nss(2)=2
      nss(3)=-1
      modul(1)=4
      modul(2)=0
      modul(3)=0
      goto 1000
  650 if(nori.eq.1) goto 680
      modul(2)=modul(3)
      modul(3)=0
      goto 1000
  680 nss(1)=0
      nss(2)=0
      goto 1000
  700 if(ncs.eq.0) goto 1000
      if(ngc.ne.18.and.ngc.ne.19) goto 1000
      nori=1
      nss(3)=0
 1000 return
      end
c     ------------------------------------------------------------------
      subroutine extin(jex,kg1,kg2,kg3,ibrav,klatt,ksym,vsym)
c   check for extinction (jex=0/1 allowed/absent)
c   first: check bravais lattice type
c   type  p   a  b    c   i    f   r
c   latt: 1   2   3   4   5    6   7
c   ibrav(    1   2   3   4    5   6  )  x  13
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,mxbg,iprin,iflag
      integer ibrav(6,13),kg(3),vsym(24),mr(3)
c
      kg(1)=kg1
      kg(2)=kg2
      kg(3)=kg3
      do 10 i=1,3
      if (kg(i).ne.0) go to 20
   10 continue
      jex=1
      return
   20 jex=0
      if(klatt.eq.0) go to 420
      nbrav=ibrav(klatt,1)
      do 410 i=1,nbrav
      isum=0
      do 400 j=1,3
      lb=1+(i-1)*4+j
 400  isum=isum+kg(j)*ibrav(klatt,lb)
      lb=4*i+1
      if(mod(isum,ibrav(klatt,lb)).eq.0) go to 410
      jex=1
      go to 700
410   continue
420   continue
c   second: check translations from symmetry operators
c         first condition for h to absent:  h*ri=h   (h=kg)
      if (ksym.eq.0) go to 700
      jc=icent+1
      do 490 kc=1,jc
      do 480 lsym=1,ksym
      isym=vsym(lsym)
        ca=0.
      do 470 jj=1,3
      nh=0
      do 430 j=1,3
430     mr(j)=0
      do 450 i=1,2
      do 440 j=1,3
      ikk=is(i,j,isym)
       ka=iabs(ikk)
      if(ka.ne.jj)goto 440
      if(kc.eq.2) ikk=-ikk
      mr(j)=isign(1,ikk)
440   continue
450   continue
      do 460 j=1,3
460   nh=kg(j)*mr(j)+nh
      if(kg(jj).ne.nh)goto 480
      ca=float(nh)*ts(jj,isym)   +  ca
470   continue
c  second condition:    h*ts ; integer, for an ext. reflexion.
      ca=abs(ca)
      ica=(ca+0.0005)*1000
      if(mod(ica,1000).eq.0)goto 480
c  variable ca is not an integer number,the reflexion is absent.
      jex=1
      goto 700
480     continue
490   continue
700     continue
      return
      end
c-----------------------------------------------------------------------
      subroutine geneq(lty,ih,kk,il,idelt,jcode,isnn,istd,rho)
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,mxbg,iprin,iflag
      dimension kl1(24),kl2(24),kl3(24),i1(3),i1s(3),i2(3),ise(24)
c
      isnn=1
      rho1=rhof(p,ih,kk,il)
      rho=rho1*rho1
      if (rho.lt.th) then
          i1(1)=ih
          i1(2)=kk
          i1(3)=il
          jcode=13
          ido=1
          maxi=1
          ise(maxi)=1
          if (nsym.eq.1.and.icent.eq.0) then
c
c-- P 1 case  
c             
              ifl = 0
              do 100 i=1,3
                 if (i1(i).ne.0.and.ifl.eq.0) then
                     if (i1(i).lt.0) then
                         ifl = 1
                         isnn = -1
                         ise(maxi)=isnn
                         i1(1) = -i1(1)
                         i1(2) = -i1(2)
                         i1(3) = -i1(3)
                     else
                         ifl = 1
                     endif
                 endif
  100         continue
          endif
          do 250 j=1,nsym
             kl1(j)=2400
             kl2(j)=2400
             do 200 i=1,3
                i2(i)=0
                kl1(j)=kl1(j)-i1(i) * int(ts(i,j)*24+0.01)
                kl2(j)=kl2(j)-i1(i) * int(ts(i,j)*12+0.01)
  200        continue
             kl1(j)=mod(kl1(j),24)
             do 220 i=1,3
                do 210 k=1,2
                   m=iabs(is(k,i,j))
                   if (m.gt.0) i2(m)=i2(m)+i1(i)*isign(1,is(k,i,j))
  210           continue
  220        continue
             if (icent.eq.1.or.ido.ne.1) goto 230
             jcode=1
             do 225 i=1,3
                if (i1(i)+i2(i).ne.0) go to 230
  225        continue
             jcode=mod(kl2(j),12)+1
             if (jcode.le.1) jcode=jcode+12
             ido=0
  230        ind=262144 * i2(1) + 512 * i2(2) + i2(3)
             kl3(j)=131328 + iabs(ind)
             if (lty.eq.1) then
                 rhomax=amax1(rhomax,rho1)
                 if (ihx(1).lt.iabs(i2(1))) ihx(1)=iabs(i2(1))
                 if (ihx(2).lt.iabs(i2(2))) ihx(2)=iabs(i2(2))
                 if (ihx(3).lt.iabs(i2(3))) ihx(3)=iabs(i2(3))
             endif
             if (j.ne.1) then
                 jm1=j-1
                 do 240 i=1,jm1
                    if (kl3(i).eq.kl3(j)) kl3(j)=0
  240            continue
                 if (kl3(j).gt.kl3(maxi)) then
                     maxi=j
                     ise(maxi)=isign(1,ind)
                 endif
             endif
  250     continue
          isnn=ise(maxi)
          call unpack (kl3(maxi),ih,kk,il)
          idelt=kl1(maxi)*15
          istd=0
          jcodes = jcode
          if (icent.eq.0) then
              ido=1
              i1s(1)=ih
              i1s(2)=kk
              i1s(3)=il
              do 300 j=1,nsym
                 kl1(j)=24000
                 do 260 i=1,3
                    i2(i)=0
                    kl1(j)=kl1(j)+i1s(i) * nint(ts(i,j)*12)
  260            continue
                 do 280 i=1,3
                    do 270 k=1,2
                       m=iabs(is(k,i,j))
                       if(m.gt.0) i2(m)=i2(m)+i1s(i)*isign(1,is(k,i,j))
  270               continue
  280            continue
                 if (ido.eq.1) then
                     jcode=1
                     ifl = 0
                     do 290 i=1,3
                        if (i1s(i)+i2(i).ne.0) ifl = 1
  290                continue
                     if (ifl.eq.0) then
                         jcode1 = mod ( kl1(j) , 24 )
                         jcode2 = mod ( ( jcode1 + 12 ), 24 )
                         jcode = min0 ( jcode1 , jcode2 )
                         jcode = jcode + 1
                         if (jcode.le.1) jcode=jcode+12
                         ido=0
                     endif
                 endif
  300         continue
          endif
          if (lty.eq.1) return
          if (i1(1).eq.ih.and.i1(2).eq.kk.and.i1(3).eq.il) istd=1
      endif
c
      return
      end
c------------------------------------------------------------
      function rhof(p,jh,jk,jl)
      dimension p(6)
c
      rho2=p(1)*float(jh*jh)+p(2)*float(jk*jk)
     1 +p(3)*float(jl*jl)+p(4)*float(jh*jk)
     2 +p(5)*float(jh*jl)+p(6)*float(jk*jl)
      rhof=sqrt(rho2)
      return
      end
c------------------------------------------------------------
      subroutine getfrg(line,lenp,dire,diret,ic,icmax,ier)
      character*(*) line,dire,diret
      character blank,digit*12,card(100)*80
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /chara/ blank,digit,card
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
      dimension vet(40),ivet(40)
      dimension xo(11),xn(11),key(10),newvet(48,3)
c
      ier=0
      n=0
      do 10 i=1,10
   10 n=n+nag(i)
      nn=n
      if (lenp.gt.0) go to 105
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 9000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
  105 call cutst(line,lenp,dire,lend)
      call lcase(dire)
      if (lenp.le.0.and.lend.le.2) go to 8000
      if (lend.gt.2) go to 7000
      n=n+1
      read(dire(1:2),'(a2)') nz(n)
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 8000
      if (iv.ne.3.and.iv.ne.4) go to 8000
      do 120 i=1,iv
  120 x(i,n)=vet(i)
      if (iv.eq.3) then
                     xo(1)=x(1,n)
                     xo(2)=x(2,n)
                     xo(3)=x(3,n)
                     iser=n
                     iactn=1
                     khead=0
                     ksp=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
                     x(4,n)=1.0/float(key(10))
                   endif
      x(5,n)=x(4,n)
      go to 100
 7000 continue
      nag(ngp)=n-nn
      line=diret
      return
 8000 continue
      ier=-1
      return
 9000 continue
      nag(ngp)=n-nn
      ier=1
      return
      end
c------------------------------------------------------------
      subroutine getfrgf(line,lenp,dire,diret,ier)
      character * 200 Msg
      common /msgerr/ Msg
      character*(*) line,dire,diret
      character blank,digit*12,card(100)*80
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /chara/ blank,digit,card
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
      dimension vet(40),ivet(40)
      dimension xo(11),xn(11),key(10),newvet(48,3)
      character*256 fname
c
      fname=line
      ier=0
      nline=0
      n=0
      do 10 i=1,10
   10 n=n+nag(i)
      nn=n
      itype=2
      iform=1
      if (jopen(kform,fname,nlen,itype,iform,ios)
     *                          .lt.0) go to 9500
  100 read(kform,'(a)',end=7000,err=8000) line
      nline=nline+1
      call shift(line,nline)
      diret=line
  105 call cutst(line,lenp,dire,lend)
      call lcase(dire)
      if (lenp.le.0.and.lend.le.2) go to 8000
      n=n+1
      read(dire(1:2),'(a2)') nz(n)
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 8000
      if (iv.ne.3.and.iv.ne.4) go to 8000
      do 120 i=1,iv
  120 x(i,n)=vet(i)
      if (iv.eq.3) then
                     xo(1)=x(1,n)
                     xo(2)=x(2,n)
                     xo(3)=x(3,n)
                     iser=n
                     iactn=1
                     khead=0
                     ksp=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
                     x(4,n)=1.0/float(key(10))
                   endif
      x(5,n)=x(4,n)
      go to 100
 7000 continue
      close(kform)
      nag(ngp)=n-nn
      line(1:9)='continue '
      return
 8000 continue
c     write(lo,8500) ios,nline,fname
      write(Msg,8505) ios,nline,fname(1:Lung(fname))
      call screrr(ier,Msg,1)
 8500 format(' *** error ***  read error, code =',i5,
     *       ' line number ',i5,'  File is ',a)
 8505 format(' Read error, code =',i5,
     *       ' line number ',i5,'  File is ',a)
      ier=-1
      close(kform)
      return
 9500 continue
      write(Msg,9015) ios,fname(1:Lung(fname))
      call screrr(ier,Msg,1)
 9010 format(' *** error ***  open error, code =',i5,' file is ',a)
 9015 format(' Open error, code =',i5,' file is ',a)
      ier=-1
      return
      end
c-----------------------------------------------------------------------
      subroutine getcon(line,dire,nw,nalf,ier)
      character*(*) line,dire
      dimension nalf(8),nw(8),vet(40),ivet(40)
c
      ier=0
      do 150 i=1,8
      call cutst(line,lenp,dire,lend)
      if (lenp.le.0) go to 300
      ier=ier+1
      read(dire,'(a2)') nalf(i)
      iopt=1
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 300
      nw(i)=ivet(1)
      call cutst(line,lenp,dire,lend)
      if (lenp.le.0) go to 200
  150 continue
  200 continue
      return
  300 continue
      ier=-1
      return
      end
c-----------------------------------------------------------------------
      subroutine getsfac(line,dire,ic,icmax,ipdir,card,ier)
      common /sfact/ nSfCard, sfacm(8, 9), kSfac(8)
      character*(*) line,dire,card(*)
c
      
      call cutst(line,lenp,dire,lend)
      if (lenp.le.0) go to 300
      nSfCard = nSfCard + 1
      n = 0
      if (lend .gt. 2) then
         lend = 2
      end if
      read(dire(1:2),'(a2)') kSfac(nSfCard)
   10 call cutst(line,lenp,dire,lend)
      if (lend.gt.0) then
         if (dire(1:1) .eq. '=') then
            ic=ic+1
            if (ic.gt.icmax) then
               ier = 0
               return
            end if
            ipdir=ipdir+1
            line=card(ipdir)
         else
            n = n + 1
            sfacm(nSfCard, n) = Valore(dire)               
         end if
         if (n .lt. 9) then
            goto 10
         end if
      end if
c ---
  200 continue
      ier = n
      return
  300 continue
      ier=-1
      return
      end
c-----------------------------------------------------------------------
      subroutine onebl(string,lenstr,ier)
      character blank,string*(*),buff*120,poss*22
      dimension in(7)
c
      ier=0
      poss='pabcifrmabcnd-123456/ '
      blank=poss(22:22)
      k=len(string)
      if (lenstr.eq.0) then
          lunghezza = k
      else
          lunghezza = 16
      endif
c
c-- check the number of blanks between items in space
c-- group symbol ( max one blank allowed )
c
      buff = ' '
      ic=0
      j=1
      do 10 i=1,k
         if (string(i:i).ne.blank) then
             buff(j:j)=string(i:i)
             j=j+1
             if (j.gt.lunghezza) go to 15
             ic=0
         else
             if (ic.eq.0) then
                 ic=ic+1
                 buff(j:j)=string(i:i)
                 j=j+1
                 if (j.gt.lunghezza) go to 15
             endif
         endif
   10 continue
   15 do 20 i=1,lunghezza
   20 string(i:i)=buff(i:i)
      if (lenstr.eq.0) then
          lenstr = Lung(string)
          return
      endif
c
c-- now check the correctness of the space group symbol
c
c     poss='pabcifrmabcnd-123456/ '
c                  123456789012345
c-- ifoll = possible following character
c         = 0   initial state ( actual char = blank )
c         = 1   only numbers < 7 ( not 5 )
c         = 2   only numbers < actual number or / or blank
c         = 3   only letters
c         = 4   only blank
      if (string(2:2).ne.blank) go to 800
      n=0
      k=0
      iz=0
      nbr=0
      do 99 i=1,7
      in(i)=0
  99  if (string(1:1).eq.poss(i:i)) nbr=i
      if(nbr.eq.0) go to 800
      do 100 i=2,lenstr
      if(string(i:i).ne.blank) go to 101
      minus=1
      num=0
      ifoll=0
      k=k+1
      go to 100
 101  m=0
      do 102 j=1,14
 102  if(string(i:i).eq.poss(j+7:j+7)) m=j
      if(m.eq.0.or.k.gt.3) go to 800
c     poss='pabcifrmabcnd-123456/ '
c                  123456789012345
           if (m.ge.1.and.m.le.6.and.ifoll.eq.3) then
                                        ifoll=4
      else if (m.ge.1.and.m.le.6.and.ifoll.eq.0) then
                                        ifoll=4
      else if (m.eq.7.and.ifoll.eq.0) then
                                        ifoll=1
                                        minus=-1
                                        num=num+1
      else if (m.ge.8.and.m.le.13.and.ifoll.le.1) then
                                        ifoll=2
                                        iold=m-7
                                        if (iold.eq.5) go to 800
                                        num=num+1
                                        if (num.gt.2) go to 800
      else if (m.ge.8.and.m.le.13.and.ifoll.eq.2) then
                                        inew=m-7
                                        if (inew.ge.iold) go to 800
                                        num=num+1
                                        if (num.gt.2) go to 800
                                        ifoll=2
      else if (m.eq.14.and.ifoll.eq.2) then
                                        ifoll=3
                                      else
                                        go to 800
                                      endif
 100  continue
      if (minus.lt.0.and.num.eq.1) go to 800
c
c-- space group symbol ok
c
      return
c
c-- error
c
  800 continue
      ier=-1
      return
      end
c------------------------------------------------------------
      subroutine unobs(kv,ibrav,klatt,ksym,vsym)
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /buffer/ vet(6,85),nrpb,idumb(4)
      common /xdata/ ibig(500000)
      common /genob/ irho
c---
c  if ibig dimension has to be changed, alter mxbg accordingly
      integer vsym(24),ibrav(6,13)
      integer  hmin,hmax,kmin,kmax,lmin,lmax
      dimension ivet(6,85),kv(3)
      equivalence (vet(1,1),ivet(1,1))
c---
      nitem=6
      mxbg=500000
      rhomax1=rhomax
      if (irho.lt.0) then
                       lty=0
                     else
                       lty=0
                     endif
c
c-- at this point the allowed reflections are on the scratch file(iscra)
c-- it is possible to add (optionally)  unobserved reflections
c
      nrec=nref/nrpb
      if (mod(nref,nrpb).gt.0) nrec=nrec+1
c
c-- ibig has been already filled with observed reflections
c
      nru=0
      nr=nref
c --
c --
      nnn=nrec
      i=mod(nref,nrpb)
      if (i.eq.0) then
         nnn=nnn+1
      else
        read(iscra,rec=nnn) ((vet(j1,j2),j1=1,nitem),j2=1,nrpb)
      endif
c--------------------
      call indmm(hmin,hmax,kmin,kmax,lmin,lmax)
c---------------------------------------------------------------
      nhmax=hmin
      nkmax=kmin
      nlmax=lmin
c-------------
      call scrper(' Checking for unobserved reflexions ',0,0)
      nnnn = (hmax-hmin+1) * (kmax-kmin+1) * (lmax-lmin+1)
      nperc=100
      iperc0=nnnn/nperc
      iperc=iperc0
      jperc=0
      nrr = 0
      do  800 indh=hmin,hmax
      do  700 indk=kmin,kmax
      do  600 indl=lmin,lmax
      nrr = nrr + 1
      if (nrr.eq.iperc) then
          jperc=jperc+1
          iperc=iperc+iperc0
          call scrper(' ',jperc,nperc)
      endif
      if (indh.eq.0.and.indk.eq.0.and.indl.eq.0) go to 600
c---
c---  vedere se il nuovo riflesso generato e' equivalente
c---  ad uno gia' considerato, in questo caso :
c---
c
c    TRIGONALE : va' considerata la condizione aggiuntiva /h/>/k/
c                nel caso (+-+)
c
      if (lsys.eq.5.and.indk.lt.0.
     *and.iabs(indh).lt.iabs(indk)) goto 600
c
c    CUBICO :  va' considerata la condizione aggiuntiva h<=k<=l
c
      if(lsys.eq.6.and.(indk.lt.indh.and.indk.gt.indl)) goto 600
c
      indh1=indh
      indk1=indk
      indl1=indl
Corig inbl=indh1*kv(1) + indk1*kv(2) + indl1 + kv(3)
      inbl=indh1*kv(1) + indk1*kv(2) + indl1
      inbl=iabs(inbl)
      if (ibig(inbl).ne.0) go to 600
      call extin(jex,indh1,indk1,indl1,ibrav,klatt,ksym,vsym)
      if (jex.ne.1) then
      call geneq(lty,indh1,indk1,indl1,idelt,jcode,isgnn,id1,rho)
      if (rho.gt.rhomax1) go to 600
      if (iabs(indh1).gt.ihx(1).
     * or.iabs(indk1).gt.ihx(2).
     * or.iabs(indl1).gt.ihx(3))
     *                           go to 600
Corig inbl=indh1*kv(1) + indk1*kv(2) + indl1 + kv(3)
      inbl=indh1*kv(1) + indk1*kv(2) + indl1
      inbl=iabs(inbl)
      if (ibig(inbl).ne.0) go to 600
c
c-- fill ibig using unobserved reflection and its equivalents
c
      ibig(inbl)=-10
c
      nru=nru+1
      if (irho.ge.0) then
                       i=i+1
                       ivet(1,i)=indh1
                       ivet(2,i)=indk1
                       ivet(3,i)=indl1
                       vet(4,i)=0.0
c
c -- sigma field set to -1 for generated reflection
c
                       vet(5,i)=-1.0
                       ivet(6,i)=jcode
                       nr=nr+1
                       if(i.eq.nrpb)then
                                      write(iscra,rec=nnn)
     *                              ((vet(j1,j2),j1=1,nitem),j2=1,nrpb)
                                      i=0
                                      nnn=nnn+1
                                    endif
                     endif
                    endif
  600 continue
  700 continue
  800 continue
c
      if (irho.ge.0) then
                      if (i.gt.0) write(iscra,rec=nnn)
     *                ((vet(j1,j2),j1=1,nitem),j2=1,nrpb)
                      nref=nr
                      if (nru.gt.0) write(lo,310) nru
                    else
                      if (nru.gt.0) write(lo,320) nru
                    endif
  310 format(10x,i5,'  reflections (not in input data) have been added')
  320 format(10x,i5,'  reflections are not in input data')
      rhomax=rhomax1
      call scrper(' ',0,-1)
      return
      end
c-----------------------------------------------------------------------
      subroutine indmm(hmin,hmax,kmin,kmax,lmin,lmax)
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
      integer  hmin,hmax,kmin,kmax,lmin,lmax
      character ntc*16
c
      write(ntc,'(16a1)') nt
c --
c --   calcolo hmin e hmax , kmin e kmax , lmin e lmax
c --
        hmin=-ihx(1)
        hmax=ihx(1)
        kmin=-ihx(2)
        kmax=ihx(2)
        lmin=-ihx(3)
        lmax=ihx(3)
c --
c -- TRICLINO
c --
      if (lsys.eq.1) then
        hmin=0
c --
c -- MONOCLINO
c --
      else if (lsys.eq.2) then
       if (ntc(3:3).eq.'1') then
        if (ntc(5:5).eq.'1') then
c -- 2//c
            hmin=0
            lmin=0
        else
c -- 2//b
            hmin=0
            kmin=0
        endif
       else
        if (ntc(4:4).eq.'1') then
         if (ntc(6:6).eq.'1') then
c -- 2//a
            hmin=0
            kmin=0
         else
c -- 2//b
            hmin=0
            kmin=0
         endif
        else
         if(ntc(5:5).eq.'1') then
c -- 2//a
            kmin=0
            hmin=0
         else
c -- 2//b
            hmin=0
            kmin=0
         endif
        endif
       endif
c --
c -- ORTOROMBICO
c --
      else if (lsys.eq.3) then
          hmin=0
          kmin=0
          lmin=0
c --
c -- TETRAGONALE :
c --
      else if (lsys.eq.4) then
          hmin=0
          kmin=0
          lmin=0
c --
c -- ESAGONALE E TRIGONALE :
c --
      else if (lsys.eq.5) then
            hmin=0
            lmin=0
c --
c -- CUBICO :  va' considerata la condizione aggiuntiva h<=k<=l
c --
      else if (lsys.eq.6) then
           hmin=0
           kmin=0
           lmin=0
      endif
c --
      return
      end
c------------------------------------------------------------
      subroutine caosm(ier)
c
c-- Caos-Sir link routine
c
      character cff
c   implementation  common
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
c     erlangen
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common / ureq1/ jpatt,jpunt(1501),ksacc,jseteq,jumpp,jmpsie,nsec
c     symmetry
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
c     scratch file reflexion arrays
      common /buffer/ vet(6,85) ,nrpb,idumb(4)
c     atomic scattering factors
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
c     miscellaneous
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
c     wilson plot parameters
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
c     sin/cos table & trigonometric constants
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      character *80 name
c
      write(cff,'(i1)') kff
      write(lo,100) cff,itle
  100 format(///,a1,120('+'),//,
     1 39h SIR97 : Caos-Sir link routine         ,68x,14hRelease  97.01
     2 ,//,20x,20a4,/,1h ,120('+'),//,
     *       40x,'                                 ',//)
c
c-- open the scratch file
      itype=1
      iform=2
      kop=kopen(iscra,name,nlen,itype,ierr)
c-- read directives
      call dircao(ier)
      if (ier.lt.0) go to 900
c-- load in memory lists 1-2-3 and transfer in iscra reflections
      call caos(ier)
      if (ier.lt.0) go to 900
      anat=float(nat)/(pts*float((icent+1)*nsym))
      aa=s3s2*s3s2*pts
c  s3s2p is related to the number of atoms in the primitive cell
      s3s2p=aa*sqrt(1.0/aa)
      s3s2=s3s2p
      is3s2=1./(s3s2p*s3s2p)+0.5
      write(lo,200) anat,is3s2
  200 format(/,39x,'number of atoms in asymmetric unit =',f6.2,/,
     1 31x,'equivalent number of equal atoms in primitive cell =',i6)
c
c-- calculate number of reflexions for (sem)invariant searching
      mn = int(4.0*anat+100.5)
      if (icent.eq.1) mn = mn + 50
      if (nsym.eq.1) mn = mn + 50
      mn = min0(mn,499)
      mm=mn+min0(499-mn,100)/2
c-- create list 7 ( e's )
      npseud=0
      iy=67543
      if (nref.gt.0) call prepl7(npseud,iy)
c-- finish
      call xdump
  900 close(iscra)
      return
      end
c-----------------------------------------------------------------------
      subroutine caos(ier)
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /buffer/ vet(6,85) ,nrpb,idumb(4)
      dimension ivet(6,85),vat(12),ivat(12)
      equivalence (vat(1)  ,ivat(1)  )
      equivalence (vet(1,1),ivet(1,1))
c
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c-- already exists a direct access file containing
c-- information concerning the structure
c
      iln=1
      call srlin (iln,lsn,lix1,ljxx,lkxx,llxx)
      if(lix1.gt.0) then
                       call yfl01
                     else
                       write(lo,1100)
                       ier=-1
                     endif
      iln=2
      call srlin (iln,lsn,lix2,ljxx,lkxx,llxx)
      if(lix2.gt.0) then
                      call yfl02
                     else
                       write(lo,1200)
                       ier=-1
                     endif
      iln=3
      call srlin (iln,lsn,lix3,ljxx,lkxx,llxx)
      if(lix3.gt.0) then
                      call yfl03
                     else
                       write(lo,1300)
                       ier=-1
                     endif
 1100 format(/,' *** error *** no cell parameters supplied')
 1200 format(/,' *** error *** no space group symbol supplied')
 1300 format(/,' *** error *** no cell content supplied')
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      if (ier.lt.0) return
c
c  assign values to constants in preamble of list 7
c
      bt=0.0
      sc=-99.9
c
c  s3s2p is related to the number of atoms in the primitive cell
c
      s3=0
      s2=0
      do 1400 i=1,nk
         ss=float(nw(i))*no(i)*no(i)
         s2=s2+ss
         s3=s3+ss*no(i)
 1400 continue
      s3s2=s3/sqrt(s2**3)
c
      nref=0
      rhm=0.0
      do 1500 i=1,3
 1500 ihx(i)=-100
c
c-- read reflections from list 6
c
      iln=6
      call srlin (iln,lsn,lixx,ljxx,lkxx,llxx)
      if (lixx.le.0) then
                       write(lo,1510) iln
                       go to 8000
                     endif
 1510 format(' *** error ***  list number',i5,' not existent',/,
     *       '                reflections expected')
      in=0
      call yfl06(in,nref)
c
      fosog=-999.9
      rhomax=-999.9
      sig=1.0
      nnn=0
      nrec=0
      nrec=0
      nuobs=0
      nrmax=0
      rhm=-99.9
      do 1600 i=1,nref
      if (kkfnr(vat).lt.0) go to 9500
      rho=rhof(p,ivat(1),ivat(2),ivat(3))
      rho=rho*rho
      if (rho.gt.rhomax) rhomax=rho
      fo=vat(4)
      eeee=vat(6)
c-    ifasi=mod(ivat(7),2**15)
      if (fo.gt.fosog) fosog=fo
      if(vat(7).lt.0.0) vat(7)=vat(7)+360.0
      iphy=int(vat(7)+0.05)
      call geneq(1,ivat(1),ivat(2),ivat(3),idelt,jcode,isgnn,id1,rho)
      if (rho.gt.rhm) rhm=rho
      nnn=nnn+1
      iphy=iphy*32+jcode
c      WRITE(LO,*)I,NNN,IVAT(1),IVAT(2),IVAT(3)
      ivet(1,nnn)=ivat(1)
      ivet(2,nnn)=ivat(2)
      ivet(3,nnn)=ivat(3)
      if (fo.gt.fosog) fosog=fo
      vet(4,nnn)=fo
      vet(5,nnn)=vat(5)
      ivet(6,nnn)=iphy
      if (nnn.ge.nrpb) then
                           nrec=nrec+1
                           write(iscra,rec=nrec)
     *                          ((vet(j1,j2),j1=1,6),j2=1,nrpb)
                           nnn=0
                         endif
 1600 continue
      nrec=nrec+1
      write(iscra,rec=nrec) ((vet(j1,j2),j1=1,6),j2=1,nrpb)
c
c-- at this point the allowed reflections are on the scratch file(iscra)
c
 8000 continue
      write(lo,1700) nref,ihx,rhm
 1700 format(  10x,i5, '  independent input reflections',
     *       /, 3x,3i4,'  maximum  h,k,l  values',
     *       /,8x,f7.4,'  maximum s**2 = (sin(theta)/lambda)**2')
      rhomax=rhm
      return
c
 9500 write(lo,9510) iln
 9510 format(' *** error ***  problems in list number',i5)
      ier=-1
      return
      end
c-----------------------------------------------------------------------
      subroutine dircao(ier)
      character line*80,dire*80,diret*80
      character blank,digit*12,card(100)*80
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /chara/ blank,digit,card
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
c
      dimension vet(40),ivet(40)
c
c-- set default values
      knw=0
      iffsq=1
      iprin=0
      ishif=0
      jump=-1
      jtran=0
      jpart=0
      bt=0.0
      sc=-99.9
      knw=0
      mm=0
      mz=100
      th=1.0
      rhomin=0.0
      en=1.2
      er=0.3
      ngp=0
      llpse=0
      npc=1
c
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 9000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
c-- directives with numeric parameters
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 8000
      if (dire(1:4).eq.'know') then
          if (iv.ne.0) go to 8000
          knw=1
          go to 100
          endif
      write(lo,6000) diret
 6000 format(' wrong directive on following line:',/a)
      go to 100
 8000 continue
      ier=-1
      write(lo,'(22h error in directive : ,a80)') diret
      return
 9000 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine ti1983(nt)
c
c-- This subroutine is used to convert the input string in
c-- lower case and to convert the notation used in
c-- International Table (1983) into the notation used in
c-- International Table (1974).
c
      integer nt(16)
      character*16 mt
c
      write(mt,'(16a1)')(nt(i),i=1,16)
c     write(6 ,'(16a1)')(nt(i),i=1,16)
      do 10 i=1,16
      j=ichar(mt(i:i))
      if (j.ge.65.and.j.le.90) j=j+32
   10 mt(i:i)=char(j)
      if(mt(5:6).eq.'-3') mt=mt(1:4)//'3'//mt(7:16)//' '
      read(mt,'(16a1)')(nt(i),i=1,16)
c     write(6 ,'(16a1)')(nt(i),i=1,16)
      return
      end
c---------------------------------------------------------------------
code for upd03
      subroutine upd03
c--update list 3, ( for neutron data )
c
c  l3  location of the information for the first form factor
c  n3  number of form factors
c
c--
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common /neutro/ neutro,neuwei,vetint(500),nsyn
      common/xlimi/ nfl,idummy(5),nfls
      common /data/ store(30000)
      dimension  istore(30000)
      dimension vet(8),ivet(8),nwn(8),non(8),rad1(8),rad2(8)
      equivalence(store,istore)
c--
      nfl=nfls
      call sldl(3,ly,l3g,lz)
      n3=     store(l3g+5)
      l3=     store(l3g+6) +l3g
      md3=    store(l3g+7)
      l=lz-1
      call xsac(3,ly,li,l)
c
c-- sort values respect to neutron scattering factor
c
      m3=l3
      do 500 i=1,n3
      ivet(i)=i
      vet (i)=abs(bs(1,i))
      rad1(i)=store(m3+15)
      m3=m3+md3
  500 continue
      n=n3
      call sortco (vet,ivet,n)
      do 600 i=1,n3
      j=ivet(i)
      ivet(i)=nalf(j)
      nwn(i)=nw(j)
      non(i)=no(j)
      vet(i)=bs(1,j)
      rad2(i)=rad1(j)
  600 continue
      do 700 i=1,n3
      nalf(i)=ivet(i)
      nw  (i)=nwn(i)
      no  (i)=non(i)
      bs(1,i)=vet(i)
  700 continue
      nk=n3
      m3=l3
cel--------
cel  controllare se con i neutroni da' qualche errore
      nat=0
cel------------------------------------
      do 1000 i=1,n3
      istore(m3   )=nalf(i)
       store(m3+12)=nw(i)
       store(m3+13)=no(i)
       store(m3 +2) = 0.0
      m3i=m3+3
      do 1100 j=1,4
      store(m3i  ) = 0.0
      if (j.eq.1) then
                    store(m3i+1) = bs(1,i)
                  else
                    store(m3i+1) = 0.0
                  endif
      m3i=m3i+2
1100  continue
      store(m3+15)=rad2(i)
      m3=m3+md3
1000  continue
      lz=12+1+n3*md3
      n=lz-nfl
      call sfrml(3,n)
      return
      end
cel------------------------------------------------------------
cel  riordina i fattori di scattering degli elettroni
cel------------------------------------------------------------
code for upd03ele
      subroutine upd03ele
c--update list 3, ( for electron data )
c
c  l3  location of the information for the first form factor
c  n3  number of form factors
c
c--
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common /neutro/ neutro,neuwei,vetint(500),nsyn
      common /elettroni/ lproj, zeff(8), rminimo, kminimo, kaminimo
      common/xlimi/ nfl,idummy(5),nfls
      common /data/ store(30000)
      dimension  istore(30000)
      dimension vet(8),ivet(8),nwn(8),non(8),rad1(8),rad2(8)
      dimension facZ(8),vetal(4,8),vetbs(4,8)
      equivalence(store,istore)
c--
      nfl=nfls
      call sldl(3,ly,l3g,lz)
      n3=     store(l3g+5)
      l3=     store(l3g+6) +l3g
      md3=    store(l3g+7)
      l=lz-1
      call xsac(3,ly,li,l)
c
c-- sort values respect to electron scattering factor
c
      m3=l3
      do 500 i=1,n3
         ivet(i)=i
         vet (i)=abs(zeff(i))
         rad1(i)=store(m3+15)
         m3=m3+md3
  500 continue
      n=n3
      call sortco (vet,ivet,n)
      do 700 i=1,n3
         j=ivet(i)
         facZ(i)=zeff(j)
         ivet(i)=nalf(j)
         nwn(i)=nw(j)
         non(i)=no(j)
         do 600 l=1,4
            vetal(l,i)=al(l,j)
            vetbs(l,i)=bs(l,j)
  600    continue
         rad2(i)=rad1(j)
  700 continue
      do 900 i=1,n3
         nalf(i)=ivet(i)
         nw  (i)=nwn(i)
         no  (i)=non(i)
         do 800 l=1,4
            al(l,i)=vetal(l,i)
            bs(l,i)=vetbs(l,i)
  800    continue
  900 continue
      nk=n3
      m3=l3
      do 1100 i=1,n3
         istore(m3   )=nalf(i)
         store(m3+12)=nw(i)
         store(m3+13)=no(i)
         store(m3 +2) = 0.0
         m3i=m3+3
         do 1000 j=1,4
            store(m3i  ) = al(j,i)
            store(m3i+1) = bs(j,i)
            m3i=m3i+2
 1000    continue
         store(m3+15)=rad2(i)
         store(m3+21)=facZ(i)
         m3=m3+md3
 1100 continue
      lz=12+1+n3*md3
      n=lz-nfl
      call sfrml(3,n)
      return
      end
c---------------------------------------------------------------------
cel---------------------------------------------------------------
cel     subroutine per il calcolo di Z effettiva in base al quale 
cel     si ordinano i fattori di scattering degli elettroni
      subroutine zeffettivo
c  
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomi
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common /elettroni/ lproj, zeff(8), rminimo, kminimo, kaminimo
      common /buffer/ vet(6,85) ,nrpb,idumb(4)
      dimension ivet(6,85)
      dimension jkl(3)
      dimension sr(30),nsum(30)
      equivalence (vet(1,1),ivet(1,1))
c---
      nb=8.0*alog10(0.05*float(max0(nref,100))+0.5)
      if(nb.gt.30) nb=30
      nrec=nref/nrpb
      if (mod(nref,nrpb).gt.0) nrec=nrec+1
      ifin=nb
      do 100 i=1,nk
        zeff(i)=0.
  100 continue
      do 150 i=1,nb
         nsum(i) = 0
         sr  (i) = 0
  150 continue
      rr=float(ifin)/rhomax
      nr=0
      do 200 nnn=1,nrec
         read(iscra,rec=nnn) ((vet(j1,j2),j1=1,6),j2=1,nrpb)
         do 200 i=1,nrpb
            nr=nr+1
            if (nr.gt.nref) go to 300
            jkl(1)=ivet(1,i)
            jkl(2)=ivet(2,i)
            jkl(3)=ivet(3,i)
            rho=rhof(p,jkl(1),jkl(2),jkl(3))
            rho=rho*rho
c-- semplifico il calcolo considerando generali tutti i riflessi
            mult=1
c
            tmul=float(mult)
c-- n stores range of rho
            n=min0(int(1.0+rr*rho),ifin)
            nsum(n)=nsum(n)+mult
            sr  (n)=sr  (n)+rho*tmul
  200 continue
  300 continue
      do 600 nnn=1,nb
         percroc=float(nsum(nnn))/float(nref)
         do 500 j=1,nk
            fzr=0.
            do 400 i=1,4
               bstroc=bs(i,j)*(sr(nnn)/nsum(nnn))
               if(bstroc.le.60.)  fzr=fzr+al(i,j)*exp(-bstroc)
  400       continue
c-- test con f
            zeff(j)=zeff(j)+fzr*percroc
c-- test con f**2
c           zeff(j)=zeff(j)+fzr*fzr*percroc
  500    continue
  600 continue
      return
      end
c----------------------------------------------------------------------
      subroutine Change03
c
c--update list 3, ( for SFAC & ANOMALOUS )
c
      common /anomalous/ nAnom,kfpfs(8),fpfs(2,8)
      common /sfact/ nSfCard, sfacm(8, 9), kSfac(8)
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common /neutro/ neutro,neuwei,vetint(500),nsyn
      common/xlimi/ nfl,idummy(5),nfls
      common /data/ store(30000)
      dimension  istore(30000)
      equivalence(store,istore)
c
      nfl=nfls
      call sldl(3,ly,l3g,lz)
      n3=     store(l3g+5)
      l3=     store(l3g+6) +l3g
      md3=    store(l3g+7)
      l=lz-1
      call xsac(3,ly,li,l)
c    f'  e' in  store(m3+1)                                              
c    f'' e' in  store(m3+11)
c
c
      do 100 i=1,nAnom
         m3 = l3 + (kfpfs(i)-1) * md3
         store(m3+1 ) = fpfs(1,i)
         store(m3+11) = fpfs(2,i)
  100 continue
      do 300 i=1,nSfCard
         m3 = l3 + (ksfac(i)-1) * md3
         store(m3+2) = sfacm(i,9)
         m3i = m3 + 3
c
         do 200 j=1,8
            store(m3i) = sfacm(i,j)
            m3i = m3i + 1
  200    continue
  300 continue
      nfl = l3g
      call sfrml(3,lz)
      call xdump
c
      return
      end
