      subroutine lsqmain(ier)
      character cff
c
      character blank,digit*12,card(100)*80
      common /chara/ blank,digit,card
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks 
      common /atoms/ xyz(5,500),icvet(500),idumx(21)
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isn(2,3,24),tsn(3,24),nnsym,pts,ksys,ncent,latt,s3s2,
     *          emme,s3s2p
      common /ureq1/ jpatt,jpunt(1501),ksacc,jseteq,jumpp,jmpsie,nsec
      common /lsql/ nAddComm,iPdire,icomatB,ipcomB,iFFour,amult,BLimit
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
c
      write(cff,'(i1)') kff
      write(lo,10) cff,itle
   10 format(///,a1 ,78('+'),//,
     1 39h Least-Squares Routine                 ,26x,14hRelease  97.01
     2 ,//,1h ,20a4,/,1h ,78('+'),//)
c++++++
      idi=0
      call dirlsq(ier,inn,idi)
      if (ier.lt.0) return
c--
      if(jh.eq.0) then 
        call scrper(' Scale computing',0,0)
      else 
        call scrper(' Start refining ',0,0)
      end if
3805  continue
      if(kmnqd(inn)) 3820,3810,3810
3810  continue
      if(jsolv(inn,BLimit)) 3820,3805,3805
3820  continue
      write(lo,3830)
3830  format(/,1h ,78('+'),//)
      return
      end
c----------------------------------------------------------------------
      subroutine dirlsq(ier,in,idi)
c--prepare lists for s.f. calculation and least-squares calc.
c  ier = error code
c  in  = 0 input reflections from disc  
c        1 reflections from store(lxxe)
c  idi = 0 normal input directives
c        1 no input directives
c
      character*200 Msg
      common /msgerr/ Msg
      character line*80,dire*80,diret*80
      character blank,digit*12,card(100)*80
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /chara/ blank,digit,card
      common /tran/ scale,mh(3),level,it4,xlim(3),kmap
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /sdir/ dm,npc,nproj,nojoin
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,kflag
      common /ureq1/ jpatt,jpunt(1501),ksacc,jseteq,jumpp,jmpsie,nsec
      common /lsql/ nAddComm,iPdire,icomatB,ipcomB,iFFour,amult,BLimit
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *         kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,nncwu
      dimension vet(40),ivet(40)
c--
      common/ylimi/nfl,lfl,nlx,idumy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/xtemp/itemp(80)                                            
      dimension temp(80)                                                 
      equivalence(itemp,temp)                                           
      common/xfour/ iverb,num,ipat,ifrag,ianom,ianomx,ipdb,iauto,irefi
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s            
      common/lst02/icx,ilx,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,    
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i               
      common/lst04/iw4,l4,m4,n4                                         
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o                        
     2 ,n5g,l5d,n5d,md5c,l5ori 
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common/lst12/l12,m12,md12,n12,isca,ibm,nbl12,idra,idrb,l12d,n12d
c
      common /xdata/ store(500000)
      dimension istore(500000)
      equivalence(store,istore)
      dimension imax(3),ixx(3),imin(3)
      data jhatom/2hh /
c
c--define variable caos
      ier=0
      nfl=1
      lfl=500000
      istat2=0
      ncru=ln
      ncwu=lo
      kk3=128
      kk2=128*kk3
      kk1=128*kk2
      ifile=10000
      ilist=11000
      iend= 11111
      ifine=-11111
      infle=240
      icfle=-1
      BLimit=99999.0 
c 
c--input directives:
c--read down the lists       
      call xfl01
      call xfl02
      call xfl03
c--check if a list 5 exists
      call srlin(5,li,lj,lk,ll,lm)
      if(lj) 1112,1112,1122
1112  continue
      call frm05
1122  continue
      call xfl05
c--check if a list 6 exists
      call srlin(6,li,lj,lk,ll,lm)
      if(lj) 1113,1113,1123
1113  continue
      call crea6
      if (ier.lt.0) return
1123  continue
      call xfl06
      l6a=l6d
c--check if a list 4 exists
      call srlin(4,li,lj,lk,ll,lm)
      if(lj) 1111,1111,1121
1111  continue
      ix=2
      idef=0
      call sc04(ix,idef)
1121  continue
      call xfl04
c--link list 5 and 3
      n3=kst53(in)+1
c--check if a list 12 exists
      call srlin(12,li,lj,lk,ll,lm)
      if(lj) 1110,1110,1120
1110  continue
       ix=1
       if(icrea12(ix))9000,1120,1120
1120  continue
      jrd12=0
c-- set default values
      k=0
c--default : refine
c  code    jb =  0
c          jh = -1
c          je =  0
c-----------------
      jb=0
      jh=-1
      je=0
      iverb=0
      iauto=1
      if(idi.eq.1) then
        jb=-1
        iverb=-1
        iauto=0
      end if
      jm=-1
      jg=-1
      ji=20
      jl=0
      z=1.0
      y=1.0
      x=1.0
      igr=0
      ifrag=0
      ianom=0
      ianomx=0
      ipdb=0
      ipat=0
      jchop=0
      num=1
      jhy=0
      iflag=0
      iandir=0
      isodir=0
      if(idi.eq.1) goto 8000 
c
      write(lo,80)
   80 format(' Used directives:',/)
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
c      write(*,*)'ic,icmax,ipdir',ic,icmax,ipdir
      if (ic.gt.icmax) go to 8000
      ipdir=ipdir+1
      line=card(ipdir)
      call shift(line,ldiret)
      diret=line
      if (iflag.eq.0) then
          write(lo,110) diret(1:ldiret)
  110     format(2x,a)
      end if
      iflag=0
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
      if (dire(1:3).eq.'end') goto 100
      if (dire(1:4).eq.'anom') then
          call cutst(line,lenp,dire,lend)
          if(lend.le.0) then
           je=0
           goto 100
          end if
          if(dire(1:2).eq.'on') then
            je=0
            goto 100
          end if
          if(dire(1:2).eq.'of') then
            je=-1
            goto 100
          end if
          goto 9000
      endif
      if (dire(1:4).eq.'anis') then
c--sir card to caos image
          do 120 i=1,80
  120     image(i)=ib
          call lcase(diret)
          read(diret,'(80a1)') (image(i),i=1,ldiret) 
          nc=1
          if(jrca(itemp,n)) 6000,1022,6000
1022      continue
          i=0
          ii=0
          if(jfnd5(i,ii)) 3910,3910,6000
3910      continue
          m5=l5
          do 2140 i=1,n5
          if(jflg5(m5)) 2150,2150,2130
2130      continue
          if(istore(m5).eq.jhatom) goto 2150
          if(store(m5+10)) 2131,2131,2150
2131      continue
          iandir=1
          b=store(m5+5)
          l=m5+5
          lk=l+5
          ly=l1s
          do 2135 m=l,lk
          store(m)=b*store(ly)
          ly=ly+1
2135      continue
2150      continue
          m5=m5+md5
2140      continue
          call sclr5
          nnff=nfl ! (posizione di salvataggio)                  
          nfl=l5d
          call xfrml(5,n5d)
          nfl=nnff ! (ripristino il valore di nfl
          go to 100
      endif
      if (dire(1:3).eq.'iso') then
c--sir card to caos image
          do 103 i=1,80
103       image(i)=ib
          call lcase(diret)
          read(diret,'(80a1)') (image(i),i=1,ldiret) 
          nc=1
          if(jrca(itemp,n)) 6000,1033,6000
1033      continue
          i=0
          ii=0
	  if(jfnd5(i,ii)) 3960,3960,6000
3960      continue
          m5=l5
          do 2240 i=1,n5
          if(jflg5(m5)) 2250,2250,2230
2230      continue
          isodir=1
            if(store(m5+10).gt.0.0) then
	      store(m5+5)=4.0/3.0  *(store(m5+ 5)*store(l1m1  )
     1			            +store(m5+ 6)*store(l1m1+1)
     2			            +store(m5+ 7)*store(l1m1+2)
     3			            +store(m5+ 8)*store(l1m1+4)
     4			            +store(m5+ 9)*store(l1m1+5)
     5			            +store(m5+10)*store(l1m1+8))
            end if
          l=m5+6
          lk=l+4
          do 2235 m=l,lk
          store(m)=0.0
2235      continue
2250      continue
          m5=m5+md5
2240      continue
          call sclr5
          nnff=nfl ! (posizione di salvataggio)                  
          nfl=l5d
          call xfrml(5,n5d)
          nfl=nnff ! (ripristino il valore di nfl
          call xfl05
          go to 100
      endif
      if(dire(1:4).eq.'defa' .or.dire(1:4).eq.'full'.or.
     1   dire(1:4).eq.'diag'.or.dire(1:4).eq.'bloc') then
c          write(*,*)'prima',ic,icmax,ipdir
	  call sr12(iflag,ic,icmax)
	  jrd12=1
c          write(*,*)'dopo',ic,icmax,ipdir,iflag
          if(iflag) 2245,8000,100
2245      continue
          if(iflag.eq.-2) goto 9000
          iflag=0
          goto 100
      end if
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 9000
      if (dire(1:4).eq.'numb') then
          if (iv.ne.1) go to 9000
          num=ivet(1)
          go to 100
      endif
      if (dire(1:4).eq.'hydr') then
          if (iv.ne.0) go to 9000
          jhy=1
          go to 100
      endif
      if (dire(1:4).eq.'prin') then
          if (iv.ne.0) go to 9000
          jg=0
          go to 100
      endif
      if (dire(1:4).eq.'anom') then
          if (iv.ne.0) go to 9000
          je=0     
          go to 100
      endif
      if (dire(1:4).eq.'refi') then
          if (iv.ne.0) go to 9000
          jb=0
          jh=-1
          go to 100
      endif
      if (dire(1:4).eq.'scal') then
          if (iv.ne.0) go to 9000
          jh=0
          jb=-1
          go to 100
      endif
      if (dire(1:4).eq.'damp') then
          if (iv.ne.1) go to 9000
          z=vet(1)
          y=z
          go to 100
      endif
      if (dire(1:4).eq.'cycl') then
          if (iv.ne.1) go to 9000
          ji=ivet(1)
          iauto=0
          go to 100
      endif
      if (dire(1:4).eq.'verb') then
          if (iv.ne.1) go to 9000
          iverb=ivet(1)
          go to 100
      endif
      if (dire(1:4).eq.'cuto') then
          if (iv.ne.1) go to 9000
          xchop=vet(1)
          jchop=1
          go to 100
      endif
      if (dire(1:4).eq.'calc') then
          if (iv.ne.0) go to 9000
          jb=-1
          jh=-1
          go to 100
      endif
      if (dire(1:4).eq.'weig') then
          if (iv.eq.0) go to 9000
          iw=ivet(1)
          npar=0
          if(iv.gt.1)then
	    npar=ivet(2)
	    if(iv.lt.npar+2) goto 9000
            do i=1,npar
            temp(i)=vet(2+i)
            enddo
          end if
	  if(npar.eq.0) then
	    idef=0
	    call sc04(iw,idef)
            goto 100
          end if
          call frm04(iw,npar)
          call xfl04
          in=0                                                         
          call xfl06
          l6a=l6d
          go to 100
      endif
6000  continue
      write(Msg,6100) diret(1:ldiret)
 6100 format(' Wrong directive in LSQ modulus:   ',a)
      call screrr(ier,Msg,1)
      ier=-1
      return
 8000 continue
c--check the directives for list 12 are correct 
       if (isodir.eq.1)then 
         call sfl12
         call iso12(ier)
       endif
c      if(iandir.eq.1.or.jrd12.eq.1) then
       jb1=jb
       jq=1
       ll=nfl
c--form the absolute list 12
 8034 continue
       call sfl12
       if(jfr22(ix)) 8035,8036,8036
8035   continue
       ier=-1
       return
8036   continue
       call sfl22
       if(iverb.ge.3) call prt22
       if(jab22(ix)) 8037,8020,8020
8037   continue
c--not enough room for refinement: change FULL/DIAG if possible
       if(istore(l12).ne.1) then
c--update list 12
           nfl=ll
           call sfl12
           call chg12(ier)
           if(ier.lt.0) goto 8035
           nfl=ll
           goto 8034
         else
           goto 8035
       endif  
8020   continue
       if(idef12(ix))9000,8001,8001
8001   continue
       nfl=ll
       jb=jb1
c      endif
c--check if the directive 'hydr' is present
c      if(jhy.eq.1) then
c      write(ncwu,*)' call genhy'
c        call genhy(ibridc)
c        ier=-1
c        return
c      end if
c
c--set code anomalous (je=0) and non-centrosymmetric (icx=0)
      if(je.eq.0.and.icx.eq.0) ianomx=1
      if(jchop.eq.1) then
c--execute the 'chop' request
      l6d=l6a                                                           
      l6 =l6a                                                             
      n6a=0
      n6=0
c--fetch the next reflection
1045  continue
      if(kldnr(in)) 1300,1050,1050
1050  continue
      in=0
      e=  store(m6+4) * xchop
      if(store(m6+3)-e) 1051,1053,1053
1051  continue
      if(istat2.ne.0) write(ncwu,1052) store(m6),store(m6+1),
     2 store(m6+2),store(m6+3),store(m6+4)
1052  format(19h int. less than sig,3f5.0,2f10.2)
      in=1
1053  continue
      if(in) 1270,1280,1270
c--number of unobserved reflections
1270  continue
      n6a=n6a+1
1280  continue
c--store the last reflection
      call xslr(in)
      n6=n6+1
1232  continue
      go to 1045
1300  continue
      call xert
c--rewrite the preamble block
c      write(*,*)'xchop exec: n6,n6a,xchop:',n6,n6a,xchop
      il=0
      call pre06(xchop,n6a,imax,imin,il,iv,ixx)
      end if
c--check if optimization weighting scheme has to be done
c      write(*,*) 'iw4=',iw4
      if(iw4.eq.2)then
c	write(*,*)'store(l6p+38)=',store(l6p+38)
	if(store(l6p+38).lt.15.) then
c--check if there is enough room  to store list 6
	  call xsto6(in)
	  j=1
	  jhost=1
	  call CaosWgt(jhost,j,ier)
c	  write(*,*) 'entro in weight'
	  call xweight(jhost)
c	  write(*,*) 'esco da weight'
	end if
      end if
c
c--prepare the store for the main program
c--read down the lists
c      call xcsae
c      call xrsl
      nfl=1
      call xfl01
      call xfl02
      call xfl03
      call xfl04
      call xfl05
c      do iii=l5d,l5-1
c      write(*,*)'iii,store(iii)',iii,store(iii)
c      enddo
      call xfl06
      l6a=l6d  
c--link list 5 and 3
      n3=kst53(in)+1
c--check if the scale is to be refined
      irefi=jb
      if(store(l5o).lt.0.0) then
         store(l5o)=-store(l5o)
         jh = 0
         jb = -1
      end if
c--check on whether there is a refinement to be done
      if(irefi) 1040,1030,1030
1030  continue
c--save list 5 as list 35  and list 12 as list 36 (not more used)
c      call xfrm35
c      call xfrm36
c--number of partial derivatives per parameter (1,2 or 4)
      jq=(2-icx)*(je+2)
      jb1=jb
c--form the absolute list 12
      ll=nfl
1034  continue
      call sfl12
      if(jfr22(ix)) 1035,1036,1036
1035  continue
      ier=-1
      return
1036  continue
      nfl=ll
      call sfl22
      if(iverb.ge.3) call prt22
      if(jab22(ix)) 1037,1020,1020
1037   continue
c--not enough room for refinement: change FULL/DIAG if possible
       if(istore(l12).ne.1) then
c--update list 12
           nfl=ll
           call sfl12
           call chg12(ier)
           if(ier.lt.0) goto 1035
           nfl=ll
           goto 1034
         else
           goto 1035
       endif
1020  continue
      jb=jb1
c--check if there is enough room  to store list 6
1040  continue
      call xsto6(in)
      if(iverb.lt.0) goto 1060
      write(ncwu,1025)
1025  format(' Structure factor least squares',5x,
     2	 '(Vers. 2496)')
      write(ncwu,9036) iw4
9036  format(' Weighting scheme no. ',i3)
      if(n4.gt.0) then
        write(ncwu,9033)n4
9033    format(' Parameter(s) provided',i3)
        write(ncwu,9032) (j,j=1,4)
9032    format( 6x,4(2hp(,i1,1h),8x))
        m4=l4+n4-1
        write(ncwu,9031) (store(l),l=l4,m4)
9031    format(1x,10f12.5)
      end if
      if(irefi.eq.0) then
        if(iauto.eq.0) write(ncwu,9035) ji
9035	format(' Cycle(s) requested  ',i3)
        if(iauto.eq.1) write(ncwu,9037) ji
9037	format(' Cycle(s) requested ',i3,' or up to convergence')
      end if
      if(jh.eq.0) then
	write(ncwu,9038)
9038	format(' Scale refinement requested')
      end if
1060  continue
c      write(ncwu,*)' exit dirlsp',ier 
      if(ier.ne.0) goto 9000
      return
 9000 continue
      ier=-1
      write(Msg,'(22h Error in directive : ,a)') diret(1:ldiret)
      call screrr(ier,Msg,1)
      return
      end
c
code for xsto6
      subroutine xsto6(in)
c--store list 6 in memory
c  in = 1  list 6 in memory
c	0  no store available
c
      common/ylimi/nfl,lfl,nlx,dummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      common /xdata/ store(500000)
      dimension istore(500000)
      equivalence(store,istore)
c
c--check if there is enough room
      in=0
      m=nfl+n6*md6d
      if(m.ge.lfl) goto 4200
c--store the reflections
      in=1
      lxxe=nfl
      nxxe=0
      mdxxe=md6d
      mxxe=lxxe
      nfl=lxxe+(n6+1)*mdxxe
      call xsac(106,1,lxxe,nfl-1)
      l6 =l6a
      l6d=l6a
4105  continue
      if(kfnr(nn)) 4115,4110,4110
4110  continue
c      if(store(m6+3).lt.0.1)write(*,*)store(m6),store(m6+1),
c     1  store(m6+2),store(m6+3)
      do 4120 l=m6,m6+md6d-1
      store(mxxe)=store(l)
      mxxe=mxxe+1
4120  continue
      nxxe=nxxe+1
      go to 4105
4115  continue
      store(mxxe)=128
c      write(*,*)'nxxe',nxxe
4200  continue
      return
      end
c
code for sfr0r
      subroutine sfr0r(iln)
c--form the preamble block for a list type six or seven
c  ja =  7 (anomalous dispersion differences)
c
c--store(l6d+ 4)      sys   0/-1=old/new version of list 6
c--store(l6d+ 5)      md6d  no. of word for reflect.(md6d=12)in input
c--store(l6d+ 6)      n6dk  no. of word for reflect.(n6dk=10)on disk
c--store(l6d+ 7)      n6    no. of reflections on disk
c--store(l6d+ 8)      n6d   no. of active reflections
c--store(l6d+ 9)      n6p   length of preamble
c--store(l6d+10)            h max.
c--store(l6d+11)            k max.
c--store(l6d+12)            l max.
c--store(l6d+13)            ilent
c--store(l6d+14)            ivelox
c--store(l6d+15)     jpart  partial struct. code
c--store(l6d+16)     knw    unknown/known code
c--store(l6d+17)     bt     b(medium) from wilson
c--store(l6d+18)     sc     scale     from wilson
c--store(l6d+19)            no. of hightest e's
c--store(l6d+20)            no. of lowest   e's
c--store(l6d+21)            s3s2
c--store(l6d+22)            s3s2p
c--store(l6d+23)            chop value
c--store(l6d+24)            no. of unobserved refl.
c--store(l6d+25)            no. of deleted refl. by user (list 18)
c--store(l6d+26)	    r% (last s.f.c.)
c--store(l6d+27)	    no. variabili affinate ultimo c.f.	  (11/10/95)
c--store(l6d+28)	    codice dati differenza (anom. disp.)  (11/10/95)
c--store(l6d+29)	    delta(h)  for sorting
c--store(l6d+30)	    delta(k)	   "
c--store(l6d+31)	    delta(l)	   "
c--store(l6d+32)	    h min 
c--store(l6d+33)	    k min
c--store(l6d+34)	    l min
c--store(l6d+35 : 41)	    r%(1)  --> r%(7)
c--store(l6d+42 : 48)	    rw%(1) --> rw%(7)
c--store(l6d+49 : 55)	    s(1) --> s(7)
c--store(l6d+56)	    ls_shift/esd_max
c--store(l6d+57)	    ls_shift/esd_min
c--store(l6d+58)	    diff_density_max
c--store(l6d+59)	    diff_density_min
c--store(l6d+60)	    diff_density_rms
c--store(l6d+61 : 65)	    not used
c
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
c
      common/xlimi/nfl,lfl,nl,idummy(3),nfls
      common/workb/ja,dummb(25)
      common /data/ store(30000)
      dimension istore(30000)
      equivalence(store,istore)
c--
      nfl = nfls
      kk3=128
      kk2=128*kk3
      kk1=128*kk2
c--
      call xcln(iln)
      sys06=-1.0
      store(nfl+4)=sys06
      n6p=65
      n6dk=5
      store(nfl+5)= md6d
      store(nfl+6)= n6dk
      store(nfl+7)= n6d
      store(nfl+8)= n6
      store(nfl+9)= n6p
c      write(6,*) 'sfr0r:nfl,md6d,n6dk,n6d,n6p',nfl,md6d,n6dk,n6d,n6p
      lj=nfl+10
      do 1000 i=lj,nfl+n6p
      store(i)=0.0
1000  continue
c      if (ja.eq.7) store(nfl+28) = 1.0
      ln=n6p+(n6d+1)*n6dk
      call sowl(ln,iln,lsn,ld6p,lk,lm,lj)
      store(nfl+2)=lsn
      l6=ld6p+n6p
c      n6=0
      call yupf(ld6p,nfl,n6p)
      llw=ld6p+ln-1
      call swlin(iln,lsn,ld6p,llw,n6p,ln)
      l=nfl+n6p
c      write(6,*)'swlin = ', iln,lsn,ld6p,llw,n6p,ln
c--check that we have not corrupted the store
      li=nfl
      nfl=l
      l=l-1
      call xsac(106,lsn,li,l)
      nfl=li
      return
      end
c
c-----------------------------------------------------------------------
code for xfl06
      subroutine xfl06
c--set up list 6 for reading and possibly writing
c
c--the common variables are used as follows
c
c  l6    disc location for writing
c  l6d   disc location for reading
c  m6    location of the core buffer at which the results are found
c  m6dk  location of the input (or output) disc buffer
c  n6dk  number of integer words in the disc buffer
c  md6d  number of real words per reflections on read
c  n6    number of reflections to be read
c  n6d   number of reflections written
c  l6p   address in store of the preamble block
c  n6p   length of the preamble block
c  ld6p  disc location of the preamble block
c  l6rs  location of the first scale factor for writing
c  l6rk  location of the first scale factor for reading
c  l6in  location of the first sorting codex
c  sys06 =0.0 means old list 'r'
c        =-1.0      new list 'r' (like sir)
c--
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,nfls
      common/xlimi/ind,dummy(6)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common /xdata/ store(500000)
      common /data/ astore(30000)
c--
      in6=6
      call srlin(in6,li,ld6p,lk,ln,lm)
      n6p=ln
c      write(6,*)' xfl06 srlin = ', in6,li ,ld6p,lk,n6p,lm
      ind=1
      call srdls(in6,l,ind,lj)
c      write(6,*)'xfl06 astore ',(astore(i),i=1,n6p)
      l6p=nfl
      do i=1,n6p
      store(l6p+i-1)=astore(i)
      enddo
      ly=l6p+n6p
      sys06=store(l6p+4)
      md6d= store(l6p+5)
      n6dk= store(l6p+6)
      n6d = store(l6p+7)
      n6  = n6d
      if(sys06.lt.-0.1) then
                       l6rs=l6p+10
                       l6rk=l6p+13
                       l6in=l6p+17
                       m6dk=ly+1
                       else
                       l6r = store(l6p+9)
                       l6rs= l6p+l6r
                       l6i = store(l6p+10)
                       l6in= l6p+l6i
                       l6rk= ly+1
                       store(l6rk  )=1.0/store(l6rs  )
                       store(l6rk+1)=1.0/store(l6rs+1)
                       store(l6rk+2)=1.0/store(l6rs+2)
                       store(l6rk+3)=1.0/store(l6rs+3)
                       m6dk= l6rk+4
                       endif
      m6  = m6dk+n6dk
      nfl = m6+md6d 
      l6d = ld6p+n6p
      l6=l6d
c       write(ncwu,*) 'xfl06 =',m6,l6,n6
      return
      end
c
code for pre06
      subroutine pre06(xchop,n6a,imax,imin,il,iv,ix)
c--rewrite the preamble block
c
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common /data/ store(30000)
      common/xlimi/ind,dummy(6)
      dimension imax(3),ix(3),imin(3)
c--
      ind=1
      call ydwnf(ld6p,ind,n6p)
      if(il.gt.0) then
      store(ind+10)=imax(1)
      store(ind+11)=imax(2)
      store(ind+12)=imax(3)
      store(ind+13)=il
      store(ind+14)=iv
      store(ind+29)=ix(1)
      store(ind+30)=ix(2)
      store(ind+31)=ix(3)
      store(ind+32)=imin(1)
      store(ind+33)=imin(2)
      store(ind+34)=imin(3)
      end if
      store(ind+23)=xchop
      store(ind+24)=n6a
      store(ind+ 8)=n6-n6a
      call yupf(ld6p,ind,n6p)
      call xdump
      return
      end
c
code for ContaObs 
      subroutine ContaObs 
c--store the last reflection on the disc
c
      common/lsq3/ numObs(10),numParam,ObsByParam
c
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common /xdata/ store(500000)
      dimension  istore(500000)
      equivalence(store,istore)
c--
      do i=1,10
      numObs(i)=0
      enddo
      l6d=l6a                                                           
      l6 =l6a                                                             
c--fetch the next reflection
1045  continue
      if(kldnr(in)) 1300,1050,1050
1050  continue
c-sum for different values of cutoff (0,1,2,3,4,5,6,7,8,9)
      if(store(m6+4).lt.0.001) then
       jjjc=10
      else
       jjjc=store(m6+3)/store(m6+4) + 1
       if(jjjc.gt.10) jjjc=10
      endif
      do jjj=1,jjjc
       numObs(jjj)=numObs(jjj)+1
      enddo
      go to 1045
1300  continue
      l6d=l6a                                                           
      l6 =l6a                                                             
      return
      end
c
code for xslr
      subroutine xslr(in)
c--store the last reflection on the disc
c
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common /xdata/ store(500000)
      common /data/ astore(30000)
      dimension  istore(500000)
      equivalence(store,istore)
c--
      in=in+1
      ih=nint(store( m6  ))+64
      ik=nint(store( m6+1))+64
      il=nint(store( m6+2))+64
      if(sys06.lt.-0.1) then
                       istore(m6dk  )=in*kk1+ih*kk2+ik*kk3+il
                       store(m6dk+1) =store(m6+3)
                       store(m6dk+2) =store(m6+4)
                       store(m6dk+3) =store(m6+5)
                       store(m6dk+4) =store(m6+6)
                      else
                       istore(m6dk  )=in*128+ih
                       istore(m6dk+1)=ik*128+il
                       istore(m6dk+2)=nint(store(m6+3)*store(l6rs  ))
                       istore(m6dk+3)=nint(store(m6+4)*store(l6rs+1))
                       istore(m6dk+4)=nint(store(m6+5)*store(l6rs+2))
                       istore(m6dk+5)=nint(store(m6+6)*store(l6rs+3))
                       endif
      do i=1,n6dk
      astore(i)=store(m6dk+i-1)
      enddo
      ind=1
      call yup (l6,ind,n6dk)
      call ydwn(l6,ind,n6dk)
      do i=1,n6dk
      store(m6dk+i-1)=astore(i)
      enddo
      l6=l6+n6dk
      return
      end
c
code for yupf
      subroutine yupf(li,m,j)
c--transfer floating point numbers from store to the disc
c
c  li address of the first word on the disc(two words)
c  m  address in store  (array holding the data)
c  j  number of words to transfer
c
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      l2=li
      l=j
      call yup(l2,m,l)
      return
      end
c
code for ydwnf
      subroutine ydwnf (li,m,j)
c--transfer floating point numbers from the disc to store
c
c  li address of the first word on the disc (two words)
c  m  address in store (array to hold the data)
c  j  number of words to transfer
c
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      l2=li
      l=j
      call ydwn(l2,m,l)
      return
      end
c
code for ydwn
      subroutine ydwn(nfw,mpri,nw)
c--transfer from disc to store
c
c  nfw   address of first word to be used on the disc
c  mpri  address of first word in core
c  nw    number of words to transfer
c
c--disc routines version iv, using 'link ' array as store
c  the buffers.
c
c--record 0 contains words  0   - (nwr-1)
c  record 1 contains words  nwr - (2*nwr-1)
c  and subsequent records are the same
c
c--
      common/xbufd/link(1600)
      common/xdisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
c
      common /data/ istore(30000)
c
c--transfer the arguments to the common block
      nfwd=nfw
      nwd=nw
      nv=1
      ipri=mpri
c--check if there are any more words to transfer
1200  continue
      if(nwd) 1250,1250,1300
1250  continue
      return
c--calculate the record number etc. for this transfer
1300  continue
      call xfndb
c--read some numbers
      do 1950 m=j,k
      istore(ipri)=link(m)
      ipri=ipri+1
      nv=nv+1
1950  continue
      go to 1200
      end
c
code for yup
      subroutine yup(nfw,mpri,nw)
c--transfer from store to disc
c
c  nfw   address of first word to be used on disc
c  mpri  address of first word in core
c  nw    number of words to transfer
c
c--disc routines version vi, using 'link ' array as store
c  the buffers.
c
c--record 0 contains words  0   - (nwr-1)
c  record 1 contains words  nwr - (2*nwr-1)
c  and subsequent records are the same
c
c--
      common/xbufd/link(1600)
      common/xdisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
c
      common /data/ istore(30000)
c
c--transfer the arguments to the common block
      nfwd=nfw
      nwd=nw
      nv=1
      ipri=mpri
c--check if there are any more words to transfer
1200  continue
      if(nwd)1250,1250,1300
1250  continue
      return
c--calculate the record number etc. for this transfer
1300  continue
      call  xfndb
c--write some numbers
2000  continue
      link(i+3)=-1
      do 2050 m=j,k
      link(m)=istore(ipri)
      ipri=ipri+1
      nv=nv+1
2050  continue
      go to 1200
      end
c
c-----------------------------------------------------------------------
      subroutine crea6
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,mxbg,iprin,iflag
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,nfls
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common /xdata/ store(500000)
      integer istore(500000)
      equivalence (store(1),istore(1))
      dimension vet(12),ivet(12),imax(3),imin(3),ix(3)
      equivalence (vet(1),ivet(1))
c
      istat2=0
c-- load reflections from list 7
c      nfl=1 
      call ysfl07(nref,nstr,nzro,npseud,iy)
      fc = 0.0
      phi = 0.0
      ib = 0
      l6tmp=nfl
      md6tmp=7
      m6=l6tmp
c      write(6,*)nfl,l6tmp,m6
      do i=1,3
      imax(i)=-1000
      imin(i)=1000
      enddo
      do 2000 i=1,nref
         call snr07(vet)
         store(m6  ) = ivet(1)
         store(m6+1) = ivet(2)
         store(m6+2) = ivet(3)
         store(m6+3) = vet(5)
         store(m6+4) = vet(9)
         if(ksigma.eq.0) store(m6+4)=0.0
         store(m6+5) = fc
	 store(m6+6) = phi
	 do n=1,3
	 if(ivet(n).lt.imin(n)) imin(n)=ivet(n)
	 if(ivet(n).gt.imax(n)) imax(n)=ivet(n)
	 enddo
c         write(6,*) ivet(1),ivet(2),ivet(3),vet(5),vet(9)
         m6=m6+md6tmp
         ib = ib + 5
 2000 continue
       nfl=m6
      iab=0
c--calculate the code for sorting (ilent & ivelox)
      ixmin=1000
      ixmax=-1000
      do 1000 i=1,3
      ia=imin(i)
      ib=imax(i)
      if(iab) 1005,1005,1001
1001  continue
      ia=iabs(ia)
      ib=iabs(ib)
1005  continue
      ix(i)=(ib-ia)+1
      if(ix(i).lt.ixmin) then
	imn=i
	ixmin=ix(i)
      endif
      if(ix(i).gt.ixmax) then
	imx=i
	ixmax=ix(i)
      endif
1000  continue
      il=imn
      iv=imx
      if(il.eq.iv) then
	il=1
	iv=3
      endif
c      write(*,*)'il,iv,ixmin,ixmax',il,iv,ixmin,ixmax
c--form the preamble of list 6
      n6d = nref
      n6=n6d
      md6d = 7
      m6dk = nfl+md6d
      nfl = m6dk+md6d
      iln = 6
      call sfr0r(iln)
      m6=l6tmp
      n6a=0
      xchop=3.0
c      write(6,*)'$',nfl,m6dk,l6tmp
      do 1010 i=1,nref
c      write(6,*)(store(m6+j-1),j=1,5)
      in=0
      e=  store(m6+4) * xchop
      if(store(m6+3)-e) 1051,1053,1053
1051  continue
      if(istat2.ne.0) write(ncwu,1052) store(m6),store(m6+1),
     2 store(m6+2),store(m6+3),store(m6+4)
1052  format(19h int. less than sig,3f5.0,2f10.2)
      in=1
1053  continue
      if(in) 1270,1280,1270
c--number of unobserved reflections
1270  continue
      n6a=n6a+1
1280  continue
c--store the last reflection
      call xslr(in)
      m6=m6+md6tmp
1010  continue
      call xert
c--rewrite the preamble block
      call pre06(xchop,n6a,imax,imin,il,iv,ix)
      n6o=n6d-n6a
*      write(   6,4030) n6d,n6o,xchop,n6a
*4030  format(' number of reflections stored',i6,/,
*     1       ' observed',i6,/,
*     1	     ' unobserved (>',f3.0,')',i6,/)
      il=0
      call sortx(il,iv,iab)
      call xdump
      call set18
      return
      end
c
code for set18
      subroutine set18
c--create list 18 on disc
c
      common/trig/sint(450),pi,twopi,dtor,rtod
c--
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xcons/pic,twopis,twopic,rtd,dtr,xnx
c
      common /xdata/ store(500000)
      dimension     istore(500000)
      equivalence(store,istore)
c--
      dimension indmx(3)
c--
      rtd=rtod
      do 100 i=1,3
100   indmx(i)=-9999
      n18=9
      m18=nfl
      nfl=m18+n18
      lb=nfl
      ka=18
      lc=lfl
      call xfl01
      call xfl02
      call xfl03
      call xfl06
      ln=0
      call xxcln(ka)
      store(nfl+ 5)=11.
      store(nfl+ 6)=float(n18)
      store(nfl+ 7)=4.
      store(nfl+ 8)=12+n18*4+3+n18
      store(nfl+ 9)=0.
      store(nfl+10)=6.
      l=nfl+store(nfl+5)
      lk=l
      do 1000 i=1,n18
      store(lk  )=10000.
      store(lk+2)=-10000.
      store(l+n18*4-1+i)=-1.
      lk=lk+4
1000  continue
      wave=store(l3g+10)
c
c--start of the reflection fetching loop
2000  continue
      if(kldnr(in)) 4000,2010,2010
2010  continue
      call inmxeq(indmx)
      lk=l
      m=m6
      m1=m18
      do 2011 i=1,7
      store(m1)=store(m)
      m=m+1
2011  m1=m1+1
      store(m18+4)=sntl2(in)
      store(m18+6)=0.0
      store(m18+7)=0.0
      store(m18+8)=0.0
      if(wave.gt.0.2.and.wave.lt.2.5) then
       a=sqrt(store(m18+4))*wave
       b=2.0*asin(a)*rtd
       store(m18+8)=b
      end if
      if(store(m18+5)-0.001) 2050,2050,2040
2040  continue
      store(m18+6)=store(m18+3)/store(m18+5)
      if(store(m18+3)-0.001) 2050,2050,2030
2030  continue
      store(m18+7)=abs(store(m18+3)-store(m18+5))/store(m18+3)
2050  continue
      m=m18
      do 2020 i=1,n18
      e=store(m)
      f=store(lk  )
      g=store(lk+2)
      store(lk  )=amin1(f,e)
      store(lk+2)=amax1(g,e)
      lk=lk+4
      m=m+1
2020  continue
      go to 2000
c
c--end of the reflection loop
4000  continue
      store(l+n18*4+n18  )=indmx(1)
      store(l+n18*4+n18+1)=indmx(2)
      store(l+n18*4+n18+2)=indmx(3)
      n18b=n18-4
      lk=l+12
      do 3000 i=1,n18b
      store(lk  )=store(lk  )-0.001*store(lk  )
      store(lk+2)=store(lk+2)+0.001*store(lk+2)
      lk=lk+4
3000  continue
      lk=l
      do 4010 i=1,n18
      store(lk+1)=store(lk)
      store(lk+3)=store(lk+2)
      lk=lk+4
4010  continue
      n =store(nfl+8)
      call xfrml(18,n )
      nfl=lb
      lfl=lc
      return
      end
c
code for inmxeq
      subroutine inmxeq(ivetm)
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
c
      common/xdata/store(500000)
      dimension   istore(500000)
      equivalence (store,istore)
c
      dimension ivet(3),ivetm(3)
c
      m2=l2
      do 1000 i=1,n2
      ivet(1)=store(m6  )*store(m2  )+store(m6+1)*store(m2+3)+
     1            store(m6+2)*store(m2+6)
      ivet(2)=store(m6  )*store(m2+1)+store(m6+1)*store(m2+4)+
     1            store(m6+2)*store(m2+7)
      ivet(3)=store(m6  )*store(m2+2)+store(m6+1)*store(m2+5)+
     1            store(m6+2)*store(m2+8)
      do 2000 k=1,3
      ive=iabs(ivet(k))
2000  if(ivetm(k).lt.ive)ivetm(k)=ive
      m2=m2+md2
1000  continue
      return
      end
c
code for sfl18
      subroutine sfl18
c--form absolute list 18 in store
c
c--the locations in store are controlled by the following variables
c
c  l18  location of the first general condition
c  md18 number of words for each general condition
c  n18  number of general condition
c  l18r location of the first reflection condition
c  md18r number of words for each reflection condition
c  n18r  number of reflection condition
c  m18  location at which the program has put the reflection
c  m18r  =m18
c  l18d  location of list 18 in core
c  md18d the list type number to be used as data of type 18.
c  n18d  lenght of list 18 in core.
c  m18d  location of maximum of equivalent indicies
c
c--
      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
c
      common /xdata/ store(500000)
      dimension     istore(500000)
      equivalence(store,istore)
      common /data/ astore(30000)
c--
      ind=1
      lj=0
      call srdls(18,li,ind,lj)
      lz=nfl
      do i=1,lj
      store(lz+i-1)=astore(i)
      enddo
      l18  =store(lz+ 5)+lz
      md18 =store(lz+ 7)
      n18  =store(lz+ 6)
      l18r =store(lz+ 8)+lz
      md18r=store(lz+10)
      n18r =store(lz+ 9)
      m18=lz+lj
      m18d=l18+md18*n18+n18
      l18d=lz
      n18d=lj
      nfl=m18+n18
      m=nfl-1
c      call xsac(18,l,l18d,m)
      md18d=18
      return
      end
c
code for sortx
      subroutine sortx(il,iv,iab)
c--sorting routine
c
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
c      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
c     2 l18d,m18d,md18d,n18d
      common/xlimi/nfl,lfl,dummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
      common /xdata/ store(500000)
      dimension istore(500000)
      equivalence(store,istore)
      dimension ix(3),imin(3)
c--
      nfl=1
      lfl=500000
      call xfl06
      l6a=l6d
      l=l6p+29
      do i=1,3
      ix(i)=store(l  )
      l=l+1
      enddo
      do i=1,3
      imin(i)=store(l)
      l=l+1
      enddo
      iab=0
      if(il) 1010,1010,1020
c
c--set the best code
1010  continue
      il=store(l6rk  )
      iv=store(l6rk+1)
1020  continue
      if(il.eq.iv) then
	il=1
	iv=3
      endif
c      write(*,*) 'il,iv,ix',il,iv,ix
      im=6-il-iv
      il1=il-1
      im1=im-1
      iv1=iv-1
c--set up the addresses for slowest index in istore
      la=nfl
      lb=la+1
      lc=lb+ix(il)
      ld=lc+1
      le=ld+ix(il)
      nfl= le
      do 1025 li=la,le
      istore(li)=0
1025  continue
      il4=4*il1
c--calculate the number of reflections with the same slow index
1030  continue
      if(kldnr(in)) 1050,1035,1035
1035  continue
      b=store(m6+il1)
      if(iab) 1040,1040,1037
1037  continue
      b=abs(b)
1040  continue
      a=b-imin(il)
      j=nint(a)
      istore(lb+j)=istore(lb+j)+1
      go to 1030
1050  continue
      do 1060 li=lb,lc
      istore(li)=istore(li)+istore(li-1)
1060  continue
      indx=istore(lc)
      jh=nfl
      jk=5
      nfl=jh+indx*jk
      if(nfl-lfl) 1065,1065,1061
1061  continue
      write(ncwu,1062)
1062  format(  /,21h too many reflections)
c      call xerr
      return
1065  continue
      l6d=l6a
c--write the reflections into the tdf$ disc file
1070  continue
      if(kldnr(in)) 1100,1075,1075
1075  continue
      b=store(m6+il1)
      if(iab) 1085,1085,1080
1080  continue
      b=abs(b)
1085  continue
      a=b-imin(il)
      j=nint(a)
      k=istore(la+j)+istore(ld+j)
      istore(ld+j)=istore(ld+j)+1
      li=jh+k*jk
      ik=lint(m6+im1) +64
      ihk=lint(m6+iv1) +64
      istore(li    )=ik*128+ihk
      istore(li  +1)=istore(m6dk+1)
      istore(li  +2)=istore(m6dk+2)
      istore(li  +3)=istore(m6dk+3)
      istore(li  +4)=istore(m6dk+4)
      go to 1070
1100  continue
      jz=ix(il)
      lf=jh
      le=ld
c--loop over the blocks with different slow index
      do 2000 jx=1,jz
      jy=istore(le)
      le=le+1
      if(jy) 2000,2000,1102
1102  continue
      if(jy-1) 1190,1190,1115
1115  continue
c--sort the current block
      m=2
1120  continue
      in=jy/m
      if(in) 1121,1121,1122
1121  continue
      in=1
1122  continue
      ifin=jy-in
1130  continue
      mark=0
      do 1160 i=1,ifin
      lk=lf+(i-1)*jk
      lk1=lk+in*jk
      if(istore(lk)-istore(lk1)) 1160,1160,1140
1140  continue
      l=lk
      ln=lk1
      do 1150 j=1,jk
      jg=istore(l)
      istore(l)=istore(ln)
      istore(ln)=jg
      l=l+1
      ln=ln+1
1150  continue
      mark=1
1160  continue
      if(mark) 1165,1165,1130
1165  continue
      if(in-1) 1190,1190,1170
1170  continue
      m=m*2
      go to 1120
1190  continue
      lf=lf+jy*jk
2000  continue
c--write the reflections into the privaty disc file
      lf=jh
      le=ld
      ih=imin(il)
      do 2100 jx=1,jz
      jy=istore(le)
      le=le+1
      if(jy) 2130,2130,2110
2110  continue
      do 2120 i=1,jy
      ix(il)=ih
      ix(im)=istore(lf  )/128
      ix(iv)=istore(lf  )-ix(im)*128
      ix(im)=ix(im)-64
      ix(iv)=ix(iv)-64
      store(m6  )=ix(1)
      store(m6+1)=ix(2)
      store(m6+2)=ix(3)
      if(sys06.lt.-0.1) then
                        store(m6+3)= store(lf+1)
                        store(m6+4)= store(lf+2)
                        store(m6+5)= store(lf+3)
                        store(m6+6)= store(lf+4)
                        else
                        store(m6+3)=istore(lf+1)*store(l6rk  )
                        store(m6+4)=istore(lf+2)*store(l6rk+1)
                        store(m6+5)=istore(lf+3)*store(l6rk+2)
                        store(m6+6)=istore(lf+4)*store(l6rk+3)
                        endif
      in=0
      call xslr(in)
      lf=lf+jk
2120  continue
2130  continue
      ih=ih+1
2100  continue
      call xert
*      write(ncwu,2140)jhk(il),jhk(im),jhk(iv)
*2140  format(/,' sorted reflection(s) (',a1,')slow  (',
*     1 a1,')medium  (',a1,')velox')
c     call stim2(1)
c     call xline
      return
      end
c
code for xert
      subroutine xert
c--end reflection transfer and rewrite the preamble block
c
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common/ylimi/nfl,lfl,nl,idummy(3),nfls
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      common /data/ astore(30000)
      common /xdata/ store(500000)
      dimension  istore(500000)
      equivalence(store,istore)
c
c--end the reflection transfer
      ifine=-11111
      iend=11111
      istore(m6dk)=iend
      if(sys06.lt.-0.1) istore(m6dk)=ifine
      do i=1,n6dk
      astore(i)=store(m6dk+i-1)
      enddo
      ind=1
      call yup(l6,ind,n6dk)
      l6=l6+n6dk
c--rewrite the preamble block
      call ydwnf(ld6p,ind,n6p)
      do i=1,n6p
      store(nfl+i-1)=astore(i)
      enddo
      store(nfl+7)=float(n6)
      if(sys06.ge.0) then
                     l6r=nint(store(nfl+9))
                     store(nfl+l6r+1)=store(l6rs+1)
                     store(nfl+l6r+2)=store(l6rs+2)
                     l6i=nint(store(nfl+10))
                     store(nfl+l6i  )=store(l6in)
                     store(nfl+l6i+1)=store(l6in+1)
                     store(nfl+l6i+2)=store(l6in+2)
                     store(l6rk+1)=1.0/store(l6rs+1)
                     store(l6rk+2)=1.0/store(l6rs+2)
                     endif
      do i=1,n6p
      astore(i)=store(nfl+i-1)
      enddo
      call yupf(ld6p,ind,n6p)
      call xdump
      return
      end
c
code for kldnr
      function kldnr(in)
c--load the next reflection from the disc
c
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common /data/ astore(30000)
      common /xdata/ store(500000)
      dimension  istore(500000)
      equivalence(store,istore)
c--
      kldnr=0
      ind=1
      call ydwn(l6d,ind,n6dk)
      l6d=l6d+n6dk
      do i=1,n6dk
      store(m6dk+i-1)=astore(i)
      enddo
c      write(ncwu,*) 'ydwn = ',l6d,n6dk,sys06,ifine,iend,
c     1 kk1,kk2,kk3,
c     1 istore(m6dk),store(m6dk+1),store(m6dk+2),store(m6dk+3)
c--unpack the values
      if(sys06.lt.-0.1) then
                       if(istore(m6dk).eq.ifine) goto 1000
                       if(istore(m6dk).eq.iend ) goto 1000
                       in  =istore(m6dk  )/kk1
                       ihkl=istore(m6dk  )-in*kk1
                       ih=ihkl/kk2
                       ikl=ihkl-ih*kk2
                       ik=ikl/kk3
                       il=ikl-ik*kk3
                       store(m6+3)=store(m6dk+1)
                       store(m6+4)=store(m6dk+2)
                       store(m6+5)=store(m6dk+3)
                       store(m6+6)=store(m6dk+4)
                       else
                       if(istore(m6dk).eq.iend) goto 1000
                       in=istore(m6dk  )/128
                       ih=istore(m6dk  )-in*128
                       ik=istore(m6dk+1)/128
                       il=istore(m6dk+1)-ik*128
                       store(m6+3)= istore(m6dk+2)*store(l6rk  )
                       store(m6+4)= istore(m6dk+3)*store(l6rk+1)
                       store(m6+5)= istore(m6dk+4)*store(l6rk+2)
                       store(m6+6)= istore(m6dk+5)*store(l6rk+3)
                       endif
      in=in-1
      store(m6  )=float(ih)-64
      store(m6+1)=float(ik)-64
      store(m6+2)=float(il)-64
c      write(ncwu,*) ' ##', store(m6),store(m6+1),store(m6+2)
      return
1000  continue
      kldnr=-1
      return
      end
c
code for kfnr
      function kfnr(in)
c--fetch the next reflection allowed by list 18
c
c--return values are :
c  -1  last reflection marker found
c   0  next reflection found
c
c  m6  location of the core buffer
c
c--
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
c--
1000  continue
      j=kldnr(in)
c--check for the last reflection
      if(j) 2000,1010,1010
1010  continue
      if(in) 1020,2000,1020
c--reflection deleted
1020  continue
      l6=l6+n6dk
      go to 1000
2000  continue
      kfnr=j
      return
      end
c                                                                       
code for kmnqd                                                          
      function kmnqd(ix)                                                
c--structure factor calculation                                         
c                                                                       
c  ix = 0  input reflections from disc (list 6)
c       1  input reflections from store(lxxe)
c      -1  input from store (list 31)
c
c--useage of control variables:
c  ja  set to 1 for iso atoms only, else n2                             
c  jb  set to -1 for no refinement, else 0                              
c  jc  set to -1 for only calculate cos, else 0                         
c  jd  set to -1 for centro, else 0                                     
c  je  set to -1 for no anomalous dispersion, else 0                    
c  jf  current value of jb,set for each atom if jb=0                    
c  jg  set to -1 for no print, else the number  of lines before page    
c  jh  set to -1 if the scale factor is not to be refined, else 0       
c  ji  cycle number                                                     
c  jl  current cycle number                                             
c  jm  set to -1 for clear the initial fc, else 0                       
c  jn  dummy location for non-refined parameters                        
c  jo  address complete partial derivatives                             
c  jp  last address complete partial derivatives
c  jq  number of partial derivatives per reflection (0,1,2 or 4)        
c  jr  address normal equations matrix                                  
c  js  work variable                                                    
c  jt  work variables used during accumulation of partial derivatives   
c  ju                                                                   
c  jv                                                                   
c  jw                                                                   
c  jx  loop variable for equivalent positions                           
c  jy  loop variable for atoms                                          
c  jz  address of the shifts
c--useage of general variables                                          
c  tc   coefficient  for the iso-temperature factors                    
c  sst  sin(theta)/lambda squared                                       
c  st   sin(theta)/lambda                                               
c  focc form factor multiplied by the occupation number                 
c  t    temperature factor                                              
c  tfocc t*focc                                                         
c  ap   a part for each symmetry position for each atom                 
c  bp   b part for each symmetry position  for each atom                
c  at   total a part for each atom                                      
c  bt   total b part for each atom                                      
c  ac   total real a part for the reflection                            
c  bc   total real b part for the reflection                            
c  aci  total imaginary a part for the reflection                       
c  bci  total imaginary b part for the reflection                       
c  act  total a part for the reflection                                 
c  bct  total b part for the reflection                                 
c  apd  partial derivatives for each atom with respect to a             
c  bpd  partial derivatives for each atom with respect to b             
c  fo   scaled fo                                                       
c  fc   fc on absolute scale                                            
c  p    phase angles in radians                                         
c  w    square root of the weight for this reflection                   
c  df   difference between fo and fc                                    
c  wdf  weighted difference between fo and fc                           
c  fot  sum of fo                                                       
c  fct  sum of fc                                                       
c  dft  sum of abs(df)
c  wdf  minimization function - sum weighted difference squared         
c  rw   hamilton weigthed r value                                       
c  r    normal weighted value                                           
c  x    (1./-1.) factor which multiplies the current fc                 
c  z    damping factor to be applied to positional parameter
c  y    (=z for standard refinement) to be applied to thermal parameter
c--
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/ylimi/nfl,lfl,nlx,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pix,twopis,twopix,rtd,dtr,xnx                          
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z  
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,           
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
      common/xtemp/itemp(80)                                            
      dimension temp(80)
      equivalence(itemp,temp)                                           
c--                                                                     
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s            
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,    
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i               
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst04/iw4,l4,m4,n4                                         
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o                        
     2 ,n5g,l5d,n5d,md5c,l5ori 
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,
     2 ieq,iwe,nsca,nbm,iadsc,iadbm
      common/xfour/ iverb,num,ipat,ifrag,ianom,ianomx,ipdb,iauto,irefi
c
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
c
      dimension apd(10),bpd(10)
c
      common /mess/ Message,ifMess,lMess
      character*80 Message,line
c
      common /data/ astore(30000)
      common /xdata/ store(500000)
      dimension istore(500000)
      equivalence(store,istore)
C!!!!!data xnx/32766.0/
c--26 variables to store in the preable block of list 6
      common/xrefi/rr(7),rw(7),ss(7),shesd(2),difro(3)
c--
      dimension fot(7),fct(7), dft(7), wdft(7)
      dimension	       fctn(7),dftn(7),wdftn(7),rwn(7),rn(7)
      dimension nrefl(7),xrap(7)
      double precision s0,s1,s2,s3,c0,c1,c2,c3
      dimension nb(10),wfw(10),iadr(10),fhami(7),flevel(7)
      data fhami(1)/1.002/,flevel(1)/0.5/
      data fhami(2)/1.006/,flevel(2)/0.25/
      data fhami(3)/1.011/,flevel(3)/0.1/
      data fhami(4)/1.016/,flevel(4)/0.05/
      data fhami(5)/1.021/,flevel(5)/0.025/
      data fhami(6)/1.028/,flevel(6)/0.01/
      data fhami(7)/1.034/,flevel(7)/0.005/
c
c--calculation of trigonometric functions (rollett,pag 39)              
c  coefficients for chebyshev series (carruthers, crystal system)       
c                                                                       
      data s0/ 1.570795134/                                             
      data s1/-0.645925832/                                             
      data s2/ 0.079500304/                                             
      data s3/-0.004370784/                                             
      data c0/ 0.999993249/                                             
      data c1/-1.233483666/                                             
      data c2/ 0.252578000/                                             
      data c3/-0.019094240/                                             
c                                                                       
c--                                                                     
900   continue
      Message = ' '
c      call stim1(1)                                                     
      xnx = 32766.0
      indch=1+store(l6p+23)+0.005
      kmnqd=jb
      wdfto=d
      ifat=2**15
      ja=n2                                                             
      m5=l5                                                             
      do 1040 i=1,n5
      if(store(m5+10)) 1045,1045,1047
1045  continue
      m5=m5+md5
1040  continue
      ja=1
1047  continue
      jd=-ic
      pi2=pi/2.0
      d=180.0/pi
      jc=0
      if(jd) 1100,1130,1130
1100  continue
      if(jb)1110,1130,1130
1110  continue
      jc=-1
1130  continue
      dd=1.0/twopi                                                      
      do jjj=1,7
      nrefl(jjj)=0
      xrap(jjj)=0.0
      rr(jjj)=0.0
      rw(jjj)=0.0
      fot(jjj)=0.0
      fct(jjj)=0.0
      dft(jjj)=0.0
      wdft(jjj)=0.0
      rn(jjj)=0.0
      rwn(jjj)=0.0
      fctn(jjj)=0.0
      dftn(jjj)=0.0
      wdftn(jjj)=0.0
      enddo
      sumdif=0.0
      sfo=0.0
      sfc=0.0                                                           
      sfok=0.0                                                          
      sfck=0.0                                                          
      scale=1.0/store(l5o)
c--check if refinement is to be done                                    
      if(jb) 2500,2000,2000
2000  continue
c--clear the matrix areas to zero
      do 2010 l=jr,jz-1
      store(l)=0.0
2010  continue
c--set up constants for partial derivative accumulation                 
      if(jd) 2020,2030,2030                                             
c--centro , check if anomalous dispersion is present                    
2020  continue                                                          
      if(je) 2100,2200,2200                                             
c--non-centro , check if anomalous dispersion is present                
2030  continue                                                          
      if(je) 2300,2400,2400                                             
c                                                                       
c--centro     without anomalous dispersion                              
2100  continue                                                          
      assign 6100 to in1                                                
      assign 8600 to in3                                                
      go to 2500                                                        
c--centro     with    anomalous dispersion                              
2200  continue                                                          
      assign 6200 to in1                                                
      assign 8700 to in3                                                
      go to 2500                                                        
c--non-centro without anomalous dispersion                              
2300  continue                                                          
      assign 6300 to in1                                                
      assign 8700 to in3                                                
      go to 2500                                                        
c--non-centro with    anomalous dispersion                              
2400  continue                                                          
      assign 6400 to in1                                                
      assign 8800 to in3                                                
2500  continue                                                          
      mxxe=lxxe
      l6d=l6a                                                           
      l6 =l6a                                                           
      n6d=0                                                             
c--
      nperc=100
      iperc0=n6/nperc
      iperc=iperc0
      jperc=0
      nrif=0
c--
c--pick up the next reflection                                          
2900  continue                                                          
      if(ix) 2902,2901,2902
2901  continue
      if(kfnr(in)) 9000,3000,3000
2902  continue
      m6=mxxe
      mxxe=mxxe+mdxxe
      if(store(m6)-64) 3000,9000,9000
c===========================================                            
c--start of the loop over reflections                                   
c==========================================                             
3000  continue          
      nrif=nrif+1
      if (nrif.eq.iperc) then
          jperc=jperc+1
          iperc=iperc+iperc0
          call scrper(' ',jperc,nperc)
      endif
c--check if centrosymmetric reflections are required
      if (ianom.eq.1) then
        store(m6  )=-store(m6  )                                                
        store(m6+1)=-store(m6+1)                                                
        store(m6+2)=-store(m6+2)                                                
      end if
      assign 7000 to in4
      icont=0                                                           
      ac=0.                                                             
      bc=0.                                                             
      aci=0.0                                                           
      bci=0.0                                                           
      act=0.0                                                           
      bct=0.0                                                           
c--calculate the information for the symmetry positions                 
      m2=l2                                                             
      m2t=l2t                                                           
      do 3030 j=1,n2
      store(m2t  )= store(m6  )*store(m2  )
     2             +store(m6+1)*store(m2+3)
     3             +store(m6+2)*store(m2+6)
      store(m2t+1)= store(m6  )*store(m2+1)
     2             +store(m6+1)*store(m2+4)
     3             +store(m6+2)*store(m2+7)
      store(m2t+2)= store(m6  )*store(m2+2)
     2             +store(m6+1)*store(m2+5)
     3             +store(m6+2)*store(m2+8)
c--calculate the h.t terms
      store(m2t+9)=(store(m6  )*store(m2+ 9)
     2             +store(m6+1)*store(m2+10)
     3             +store(m6+2)*store(m2+11))*twopi
c--check if the aniso contributions are required
      if(ja-j) 3020,3010,3010
3010  continue
      store(m2t+3)=store(m2t  )*store(m2t  )
      store(m2t+4)=store(m2t  )*store(m2t+1)
      store(m2t+5)=store(m2t  )*store(m2t+2)
      store(m2t+6)=store(m2t+1)*store(m2t+1)
      store(m2t+7)=store(m2t+1)*store(m2t+2)
      store(m2t+8)=store(m2t+2)*store(m2t+2)
3020  continue
      store(m2t  )=store(m2t  )*twopi
      store(m2t+1)=store(m2t+1)*twopi
      store(m2t+2)=store(m2t+2)*twopi
      m2=m2+md2
      m2t=m2t+md2t
3030  continue
c--calculate sin(theta)/lambda squared
      sst=store(l2t+3)*store(l1s  )+store(l2t+4)*store(l1s+1)
     2   +store(l2t+5)*store(l1s+2)+store(l2t+6)*store(l1s+3)
     3   +store(l2t+7)*store(l1s+4)+store(l2t+8)*store(l1s+5)
      st=sqrt(sst)
      tc=-sst
c--calculate the forms factors
      call scatt(st)
      m3t=l3t
      m3ti=l3ti
      do 3040 i=1,n3
c--calculate the ratio of the imaginary to real form factors
      store(m3ti)=store(m3ti)/store(m3t)
      if(ipat.eq.1) store(m3t)=store(m3t)*store(m3t)
      store(m3t)=store(m3t)*g2
      m3ti=m3ti+1
      m3t=m3t+1
3040  continue
c--clear the partial derivative areas to zero
      if(jb) 4000,3360,3360
3360  continue
      js=jo
      do 3390 j=1,n22a
      do 3380 jw=1,jq
      store(js)=0.0
      js=js+1
3380  continue
3390  continue
      m22=l22
4000  continue
c==========================================                             
c--start of the loop based on the atoms                                 
c==========================================                             
c                                                                       
      m5=l5                                                             
      jy=1                                                              
c--clear the accumulation variables
4100  continue
      at=0.
      bt=0.
      jf=jb
c--check if refinement is being done                                    
      if(jb) 4520,4500,4500                                             
c__jf=number of the parameters of the current atom                      
c__that are being refine                                                
4500  continue                                                          
      jf=istore(m22)
      if(jf) 4520,4520,4501
4501  continue
      m22a=m22+1
      do 4505 i=1,10                                                    
      nb(i)=istore(m22a)
      iadr(i)=istore(m22a+2)
      f=istore(m22a+1)
      wfw(i)=f/1000.0
      m22a=m22a+md22a
4505  continue                                                          
c--clear partial derivative stacks                                      
      do 4510 jx=1,10                                                   
      apd(jx)=0.0                                                       
      bpd(jx)=0.0                                                       
4510  continue                                                          
c--pick up the form factors for this atom                               
4520  continue                                                          
      i=int(store(m5+17))                                                   
      m3t=l3t+ i                                                        
      m3ti=l3ti+ i                                                      
      focc=store(m3t)*store(m5+11)                                      
c--check the temperature type for this atom                             
*     if (store(m5+10).gt.0) write(6,*) 'OK',store(m5+10)
      if(store(m5+10)) 4530,4530,4540                                   
c--calculate the iso-temperature factor coefficients for this atom      
4530  continue                                                          
      t=exp(store(m5+5)*tc)                                             
      tfocc=t*focc                                                      
c--loop cycling over the different equivalent positions for this atom   
4540  continue                                                          
      m2t=l2t                                                           
      do 5700  jx=1,n2t                                                 
c--calculate h'.x+h.t                                                   
4545  continue                                                          
      a=store(m5+2)*store(m2t  )                                        
     2 +store(m5+3)*store(m2t+1)                                        
     3 +store(m5+4)*store(m2t+2)+store(m2t+9)                           
c--check the temperature factor type                                    
      if(store(m5+10)) 5000,5000,4550                                   
c--calculate the aniso-temperature factor                               
4550  continue                                                          
      t=exp(-(store(m5+ 5)*store(m2t+ 3)+store(m5+ 6)*store(m2t+ 4)     
     2 +store(m5+7)*store(m2t+5)+store(m5+ 8)*store(m2t+6)              
     2 +store(m5+9)*store(m2t+7)+store(m5+10)*store(m2t+8)))            
      tfocc=t*focc                                                      
c--calculate the sin/cos terms                                          
5000  continue                                                          
      a=a*dd                                                            
      a=4.0*(a-float(int(a)))                                           
      if(a) 5020,5010,5030                                              
5010  continue                                                          
      s=0.0                                                             
      c=1.0                                                             
      go to 5100                                                        
5020  continue                                                          
      a=a+4.0                                                           
5030  continue                                                          
      s=1.0                                                             
      if(a-2.0) 5045,5035,5040                                          
5035  continue                                                          
      s=0.0                                                             
      c=-1.0                                                            
      go to 5100                                                        
5040  continue                                                          
      s=-1.0                                                            
      a=a-2.0                                                           
5045  continue                                                          
      c=s                                                               
      if(a-1.0) 5060,5050,5055                                          
5050  continue                                                          
      c=0.0                                                             
      go to 5100                                                        
5055  continue                                                          
      c=-c                                                              
      a=2.0-a                                                           
5060  continue                                                          
      b=a*a                                                             
      c=c*(c0+b*(c1+b*(c2+b*c3)))                                       
      if(jc) 5200,5090,5090                                             
5090  continue                                                          
      s=s*a*(s0+b*(s1+b*(s2+b*s3)))                                     
c--calculate the b contribution                                         
5100  continue                                                          
      bp=s*tfocc                                                        
      bt=bt+bp                                                          
c--calculate the a contribution                                         
5200  continue                                                          
      ap=c*tfocc                                                        
      at=at+ap                                                          
c--check if any refinement is being done                                
      if (jf) 5600,5600,5300
c--calculate the partial derivatives for a,a w.r.t.x,y,z
 5300 continue
      do 5315 k=1,3
      if(nb(k).eq.0) go to 5315
      k1=k-1
      apd(k)=apd(k)-store(m2t+k1)*bp
c__check if the structure is centro
      if(jd) 5315,5310,5310
5310  continue
      bpd(k)=bpd(k)+store(m2t+k1)*ap
5315  continue
c--check the temperature factor type
      if(store(m5+10)) 5320,5320,5330
c--calculate the partial derivatives for a,b w.r.t.b(iso)
 5320 continue
      k=4
      if(nb(k).eq.0) go to 5350
      apd(k)=apd(k)+tc*ap
      if(jd) 5350,5325,5325
5325  continue                                                          
      bpd(k)=bpd(k)+tc*bp                                               
      go to 5350                                                        
c--calculate the partial derivatives  for a,b w.r.t.the aniso-terms     
 5330 continue                                                          
      do 5340 k=4,9                                                     
      if(nb(k).eq.0) go to 5340                                         
      k1=k-1                                                            
      apd(k)=apd(k)-store(m2t+k1)*ap
      if(jd) 5340,5335,5335
5335  continue
      bpd(k)=bpd(k)-store(m2t+k1)*bp
5340  continue                                                          
5350  continue                                                          
c__check if the occupation number is to refine                          
      k=10                                                              
      if(nb(k).eq.0) go to 5600                                         
      apd(k)=apd(k)+ap/store(m5+11)                                     
      if(jd) 5600,5360,5360                                             
5360  continue                                                          
      bpd(k)=bpd(k)+bp/store(m5+11)                                     
5600  continue                                                          
c--update the symmetry information pointer                              
      m2t=m2t+md2t                                                      
5700  continue                                                          
c==========================================                             
c--loop on equivalent position ends                                     
c==========================================                             
c                                                                       
c--accumulate the totals for this atom                                  
      ac=ac+at                                                          
      bc=bc+bt                                                          
c--check if anomalous dispersion is being considered                    
      if(je) 5750,5710,5710                                             
c--calculate the immaginary parts                                       
 5710 continue                                                          
*     write(6,*) m3ti,store(m3ti)                                            
      aci=aci-bt*store(m3ti)                                            
      bci=bci+at*store(m3ti)                                            
c--check if any refinement is being done                                
 5750 continue                                                          
      if(jf) 6900,6900,5800
5800  continue
      if(iwe.eq.0) go to 5820
c--multipay  the derivatives with the appropriate weghts
      do 5815 k=1,10                                                    
      if(nb(k).eq.0) go to 5815                                         
      apd(k)=apd(k)*wfw(k)
      if(jd) 5815,5805,5805
5805  continue
      bpd(k)=bpd(k)*wfw(k)
5815  continue
5820  continue
      in10=10
c--start of the loops for adding the partial derivatives of the
c  coefficent of fc into the tempory stacks
6005  continue
      go to in1
c--unity,centro and no anomalous dispersion
 6100 continue
      do 6110 k=1,in10
      if(nb(k).eq.0) go to 6110
      jw=iadr(k)
      store(jw  )=store(jw  )+apd(k)
6110  continue                                                          
      go to 6900                                                        
c--unity,centro and anomalous dispersion                                
 6200 continue                                                          
      do 6210 k=1,in10
      if(nb(k).eq.0) go to 6210
      jw=iadr(k)
      store(jw  )=store(jw  )+apd(k)
      store(jw+1)=store(jw+1)+apd(k)*store(m3ti)
 6210 continue                                                          
      go to 6900                                                        
c--unity, non-centro and no anomalous dispersion                        
 6300 continue                                                          
      do 6310 k=1,in10
      if(nb(k).eq.0) go to 6310
      jw=iadr(k)
      store(jw  )=store(jw  )+apd(k)
      store(jw+1)=store(jw+1)+bpd(k)
 6310 continue
      go to 6900
c--unity,non-centro and anomalous dispersion
 6400 continue
      do 6410 k=1,in10
      if(nb(k).eq.0) go to 6410
      jw=iadr(k)
      store(jw  )=store(jw  )+apd(k)
      store(jw+1)=store(jw+1)+bpd(k)
      store(jw+2)=store(jw+2)-bpd(k)*store(m3ti)
      store(jw+3)=store(jw+3)+apd(k)*store(m3ti)
6410  continue                                                          
6900  continue                                                          
      goto in4
c==========================================
c--end of atom cycling loop
c==========================================
c
7000  continue
      m5=m5+md5                                                         
      m22=m22+md22
      jy=jy+1
      if(jy.le.n5) go to 4100
c
c--end of reflection housekeeping
      if(jd)8010,8020,8020
 8010 continue
      bc=0.0
      aci=0.0
 8020 continue
      act=ac+aci
      bct=bc+bci
       if(abs(act)-0.000001) 8030,8030,8040
8030  continue
      act=0.000001
8040  continue
      if(jm) 8045,8042,8042
8042  continue
      a=store(m6+5)*cos(store(m6+6))
      b=store(m6+5)*sin(store(m6+6))
      act=a+x*act
      bct=b+x*bct
8045  continue
      fc=sqrt(act*act+bct*bct)
      p=atan2(bct,act)
      store(m6+5)=fc
      p=p*d
      if(p.lt.0)p=p+360.0
      fo=store(m6+3)
      if(ifrag.eq.0) goto 8047
      idum =istore(m6+6)/ifat
      idum1=istore(m6+6)-idum*ifat
      idum=p
      istore(m6+6)=idum*ifat+idum1
      goto 8046
8047  if(ipat.eq.1) fo=fo*fo
      store(m6+6)=p
      fo=fo*scale
c--calculate the square-root of the weight ( = w )
      call sweig(st,w)
      df=fo-fc
      wdf=w*df
c--sum for different values of cutoff (0,1,2,3,4,5,6)
      if(store(m6+4).lt.0.001) then
       jjjc=7
      else
       jjjc=store(m6+3)/store(m6+4) + 1
       if(jjjc.gt.7) jjjc=7
      endif
      do jjj=1,jjjc
       nrefl(jjj)=nrefl(jjj)+1
       fot(jjj)=fot(jjj)+fo
       fct(jjj)=fct(jjj)+fc
       dft(jjj)=dft(jjj)+abs(df)
       wdft(jjj)=wdft(jjj)+wdf*wdf
       rw(jjj)=rw(jjj)+w*w*fo*fo
      enddo
      sfok=sfok+store(m6+3)
      sfck=sfck+fc
      if (ianomx.eq.1) then
c--	act=ac+aci
c--	bct=bc+bci
	actn=ac-aci
	bctn=bc-bci
	bctn=-bctn
        if(abs(actn)-0.000001) 8031,8031,8041
8031    continue
        actn=0.000001
8041    continue
	fcn=sqrt(actn*actn+bctn*bctn)
	pn=atan2(bctn,actn)
	pn=pn*d
	dfn=fo-fcn
	wdfn=w*dfn
	do jjj=1,jjjc
	 fctn(jjj) =fctn(jjj) +fcn
	 dftn(jjj) =dftn(jjj) +abs(dfn)
	 wdftn(jjj)=wdftn(jjj)+wdfn*wdfn
	enddo
	a=sqrt(ac*ac+bc*bc)
	pa=atan2(bc,ac)
	pa=pa*d
	if(pa.lt.0)pa=pa+360.0
	s=sqrt(aci*aci+bci*bci)
        if (abs(aci).gt.0.0) then
	    ps=atan2(bci,aci)
        else
            ps=0.0
        endif
	ps=ps*d
	if(ps.lt.0)ps=ps+360.0
	den=(4.0*a*s)
	if(den.lt.0.00001) den=0.00001
	fnum=fc*fc-fcn*fcn
	cosarg=fnum/den
	if(cosarg.gt.1.0) cosarg=1.0
	if(cosarg.lt.-1.0) cosarg=-1.0
c	write(ncwu,*) 'hkl,a,pa,s,ps,den,fnum,cosarg = ',store(m6),
c     1	store(m6+1),store(m6+2),a,pa,s,ps,den,fnum,cosarg
	cosang=acos(cosarg)*d
	ang1=ps+cosang
	ang2=ps-cosang
	if(ang1.lt.0)ang1=ang1+360.0
	if(ang1.gt.360.0)ang1=ang1-360.0
	if(ang2.lt.0)ang2=ang2+360.0
	if(ang2.gt.360.0)ang2=ang2-360.0
	angdif1=pa-ang1
	if(angdif1.lt.0)angdif1=angdif1+360.0
	if(angdif1.gt.180.0)angdif1=360.0-angdif1
	angdif2=pa-ang2
	if(angdif2.lt.0)angdif2=angdif2+360.0
	if(angdif2.gt.180.0)angdif2=360.0-angdif2
	angdif=angdif1
	if(angdif2.lt.angdif1) angdif=angdif2
	sumdif=sumdif+angdif
c--check if the file for sirbig is requested
	if (ipdb.eq.1) then
	  ihh=store(m6	)
	  ikk=store(m6+1)
	  ill=store(m6+2)
          if (istat2.gt.1) then
	    write(ncwu,8083) ihh,ikk,ill,pa,ps,cosang,angdif,fnum,den,
     1	    cosarg
8083	    format(3i4,4f7.1,3f15.4)
          end if
	  write(ncpu,8082) ihh,ikk,ill,a,store(m6+4),pa,
     1	  fc,fcn,s,ps
8082	  format(3i4,7f10.4)
	end if
c	do jjj=1,jjjc
c	write(ncwu,*) 'fot,fct,dft,wdft,rw : ',
c    1	fot(jjj),
c    2	fct(jjj),
c    3	dft(jjj),
c    4	wdft(jjj),
c    5	rw(jjj)
c	write(ncwu,*) 'fot,fctn,dftn.wdftn : ',
c    x	fot(jjj),
c    1	fctn(jjj),
c    2	dftn(jjj),
c    3	wdftn(jjj)
c	enddo
c--end of (ianomx.eq.1) routine
      end if
c--check if a print of the reflections is needed
8046  if(jg) 8100,8050,8070
8050  continue
      write(ncwu,8060)
8060  format(1h1,6x,1hh,5x,1hk,5x,1hl,6x,4h/fo/,5x,4h/fc/,4x,5hphase,
     2 8x,18h d/f/ sqrt(w)*d/f/,
     3 3x,5h/fc'/,2x,6h/fc''/,2x,7hd/f/**2,2x,9ht.b.r.(%),
     4 2x,7hsinth/l,/)
      jg=57
8070  continue
c     jg=jg-1
      a=sqrt(ac*ac+bc*bc)
      s=sqrt(aci*aci+bci*bci)
      t=4.*(bc*bci+ac*aci)
      c=t*200.0/(2.0*fc*fc-t)
      write(ncwu,8080)store(m6),store(m6+1),store(m6+2),
     2 fo,fc,p,df,wdf,a,s,t,c,st
8080  format(3x,3f6.0,3f9.1,f12.1,f10.1,f11.1,f8.3,f9.3,f10.3,f11.5)
c      write(ncwu,8081)store(m6),store(m6+1),store(m6+2),
c     2 fo,fcn,pn,dfn,wdfn,a,s,t,c,st
c8081  format(3x,3f6.0,3f9.1,f12.1,f10.1,f11.1,f8.3,f9.3,f10.3,f11.5)
8100  continue
      if (ianom.eq.1) then
        store(m6  )=-store(m6  )                                                
        store(m6+1)=-store(m6+1)                                                
        store(m6+2)=-store(m6+2)                                                
      end if
      if(ix.eq.0) call xslr(in)
      n6d=n6d+1
      if(jb) 8980,8110,8110
c--set up the coefficients for the overall parameters
 8110 continue
      ac=act/fc
      bc=bct/fc
      apd(1)=scale*fc*ac
      apd(2)=tc*fc*ac                                                   
      bpd(1)=scale*fc*bc                                                
      bpd(2)=tc*fc*bc                                                   
      iadr(1)=iadsc
      iadr(2)=iadbm
      nb(1)=nsca
      nb(2)=nbm
      in10=2
      assign 8500 to in4
      go to 6005
c--calculate the cos and sin terms for the partial derivatives          
 8500 continue                                                          
      js=jo
      ac=ac*store(l5o)*w
      bc=bc*store(l5o)*w                                                
      wdf=wdf*store(l5o)                                                
c                                                                       
c--routines to transfer partial derivatives from temporary to
c  permanent store
      go to in3
c                                                                       
c--centro without anomalous dispersion                                  
8600  continue                                                          
      do 8610 jw=jo,jp
      store(jw)=store(js  )*ac
      js=js+jq
8610  continue
      go to 8900                                                        
c--non-centro without anomalous dispersion or centro with anomalous     
c  dispersion                                                           
8700  continue                                                          
      do 8710 jw=jo,jp
      store(jw)=store(js  )*ac
     2         +store(js+1)*bc
      js=js+jq
8710  continue
      go to 8900                                                        
c--non-centro with anomalous dispersion                                 
8800  continue                                                          
      do 8810  jw=jo,jp
      store(jw)=(store(js  )+store(js+2))*ac
     2         +(store(js+1)+store(js+3))*bc
      js=js+jq
8810  continue
8900  continue                                                          
c--accumulation of the l.s. normal equations                            
      call accum (wdf)                                                  
      go to 2900                                                        
c--check if the scale factor is to be refined                           
8980  continue                                                          
      if(jh) 2900,8990,8990                                             
8990   continue                                                         
      fc=fc*scale*w                                                     
      sfo=sfo+df*fc*w                                                   
      sfc=sfc+fc*fc
      go to 2900                                                        
9000  continue
      if(ifrag.eq.1) goto 9092
c--calculate the various r values
      do 9300 jjj=1,7
c      write(ncwu,*)dft(jjj),fot(jjj),wdft(jjj),rw(jjj),
c     1		   dftn(jjj),fot(jjj),wdftn(jjj),rw(jjj)
      if(fot(jjj).lt.0.001.or.rw(jjj).lt.0.001) goto 9300
      rr(jjj)=dft(jjj)/fot(jjj)*100.0
      rw1=rw(jjj)
      rw(jjj)=sqrt(wdft(jjj)/rw(jjj))*100.0
      if (ianomx.eq.1) then
	rn(jjj)=dftn(jjj)/fot(jjj)*100.0
	rwn(jjj)=sqrt(wdftn(jjj)/rw1)*100.0
      end if
      wdft(jjj)=wdft(jjj)*store(l5o)*store(l5o)
c      write(ncwu,*)'jjj,wdft(jjj),nrefl(jjj),n22a',
c     1	jjj,wdft(jjj),nrefl(jjj),n22a
      if((nrefl(jjj)-n22a).gt.0) then
      ss(jjj)=sqrt(wdft(jjj)/(nrefl(jjj)-n22a))
      else
      ss(jjj)=0.0
      endif
c      write(ncwu,*)'jjj,ss(jjj)',
c     1	jjj,ss(jjj)
      if(iverb.lt.0) goto 9300
	if(rr(jjj).gt.999.)rr(jjj)=999.
	if(rw(jjj).gt.999.)rw(jjj)=999.
      if (ianomx.eq.1) then
	if(ipdb.eq.1) then
	  sumdif=sumdif/n6d
	  write(ncwu,9054) sumdif
9054	  format(/,' <phi diff> = ',f10.4)
	end if
	if(rn(jjj).gt.999.)rn(jjj)=999.
	if(rwn(jjj).gt.999.)rwn(jjj)=999.
      end if
c--end of loop on r calcutions
9300  continue
c--write the r values
      if(iverb.ge.0) then
      if(jl.eq.1) write(ncwu,9302) n22a
9302  format(' number of refined parameters ',i6)
      write(ncwu,9319)
9319  format(1h )
      write(ncwu,9310) (jjj-1,jjj=indch,7)
9310  format(' threshold=n*sig(fo)',i4,6i7)
      write(ncwu,9320) (nrefl(jjj),jjj=indch,7)
9320  format(  ' no. reflections...',7i7)
      do jjj=1,7
      xrap(jjj)=float(nrefl(jjj))/float(n22a)
      enddo
      write(ncwu,9321) (xrap(jjj),jjj=indch,7)
9321  format(	' no(refl)/param....',7f7.2)
      if (ianomx.eq.1) then
      write(ncwu,9311)(rr(jjj),jjj=indch,7)
9311  format(  '  R(F)%    (+).....',7f7.3)
      write(ncwu,9312)(rw(jjj),jjj=indch,7)
9312  format(  ' wR(F**2)% (+).....',7f7.3)
      write(ncwu,9313)(rn(jjj),jjj=indch,7)
9313  format(  '  R(F)%    (-).....',7f7.3)
      write(ncwu,9314)(rwn(jjj),jjj=indch,7)
9314  format(  ' wR(F**2)% (-).....',7f7.3)
      write(ncwu,9317)(ss(jjj),jjj=indch,7)
9317  format(' goodnes of fit....',7f7.3)
cc--calculate the hamilton test
	jjj=4
	if(rr(jjj).lt.30.) then
        imeno=0
	rwr=rw(jjj)/rwn(jjj)
        if(rwr.lt.1.0000) then
	  rwr=rwn(jjj)/rw(jjj)
          imeno=1
        end if
        rhami=120.0/float(n6d-n22a)
        do 9076 i=1,7
        jham=i
        xhami=1+rhami*(fhami(7-i+1)-1)
        if(rwr.gt.xhami) goto 9078
9076    continue
        write(ncwu,9084)
9084    format(' Hamilton test out of range!')
        goto 9077
9078    continue
        write(ncwu,9079) rwr,xhami,flevel(7-jham+1)
9079	format(' the ratio of wR factors =',f7.4,/,
     1         ' the test =',f7.4,' at the level',f6.3)
        if(imeno.eq.0) then
          write(ncwu,9082)
9082      format(' we can reject the hypotesis (+) !')
        else
          write(ncwu,9083)
9083      format(' we can reject the hypotesis (-) !')
        end if
9077	continue
c--end ot hamilton test
	end if
      else
      write(ncwu,9315)(rr(jjj),jjj=indch,7)
9315  format('  R(F)% ...........',7f7.3)
      write(ncwu,9316)(rw(jjj),jjj=indch,7)
9316  format(' wR(F**2)% ........',7f7.3)
      write(ncwu,9317)(ss(jjj),jjj=indch,7)
      end if
      end if
c--end of writing
      if(iverb.lt.0) goto 9035
      write(ncwu,9056)wdft(1)
9056  format(' minimization function = ',f20.4) 
*     write(Message,9002) r(1),rw(1)
*     errem = r * 100.0
c
 9002 format('Cycle #',3x,'  R(F)% ( wR(F**2)% ) =',f6.2,' (',f6.2,')')
c
9035  continue
      write(Message,9002) rr(1),rw(1)
      errem = rr(1) * 100.0
      erre  = rr(1)  / 100.0
      if(iverb) 9030,9030,9020
9020  continue
      write(ncwu,9025)fot(1),fct(1),dft(1)
9025  format(/,
     2   70h sum of /fo/    sum of /fc/   sum of /delta/     minimizatio
     3n function,//,f11.1,f15.1,f16.1,34x,17h on scale of /fc/)
9030  continue
      fot(1)=fot(1)*store(l5o)
      fct(1)=fct(1)*store(l5o)
      dft(1)=dft(1)*store(l5o)
      if(jb.eq.-1) go to 9052
      if(jl.eq.0) go to 9052
      if(ix.eq.-1)go to 9052
      swdft=wdfto+(wdfto/2)
      if(wdft(1).lt.swdft) go to 9052
      write(ncwu,9051) wdft(1)
9051  format(/	,' error: minimiz. function diverges #',f20.4)
c      call xerr
      kmnqd=-1
      return
9052  continue
      if(iverb.gt.0) write(ncwu,9055)fot(1),fct(1),dft(1),wdft(1)
9055  format(f11.1,f15.1,f16.1,f24.4,10x,17h on scale of /fo/)
      if(jh) 9080,9060,9060
c--calculate the new scale factor
9060  continue
      b=sfok/sfck
      ac=1./scale
      bc=sfo/sfc
      ac=ac+bc
      scale=1.0/ac
      store(l5o)=1.0/scale
      if(iverb)9080,9075,9075
9075  continue
      write(ncwu,9070) store(l5o),b
9070  format(' new scale factor   g = ',f10.5
     2    ,/,' sum/fo//sum/fc/      = ',f10.5)
9080  continue
      jl=jl+1
      if(iverb.ge.0) write(ncwu,9090) jl
9090  format(' Structure factor least squares calculation',
     2 i5,' ends')
      write(Message(8:10),9003) jl
 9003 format(i3)
      line = Message
      if(jh.eq.0) then
        call scrper(' Start refining ',0,0)
      else
         call scrper(line,0,0)
      endif
      ji=ji-1
c--terminate the output of list 6
9092  if(ix.eq.0) call xert
      if(ix.ge.0) then
c--rewrite the preamble block
        ind=1
	call ydwnf(ld6p,ind,n6p)
        do i=1,n6p
        store(nfl+i-1)=astore(i)
        enddo
	store(nfl+26)=rr(1)
	kkkr=nfl+34
	kkkrw=nfl+41
	kkks=nfl+48
	do kkk=1,7
	store(kkkr+kkk)=rr(kkk)
	store(kkkrw+kkk)=rw(kkk)
	store(kkks+kkk)=ss(kkk)
	enddo
	store(nfl+56)=shesd(1)
	store(nfl+57)=shesd(2)
	do i=1,n6p
        astore(i)=store(nfl+i-1)
        enddo
	call yupf(ld6p,ind,n6p)
	call xdump
      end if
c      if((jl.eq.1).and.(iverb.ge.0))  call stim2(1)
      if(jh) 9110,9120,9120
9120  continue
      jl=0
      jh=-1
      jb=irefi
      goto 900
9110  continue
      if (jb) 9095,9100,9100
 9095 continue
c--rewrite list 6
      if(ix.eq.1) call stor6
c--rewritee list 5
      l=nfl
      nfl=l5d
c      write(*,*) ' mnqd: l5d,l5ori,n5d',l5d,l5ori,n5d
c      do iii=l5d,l5-1
c      write(*,*)'iii,store(iii)',iii,store(iii)
c      enddo
      call xfrml(5,n5d)
      nfl=l
      return
 9100 continue
c--check if the refinement converged
      if(ji.eq.0) then
	jb=-1
      else
	if(iauto.eq.1) then
	 if(jl.gt.1) then
	  swdft=abs(wdfto-wdft(1))/wdfto
	  if(swdft.lt.0.01) ji=1
	 end if
	end if
      endif
      d=wdft(1)
      return
      end
c
code for stor6
      subroutine stor6
c--save the reflections onto disc file
c
      common/ylimi/nfl,lfl,nlx,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
      common/xfour/ iverb,num,ipat,ifrag,ianom,ianomx,ipdb,iauto,irefi
c
      common /xdata/ store(500000)
      dimension istore(500000)
      equivalence(store,istore)
c--
      mxxe=lxxe
      l6 =l6a
      l6d=l6a
4105  continue
      m6=nfl
      if(kfnr(in)) 4115,4110,4110
4110  continue
      m6=mxxe
      mxxe=mxxe+mdxxe
      if(store(m6)-64) 4111,4115,4115
4111  continue
      call xslr(in)
      goto 4105
4115  continue
      call xert
      return
      end
c                                                                       
code for accum                                                          
      subroutine accum(wdf)                                             
c--accumulation of the least squares normal equations                   
c                                                                       
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx                          
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z  
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,           
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
      common/xtemp/itemp(80)                                            
      dimension temp(80)
      equivalence(itemp,temp)                                           
c--                                                                     
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,
     2 ieq,iwe,nsca,nbm,iadsc,iadbm
c                                                                       
      common /xdata/ store(500000)
      dimension istore(500000)
      equivalence(store,istore)                                         
c                                                                       
      ju=jo
      m22b=l22b
      do 1100 ka=1,n22
c--number of the elements in the current block
      jf=istore(m22b)
      if(jf.eq.0) goto 1065
      jv=istore(m22b+3)
      m22d=m22b+md22b
      jt=istore(m22d+3)-jf
c--loop on the number of the rows of the block matrix
      do 1060 jj=1,jf
      ii=ju
c--loop on the number of the columns of the block matrix
      do 1050 nj=jj,jf
      store(jv)=store(jv)+store(ju)*store(ii)
      jv=jv+1
      ii=ii+1
 1050 continue
      store(jt)=store(jt)+wdf*store(ju)
      ju=ju+1
      jt=jt+1
 1060 continue
 1065 continue
      m22b=m22b+md22b
1100  continue                                                          
      return                                                            
      end                                                               
c                                                                       
code for jsolv                                                          
      function jsolv(ix,BLimit)                                                
c--solution of normal equations
c
c  ix = 0  input reflections from disc (list 6)
c       1  input reflections from store(lxxe)
c      -1  input from store (list 31)
c
      character*200 Msg
      common /msgerr/ Msg
      common/ylimi/nfl,lfl,idummy(5)
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx                          
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z  
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,           
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
      common/xtemp/itemp(80)                                            
      dimension temp(80)
      equivalence(itemp,temp)                                           
c--                                                                     
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s            
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o                        
     2 ,n5g,l5d,n5d,md5c,l5ori 
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,
     2 ieq,iwe,nsca,nbm,iadsc,iadbm
      common/xfour/ iverb,num,ipat,ifrag,ianom,ianomx,ipdb,iauto,irefi
c--26 variables to store in the preable block of list 6
      common/xrefi/rr(7),rw(7),ss(7),shesd(2),difro(3)
c
      common /xdata/ store(500000)
      dimension istore(500000)
      equivalence(store,istore)
c
      dimension bc(10),ias(9)
      dimension jflg(3)
      character*8 singat(5)
      character*8 modiat(5)
      data jflg /4,7,9/
c--
      nsin=0                                            
      if(jl.eq.1) BLimit=9999.0
      jdim = 4
      idim = 80
      ibc = 10
      jsolv=ji
      if(iverb.le.1) goto 1000
c      call xline
      write(ncwu,900)
 900  format(29h form the new coordinate list,5x,
     2 11hversion  1a,5x,17hcreated  01/4/85,//)
      write(ncwu,2005)
2005  format(132(1h-), /,11x,'blk',14x,'num.par',10x,'num.par.b',10x,
     2 'name',11x,'par',16x,'shift.cal.',5x,'e.s.d.',6x,'ratio',/,
     3 132(1h-),/)
1000  continue
      if(n6d.gt.n22a)then
      e=d/(n6d-n22a)
      else
      e=0.0
      endif
*     write(ncwu,*) 'e,d,n6d,n22a',e,d,n6d,n22a
      f=0.0
      ff=0.0
      p=-9999.0
      q=9999.0
      do i=1,10
      bc(i)=0.0
      enddo
c---chek if the dummy overall temperature factor has been refined
      if(nbm.le.0) go to 2000
      m22b=l22b+(nbm-1)*md22b
      m=istore(m22b+3)
c--calculate the correction for the dummy overall t.f.
c  ignoring the scale factor interaction
      aa=store(m+4)/store(m+2)
2000  continue
c
c--begin the inversion - a block at a time
      npi=1
      m22c=l22c
      m22b=l22b
      do 2070 kd=1,n22
      jf=istore(m22b)
      if(jf.eq.0) goto 2065
      js=istore(m22b+3)
      m22d=m22b+md22b
      jv=istore(m22d+3)-jf
c--invert the current block                                             
      if(istat2-1) 2012,2012,2013
2013  continue
      write(ncwu,2021) kd,jf,js,jz
2021  format(//,' block no.',i3,' ; matrix order =',
     1 i4,' ; 1 elem. address =',i5,' ; work space address =',
     2 i5,/)
      iii=jf-1
      iv=js
      do 2022 ivi=1,jf
      write(ncwu,2023)(store(ivv),ivv=iv,iv+iii)
2023  format(1x,10e12.4)
      iv=iv+iii+1
      iii=iii-1
2022  continue
      write(ncwu,2023)(store(ivv),ivv=jv,jv+jf-1)
2012  continue
      if(jchol(jf,js,jz)) 3010,2011,3010
2011  continue
      call xsolv(jf,js,jv,jz)
      m=jv
      l=jz
      do 2025 i=1,jf
      store(m)=store(l)
      l=l+1
      m=m+1
2025  continue
      iii=jf
      is=js
      iv=jv
      do 2060 ka=1,jf
      call nparam(m22c,itemp)
      m22c=m22c+md22c
      c=store(iv)
      s=0.0
      a=sqrt(store(is)*e)
      if(a.gt.0.0000001) s=c/a
      if(iverb.gt.1)
     1 write(ncwu,2091) kd,npi,ka,(itemp(l),l=1,8),c,a,s
2091  format(10x,i3,16x,i4,12x,i4,15x,4a2,5x,4a2,10x,
     2 f10.5,3x,f10.5,2x,f10.5)
      f=f+s*s
      t=abs(s)                                                          
      ff=ff+t
      p=amax1(p,t)
      q=amin1(q,t)                                                      
      is=is+iii
      iii=iii-1
      iv=iv+1
      npi=npi+1
2060  continue
2065  continue
c--change the block
      m22b=m22b+md22b
      if(jf.eq.0) goto 2070
      if(iverb.gt.1) write(ncwu,2069)
2069  format(1x,131(1h ))
2070  continue
      ff=ff/n22a
      shesd(1)=p
      shesd(2)=ff
      e=sqrt(e)
      ss(1)=e
c--	ff=float(n6d)/float(n22a)
      if(iverb.lt.0) goto 3031
      write(ncwu,3005) q,p,ff
3005  format(' Minimum (shift/e.s.d.) =',f7.2,/,
     2	     ' Maximum (shift/e.s.d.) =',f7.2,/,
     3	     ' Mean    (shift/e.s.d.) =',f7.2)
      write(ncwu,3006) f
3006  format(' Sum of the squares of the (shift/e.s.d.) =',f7.2)
3031  continue
c--move the results into the proper positions
      m=jz
      l=jz+n5*10+n5o-1
      do 2381 ll=m,l
      store(ll)=0.0
2381  continue
      m22c=l22c
      m22b=l22b
      do 3070 kd=1,n22
      jf=istore(m22b)
      if(jf.eq.0) goto 3065
      js=istore(m22b+3)
      m22d=m22b+md22b
      jv=istore(m22d+3)-jf
      iii=jf
      is=js
      iv=jv
      do 3060 ka=1,jf
      m5=istore(m22c)
      b=sqrt(store(is))*e
      c=store(iv)
      if(m5) 2380,2385,2390
2380  continue
      m5a=l5o+2
      m5b=jz+n5*10
      goto 2395
2385  continue
      m5a=l5o+3
      m5b=jz+n5*10+1
      goto 2395
2390  continue
      np=istore(m22c+1)-1
      m5a=m5+20+np
      n5i=(m5-l5)/md5
      m5b=jz+n5i*10+np
2395  continue
      store(m5a)=b
      store(m5b)=c
      is=is+iii
      iii=iii-1
      iv=iv+1
      m22c=m22c+md22c
3060  continue
3065  continue
      m22b=m22b+md22b
3070  continue
c
c--check if equivalenced parameters are present
      if(ieq.eq.0) goto 3090
      m22=l22
      m5=l5
      jzh=jz
      do 3085 n=1,n5
      if(istore(m22)) 3084,3084,3075
3075  continue
      m22a=m22+1
      do 3080 i=1,10
      if(istore(m22a  ).le.0) go to 3079
      if(istore(m22a+3).le.0) go to 3079
      n5i=istore(m22a+3)
      np =istore(m22a+4)
      m5a=l5+(n5i-1)*md5
      m5a=m5a+20+np-1
      m5b=jz+(n5i-1)*10+np-1
      m5c=m5+20+i-1
      store(m5c)=store(m5a)
      store(jzh+i-1)=store(m5b)
3079  continue
      m22a=m22a+md22a
3080  continue
3084  continue
      m22=m22+md22
      m5=m5+md5
      jzh=jzh+10
3085  continue
c
c--apply and print the results
c--set up the constants involving the dummy temperature correction
3090  b=0.0
      l=l5o
      m=jz+n5*10
      if(nbm.gt.0) b=store(m+1)-aa
      do 3095 k=1,n5o
      store(m)=store(m)*z
      store(l)=store(l)+store(m)
      l=l+1
      m=m+1
3095  continue
      if(iverb) 3110,3110,3100
3100  continue
c      call xline
      write(ncwu,3032)
3032  format(5x,10h format : ,5x,14hnew coordinate,/,
     1 20x,13happlied shift,/,
     2 20x,17hcalculated e.s.d.,//)
c--print the results for the overall parameters
      write(ncwu,1020) n5o
 1020 format(/,i3,22h  overall parameter(s),/)
      write(ncwu,1030)
 1030 format(3x,6h scale,4x,8h ob(iso),/)
      i=l5o+n5o-1
      write(ncwu,1040)(store(j),j=l5o,i)
 1040 format(1x,10f10.5)
      k=jz+n5*10
      write(ncwu,1040)(store(m),m=k,k+n5o-1)
      l=l5o+n5o
      write(ncwu,1040)(store(m),m=l,l+n5o-1)
      write(ncwu,1045)b
1045  format(/,46h correction to isotropic temperature factor =  ,
     2 f9.5,/)
      write(ncwu,3035)
3035  format(1x,5h name,2x,5h type,1x,7h serial,4x,2h x,8x,2h y,8x,2h z,
     2 4x,11hb(iso)/(11),2x,6h b(12),4x,6h b(13), 4x,6h b(22),
     3 4x,6h b(23),4x,6h b(33),3x,4h occ,/)
3110  continue
      m5=l5
      m22=l22
      ll=jz
      do 3040 ka=1,n5
      if(istore(m22)) 3052,3052,3054
3054  continue
      store(m5+12)=1.0
      if(nbm.le.0) go to 3050
c--set up the constants involving the dummy temperature correction
      if(store(m5+10)) 3056,3055,3056
3055  continue
      bc(4)=b
      goto 3050
3056  continue
      jy=l1s
      j=l1s+3
      do 1046 jx=1,3
      bc(jx+3)=b*store(jy)
      bc(jx+6)=b*store(j)
      jy=jy+1
      j=j+1
1046  continue
3050  continue
      call saply(ll,bc,ibc)
3052  continue
      m5i=m5
      m5h=m5+13
      l=m5+1
      lk=m5+11
      if(iverb.gt.0) write(ncwu,3036)(istore(mm),mm=m5h,m5h+3),
     2  istore(m5i),(store(m),m=l,lk)
3036  format(1x,4a2,2x,a2,f7.0,10f10.5)
      l=ll
      lk=ll+9
      if(iverb.gt.0) write(ncwu,3037) (store(m),m=l,lk)
      l=m5+20
      lk=m5+29
      if(iverb.gt.0) write(ncwu,3037) (store(m),m=l,lk)
3037  format(20x,10f10.5)
      if(iverb.gt.0) write(ncwu,3038)
3038  format(1x,131(1h ))
      m5=m5+md5
      m22=m22+md22
      ll=ll+10
3040  continue
c--modified the unreasonable anisotropic temperature factor
      ll=jz
      m5=l5
      n=0
      nmodi=0
      do i=1,5
	modiat(i)=' '
      enddo
      if(iverb.lt.-3)n=1
      do 3190 k=1,n5
      if(ix.ne.-1) goto 3290
      m=m5+2
      do 3210 j=1,3
      i=store(m)*1000
      ii=mod(i,250)
      if(ii.eq.0) store(m)=store(m)+0.001
      m=m+1
3210  continue
3290  continue
      do 3185 j=1,9
3185  ias(j)=ib
      jflag=store(m5+30)
      if(jflg5(m5).ne.0) then
      if(n.eq.0.and.iverb.gt.0) write(ncwu,3120)jflag
3120  format(/,i5,' warning! the following atoms are modified:',/)
      n=n+1
	nmodi=nmodi+1
	if(nmodi.le.5)then
	  m5h=m5+13
	  write(modiat(nmodi),'(4a2)') (istore(m),m=m5h,m5h+3)
        endif
c      jflagg=jflg(jflag)
c      ias(jflagg)=ia
c	jx=m5+10
c	if(store(jx).eq.0.0) then
c	 store(m5+5)=store(m5+23)
c	endif
c      jx=m5+5
c      llx=ll+3
c      i=3
c      do 3160 j=1,3
c      if(store(jx)) 3130,3140,3140
c3130  continue
c      if(ix.ne.-1) goto 3131
c      store(jx)=store(jx)-store(llx)
c     store(m5+11)=store(m5+11)+0.5*store(m5+11)
c      goto 3140
c3131  continue
c      store(jx)=store(jx+18)
c3140  continue
c      llx=llx+i
c      jx=jx+i
c      i=i-1
c3160  continue
c      go to 3170
c3150  if(n.eq.0.and.iverb.gt.0)write(ncwu,3120)jflag
c      n=n+1
c      jflagg=iabs(jflag)
c      ias(jflagg)=ia
c      jsolv=-2
      m5i=m5
      m5h=m5+13
       iserial=nint(store(m5+1))
      l=m5+2
      lk=m5+11
      if(iverb.gt.0)
     1write(ncwu,3136)(istore(mm),mm=m5h,m5h+3),istore(m5i),
     2	iserial,(store(m),m=l,lk)
3136	format(1x,4a2,1x,a2,i6,11f9.5)
      endif
      m5=m5+md5
      ll=ll+10
3190  continue
c--stampa messaggio b modificati
      if(nmodi.gt.0) then
      if(nmodi.gt.5) then
	 nmodi=5
c	  write(ncwu,3564)nmodi,(modiat(j),j=1,5)
	 write(Msg,3564)nmodi,(modiat(j),j=1,5)
      else
c	  write(ncwu,3566)nmodi,(modiat(j),j=1,nmodi)
	 write(Msg,3566)nmodi,(modiat(j),j=1,nmodi)
      endif
 3564 format('At least',i3,' atoms have T.F. inconsistent : ',5a)
 3566 format(i3,' atoms have T.F. inconsistent : ',5a)
      call manage_mouse_cursor(0)
      call screrr(ier,Msg,1)
*     call manage_mouse_cursor
      end if
c--fine stampa
      nsin=0
      if(jl.eq.1) then
c--calculate the <b>
      m5=l5
      sumb=0.0
      do 3450 i=1,n5
      if(store(m5+10)) 3400,3400,3410
3400  continue
      bbb=store(m5+5)
      goto 3420
3410  continue
      bbb         = 4.0/3.0  *(store(m5+ 5)*store(l1m1  )
     1                        +store(m5+ 6)*store(l1m1+1)
     2                        +store(m5+ 7)*store(l1m1+2)
     3                        +store(m5+ 8)*store(l1m1+4)
     4                        +store(m5+ 9)*store(l1m1+5)
     5                        +store(m5+10)*store(l1m1+8))
3420  continue
      sumb=sumb+bbb
      m5=m5+md5
3450  continue
      sumb=sumb/n5
      BLimit=sumb*5
      write(ncwu,3452) sumb
3452  format(' average value of B(equiv) =',f10.3)
      do i=1,5
      singat(i)=' '
      enddo
      nsin=0
      endif
c--check the b(iso) or b(equiv) for the last lsq cycle
3405  continue
      if(ji.le.1) then
      m5=l5
      do 3550 i=1,n5
      if(store(m5+10)) 3500,3500,3510
3500  continue
      bbb=store(m5+5)
      goto 3520
3510  continue
      bbb         = 4.0/3.0  *(store(m5+ 5)*store(l1m1  )
     1                        +store(m5+ 6)*store(l1m1+1)
     2                        +store(m5+ 7)*store(l1m1+2)
     3                        +store(m5+ 8)*store(l1m1+4)
     4                        +store(m5+ 9)*store(l1m1+5)
     5                        +store(m5+10)*store(l1m1+8))
3520  continue
      if(bbb.ge.BLimit) then
        nsin=nsin+1
        if(nsin.le.5)then
          m5h=m5+13
          write(singat(nsin),'(4a2)') (istore(m),m=m5h,m5h+3)
        endif
      endif
      m5=m5+md5
3550  continue
      if(nsin.gt.0) then
      if(nsin.gt.5) then
         nsin=5
c         write(ncwu,3560)nsin,BLimit,(singat(j),j=1,5)
         write(Msg,3560)nsin,BLimit,(singat(j),j=1,5)
      else
c         write(ncwu,3562)nsin,BLimit,(singat(j),j=1,nsin)
         write(Msg,3562)nsin,BLimit,(singat(j),j=1,nsin)
      endif
 3560 format('At least',i2,' atoms have b(equiv) > ',f6.1,' : ',5a)
 3562 format(i2,' atoms have b(equiv) > ',f6.1,' : ',5a)
      call manage_mouse_cursor(0)
      call screrr(ier,Msg,1)
*     call manage_mouse_cursor
      end if
      end if
c--end of check b values for the last lsq cycle
      if(jsolv.lt.0)return
      call sclr5
      if(ix.eq.-1) return
c--write the list 5 on disc file
      l=nfl
      nfl=l5d
c      write(*,*) ' jsolv: l5d,l5ori,n5d',l5d,l5ori,n5d
c      do iii=l5d,l5-1
c      write(*,*)'iii,store(iii)',iii,store(iii)
c      enddo
      call xfrml(5,n5d)
      nfl=l
      return
3010  continue
      jsolv=-1
      ji=0
      goto 3405
      end
c
code for nparam
      subroutine nparam(m22c,itemp)
c--put the current paramater 
c
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori 
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
c
      common /xdata/ store(500000)
      dimension istore(500000)
      equivalence(store,istore)
c
      dimension itemp(40)
      dimension nam(4)
      dimension iscal(4),iobi(4)
      character*40 ifmt
      data iscal/2hsc,2hal,2he ,2h  /
      data iobi /2hob,2h(i,2hso,2h) /
c--
      jdim=4
      idimen=40
      j1=1
      do 2305 i=1,8
      itemp(i)=ib
2305  continue
      ifmt=' '
      m5=istore(m22c)
      if(m5) 2310,2315,2320
2310  continue
      call inlin(0,j1,iscal,itemp,jdim,idimen)
      goto 2375
2315  continue
      call inlin(0,j1,iobi,itemp,jdim,idimen)
      go to 2375
2320  continue
      m5h=m5+13
      call inlin(0,j1,istore(m5h),itemp,jdim,idimen)
      np=istore(m22c+1)
      call par(np,nam)
      call inlin(0,j1,nam,itemp,jdim,idimen)
2375  continue
      return
      end
c
code for saply
      subroutine saply(lp,bc,ibc)
c--apply the calculate shifts
c
c  lp    address of the shifts
c--
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c--
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori 
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,
     2 ieq,iwe,nsca,nbm,iadsc,iadbm
c
      common /xdata/ store(500000)
      dimension istore(500000)
      equivalence(store,istore)
c
      dimension buf1(10),buf2(10)
      dimension bc(ibc)
      dimension bij(3,3)
c--
      np=10
      m22a=m22+1
      jt=lp
      do 1010 jx=1,np                                                   
      if(istore(m22a))1015,1015,1017
1017  continue
c--calculate the shift for this parameter                               
      store(jt)=store(jt)+bc(jx)
1015  continue
      m22a=m22a+md22a
      jt=jt+1                                                           
 1010 continue                                                          
c                                                                       
c--check if there are parameters with a weight different from 1
      if(iwe.eq.0) go to 915
      m22a=m22+1
      jt=lp
      do 910 k=1,np                                                     
      f=istore(m22a+1)
      f=f/1000.0
      store(jt)=store(jt)*f
      jt=jt+1
      m22a=m22a+md22a
910   continue
915   continue
c--apply the shifts
      jt=lp
      m22a=m22+1
c--	jx=m5+2
      do 1020 i=1,np
      if(istore(m22a).gt.0) then
       if(i.le.3) store(jt)=store(jt)*z
       if(i.gt.3) store(jt)=store(jt)*y
       if(i.le.3) then
	if(abs(store(jt)).gt.1.)store(m5+30)=-i
       endif
	i1=i-1
	incr=2
        jx =m5+incr+i1
	buf1(i)=store(jt)
	buf2(i)=store(jx)
       store(jx)=store(jx)+store(jt)
      endif
      m22a=m22a+md22a
      jt=jt+1
 1020 continue                                                          
c--check if there are unreasonable values for t.p.
      store(m5+30)=0
      jx=m5+10
      if(store(jx).eq.0.0) then
       if(store(m5+5).le.0.0) then
	store(m5+5)=buf2(4)
	store(m5+30)=1
       endif
      else
c--check the bii terms
      jx=m5+5
      i=3
      do 3160 j=1,3
      if(store(jx)) 3130,3130,3140
3130  continue
      store(m5+30)=j
3140  continue
      jx=jx+i
      i=i-1
3160  continue
      if(store(m5+30).eq.0) then
c--check the det of ellipsoid
      bij(1,1)=store(m5+5)
      bij(1,2)=0.5*store(m5+6)
      bij(1,3)=0.5*store(m5+7)
      bij(2,1)=bij(1,2)
      bij(2,2)=store(m5+8)
      bij(2,3)=0.5*store(m5+9)
      bij(3,1)=bij(1,3)
      bij(3,2)=bij(2,3)
      bij(3,3)=store(m5+10)
      call dt3(bij,det)
c      write(ncwu,*)'determinante:',det
      if(det.le.0.0) then
	store(m5+30)=1
       endif
      endif
      if(store(m5+30).eq.0) then
      s1=bij(2,2)*bij(3,3)-bij(2,3)*bij(3,2)
      s2=bij(1,1)*bij(3,3)-bij(1,3)*bij(3,1)
      s3=bij(1,1)*bij(2,2)-bij(1,2)*bij(2,1)
      stot=s1+s2+s3
      if(stot.le.0.0) then
	store(m5+30)=1
       endif
      endif
      if(store(m5+30).ne.0) then
	do i=1,6
	incr=4
	ij=3+i
	jx =m5+incr+i
c--        write(ncwu,*) '-->',store(jx),buf2(ij)
	store(jx)=buf2(ij)
	enddo
      endif
c--end of check
      endif
      return                                                            
      end                                                               
c
code for par                                                            
      subroutine par(npar,nam)
c--set the name of the parameter
c
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori 
c--
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint
c--
      common/xdata/ store(500000)
c--
      dimension namb(3),nambx(6),namo(2),nam(4)
      data namx/2hx /,namy/2hy /,namz/2hz /
      data namb/2hb(,2his,2ho)/,namo/2hoc,2hc /
      data nambx/2h11,2h12,2h13,2h22,2h23,2h33/
c--
      nam(4)=ib
      go to(10,20,30,40,50,60,70,80,90,100), npar
10    continue
      nam(1)=namx
      nam(2)=ib
      nam(3)=ib
      go to 110
20    continue
      nam(1)=namy
      nam(2)=ib
      nam(3)=ib
      go to 110
30    continue
      nam(1)=namz
      nam(2)=ib
      nam(3)=ib
      go to 110
40    continue
      if(store(m5+10)) 45,45,46
45    continue
      nam(1)=namb(1)
      nam(2)=namb(2)
      nam(3)=namb(3)
      go to 110
46    continue
      nam(1)=namb(1)
      nam(2)=nambx(1)
      nam(3)=ie
      go to 110
50    continue
      nam(1)=namb(1)
      nam(2)=nambx(2)
      nam(3)=ie
      go to 110
60    continue
      nam(1)=namb(1)
      nam(2)=nambx(3)
      nam(3)=ie
      go to 110
70    continue
      nam(1)=namb(1)
      nam(2)=nambx(4)
      nam(3)=ie
      go to 110
80    continue
      nam(1)=namb(1)
      nam(2)=nambx(5)
      nam(3)=ie
      go to110
90    continue
      nam(1)=namb(1)
      nam(2)=nambx(6)
      nam(3)=ie
      go to 110
100   continue
      nam(1)=namo(1)
      nam(2)=namo(2)
      nam(3)=ib
110   continue                                                          
      return                                                            
      end                                                               
c                                                                       
code for jchol                                                          
      function jchol (n,ibase,ires)                                     
c--inversion of a symmetric upper triangular matrix by the cholesky     
c  method                                                               
c--the matrix is held in the array store                                
c  n      order of rhe matrix                                           
c  ibase  address of the first element                                  
c  ires   address of work space of length n                             
c--                                                                     
      double precision dpv,asing,bsing,csing,dsing,epv,one              
      common/xchox/ n1,ls,lt,lu,lv,lw,add,dummy
     2 ,dpv,asing,bsing,csing
c
      common /xdata/ store(500000)
      data dsing/0.2d1/
      data one/0.1d1/                                                   
c--assign the singularity check limits                                  
      csing=dsing**(-34)                                                
      bsing=dsqrt(csing)                                                
c--decompose the matrix in to l.l'                                      
      lu=ires                                                           
      n1=n-1                                                            
      k=ibase                                                           
      aa=store(k)                                                        
      dpv=dble(aa)                                                      
      asing=bsing                                                       
c--check the first element of the first row                             
      if(n1) 1300,2000,1000                                             
 1000 continue                                                          
      if(dpv-bsing) 1010,1010,1020                                      
 1010 continue                                                          
      call xsing(0,n,ibase)                                             
      go to 2015                                                        
 1020 continue                                                          
      dpv=dsqrt(dpv)                                                    
      store(k)=sngl(dpv)                                                 
      store(lu)=1.0/store(k)                                             
      k=k+1                                                             
      do 1030 i=1,n1                                                    
      store(k)=store(k)*store(lu)                                         
      k=k+1                                                             
 1030 continue                                                          
c--continue with the rest of the matrix                                 
 1040 continue                                                          
      lu=lu+1                                                           
      do 1140 i=1,n1                                                    
      aa=store(k)
      dpv=dble(aa)
      asing=dpv*csing
      l=ibase+i
      do 1050 j=1,i
      aa=store(l)*store(l)
      dpv=dpv-dble(aa)
      l=l+n-j
 1050 continue
      if(dpv-bsing) 1070,1070,1060
 1060 continue
      if(dpv-asing) 1070,1070,1080
 1070 continue
      ioi=i
      call xsing(ioi,n,ibase)
      go to 2015
 1080 continue
      dpv=dsqrt(dpv)
      epv=one/dpv
      store(k)=sngl(dpv)
      store(lu)=1.0/store(k)
      k=k+1
      if(i-n1) 1090,1120,1090
 1090 continue
      lw=i+1
      do 1110 j=lw,n1
      aa=store(k)
      dpv=dble(aa)
      ls=ibase+i
      lt=ibase+j
      do 1100 m=1,i
      aa=store(ls)*store(lt)
      dpv=dpv-dble(aa)
      ls=ls+n-m
      lt=lt+n-m
 1100 continue
      store(k)=sngl(dpv*epv)
      k=k+1
 1110 continue
 1120 continue
      lu=lu+1
 1140 continue
c--inversion of the triangular matrix l
      lv=k
      k=k-1
      lu=lu-1
      store(k)=store(lu)
      k=k-1
      lu=lu-1
      do 1170 i=1,n1
      lw=lv
      do 1160 j=1,i
      add=0.0
      lw=lw-j
      lt=k
      ls=lw
      do 1150 l=j,i
      add=add-store(lt)*store(ls)
      lt=lt-1
      ls=ls-l
 1150 continue
      store(k)=add*store(lu)
      k=k-1
 1160 continue
      store(k)=store(lu)
      k=k-1
      lu=lu-1
 1170 continue
c--form the inverse matrix from the two inverted triangles
      k=ibase
      ls=ibase-1
      do 1200 i=1,n
      lt=ls
      do 1190 j=i,n
      add=0.0
      do 1180 m=j,n
      lv=m+lt
      lw=m+ls
      add=add+store(lv)*store(lw)
 1180 continue
      store(k)=add
      k=k+1
      lt=lt+n-j
 1190 continue
      ls=ls+n-i
 1200 continue
 1300 continue
      jchol=0
      return
c--only one element
 2000 continue
      if(dpv-asing) 2010,2010,2020
 2010 continue
      call xsing(0,n,ibase)
2015  continue
      jchol=-1
      return
 2020 continue
      store(k)=1.0/store(k)
      go to 1300
      end
c
code for xsolv
      subroutine xsolv (n,ibase,ivect,ires)
c--solve the normal equations
c  n     order of the matrix
c  ibase first location of the matrix
c  ivect first location of the vector
c  ires  first location of the results
c--
      double precision dpv,asing,bsing,csing
      common/xchox/ n1,ls,lt,lu,lv,lw,add,dummy
     2 ,dpv,asing,bsing,csing
c--
      common /xdata/ store(500000)
c--work out the answers
 1300 continue
      k=ires
      do 1360 i=1,n
      ls=ibase+i-1
      store(k)=0.0
      lt=ivect
      do 1350 j=1,n
      store(k)=store(k)+store(lt)*store(ls)
      if(j-i) 1310,1330,1330
 1310 continue
      ls=ls+n-j
      go to 1340
 1330 continue
      ls=ls+1
 1340 continue
      lt=lt+1
 1350 continue
      k=k+1
 1360 continue
 1370 continue
      return
      end
c
code for xsing
      subroutine xsing(noc,n,ibase)
c--singularity error
c
      character*200 Msg
      common /msgerr/ Msg
      double precision dpv,asing,bsing,csing
      common/xchox/ n1,ls,lt,lu,lv,lw,add,dummy
     2 ,dpv,asing,bsing,csing
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,
     2 ieq,iwe,nsca,nbm,iadsc,iadbm
c
      common /xdata/ store(500000)
c
      ls=noc+1
      i=m22c+noc*md22c
      call nparam(i,itemp)
      write(Msg,1000)ls,(itemp(j),j=1,8)
 1000 format(33h singularity - relative parameter,i5,' --> ',8a2)
      ier = -1
      call manage_mouse_cursor(0)
      call screrr(ier,Msg,1)
*     call manage_mouse_cursor
c
      ls=ibase+noc
      do 1030 lt=1,n
      store(ls)=0.0
      if(noc-lt) 1020,1010,1010
 1010 continue
      ls=ls+n-lt
      go to 1030
 1020 continue
      ls=ls+1
      k=k+1
 1030 continue
      store(lu)=0.0
      return
      end
c
code for jab22
      function jab22(in)
c--form absolute list 22
c
c  n22a number of parameters to refine
c  lenx occupation of normal equation matricies
c  len0 occupation for partial derivatives
c
      character*200 Msg
      common /msgerr/ Msg
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori 
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,
     2 ieq,iwe,nsca,nbm,iadsc,iadbm
c
      common/ylimi/nfl,lfl,nl,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(500000)
      dimension istore(500000)
      equivalence(store,istore)
c--
      dimension iline(100),nam(4)
      dimension iscal(4),iobi(4)
      data iscal/2hsc,2hal,2he ,2h  /
      data iobi /2hob,2h(i,2hso,2h) /
c--
      inn=in
      jab22=0
      jdim = 4
      idimen = 100
c
c--calculate the number of the parameter for each block
      lz=nfl
      l22b=lz
      md22b=4
      l22c=l22b+(n22+1)*md22b
      md22c=2
      m22b=l22b
c      write(6,*)' lz,l22,n22,n5,l22c= ',lz,l22,n22,n5,l22c
c      write(6,*)' ieq,iwe,nsca,nbm,iadsc,iadbm : ',
c     1 ieq,iwe,nsca,nbm,iadsc,iadbm 
      do 2100 i=1,n22
      istore(m22b)=0
      m22b=m22b+md22b
2100  continue
      m22=l22                                                           
      do 2120 n=1,n5                                                    
      ii=0
      ieqx=0
      m22a=m22+1
      do 2110 i=1,10
      j=istore(m22a)
c      write(6,*)'n,i,j',n,i,j
      if(j.le.0) go to 2106
      if(istore(m22a+3).gt.0) goto 2105
      ii=ii+1
      m22b=l22b+(j-1)*md22b
      istore(m22b)=istore(m22b)+1
      goto 2106
2105  continue
      ieqx=1
2106  continue
      m22a=m22a+md22a
2110  continue
      if((ii.eq.0).and.(ieqx.eq.1)) ii=1
      istore(m22)=ii
      m22=m22+md22
2120  continue
      m22b=l22b+(nbm-1)*md22b                                           
      if(nbm.ne.0)istore(m22b)=istore(m22b)+1                           
      m22b=l22b+(nsca-1)*md22b                                          
      if(nsca.ne.0)istore(m22b)=istore(m22b)+1                          
      lblx=0                                                            
      lenx=0                                                            
      leno=0                                                            
      n22a=0
      m22b=l22b
      do 2130 i=1,n22
      n=istore(m22b)
      if(n.eq.0)goto 2129
      n22a=n22a+n
      lenx=lenx+n*(n+1)/2+n
      leno=leno+n*jq
      lblx=max0(n,lblx)
2129  continue
      m22b=m22b+md22b
2130  continue
      len=l22c+n22a*md22c
c      write(*,*) 'len=',len
      nfl=len
c      m=nfl-1
c      l=1
c      call xsac(122,l,lz,m)
c
c--calculate the address of complete partial derivatives
c  and of normal equations matrix
      jo=nfl
      jp=jo+n22a-1
      jr=jo+leno
      nfl=jr+lenx
c      m=nfl-1
c      call xsac(132,l,jo,m)
c
c--check if there is enough room for the work area
c  or for the shift storage
c--jz e' anche l'indirizzo finale delle work aree per l'azzeramento
      jz=nfl
      nfl=jz+n5*10+n5o
c      write(*,*) 'jz,jo,jp,jr=',jz,jo,jp,jr
c      write(*,*) 'nfl,lfl=',nfl,lfl
c      m=nfl-1
c      call xsac(105,l,jz,m)
c--check nfl against lfl
      if(nfl.ge.lfl) then
       write(ncwu,2000) lenx
2000   format(/,' There is not enough room for the work area:',/,
     1          ' The requested for the normal equations',
     2          ' matrix is',i7)
      ier=-1
      Msg=' The LSQ matrix type will be set to DIAGONAL' 
      call manage_mouse_cursor(0)
      call screrr(ier,Msg,2)
*     call manage_mouse_cursor
       jab22=-1
       return
      endif 
c
c--calculate the initial address for each block
      m22b=l22b
      istore(m22b+1)=jo
      istore(m22b+2)=l22c
      do 2142 i=2,n22
      n=istore(m22b)
c      if(n.eq.0) goto 2143
      m22d=m22b+md22b
      istore(m22d+1)=istore(m22b+1)+n*jq
      istore(m22d+2)=istore(m22b+2)+n*md22c
2143  continue
      m22b=m22b+md22b
2142  continue
c
c--calculate the address of the derivative for each parameter
      m22b=l22b
      do 2145 i=1,n22
      istore(m22b+3)=istore(m22b+1)
c      write(*,*)'block',istore(m22b),istore(m22b+1),istore(m22b+2),
c     1 istore(m22b+3)
      m22b=m22b+md22b
2145  continue
      m22=l22
      do 2180 n=1,n5
      if(istore(m22)) 2175,2175,2150
2150  continue
      m22a=m22+1
      do 2170 i=1,10
      j=istore(m22a)
      if(j.le.0) go to 2165
      if(istore(m22a+3).gt.0) goto 2165
      m22b=l22b+(j-1)*md22b
      istore(m22a+2)=istore(m22b+3)
      istore(m22b+3)=istore(m22b+3)+jq
2165  continue
      m22a=m22a+md22a
2170  continue
2175  continue
      m22=m22+md22
2180  continue
      if(nsca.eq.0) goto 2184
      m22b=l22b+(nsca-1)*md22b
      iadsc=istore(m22b+3)
      istore(m22b+3)=istore(m22b+3)+jq
2184  continue
      if(nbm.eq.0) goto 2183
      m22b=l22b+(nbm-1)*md22b
      iadbm=istore(m22b+3)
      istore(m22b+3)=istore(m22b+3)+jq
2183  continue
c
c--check if equivalenced parameter are present
      if(ieq.eq.0) goto 2186
      m22=l22
      do 2139 n=1,n5
      if(istore(m22)) 2138,2138,2131
2131  continue
      m22a=m22+1
      do 2137 i=1,10
      if(istore(m22a  ).le.0) goto 2135
      if(istore(m22a+3).le.0) goto 2135
      n5i=istore(m22a+3)
      m22d=l22+(n5i-1)*md22+1
      np=istore(m22a+4)
      m22d=m22d+(np-1)*md22a
      istore(m22a+2)=istore(m22d+2)
2135  continue
      m22a=m22a+md22a
2137  continue
2138  continue
      m22=m22+md22
2139  continue
c
c--print for testing
2186  continue
      if(istat2.le.1) goto 2194
      write(ncwu,2176) jq
2176  format(//,' absolute address of the derivative',//,
     1 ' parameter',15x,'block',10x,'address',6x,'(step=',i2,')',/)
      do 2179 i=1,4
      nam(i)=ib
2179  continue
      if(nbm.ne.0) write(ncwu,2177) iobi,nam,nbm,iadbm
2177  format(1x,4a2,2x,4a2,i10,i15)
      if(nsca.ne.0) write(ncwu,2177) iscal,nam,nsca,iadsc
      m5=l5
      m22=l22
      do 2280 n=1,n5
      if(istore(m22)) 2275,2275,2250
2250  continue
      m22a=m22+1
      do 2270 i=1,10
      j=istore(m22a)
      if(j.le.0) goto 2265
      i1=i
      call par(i1,nam)
      m5h=m5+13
      write(ncwu,2177) (istore(ll),ll=m5h,m5h+3),nam,
     1 j,istore(m22a+2)
2265  continue
      m22a=m22a+md22a
2270  continue
2275  continue
      m22=m22+md22
      m5=m5+md5
2280  continue
c
c--insert the address of parameters in list 22c
2194  continue
      m22b=l22b
      do 2195 i=1,n22
      istore(m22b+3)=istore(m22b+2)
      m22b=m22b+md22b
2195  continue
      m22=l22
      m5=l5
      do 2230 n=1,n5
      if(istore(m22)) 2225,2225,2190
2190  continue
      m22a=m22+1
      do 2210 i=1,10
      j=istore(m22a)
c      write(*,*)'fine 2210',n,istore(m22),j,i
      if(j.le.0) go to 2200
      if(istore(m22a+3).gt.0) goto 2200
      m22b=l22b+(j-1)*md22b
      m22c=istore(m22b+3)
      istore(m22c  )=m5
      istore(m22c+1)=i
      istore(m22b+3)=istore(m22b+3)+md22c
2200  continue
      m22a=m22a+md22a
2210  continue
2225  continue
c      write(*,*)'fine 2225',n,istore(m22)
      m22=m22+md22
      m5=m5+md5
2230  continue
      if(nsca.eq.0) goto 2251
      m22b=l22b+(nsca-1)*md22b
      m22c=istore(m22b+3)
      istore(m22c)=-1
      istore(m22b+3)=istore(m22b+3)+md22c
2251  continue
      if(nbm.eq.0) goto 2240
      m22b=l22b+(nbm-1)*md22b
      m22c=istore(m22b+3)
      istore(m22c)=0
      istore(m22b+3)=istore(m22b+3)+md22c
2240  continue
      if(istat2.le.1) goto 2400
      write(ncwu,2300) n22,n22a
2300  format(//,' number of block(s) =',i6,/,
     1 ' number of parameters to refine =',i6,//,
     2 ' block',5x,'parameters',/)
      m22c=l22c
      m22b=l22b
      do 2390 i=1,n22
      ix=i
      j1=1
      do 2305 j=1,50
      iline(j)=ib
2305  continue
      nb=istore(m22b)
      if(nb.eq.0) goto 2389
      do 2380 n=1,nb
      m5=istore(m22c)
      if(m5) 2310,2315,2320
2310  continue
      call inlin(ix,j1,iscal,iline,jdim,idimen)
      j1=j1+5
      goto 2375
2315  continue
      call inlin(ix,j1,iobi,iline,jdim,idimen)
      j1=j1+5
      go to 2375
2320  continue
      m5h=m5+13
      call inlin(ix,j1,istore(m5h),iline,jdim,idimen)
      np=istore(m22c+1)
      call par(np,nam)
      call inlin(ix,j1,nam,iline,jdim,idimen)
2375  continue
      m22c=m22c+md22c
2380  continue
      if(j1.ne.1) call sprtl(ix,j1,iline)
      write(ncwu,2385)
2385  format(1h )
2389  continue
      m22b=m22b+md22b
2390  continue
c
c--calculate the initial address of normal equations
c  matrix for each block
2400  continue
      m22b=l22b
      istore(m22b+3)=jr
      do 2410 i=1,n22
      n=istore(m22b)
c      if(n.eq.0)goto 2405
      m22d=m22b+md22b
      istore(m22d+3)=istore(m22b+3)+n*(n+1)/2+n
2405  continue
      m22b=m22b+md22b
2410  continue
      return
      end
c
code for inlin
      subroutine inlin(ix,j1,ibu,iline,jdim,idim)
c--insert onto the printer buffer
c
      dimension ibu(jdim),iline(idim)
c--
      j2=j1
      do 1000 j=1,4
      iline(j2)=ibu(j)
      j2=j2+1
1000  continue
      j1=j1+5
      if(j1.lt.50) return
      call sprtl(ix,j1,iline)
      return
      end
c
code for sprtl
      subroutine sprtl(ix,j1,iline)
c--print the line
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint
      dimension iline(1)
c--
      if(ix.eq.0) write(ncwu,1000)(iline(i),i=1,50)
1000  format(10x,50a2)
      if(ix.ne.0) write(ncwu,1010)ix,(iline(i),i=1,50)
1010  format(i4,6x,50a2)
      ix=0
      j1=1
      do 1020 i=1,50
      iline(i)=ib
1020  continue
      return
      end
 
