c-- sir code for sir97                          Release 97.01
      program sir97
c      use dflib
c      use dfwin
      character file*256,line*256
      character fname(15)*256,ext(15)*4,path*256
c-- file names and extensions
      common/dotdat/ fname,ext,path
c-- input/output units, title
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c-- trigonometric tables and constants
      common/trig/sint(450),pi,twopi,dtor,rtod
c-- implementation specific flags
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
c-- direct access file related commons
      common /xfile/ ifile,jjlist,jjend,infle,nwfle,icfle,lid(4),ifine
      common /xfili/ lfirst,nwblo,lindex(240)
c-- scratch file reflexion arrays
      common /buffer/ vet(6,85),nrpb,idumb(4)
c-- user requests
      common / ureq1/ jpatt,jpunt(1501),ksacc,jseteq,jumpp,jmpsie,nsec
c-- coordinats
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
      common /atomo/ xtot(4000)
c-- graphics
      common/screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /SizeScr/ MinScX, MaxScX, MinScY, MaxScY
      common /scale/ x11scale(2),x11disp(2),ragmed,DeltaX,DeltaY
c--
      common /bufferg/ ixv(1000),iyv(1000),kptr(1000),nptr,
     *                 ixp(107),iyp(107)
      common /fonte/ FntType,FntAscent,FntPixWidth,FntPixHeight,
     *               FntAvgWidth
      common /puls/Lim(190,4),iAct(190),iDepr(190),iRep(190),iFocus(190)
     *              ,ipu(190),iHB,iDeep,nFocus(5)
      common /parfin/ LimF(5,4), iPal(5), Livel, nPulsTot(5), iFull(5),
     *                iHConv, iwLMenu, iVP(5,4), Lhh(5), Lhs(5)
      common /contr/ NF,iFirstTime,Titolo,Ratio,ifCont,ifEdge,ifScale,
     *               kplty,ifDrRes,AngDef,PercTra,ViewDist,ifChangedXYZ
      common /GeneraC/ DeA(3), DeADef(3), nCell(3),
     *                 RB(3, 3, 48), T(3, 48),
     *                 Shf(3, 3), Tra(3, 20), nsy, NatInd, nt1
      common /atomi/ xyz(3,9800),NAT,RR(9800),iCol(9800),iOrd(9800),nv,
     *        MLU(9800), Lab(9800), RS(9800), ipix(3,9800),iEqui(9800)
     *       ,nOpEq(9800)
      common /Crt/ iBarre(99, 4),Lett(100),NumBar(99), iCheBarre(99, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PIG,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(9800,2), RI(3)
      character Lab*8, nt1*1, Titolo*80, Lett*1
      real MLU
      common /viewp/ jx1, jy1, jx2, jy2
      common /colori/ c, cs, csd, nPal, Palets, DefPals, nActPal
      integer c(4,11),cs(4,2,11),Palets(4,256),DefPals(4,256),
     *        csd(4,2,11)
      common /RotMou/ iAnchorX, iAnchorY, IfDrag, IcanDrag, iDragEnabled
     *               ,mEv_fsBtn
      common /W95/ ifW95
c ---
      character*256 sirtx,ffile,sirpal,iasun,ciffle
      common /sirtxt/ sirtx,jhelp,ffile,sirpal,jwrpal,iasun,ciffle
      common /WildRun1/ nWsymb,nWrand,kWstop,NoWild
      common /WildRun2/ nwild,nWDelay,kWDelay,iverbo,interv,errev(101)
      common /chm/ IfChangeHM, IfHelpEnabled, IfRotTran
      common /PlotOpt/ ifLabels, nRadType, ProbF, ifMonoCr, nColPal
      common /BackSt/ IfBackingStore
      common /Brow/ ifBro,kBro,nBro,ifEditing
      common /sfact/ nSfCard, sfacm(8, 9), sfacc(8)
      character *2 sfacc
c ---
      iAbout = 0
      kprog = kprog + 1
   10 continue
c
c-- name of scattering factors file,
c-- help file,palets file, space group file and CIF file
c
      ffile  = 'SirWare.xen'
      sirtx  = 'SirWare.hlp'
      sirpal = 'SirWare.pal'
      iasun  = 'SirWare.spg'
      ciffle = 'SirWare.cif'
c
      MinScX = kscrx
      MinScY = kscry
      IfBackingStore = 2
      IfHelpEnabled = 1
      IfChangeHM = 1
      IfRotTran = 1
      iDragEnabled = 0
      IfLabels = 0
      nRadType = 1
      ProbF = 0.5
      ifEditing = 0
      nSfCard = 0
      call BeccaSt(ier,iAbout)
      if (ier.lt.0) go to 1200
c     set flag for caos environment
      jcaos=0
c     set flag for direct execution
      iexec=-1
c
c-- set up the default names for work files
c
      do 40 i=1,5
	L = Lung(fname(i))
	if (L.gt.0) then
         file=fname(i)(1:L)//ext(i)
	else
	   file = ext(i)
	end if
	if (ifW95.ne.1) then
         call xcmprp(file,lfile)
	end if
      fname(i)=file
   40 continue
	L = Lung(fname(9))
	if (L.gt.0) then
         file=fname(9)(1:L)//ext(9)
	else
         file=ext(9)
	end if
	if (ifW95.ne.1) then
         call xcmprp(file,lfile)
	end if
      fname(9)=file
c
c-- define the number of reflections per block in scratch file
c--   nrpb = (number of words in block) / 6
c
      nrpb=knwr/6
   50 call spoolr(jcaos,line,newf,iexec,jfour,ier)
      if (ier.lt.0) go to 1000
c ---
      if (kscreen.eq.1.and.jscreen.eq.0) then
          call scr0
          ifW95 = iabs(ifW95)
          call InitialPlot
          nWDelay=-interv
          call About
          nWDelay=0
          call Hide_Mouse_Cursor
          call manage_mouse_cursor(1)
      endif
c--
      ier = 0
c
      call scrrr1
c
      call sircom(iexec,ier)
      if (ier.lt.0) go to 1200
 1000 if (ier.lt.0) then
          if (kscreen.eq.1.and.jscreen.eq.1) then
              go to 10
          endif
      endif
 1200 if (ier.lt.0) then
          write(line,2000)
      else
          write(line,3000)
      endif
c
      lline=20
      if(ier.ne.-2) call scrend(line,lline)
      if (jcaos.eq.0) close (jdir)
      write(lo,4000) line(1:lline)

      call winexit

c      if (ier.lt.0) then
c          stop 'ERROR'
c      else
c          stop 'OK'
c      endif
c
 2000 format(' SIR97 ends in error')
 3000 format(' SIR97 ends ok      ')
 4000 format(//,1h ,a)
      end
c-----------------------------------------------------------------------
      subroutine spoolr(jcaos,line,newf,iexec,jfour,ier)
      character*200 Msg
      common /msgerr/ Msg
      character line*256,hklf*256,releas*5,com4*4
      character usefile*256
      character beg,commen,allcom(35)*14,dire*256,defa*7
      character blank,digit*12,card(100)*80
      common /Sir97_vs_Sir2004/ erre_to_stop
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /xfile/ ifile,jjlist,jjend,infle,nwfle,icfle,lid(4),ifine
      common /xfili/ lfirst,nwblo,lindex(240)
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      character*8 itldef
      character fname(15)*256,ext(15)*4,path*256
      common/dotdat/ fname,ext,path
      common /chara/ blank,digit,card
      common /charas/ beg,commen,allcom
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common / ureq1/ jpatt,jpunt(1501),ksacc,jseteq,jumpp,jmpsie,nsec
      common /WildRun1/ nWsymb,nWrand,kWstop,NoWild
      common /genob/ irho
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /SizeScr/ MinScX, MaxScX, MinScY, MaxScY
      character*256 sirtx,ffile,sirpal,iasun,ciffle
      common /sirtxt/ sirtx,jhelp,ffile,sirpal,jwrpal,iasun,ciffle
      dimension vet(40),ivet(40),jcanc(10)
      common /BackSt/ IfBackingStore
      common /bufferg/ ixv(1000),iyv(1000),kptr(1000),nptr,
     *                 ixa(107),iya(107)
      common /parfin/ LimF(5,4), iPal(5), Livel, nPulsTot(5), iFull(5),
     *                iHConv, iwLMenu, iVP(5,4), Lhh(5), Lhs(5)
      common /W95/ ifW95
      data itldef /' Sir 97 '/
c
      erre_to_stop = 25
      kcanc = 0
      if (iexec.lt.0) then
          pi=4.0*atan(1.0)
          twopi=2.0*pi
          rtod=180.0/pi
          dtor=1.0/rtod
c     set up sin/cos table
          do 50 i=1,450
             sint(i)=sin(dtor*float(i-1))
   50     continue
          allcom(15)(1:1)=beg
          do 100 i=1,19,2
  100        read(itldef,'(2a4)') itle(i),itle(i+1)
             jfour=0
      endif
      kusef=ln
      ifper=0
      irefl=0
      kcont=0
      ier=0
      init=0
      nallc=35
      ipcom=0
      icomo=2
      ipdir=0
      nerr=0
      do 120 i=1,maxcom
         do 120 j=1,2
  120 icomq(i,j)=0
      ifli=0
c
      if (jcaos.eq.1) ifli=1
c
c-- read cards
c
  130 format(a)
      if (iexec.gt.0) write(lo,135) beg,beg,beg
  135 format(//,' Please enter commands and directives ( ',a1,a1,' to go
     *, ',a1,'end to stop )')
  140 if (ifli.eq.0) read(kusef,130,end=2000) line
c
      k = index(line,'!')
      if (k.ne.0) then
          line(k:) = ' '
      endif
c
      ifli=0
      call shift(line,nchar)
      if (nchar.le.0.or.line(1:1).eq.commen) go to 140
c
c-- if first character is equal to '%' it is a command
c
      if (line(1:1).eq.beg) then
c
c-- check if the command is an "exec" one
c
          if (line(2:2).eq.beg) then
              iexec=iexec+1
              go to 165
          endif
c
c-- verify if the command is allowed
c
         icom=0
         com4=line(2:5)
         call lcase(com4)
         if (com4.eq.'expo') then
             com4 = 'menu'
         endif
         do 150 i=1,nallc
            if (com4.eq.allcom(i)(1:4)) icom=i
  150    continue
         jcom=0
c
c-- if %PATTERSON next command must be %END
c
         if (icomo.eq.16) icom=7
c
         if (icom.eq.0) then
             go to 3000
         else
c
c--       the command is  %cancel list_number
c
             if (icom.eq.11) then
                 call cutst(line,lenp,dire,lend)
                 iopt=0
                 call getnum(line,vet,ivet,iv,iopt)
                 list_number = ivet(1)
                 kcanc = kcanc + 1
                 jcanc(kcanc) = list_number
                 jcom=1
             endif
c
c--       the command is  %use usefile
c
             if (icom.eq.19) then
                 call cutst(line,lenp,dire,lend)
                 usefile = line(1:lenp)
                 jcom=1
                 itype=2
                 iform=1
                 jop=jopen(kform,usefile,nlen,itype,iform,ierr)
                 if (jop.lt.0) then
                     write(Msg,270) ierr,usefile(1:lenp)
                     call screrr(ier,Msg,1)
                     ier=-2
                 else
                     kusef = kform
                 endif
             endif
c
c--       the command is  %return
c
             if (icom.eq.20) then
                 if (kusef.ne.ln) then
                     close (kform)
                     kusef=ln
                     jcom=1
                 else
                     go to 8000
                 endif
             endif
c
c--       the command is  %path
c
             if (icom.eq.21) then
                 call cutst(line,lenp,dire,lend)
                 path(1:lenp) = line(1:lenp)
                 jcom=1
             endif
c
c--       the command is  %nowindow
c
             if (icom.eq.24) then
                 jcom=1
                 if (ifW95.eq.0) then
                     if (jscreen.eq.1) call text_mode
                     kscreen=0
                 endif
             endif
c
c--       the command is  %window
c
             if (icom.eq.25) then
                 call cutst(line,lenp,dire,lend)
                 iopt=0
                 call getnum(line,vet,ivet,iv,iopt)
                 if (iv.eq.2) then
                     kscrx=max0(kscrx,ivet(1))
                     kscry=max0(kscry,ivet(2))
                     if (jscreen.eq.1) then
	                   if (kscrx.lt.MinScX) kscrx = MinScX
	                   if (kscrx.gt.MaxScX) kscrx = MaxScX
	                   if (kscry.lt.MinScY) kscry = MinScY
	                   if (kscry.lt.MaxScY) kscry = MaxScY
c
c-- resize the window
c
	                   call manage_mouse_cursor(1)
	                   call scr0
                     endif
                 endif
                 jcom=1
                 kscreen=1
             endif
c
c--       the command is  %save
c
             if (icom.eq.26) then
                 jcom=1
                 IfBackingStore = 0
             endif
c
c--       the command is  %continue
c
             if (icom.eq.8) then
                 jcom=1
                 icomo=icomo+1
                 if (icomo.eq.2) icomo=3
                 if (icomo.eq.24) icomo=1
                 do 160 ii=icomo,7
                    if (ii.eq.2) go to 160
                    ipcom=ipcom+1
                    if (ipcom.gt.maxcom)
     *                  go to 6000
                    icomq(ipcom,1)=ii
  160            continue
             endif
c
c--       the command is  %job
c
             if (icom.eq.9) then
                 jcom=1
                 call cutst(line,lenp,dire,lend)
                 dire = ' '
                 ioffset = ( 80 - lenp ) / 2
                 if (ioffset.le.0) ioffset = 1
                 dire(ioffset:) = line
                 read(dire,'(20a4)') itle
             endif
c
c--       the command is  %one
c
             if (icom.eq.13) then
                 NoWild = 1
                 jcom=1
             endif
c
c--       the command is  %resid
c
             if (icom.eq.33) then
                 call cutst(line,lenp,dire,lend)
                 iopt=0
                 call getnum(line,vet,ivet,iv,iopt)
                 erre_to_stop = vet(1)
                 jcom=1
             endif
c
c--       the command is  %structure
c
             if (icom.eq.22) then
                 jcom=1
                 call cutst(line,lenp,dire,lend)
                 if (lenp.le.0) go to 1000
	           if (ifW95.ne.1) then
                    call cutst(line,lenp,dire,lend)
	           else
	              dire = line
	              lend = lenp
	           end if
                 fname(1)=dire(1:lend)//ext(1)
                 fname(2)=dire(1:lend)//ext(2)
                 fname(3)=dire(1:lend)//ext(3)
                 fname(4)=dire(1:lend)//ext(4)
                 fname(5)=dire(1:lend)//ext(5)
                 fname(9)=dire(1:lend)//ext(9)
             endif
c
c--       the command is %initialize
c
             if (icom.eq.12) then
                 jcom=1
                 init=1
             endif
c
             if (jcom.eq.0) then
                 ipcom=ipcom+1
                 if (ipcom.gt.200) go to 6000
                 icomq(ipcom,1)=icom
                 icomo=icom
             endif
             endif
      else
c
c-- it is a directive
c
            if (ipcom.eq.0) go to 4000
            ipdir=ipdir+1
            if (ipdir.gt.100) go to 5000
            card(ipdir)=line
            com4=line(1:4)
            call lcase(com4)
            icomq(ipcom,2)=icomq(ipcom,2)+1
            if (com4.eq.'scha'.or.
     *          com4.eq.'mold'.or.
     *          com4.eq.'molp') then
                                  call cutst(line,lenp,dire,lend)
                                  if (lenp.gt.0) fname(4)=line
                                endif
            if (com4.eq.'refl') then
                        call cutst(line,lenp,dire,lend)
                        call cutst(line,lenp,dire,lend)
                        irefl=1
                        com4=dire(1:4)
                        call lcase(com4)
                        if (com4.eq.'foll') then
                            jfile=ln
                            hklf=' '
                            hklf(1:20) ='card reader         '
                          else
                            hklf=dire(1:lend)
                          endif
                        endif
            if (com4.eq.'cont') kcont=1
            if (com4.eq.'neut') neutro=1
            if (com4.eq.'elet') neutro=2
      endif
      if (icom.ne.7.and.icom.ne.8) go to 140
      if (nerr.ne.0) go to 9000
  165 if (iexec.gt.0) return
      iexec=iexec+1
      if (jcaos.eq.0) then
c-- initialize history array
      if (kenvir.eq.0) then
          do 170 i=1,99
  170        kstory(i)=0
      endif
c-- set up internal structures
      call star9
      itipe=0
      if (kopen(jdir,fname(1),nlen,itipe,ierr).ge.0) go to 200
      write(Msg,190) ierr,fname(1)(1:Lung(fname(1)))
      call screrr(ier,Msg,1)
  190 format(' Error ',i5,'  opening file ',a)
      ier=-2
      return
  200 continue
      call xdwn(lfirst,lindex,10)
c      write(lo,*) 'lfirst = ',lfirst,lindex(1),lindex(2),
c     1 lindex(3),lindex(4),lindex(5),lindex(6),lindex(7),lindex(8)
      newf=0
      if (init.eq.1) lindex(8)=ifile+1
      if (lindex(8).ne.ifile) then
          call setfi
          newf=1
      endif
      call xlc
      call xcsae
      endif
c-- Cancel lists ( if any )
      if (kcanc.gt.0) then
          do 210 i=1,kcanc
             list_number = jcanc(i)
             if (list_number.gt.0) call cancella(list_number)
  210     continue
      endif
c--
      write(lo,215) itle
  215 format(1h ,78('*'),/,1h ,20a4,//)
      call wrhead
      write(lo,220)
  220 format(' Used commands & directives:',/)
      jj=0
      do 240 i=1,ipcom
         do 225 j=1,80
  225    line(j:j)=blank
         j=icomq(i,1)
         if (j.eq.6) jfour=1
         write(line(1:26),'(11x,a1,a14)') beg,allcom(j)
         if (icomq(i,2).eq.0) then
             defa='default'
             if (icomq(i,1).eq.7) defa='       '
             write(line(28:34),'(a7)') defa
             write(lo,'(/,a)') line
         else
             do 230 j=1,icomq(i,2)
                jj=jj+1
                nc = 0
                call onebl(card(jj),nc,ier)
                if (j.eq.1) then
                    write(lo,'(/,a)') line(1:27)//card(jj)(1:nc)
                else
                    write(lo,'(27x,a)') card(jj)(1:nc)
                endif
  230        continue
      endif
  240 continue
      if (jscreen.eq.0) then
          call checkp(ier)
      endif
      if (ier.lt.0) return
      write(lo,290) ln,fname(14)(1:Lung(fname(14))),
     *              lo,fname(15)(1:Lung(fname(15))),
     *            jdir,fname( 1)(1:Lung(fname( 1))),iscra,jrel
      if (irefl.ne.0) write(lo,300) jfile,hklf(1:Lung(hklf))
      if (kcont.eq.1)  then
         itype=2
         iform=1
         jop=jopen(kform,ffile,nlen,itype,iform,ierr)
         if (jop.lt.0) then
            write(Msg,270) ierr,ffile(1:Lung(ffile))
            call screrr(ier,Msg,1)
            ier=-2
         else
            read(kform,280,iostat=ierr,err=7000) releas
            write(lo,310) kform,ffile(1:Lung(ffile)),releas
            close (kform)
            if (releas.ne.'05.98') then
               ier=-2
               write(Msg,311) '05.98'
               call screrr(ier,Msg,1)
            endif
         endif
      endif
      if (jfour.eq.1)  write(lo,320) jhost,fname(3)(1:Lung(fname(3))),
     *                               jgrap,fname(4)(1:Lung(fname(4))),
     *                               ifour
  270 format(' Open error, code =',i5,' file is ',a)
  280 format(a5)
  290 format(//,   ' Files used in sir:',//,
     *     '  Channel                                  Name',/,
     1            i6,'    instruction input file           ',a,/,
     1            i6,'    printer output file              ',a,/,
     3            i6,'    direct access structure file     ',a,/,
     4            i6,'    direct access scratch file',/,
     5            i6,'    sequential scratch file ')
  300 format(     i6,'    reflection input file            ',a)
  310 format(     i6,'    scattering factors file          ',a,
     1     /, 6x,    '    ( Release : ',a5,' )')
  311 format('Release should be ',a5,' !!')
  320 format(     i6,'    fourier peaks file               ',a,/,
     *            i6,'    peaks file to be plotted         ',a,/,
     *            i6,'    sequential scratch file ',//)
      write(lo,'(//)')
      if (newf.eq.1) then
                       write(lo,330)
                     else
                       write(lo,340)
c
*     iln=18
*     call cancella(iln)
c
                       call summar
                     endif
  330 format(6x,'Direct access structure file has been initialized'//)
  340 format(6x,'Direct access structure file actually contains:'/)


      kscreen = 0
!     write(*,*) erre_to_stop


      return
 1000 continue
      write(lo,1010)
 1010 format(' No structure name specified ')
      go to 9000
 2000 continue
      write(lo,2010)
 2010 format(' no   %end or %continue   command specified')
      go to 9000
 3000 continue
      write(Msg,3010) line(1:nchar)
      call screrr(ier,Msg,1)
 3010 format(' Error in command ',a)
      go to 9000
 4000 write(Msg,4100) line(1:nchar)
      call screrr(ier,Msg,1)
 4100 format(' No command specified for directive ',a)
      go to 9000
 5000 write(Msg,5100)
      call screrr(ier,Msg,1)
 5100 format(' more than 100 directives used ',/,
     *       ' check for missing  %end or %continue')
      go to 9000
 6000 write(Msg,6100) maxcom
      call screrr(ier,Msg,1)
 6100 format(' More than ',i5,' commands used.',
     *       ' Check input file or submit two jobs.')
      go to 9000
 7000 nrec=1
      write(Msg,7100) ierr,nrec,ffile(1:Lung(ffile))
      call screrr(ier,Msg,1)
 7100 format(' Error ',i5,' reading record #',i3,' in file ',a)
      go to 9000
 8000 write(Msg,8100)
      call screrr(ier,Msg,1)
 8100 format(' %RETURN command out of sequence')
 9000 ier=-2
      close(kusef)
      return
      end
c-----------------------------------------------------------------------
      subroutine sircom(iexec,ier)
c-- main subroutine to handle sir commands
      character*200 Msg
      common /msgerr/ Msg
      character beg,commen,allcom(35)*14
      common /charas/ beg,commen,allcom
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      character fname(15)*256,ext(15)*4,path*256
      common/dotdat/ fname,ext,path
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /xlimi/ idummy(6),nfls
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common / ureq1/ jpatt,jpunt(1501),ksacc,jseteq,jumpp,jmpsie,nsec
      common /genob/ irho
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      character *80 MessH,Messages(200)
      common /scmess/MessH,Messages
c
      ier=0
      ipdir =0
      icomat=0
   80 if (ier.lt.0) return
      ncwu = lo
      nfls=1
      nfl=1
      icomat=icomat+1
      j=icomq(icomat,1)
      if (j.ne.0) then
      jj=kstory(20)+1
      kstory(20)=jj
      jj=jj+20
      if (jj.le.99) kstory(jj)=j
c
      call scr2
c
      go to (100,200,300,400,500,600,700,800,900,1000,
     *       1100,1200,1300,1400,1500,1600,1700,1800,
     *       1900,2000,2100,2200,2300,2400,2500,2600,2700,
     *       2800,2900,3000,3100,3200),j
c-- normal     routine
  100 continue
      call normal(ier)
      go to 80
c-- seminvariants routine
  200 continue
      call seminv(ier)
      go to 80
c-- invariants routine
  300 continue
      call invar(ier)
      go to 80
c-- phase   routine
  400 continue
      call contan(ier)
      go to 80
c-- fourier routine
  500 continue
      call fourie(ier)
      go to 80
c-- menu command
  600 continue
      call export(ier)
      go to 80
c-- end command
  700 continue
      go to 1500
c-- continue command
  800 continue
      ier=-1
      go to 5000
c-- job command
  900 continue
      ier=-1
      go to 5000
c-- dummy command
 1000 continue
      ier=-1
      go to 5000
c-- dummy  command
 1100 continue
      ier=-1
      go to 5000
c-- initialize
 1200 continue
      ier=-1
      go to 5000
c-- dummy command
 1300 continue
      ier=-1
      go to 5000
c-- history command
 1400 continue
      call befor
      go to 80
c-- patterson command
 1600 continue
      call patter(ier)
      go to 80
c-- quartets command
 1700 continue
      kkk=0
c     call newqua(kkk,ier)
      go to 80
c-- caos command
 1800 continue
      call caosm(ier)
      go to 80
c-- use command
 1900 continue
      ier=-1
      go to 5000
c-- return command
 2000 continue
      ier=-1
      go to 5000
c-- path command
 2100 continue
      ier=-1
      go to 5000
c-- structure command
 2200 continue
      ier=-1
      go to 5000
c-- data       routine
 2300 continue
      call datasir(ier)
      go to 80
c--  nowindow command
 2400 continue
      ier=-1
      go to 5000
c--  window command
 2500 continue
      ier=-1
      go to 5000
c--  save command
 2600 continue
      ier=-1
      go to 5000
c--  lsq command
 2700 continue
      call lsqmain(ier)
      if (ier.ge.0) then
          rr = errem / 100.0
          write(Messages(icomat)(1:31),'(4hR = ,f7.2,1h%)') rr
      endif
      go to 80
c-- update  command
 2800 continue
      call SirUpdate(ier)
      go to 80
c-- hydrogen  command
 2900 continue
      call SirHydro(ier)
      go to 80
c-- geometry  command
 3000 continue
      call SirGeom(ier)
      go to 80
c-- agreement  command
 3100 continue
      call SirAgr(ier)
      go to 80
c-- weight  command
 3200 continue
      call SirWgt(ier)
c-- exec command
 1500 iexec=-1
          endif
      return
 5000 write(Msg,5100) j,allcom(j)(1:Lung(allcom(j)))
      call screrr(ier,Msg,1)
 5100 format(' Wrong command code = ',i5,' for ',a,' command')
      return
      end
c-----------------------------------------------------------------------
      subroutine befor
      character cff,beg,commen,allcom(35)*14
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /charas/ beg,commen,allcom
c
      kkff=0
      write(cff,'(i1)') kkff
      write(lo,100) cff,itle
  100 format(///,a1 ,120('+'),//,
     1 39h SIR97 : History of the structure      ,68x,14hRelease  97.01
     2 ,//,20x,20a4,/,1h ,120('+'),/)
      ifin=kstory(20)-1
      kstory(20)=ifin
      if (ifin.le.0) then
                      write(lo,300)
                     else
                      write(lo,400)
                      do 200 i=1,ifin
                      j=i+20
                      jj=kstory(j)
                      write(lo,500) allcom(jj)
  200                 continue
                     endif
  300 format(/,10x,' The structure has no story',/)
  400 format(/,10x,' List of commands issued in the past',/)
  500 format(11x,a1,a14)
      return
      end

c-----------------------------------------------------------------------
code for cancella
      subroutine cancella(iln)
c
c--clear the entry for a list in the current index table
c--iln = the list type number
c
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      common/xfili/lfirst,nwblo,lindex(240)
c
      lista=iln
      call srlin (lista,lsn,lixx,ljxx,lkxx,llxx)
      if (lixx.gt.0) then
          mln=lindex(2)
          il =lindex(5)
          if(lista) 2051,2051,2210
 2210     continue
          if(lista-mln) 2220,2220,2051
 2220     continue
          i=lista*il+1
          lindex(i)=0
          i=lindex(6)
          call xup(lindex(3),lindex,i)
          call xdump
      endif
 2051 return
      end
c-----------------------------------------------------------------------
      subroutine getnum(linei,vet,ivet,iv,iopt)
      dimension vet(40),ivet(40)
      character blank,digit*12,card(100)*80
      character linei*(*),resto*256,cifre*256
      common /chara/ blank,digit,card
c
      iv=0
      do 1 i=1,40
         vet(i)=0.0
    1 continue 
      k=len(linei)
      do 2 i=1,256
         resto(i:i)=blank
    2 continue 
      do 3 i=1,k
         resto(i:i)=linei(i:i)
    3 continue 
    5 sum=0.0
      isum=0
      call cutst(resto,ncharl,cifre,nchard)
      if (nchard.le.0) return
      segno=1.0
      isegno=1
      iniz=1
      if (cifre(1:1).eq.digit(12:12)) then
          segno=-1.0
          isegno=-1
          iniz=2
      endif
      ipoi=index(cifre(1:nchard),digit(11:11))
      if (ipoi.eq.0) ipoi=nchard+1
      dec=ipoi-1-iniz
      idec=ipoi-1-iniz
      do 10 i=iniz,nchard
         idig=index(digit,cifre(i:i))
         if (idig.ge.1.and.idig.le.11)  then
             if (idig.le.10)  then
                 sum=sum+float(idig-1)*10.0**dec
                 if (idec.ge.0) isum=isum*10+(idig-1)
                 dec=dec-1.0
                 idec=idec-1.0
             endif
         else
             iopt=-1
             return
         endif
   10 continue
      iv=iv+1
      vet(iv)=sum*segno
      ivet(iv)=isum*isegno
      if (ncharl.le.0) then
          iopt=1
          return
      endif
      if (iv.eq.iopt) return
      go to 5
      end
c-----------------------------------------------------------------------
      subroutine shift(string,lenp)
      character string*(*)
      character blank,digit*12,card(100)*80
      common /chara/ blank,digit,card
c
      k=len(string)
c
c-- TAB filter
c
      do 5 i=1,k
      j = ichar(string(i:i))
      if (j.eq.9) string(i:i)=blank
    5 continue
      ifin=1
      do 10 i=1,k
      if (string(i:i).ne.blank) then
                                  iniz=i
                                  go to 20
                                endif
   10 continue
      lenp=-1
      return
   20 do 30 i=k,1,-1
      if (string(i:i).ne.blank) then
                                  ifin=i
                                  go to 40
                                endif
   30 continue
   40 continue
      lenp=ifin-iniz+1
      if (iniz.eq.1) return
      do 50 i=1,lenp
      j=iniz+i-1
   50 string(i:i)=string(j:j)
      if (lenp.eq.k) return
      do 60 i=lenp+1,k
   60 string(i:i)=blank
      return
      end
c-----------------------------------------------------------------------
      subroutine cutst(string,lens,dire,lend)
      character string*(*),dire*(*)
      character blank,digit*12,card(100)*80
      common /chara/ blank,digit,card
c
      k=len(dire)
      do 5 i=1,k
    5 dire(i:i)=blank
      k=len(string)
      do 10 i=1,k
      if (string(i:i).eq.blank) then
                                  iniz1=i
                                  go to 20
                                endif
   10 continue
   20 continue
      lend=min0(iniz1-1,80)
      do 25 i=1,lend
      dire(i:i)=string(i:i)
   25 string(i:i)=blank
      call shift(string,lens)
      return
      end
c-----------------------------------------------------------------------
      subroutine summar
c
c-- summarize the content of the direct access file
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /restr/rescon(6),vres(6000),nres,wq,dmean,amean,nplane,mres
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
      common /xdata/ num(350),dmat(3,500),mat(3,30000),
     * mat1(7,1000),lpseud(12),cfom(302),ipos(302),dumm(60534)
     * ,dummpc(340000)
      integer dmat
      common/lst04/ iw4,l4,m4,n4
      common/lst05/l5,m5,md5,n5
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common/lst12/l12,m12,md12,n12,isca,ibm,nbl12,idra,idrb,l12d,n12d
      common/ylimi/nflx,lflx,idummy(5)
c
      nflx=1
      lflx=500000
      call srlin (1,lsn,lixx,ljxx,lkxx,llxx)
      if (lixx.gt.0) then
          call yfl01
          write(lo,30)
      endif
      call srlin (2,lsn,lixx,ljxx,lkxx,llxx)
      if (lixx.gt.0) then
          call yfl02
          write(lo,50) nsym
      endif
      call srlin (3,lsn,lixx,ljxx,lkxx,llxx)
      if (lixx.gt.0) then
          call yfl03
          write(lo,96) nk
      endif
      call srlin (4,lsn,lixx,ljxx,lkxx,llxx)
      if (lixx.gt.0) then
          call xfl04
          write(lo,97) iw4
      endif
      call srlin (5,lsn,lixx,ljxx,lkxx,llxx)
      if (lixx.gt.0) then
          call xfl05
          write(lo,98) n5
      endif
*     call srlin (6,lsn,lixx,ljxx,lkxx,llxx)
*     if (lixx.gt.0) then
*         call xfl06
*         write(lo,99) n6
*     endif
      call srlin (7,lsn,lixx,ljxx,lkxx,llxx)
      if (lixx.gt.0) then
          call ysfl07(nref,mmm,mmmz,npseud,iy)
          if (jpart.gt.0) write(lo,160)
          if (npseud.gt.0) write(lo,140)
          if (sc.lt.0.0) then
              write(lo,150) nref
          else
              write(lo,155) nref
          endif
      endif
      call srlin (12,lsn,lixx,ljxx,lkxx,llxx)
      if (lixx.gt.0) then
          call sfl12
          write(lo,95) n12
      endif
      iprea=0
      call srlin (26,lsn,lfw,llw,lpb,ll)
      if (lfw.gt.0) then
          call sflxx(iprea,26,nsem1g,nsem1g,nstron,nxxe,iccd,mat)
          write(lo,244) nsem1g
      endif
      call srlin (27,lsn,lfw,llw,lpb,ll)
      if (lfw.gt.0) then
          call sflxx(iprea,27,nsem2,nsem2,nstron,nxxe,iccd,mat)
          write(lo,254) nsem2
      endif
      call srlin (9,lsn,lfw,llw,lpb,ll)
      if (lfw.gt.0) then
          call sflxx(iprea,9,nps,nps,nrefp,nxxe,iccd,mat)
          write(lo,2500) nps
      endif
      call srlin (24,lsn,lfw,llw,lpb,ll)
      if (lfw.gt.0) then
          call sflxx(iprea,24,ntot,ntrp,nreft,nxxe,iccd,mat)
          write(lo,6010) ntot
      endif
      call srlin (8,lsn,lfw,llw,lpb,ll)
      if (lfw.gt.0) then
          call sflxx(iprea,8,ntot,ntrp,nreft,nxxe,iccd,mat)
          write(lo,4010) ntrp
      endif
      call srlin (11,lsn,lfw,llw,lpb,ll)
      if (lfw.gt.0) then
          call sflxx(iprea,11,ntre,ntre,nreft,nxxe,iccd,mat)
          write(lo,4510) ntre
      endif
      call srlin (10,lsn,lfw,llw,lpb,ll)
      if (lfw.gt.0) then
          call sflxx(iprea,10,ntrn,ntrn,nreft,nxxe,iccd,mat)
          write(lo,5010) ntrn
      endif
      call srlin (20,lsn,lfw,llw,lpb,ll)
      if (lfw.gt.0) then
          call sflxx(iprea,20,nqn,nqn,nrefp,nxxe,iccd,mat)
          write(lo,5020) nqn
      endif
      call srlin (21,lsn,lfw,llw,lpb,ll)
      if (lfw.gt.0) then
          call sflxx(iprea,21,nqen,nqen,nrefp,nxxe,iccd,mat)
          write(lo,5030) nqen
      endif
      call srlin (16,lsn,lfw,llw,lpb,ll)
      if (lfw.gt.0) then
          call ysfl16(cfom,ipos,nset)
          write(lo,5040) nset
      endif
      call srlin (15,lsn,lfw,llw,lpb,ll)
      if (lfw.gt.0) then
          idisp=1
          call sfl15(nats,idisp,interp)
          if (numset.gt.0) then
              write(lo,5050) nats,numset
          else
              write(lo,5060) nats
          endif
      endif
****  call srlin (31,lsn,lfw,llw,lpb,ll)
****  if(lfw.gt.0) then
****                 call sfl31
****                 if (nres.gt.0) write(lo,5070) nres
****               endif
   30 format(22x,' cell parameters ')
   50 format(16x,i6,' symmetry operators ')
   96 format(16x,i6,' atomic species')
   97 format(16x,i6,' weighting scheme')
   98 format(16x,i6,' number of atoms')
*  99 format(16x,i6,' reflections')
   95 format(16x,i6,' refinement directives')
  140 format(22x,' pseudotranslational information')
  150 format(16x,i6,' not normalized reflections ')
  155 format(16x,i6,' normalized reflections ')
  160 format(22x,' fragment information')
  244 format(16x,i6,' one phase seminvariants ')
  254 format(16x,i6,' two phase seminvariants')
 2500 format(16x,i6,' psi-zero triplets ')
 4010 format(16x,i6,' positive triplets')
 4510 format(16x,i6,' enantiomorph sensitive triplets')
 5010 format(16x,i6,' negative triplets')
 5020 format(16x,i6,' negative quartets ')
 5030 format(16x,i6,' enantiomorph sensitive quartets ')
 5040 format(16x,i6,' sets of phases')
 6010 format(16x,i6,' psi-e triplets')
 5050 format(16x,i6,' coordinates related to set no.',i4)
 5060 format(16x,i6,' Patterson''s peaks')
*5070 format(16x,i6,' restraint conditions')
      return
      end
c-----------------------------------------------------------------------
      subroutine histor(nfield,ivalue,ier)
c
c-- this subroutine is used to get the story of different
c-- attemps solving the actual structure
c
c     nfield = 1   information about pseudotranslational symmetry
c                  ( ivalue=0 if absent, ivalue= n if it exists with
c                    a percentage value of n , ivalue = -n if used )
c            = 2   information about partial procedure
c                  ( ivalue=1 if used , ivalue=0 otherwise )
c            = 3   number of symbols used
c            = 4   information about the use of seminvariants
c                  ( ivalue=1 if used , ivalue=0 otherwise )
c            = 5   information about the use of mess
c                  ( ivalue=1 if used , ivalue=0 otherwise )
c            = 6 - 16   not used
c
      character*200 Msg
      common /msgerr/ Msg
      character*256 filen
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
              if (kenvir.eq.0) then
c-- standard sir91 environment
                                 kstory(nfield)=ivalue
         else if (kenvir.eq.1) then
c-- enraf-nonius environment
c-- update the 170-th record (16 words lenght)
c-- in the master file for enraf-nonius implementation
c-- the record is red into kstory array, updated and rewritten
                                 namel=9
                                 filen(1:namel)='struc.nme'
                                 nrec=170
                                 jnon=30
                                 itipe=0
                                 nonius=16
         if (kopen(jnon,filen(1:namel),nonius,itipe,ierr).ge.0) then
            read (jnon,rec=nrec,err=100,iostat=ierr) (kstory(i),i=1,16)
                                    kstory(nfield)=ivalue
            write(jnon,rec=nrec,err=120,iostat=ierr) (kstory(i),i=1,16)
                                    close(jnon)
                                  else
                                    ier=-1
                                    write(Msg,90) ierr,filen(1:namel)
                                    call screrr(ier,Msg,1)
                                  endif
         else if (kenvir.eq.2) then
                                 kstory(nfield)=ivalue
                               endif
      return
   90 format(' Error ',i5,'  opening file ',a)
  100 ier=-1
      write(Msg,110) ierr,nrec,filen(1:namel)
      call screrr(ier,Msg,1)
  110 format(' Error ',i5,' reading record #',i3,' in file ',a)
      return
  120 ier=-1
      write(Msg,130) ierr,nrec,filen(1:namel)
      call screrr(ier,Msg,1)
  130 format(' Error ',i5,' writing record #',i3,' in file ',a)
      return
      end
c--------------------------------------------------------------------
      subroutine unpak3(index,kod1,kod2,ifaz)
      isave=index/32
      ifaz=index-isave*32 -1
      kod1=isave/4096
      kod2=isave-4096*kod1-2048
      kod1=kod1-2048
      return
      end
c-----------------------------------------------------
      subroutine besse(xx,vec)
c--bessel function
c
      x=abs(xx)
      vec=amin1((x+0.4807)*x/((x+0.8636)*x+1.3943),1.0)
      if (xx.lt.0.0) vec=-vec
      return
      end
c     ------------------------------------------------------------------
      subroutine musym(smat,tmat,n2,is,ts)
      integer is(2,3,24),smat(48,3,3)
      dimension ts(3,24),tmat(48,3)
c
c-----------------------------------------------------------------------
c
c     purpose
c             conversion of matricies in multan notation
c
c     usage
c             call musym(smat,tmat,n2,is,ts)
c
c     description of parameters
c
c             smat - 3-dimensionale array containing the rotational
c                    matricies computed by subroutine symm
c             tmat - bidimensional array containing the traslational
c                    matricies computed by subroutine symm
c             n2   - number of symmetry operators not related by
c                    a centre of symmetry
c             is   - 3-dimensional array containing the rotational
c                    matricies in multan notation
c             ts   - bidimensional array containing the traslational
c                    matricies in multan notation
c
c-----------------------------------------------------------------------
c
      do 10  j=1,2
      do 10 ja=1,3
      do 10 jb=1,n2
      is(j,ja,jb)=0
      ts(  ja,jb)=0
   10 continue
      do 50 jc=1,n2
      do 30  l=1,3
      m=1
      do 20  i=1,3
      if (smat(jc,l,i).eq.0) go to 20
      is(m,l,jc)=smat(jc,l,i)*i
      m=2
   20 continue
   30 continue
      do 40 ja=1,3
      ts(ja,jc)=tmat(jc,ja)
   40 continue
   50 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine unpack (index,ih,kk,il)
      ih = index/262144
      is = index - 262144*ih
      kk = is/512-256
      il = is-512*(kk+256)-256
      return
      end
c ----------------------------------------------------------------------
      function bes(x)
      is=1
      if(x.lt.0.0) is=-1
      x1=abs(x)
      if(x1.lt.0.000001)  go to 200
      if(x1.le.2.9) go to 180
      if(x1.le.7.5) go to 160
      if(x1.le.20.) go to 140
      if(x1.le.39.) go to 120
      if(x1.le.45.) go to 100
      if(x1.le.55.) go to  80
      if(x1.le.65.) go to  60
      if(x1.le.80.) go to  40
      if(x1.le.99.) go to  20
      bes=1.*is
      return
   20 bes=0.0000631*x1+.988652
      bes=abs(bes)*is
      return
   40 bes=0.0000933*x1+.9862355
      bes=abs(bes)*is
      return
   60 bes=0.00014*x1+.9832
      bes=abs(bes)*is
      return
   80 bes=0.00021*x1+.97935
      bes=abs(bes)*is
      return
  100 bes=0.0000666*x1+.9858026
      bes=abs(bes)*is
      return
  120 bes=0.9459 +0.00187*x1-0.00002*x1*x1
      bes=abs(bes)*is
      return
  140 bes=0.82227+0.02189*x1-0.00114*x1*x1+0.00002*x1*x1*x1
      bes=abs(bes)*is
      return
  160 bes=0.444+0.19096*x1-0.02697*x1*x1+0.00135*x1*x1*x1
      bes=abs(bes)*is
      return
  180 bes=-0.00718+0.5668*x1-0.12287*x1*x1 +0.008*x1*x1*x1
      bes=abs(bes)*is
      return
  200 bes=0.
      return
      end
c ----------------------------------------------------------------------
      function besinv(y)
      if (abs(y).lt.0.000001)  go to  200
      if (y.le.0.6989)  go to 180
      if (y.le.0.8666) go to 160
      if (y.le.0.9259)  go to 140
      if (y.le.0.9553)  go to 120
      if (y.le.0.9635)  go to 100
      if (y.le.0.9884) go to 90
      if (y.le.0.9888) go to 80
      if (y.le.0.9909) go to 70
      if (y.le.0.9923) go to 60
      if (y.le.0.9937) go to 50
      if (y.le.0.9949) go to 40
      besinv=100.
      return
   40 besinv=15833.333*y-15653.583
      return
   50 besinv=10714.285*y-10566.785
      return
   60 besinv=7142.8571*y-7022.8571
      return
   70 besinv=4761.9047*y-4663.5713
      return
   80 besinv=15000*y-14787
      return
   90 besinv=49773.46954-102737.23532*y+53033.83171*y*y
      return
  100 besinv=77576.4096-162332.52722*y+84935.62155*y*y
      return
  120 besinv=3117.15834-6767.58257*y+3681.64105*y*y
      return
  140 besinv=486.69735-1127.7574*y+658.80603*y*y
      return
  160 besinv=-82.06253+344.25645*y-478.71058*y*y+226.35886*y*y*y
      return
  180 besinv=-0.00252+2.1065*y-1.12674*y*y+3.09414*y*y*y
      return
  200 besinv=0
      return
      end
c-----------------------------------------------------------------------
code for sortz
      subroutine sortz(lind,numb,iblk,jump)
c--sort the data in store
c
c  lind  addres in store
c  numb  number of block of data to be sorted
c  iblk  block lenght of the data (i.e. number of items per block)
c  jump  < 0 sort in decreasing order
c  jump  > 0 sort in increasing order
c  iabs(jump) = relative addres of the key of sort
c
      common /xdata/ store(500000)
c
      jsig=1
      if (jump.lt.0) then
                       jump=iabs(jump)
                       jsig=-1
                     endif
      if (numb.eq.1) return
      jump=jump-1
      ja=2
2010  continue
      jb=numb/ja
      if(jb) 2020,2020,2030
2020  continue
      jb=1
2030  continue
      jc=numb-jb
2040  continue
      jd=0
      m=lind
      do 2070 i=1,jc
      mk=m+jb*iblk
      if ((store(m+jump)-store(mk+jump))*jsig) 2060,2060,2050
 2050 continue
      mm=m
      mmk=mk
      do 2055 je=1,iblk
      f=store(mm)
      store(mm)=store(mmk)
      store(mmk)=f
      mm=mm+1
      mmk=mmk+1
 2055 continue
      jd=1
 2060 continue
      m=m+iblk
 2070 continue
      if (jd) 2080,2080,2040
 2080 continue
      if (jb-1) 2100,2100,2090
 2090 continue
      ja=ja*2
      go to 2010
 2100 continue
      return
      end
c-----------------------------------------------------
      subroutine stst
c--print the test (centro)
      common/tst/nt,ar(26),nn(11,26,3),pp(11,26,3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      dimension pa(11,26,3)
c
      write(lo,1000)
 1000 format(/,' number of relations(nr),number of correct rel.',
     2'(nc) and percentage(%) of correct relationship ')
      write(lo,1001)
 1001 format(///)
      write(lo,1010)
 1010 format(14x,'rel.posit.',20x,'rel.negat.',//,
     2 1x,5h arg.,2(9x,3hnr.,4x,3hnc.,4x,1h%,2x),/)
      do 1030 l=1,2
      do 1020 i=1,nt
      if (nn(1,i,l).gt.0) then
                            fn=float(nn(1,i,l))
                            pa(1,i,l)=pp(1,i,l)*100.0/fn
                          else
                            pa(1,i,l)=0.0
                          endif
 1020 continue
 1030 continue
      do 1050 i=1,nt
      if (nn(1,i,1).eq.0.and.nn(1,i,2).eq.0) go to 1050
      write(lo,1040)ar(i),(nn(1,i,l),pp(1,i,l),pa(1,i,l),l=1,2)
 1040 format(f5.1,2(5x,i7,2f7.1))
 1050 continue
      return
      end
c--------------------------------------------------
      subroutine nstst
c--print the test (non-centro)
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
c
      write(lo,1000)
1000  format(' number of relationships(nr), percentages(%) of correct si
     *gns',/,' average errors in relationships')
      write(lo,1001)
 1001 format(///)
      en=float(mjn(1,1))/10.0
      write(lo,1010)
 1010 format(20x, 'positive rel.',25x,'negative rel.')
      write(lo,1020)
 1020 format(3x,2hg ,1x,2(8x,'nr.    %     <|phi|>         '),//)
      do 1100 j=1,3
      do 1090 i=1,ns
      if(nb(1,i,j)) 1090,1090,1030
 1030 continue
      fn=1.0/float(nb(1,i,j))
      fnb(1,i,j)=fnb(1,i,j)*fn*100.0
      bcm(1,i,j)=bcm(1,i,j)*fn
 1090 continue
 1100 continue
      do 1110 i=1,ns
*     do 1105 j=1,2
*     if (nb(1,i,j).gt.0) then
*                   arg=rtod*atan2( acm(1,i,j) , bcm(1,i,j))
*                   arg=rtod*atan( acm(1,i,j) / bcm(1,i,j))
*                   arg=amod(arg+3600.0,360.0)
*                   if (arg.gt.180.0) arg=360-arg
*                   bcm(1,i,j)=arg
*                 endif
*1105 continue
      write(lo,1120) br(i),(nb(1,i,j),fnb(1,i,j),bcm(1,i,j),j=1,2)
 1120 format(f5.1,3(5x,i7,f7.1,f9.3,9x))
 1110 continue
      return
      end
c------------------------------------------------------
      subroutine nctet(aa,cc,ang,j)
c--test for the correct coincidence (non-centro)
c
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
c
      if (aa.lt.0.0) then
                       kk=2
                     else
                       kk=1
                     endif
      bb=abs(aa)
      do 1100 i=1,ns
      ii=i
      if(br(i)-bb) 1020,1020,1200
1020  continue
       nb(j,ii,kk)= nb(j,ii,kk)+1
      bcm(j,ii,kk)=bcm(j,ii,kk)+ang
      a=aa*cc
      if(a) 1100,1030,1030
1030  continue
      fnb(j,ii,kk)=fnb(j,ii,kk)+1.0
1100  continue
1200  continue
      return
      end
c--------------------------------------------------------
      subroutine nclrt
c--prepare the test buffer (non-centro)
c
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
c
      ns=15
      br(1)=0.0
      do 1100 i=2,6
      br(i)=br(i-1)+0.4
1100  continue
      do 1110 i=7,10
      br(i)=br(i-1)+0.6
1110  continue
      br(11)=5.5
      br(12)=6.5
      br(13)=9.0
      br(14)=15.0
      br(15)=20.0
      do 1140 k=1,11
      do 1140 j=1,3
      do 1150 i=1,ns
      nb (k,i,j)=0
      fnb(k,i,j)=0.0
      bcm(k,i,j)=0.0
      acm(k,i,j)=0.0
1150  continue
1140  continue
      return
      end
c-----------------------------------------------------
      subroutine clrt
c--prepare the test buffer (centro)
      common/tst/nt,ar(26),nn(11,26,3),pp(11,26,3)
      ar( 1)=.0
      ar( 2)=.2
      ar( 3)=.4
      ar( 4)=.6
      ar( 5)=.8
      ar( 6)=1.
      ar( 7)=1.2
      ar( 8)=1.4
      ar( 9)=1.6
      ar(10)=2.
      ar(11)=2.4
      ar(12)=2.8
      ar(13)=3.2
      ar(14)=3.4
      ar(15)=3.8
      ar(16)=4.2
      ar(17)=4.6
      ar(18)=5.0
      ar(19)=5.5
      ar(20)=6.0
      ar(21)=6.5
      ar(22)=7.
      ar(23)=7.5
      ar(24)=8.0
      ar(25)=8.5
      ar(26)=9.0
      nt=26
      do 100 k=1,11
      do 100 l=1,3
      do 200 i=1,nt
      nn(k,i,l)=0
      pp(k,i,l)=0
 200  continue
 100  continue
      return
      end
c----------------------------------------------------------
      subroutine sctst(aa,cc,j)
c--test for the correct coincidence (centro)
      common/tst/nt,ar(26),nn(11,26,3),pp(11,26,3)
c
      if(aa.lt.0) then
                    k=2
                  else
                    k=1
                  endif
      bb=abs(aa)
      do 1100 i=1,nt
      if(ar(i)-bb)1020,1020,1200
 1020 continue
      nn(j,i,k)=nn(j,i,k)+1
      if(cc)1100,1030,1030
 1030 continue
      pp(j,i,k)=pp(j,i,k)+1.0
 1100 continue
 1200 continue
      return
      end
c----------------------------------------------------------------------
      subroutine ucase(line)
      character*(*) line
      character*52 ulc
      common /ulcase/ ulc
      character a
c
      k=len(line)
      do 20 i=1,k
      a=line(i:i)
      l=0
      do 10 j=1,26
      if (a.eq.ulc(j:j)) l=j
   10 continue
      if (l.ne.0) line(i:i)=ulc(l+26:l+26)
   20 continue
      return
      end
c----------------------------------------------------------------------
      subroutine lcase(line)
      character*(*) line
      character*52 ulc
      common /ulcase/ ulc
      character a
c
      k=len(line)
      do 20 i=1,k
      a=line(i:i)
      l=0
      do 10 j=27,52
      if (a.eq.ulc(j:j)) l=j
   10 continue
      if (l.ne.0) line(i:i)=ulc(l-26:l-26)
   20 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine wrhead
      character str*80,messh*80
      character fname(15)*256,ext(15)*4,path*256
      common/dotdat/ fname,ext,path
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c
c-- write the Header
c
      k=index(fname(1),'.')
      call sirdate(str,icod)
      if (icod.eq.0) then
          messh=' SIR97(1.04) runs on:   '//fname(1)(1:k-1)
        else
          messh=str(1:icod)//' SIR97(1.04) runs on:   '//fname(1)(1:k-1)
        endif
c
      write(lo,10) messh
   10 format(1h ,a,//)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine checkp(ier)
c
c-- add path to data files and check if they exist
c
      character*200 Msg
      common /msgerr/ Msg
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      character*256 sirtx,ffile,sirpal,iasun,ciffle
      common /sirtxt/ sirtx,jhelp,ffile,sirpal,jwrpal,iasun,ciffle
      character fname(15)*256,ext(15)*4,path*256
      common/dotdat/ fname,ext,path
      common /colori/ c, cs, csd, nPal, Palets, DefPals, nActPal
      common /MolCol/ cp, cps, cpsd
c ---
      integer c(4,11),cs(4,2,11),Palets(4,256),DefPals(4,256)
     *        , csd(4,2,11)
      integer  cp(15), cps(4, 15), cpsd(4, 15)
      character line*256
      integer ex1,ex2,ex3
c
      ier = 0
c
c-- add path to data files 
c
      i = lung ( path )
      j1=lung(ffile)
      j2=lung(sirtx)
      j3=lung(sirpal)
      j4=lung(iasun)
      j5=lung(ciffle)
      if (i.gt.0) then
          line=' '
          line(1:i)=path
          line(i+1:i+j1)=ffile
          ffile=line
          line=' '
          line(1:i)=path
          line(i+1:i+j2)=sirtx
          sirtx=line
          line=' '
          line(1:i)=path
          line(i+1:i+j3)=sirpal
          sirpal=line
          line=' '
          line(1:i)=path
          line(i+1:i+j4)=iasun
          iasun=line
          line=' '
          line(1:i)=path
          line(i+1:i+j5)=ciffle
          ciffle=line
      endif
      j1 = j1 + i
      j2 = j2 + i
      j3 = j3 + i
      j4 = j4 + i
      j5 = j5 + i
c
c-- check if files exist
c
      itype=2
      iform=1
      jop=jopen(kform,ffile,nlen,itype,iform,ierr)
      if (jop.lt.0) then
          ex1 = 0
        else
          ex1 = 1
          close(kform)
      endif
c
      jop=jopen(kform,sirtx,nlen,itype,iform,ierr)
      if (jop.lt.0) then
          ex2 = 0
        else
          ex2 = 1
          close(kform)
      endif
c
      jop=jopen(kform,sirpal,nlen,itype,iform,ierr)
      if (jop.lt.0) then
          ex3 = 0
        else
          ex3 = 1
          close (kform)
      endif
c
      jop=jopen(kform,iasun,nlen,itype,iform,ierr)
      if (jop.lt.0) then
          ex4 = 0
        else
          ex4 = 1
          close (kform)
      endif
c
      jop=jopen(kform,ciffle,nlen,itype,iform,ierr)
      if (jop.lt.0) then
          ex5 = 0
        else
          ex5 = 1
          close (kform)
      endif
c
      if (ex1.ne.1) then
          write(Msg,70) ffile(1:j1)
          call screrr(ier,Msg,1)
          ier = -2
      endif
      if (ex2.ne.1) then
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) sirtx(1:j2)
              call screrr(ier,Msg,1)
            else
              write(lo,80) sirtx(1:j2)
          endif
      endif
      if (ex3.ne.1) then
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) sirpal(1:j3)
              call screrr(ier,Msg,1)
            else
              write(lo,80) sirpal(1:j3)
          endif
      endif
      if (ex4.ne.1) then
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) iasun(1:j4)
              call screrr(ier,Msg,1)
            else
              write(lo,80) iasun(1:j4)
          endif
      endif
      if (ex5.ne.1) then
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) ciffle(1:j5)
              call screrr(ier,Msg,1)
            else
              write(lo,80) ciffle(1:j5)
          endif
      endif
      if (jwrpal.eq.0) write(lo,90) sirpal(1:j3)
   70 format(' File ',a,' does not exist. Check %PATH command',
     *       ' or use %NOWINDOW command. ')
   80 format(//,' *** WARNING ***  File ',a,' does not exist.'
     *       ,/,'                  Check %PATH command. ')
   90 format(//,' *** WARNING ***  File ',a,' is read-only.'
     *       ,/,18x,'It should be changed in read-write.')
      return
      end
c-----------------------------------------------------------------------
      block data sirblk
      character beg,commen,allcom(35)*14
      character blank,digit*12,card(100)*80
      character fname(15)*256,ext(15)*4,path*256
      character*256 sirtx,ffile,sirpal,iasun,ciffle
      character Species(8)*2
      integer color, xo, yo, khead
      character*52 ulc
      character*80 Titolo
      integer AngDef
c
      common /xdata/ store(500000)
      common /charas/ beg,commen,allcom
      common /chara/ blank,digit,card
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common / ureq1/ jpatt,jpunt(1501),ksacc,jseteq,jumpp,jmpsie,nsec
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /scale/ x11scale(2),x11disp(2),ragmed,deltax,deltay
      common/xwi/ color,xo,yo,khead,Species,NumSpec,ihcopy,ipres,jpres
      common /chc/ kconth,nSelect,lmi(60,4),nhot,nHook(60,3)
      common /ccurs/ ifwatch, mcShape
      common/dotdat/ fname,ext,path
      common /neutro/ neutro,neuwei,vetint(500),nsyn
      common /sirtxt/ sirtx,jhelp,ffile,sirpal,jwrpal,iasun,ciffle
      common /ulcase/ ulc
      common /lsq1/ nWeight,Dampi,nCycles,iCutoff,LsqType,ifDefault,iW12
      common /contr/ NF,iFirstTime,Titolo,Ratio,ifCont,ifEdge,ifScale,
     *               kplty, ifDrRes,AngDef,PercTra,ViewDist,ifChangedXYZ
      common /contr1/ ifGhost,ifDrHydr,FProb,ifHardC,ifHBridge,ifContour 
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common /restr/rescon(6),vres(6000),nres,wq,dmean,amean,nplane,mres
      common/bigcom/ maxstr,maxpsi
      common /restw/ dfr(3,500),qvr(3,500),kblock(500)
      common /fonte/ FntType,FntAscent,FntPixWidth,FntPixHeight,
     *               FntAvgWidth
      common /WildRun1/ nWsymb,nWrand,kWstop,NoWild
      common /WildRun2/ nwild,nWDelay,kWDelay,iverbo,interv,errev(101)
      common /pkitc/ kit,kitvet(35)
      common /swc/ kpunti(3,4),nswp(2,8),ksw(2,217)
      common /setequ/ kpatt,dummy(504)
      common /crisTest/ ktest
      common /elettroni/ lproj, zeff(8), rminimo, kminimo, kaminimo
      common /lsql/ nAddComm,iPdire,icomatB,ipcomB,iFFour,amult,BLimit
c
      data rminimo /99999.999/
      data kit/2/
      data kpatt/0/
c
      data ktest/0/
      data FntType,FntAscent,FntPixWidth,FntPixHeight,FntAvgWidth
     *    /  0    ,    10   ,    10     ,   15       ,   10     /
c
      data ulc/'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'/
c
      data blank/' '/
      data digit/'0123456789.-'/
      data beg,commen /'%','>'/
      data maxcom/200/
      data allcom/'normal        ','seminvariants ','invariants    ', ! 3
     *            'phase         ','fourier       ','menu          ', ! 6
     *            'end           ','continue      ','job           ', ! 9
     *            '              ','cancel        ','initialize    ', !12
     *            'one           ','history       ','%             ', !15
     *            'patterson     ','quartets      ','caos          ', !18
     *            'use           ','return        ','              ', !21
     *            'structure     ','data          ','nowindow      ', !24
     *            'window        ','save          ','lsq           ', !27
     *            'update        ','hydrogen      ','geometry      ', !30
     *            'agreement     ','weight        ','resid         ', !33
     *            '              ','              '/
c
c--   fourier recycling common
      data jrecyc,krecy,nemap /6*0/
      data erre,erreo /2*0.0/
      data bfac /500*0.0/
c--   graphics
      data ifCont,ifEdge,ifScale,IfGhost,ifDrRes,ifDrHydr,ifChangedXYZ
     *      /0,      0,     1,     1,       0,      1,         0/
      data nWeight,Dampi,nCycles,iCutoff,LsqType,ifDefault,iW12
     *      /6,     1.,     3,      3,      2,       0,       0/
      data ifContour / 0 /
      data deltax,deltay /88.0 , 0.0/
      data ihcopy,ipres,jpres / 0, 0, 0/
      data iprin/0/
c-- restraints
      data nres,nplane/0,0/
      data mres/6000/
      data kblock/500*0/
c--   maxstr = maximum number of strong reflections
c--   maxpsi = maximum number of weak reflections
c     data maxstr,maxpsi /800,300/
      data maxstr,maxpsi /1500,500/
c-- kconth = 0 the contestual help window can be activated
c--          1 the contestual help window cannot
      data kconth /0/
c-- ifwatch=1 the watch (or similar) shape is active for mouse cursor
c-- ifwatch=0 the pointer (or similar) shape is active for mouse cursor
      data ifwatch ,mcShape/0, 0/
c
c-- nwild = phase set number in super-automatic refinement
      data nwild, nWDelay, NoWild /3*0/
      data interv /300/
      data kWstop/0/
c
      data jhelp /44/
c-- jwrpal = 1 if SirPal.pal can be modified, = 0 otherwise
      data jwrpal /1/
c**machine specific -
CHANGE
c
c-- name of scattering factors file,
c-- help file,palets file, space group file and CIF file
c
      data ffile /  'SirWare.xen'   /
      data sirtx /  'SirWare.hlp'/
      data sirpal/  'SirWare.pal' /
      data iasun /  'SirWare.spg'  /
      data ciffle/  'SirWare.cif' /
      data path  /  ' '          /
c-- default name for work files
      data fname( 1)/        'struct'            /
      data fname( 2)/        'struct'            /
      data fname( 3)/        'struct'            /
      data fname( 4)/        'struct'            /
      data fname( 5)/        'struct'            /
      data fname( 6)/        '      '            /
      data fname( 7)/        '      '            /
      data fname( 8)/        '      '            /
      data fname( 9)/        '      '            /
      data fname(10)/        '      '            /
      data fname(11)/        'struct'            /
      data fname(12)/        'struct'            /
      data fname(13)/        'struct'            /
      data fname(14)/        'struct'            /
      data fname(15)/        'struct'            /
c-- default extension for work files
      data ext( 1)/        '.bin'            /
      data ext( 2)/        '.hkl'            /
      data ext( 3)/        '.ins'            /
      data ext( 4)/        '.plt'            /
      data ext( 5)/        '    '            /
      data ext( 6)/        '    '            /
      data ext( 7)/        '    '            /
      data ext( 8)/        '    '            /
      data ext( 9)/        '.bmp'            /
      data ext(10)/        '    '            /
      data ext(11)/        '    '            /
      data ext(12)/        '    '            /
      data ext(13)/        '    '            /
      data ext(14)/        '.sir'            /
      data ext(15)/        '.out'            /
c     *** warning *** if the user wants to change the lenght of these
c                     default name and/or extension he must modify
c                     also in the subroutine 'spoolr' the relative
c                     assignement statements
      data neutro /0/
c
c-- sirware logo
c
      data (kpunti(1,j),j=1,4) /44,22,48,14/
      data (kpunti(2,j),j=1,4) /28, 4, 3, 6/
      data (kpunti(3,j),j=1,4) /46,12, 3, 6/
      data nswp / 45, 6, 7, 6, 7, 6, 5, 0,42, 0,31, 0,43, 0,37, 0/
      data ((ksw(j,i),j=1,2),i=  1, 50) /
     *17, 2,15, 4,10, 2, 6, 2, 5, 3, 4, 3, 1, 6, 1,11, 2,12, 2,13,
     * 3,14,10,17,11,17,15,21,15,23,12,26,10,26, 5,24, 5,23, 3,21,
     * 1,16, 1,25, 3,23, 4,23,10,26,12,26,13,25,15,25,18,22,18,20,
     *19,19,19,17,18,14,16,12,15,12,14,11,11,11,10,10, 5, 8, 5, 4,
     * 7, 2,10, 2,15, 4,17, 9,17, 2,30,10,22,10,22,11,25,11,25,26/
      data ((ksw(j,i),j=1,2),i= 51,100) /
     *30,26,30,10,41,10,33,10,33,11,36,11,36,26,41,26,41,10,13,21,
     *12,22,12,24,13,23,13,21,15,27,14,27,13,28,13,32,14,33,14,35,
     *15,36,15,37,16,38,18,38,21,35,23,37,23,40,24,40,25,41,25,40,
     *26,39,26,38,28,36,28,35,29,34,29,33,31,31,31,30,33,28,33,22,
     *32,21,32,27,32,28,27,28,26,29,26,32,23,32,23,28,22,25,21,28/
      data ((ksw(j,i),j=1,2),i=101,150) /
     *20,31,18,33,16,31,16,29,15,28,15,27,47,20,44,19,43,19,43,30,
     *41,32,39,32,38,31,39,28,37,28,36,31,36,33,33,33,34,35,34,36,
     *35,36,34,37,34,39,33,42,34,42,35,39,36,36,37,35,43,35,43,41,
     *43,40,46,37,46,35,49,32,49,31,47,31,47,20,67,22,59,20,54,20,
     *52,23,54,22,54,26,53,27,53,32,52,33,52,39,53,40,54,40,55,39/
      data ((ksw(j,i),j=1,2),i=151,200) /
     *55,37,56,36,57,37,58,37,60,39,63,40,64,41,66,40,67,39,68,38,
     *63,36,57,30,57,25,58,24,61,24,62,25,64,25,66,27,65,28,64,28,
     *63,29,59,29,60,30,65,30,68,29,69,28,69,26,68,25,68,23,67,22,
     *86,20,77,20,76,21,75,21,74,22,74,24,73,25,73,28,72,29,72,39,
     *73,39,75,41,77,41,79,39,81,39,83,37,80,37,79,38,77,38,75,36/
      data ((ksw(j,i),j=1,2),i=201,217) /
     *78,33,79,33,80,32,84,32,84,30,82,30,80,29,78,29,77,28,78,25,
     *79,24,83,24,84,23,85,23,85,22,86,21,86,20/
      data nAddComm,iPdire,icomatB,ipcomB,iFFour,amult,BLimit
     *     /      0,     0,      0,     0,     0,  0.0, 9999.9/
c
      end
c ----------------------------------------------------------------------
      block data caosblk
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
c
      data ncru,ncwu,ncpu,ncpt,itty,istat2,iabort 
     *    /   5,   6,   7,  62,   1,     0,     0/
c
      end
c ----------------------------------------------------------------------
      subroutine About
c ---
      common /bufferg/ ixv(1000),iyv(1000),kptr(1000),nptr,
     *                 ixa(107),iya(107)
      common /colori/ c, cs, csd, nPal, Palets, DefPals, nActPal
      common /screen/ kscreen,jy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /scale/ x11scale(2),x11disp(2),ragmed,deltax,deltay
      common /puls/Lim(190,4),iAct(190),iDepr(190),iRep(190),iFocus(190)
     *              ,ipu(190),iHB,iDeep,nFocus(5)
      common /parfin/ LimF(5,4), iPal(5), Livel, nPulsTot(5), iFull(5),
     *                iHConv, iwLMenu, iVP(5,4), Lhh(5), Lhs(5)
      common /fonte/ FntType,FntAscent,FntPixWidth,FntPixHeight,
     *               FntAvgWidth
      common /swc/ kpunti(3,4),nswp(2,8),ksw(2,217)
c ---
      integer  c(4,11),cs(4,2,11),Palets(4,256),DefPals(4,256)
     *         ,csd(4,2,11)
      character*80 Msg1,Msg2,Msg3
      character Inte*80,Msg*320
      character*400 MsgB, MsgC
      character *80 Card(10)
      character *6 BK(3)
      character Buff
c ---
      if (kscreen.eq.0) return
c
      nType = 0
      Inte = 'About SIR97 ( Release 1.04 )'
C     '1234567890123456789012345678901234567890'
*     Msg1=
*    +'A program for automatic solution and re'//
*    +'finement of crystal structure. By A. A'
*     Msg2=
*    +'ltomare, G. Cascarano, C. Giacovazzo, A.'//
*    +' Guagliardi, A.G.G. Moliterni, M.C. Burl'
*     Msg3=
*    +'a, G. Polidori, M. Camalli & R. Spagna'
      Msg1=
     +'A program for automatic solution and re'//
     +'finement of crystal structure. By A. A'
      Msg2=
     +'ltomare, M.C. Burla, M. Camalli, G. Cas'//
     +'carano, C. Giacovazzo, A. Guagliardi,'
      Msg3=
     +' A.G.G. Moliterni, G. Polidori, R. Spagna'
      Msg = Msg1(1:Lung(Msg1))//
     a      Msg2(1:Lung(Msg2))//
     b      Msg3(1:Lung(Msg3))
c ---
      Livel = Livel + 1
      nPal = 2
      iPal(Livel) = nPal
      iFull(Livel) = 0
      Lht = Lhs(Livel)
      Lhhl = Lhh(Livel)
c ---
      jTipo = nType / 10
      iTipo = nType - (jTipo * 10)
      if (jTipo.lt.2) then
         jTipo = 1
      end if
      nrMax = 5
*     mp =  iVP(1,3) / 2
*     Lx =  iVP(1,3) / 4
      mp =  kscrx / 2
      pm =  ( kscrx - deltax ) / 2.0
      Lx =  pm * 0.80
      iForce = 0
    2 ix1 = mp - Lx
      ix2 = mp + Lx
      if (ix1 .lt. 0) then
         ix1 =            iHB
         ix2 = iVP(1,3) - iHB
         iForce = 1
      end if
c ---
      LenLogo = 90
      ix1_save = ix1
      ix1 = ix1 + 4 * Lht + LenLogo
c ---
      nr = 0
      MsgC = Msg
    1 iz = Lung(Msg)
      ind = 30
    3 call graphs(ixv,iyv,iz,ind,Msg,icol,icol)
      nPix = ixv(1)
      nPixM = ix2 - ix1 - 2 * (Lht + FntPixWidth)
      if (nPix .gt. nPixM.or.iz.gt.79) then
         call CutStrBlank(Msg, iz)
         goto 3
      end if
      nr = nr + 1
      if (nr .gt. nrMax .and. iForce .eq. 0) then
         Lx = 1.2 * Lx
         Msg = MsgC
         goto 2
      end if
      Card(nr) = ' '
      Card(nr)(1:iz) = Msg
      if (nr .eq. 10 ) then
         goto 4
      end if
      if (iz .lt. Lung(Msg)) then
          MsgB = Msg(iz+1:Lung(Msg))
          Msg = MsgB
          call ltrim(Msg)
          goto 1
      end if
c ---
    4 continue
      nr = nr + 1     ! blank line
      Card(nr) = ' '
      nr = nr + 1     ! The Heir
      Card(nr) = 'The heir of SIR92 and C.A.O.S.'
      nr = nr + 1     ! blank line
      Card(nr) = ' '
      nr = nr + 1     ! support
      Card(nr) = 'Support: sirware@area.ba.cnr.it'
      nr = nr + 1     ! WEB
      Card(nr) = 'http://www.ba.cnr.it/IRMEC/SirWare.html'
      forText = 10 + nr * (1.4 * FntPixHeight) + FntPixHeight
      forDisp = 2 * iHB
      forDisp = 0
      forButt = 2 * iHB
      ky2 =  Lhhl + 2*Lht + forText + forDisp + forButt
         iy1 = iVP(1,2) + (iVP(1,4)-iVP(1,2)-ky2) / 2
      iy2 = iy1 + ky2
      iyc = iy1 + 2 * Lht + 1.5 * Lhhl + 10
cnew
      iy22 = iyc + 10 + Lhhl + 1.5 * iHB
      if (iy2.lt.iy22) iy2 = iy22
cnew
      call Hide_Mouse_Cursor
      call ScreenSave(0, 0, kscrx, kscry, 1)
c ---
      LungMax = 0
      do 51 i=1, nr
         iz = Lung(Card(i))
         ind = 30
         call graphs(ixv, iyv, iz, ind, Card(i), c(nPal, 5),c(nPal, 5))
         if (ixv(1).gt.LungMax) then
	      LungMax = ixv(1)
	   end if
   51 continue 
      WinWidth = 4*Lht + LenLogo + LungMax + iHB + Lht
	ix1_save = mp - WinWidth/2
	ix2 = mp + WinWidth/2
      ix1 = ix1_save + 4 * Lht + LenLogo
c ---
      BK(1) = '   OK'
      nBK = 1
      iTipInt = 0
      call XWindow(ix1_save, iy1, ix2, iy2, Inte, iTipInt, nb)
c ---
      ixp = ix1 + Lht + FntPixWidth
      iyp = iy1 + Lhhl + 10
      do 5 i=1, nr
         iz = Lung(Card(i))
         ind = 90
         ixv(1)= ixp
         iyv(1)= iyp
         call graphs(ixv, iyv, iz, ind, Card(i), c(nPal, 5),c(nPal, 5))
         iyp = iyp + 1.4 * FntPixHeight
    5 continue
c ---
c
c-- SirWare logo
c
      kscrx0 = ix1_save + 4 * Lht
      kscry0 = iy1 + ( iy2 - iy1 - 50 ) / 2
      do 100 i=1,3
         ix = kpunti(i,1) - kpunti(i,3)
         iy = kpunti(i,2) - kpunti(i,3)
         iz = 2 * kpunti(i,3)
         iColor = kpunti(i,4)
         ixv(1) = kscrx0 + ix
         iyv(1) = kscry0 + iy
         ind = 11
         call graphs(ixv, iyv, iz, ind, Buff, iColor, iColor)
         if (i.eq.1) then
             iColor0 = 0
             ind = 10
             call graphs(ixv, iyv, iz, ind, Buff, iColor0, iColor0)
         endif
  100 continue
      k = 0
      do 300 j=1,8
         nPunti = nswp(1,j)
         iColor = nswp(2,j)
         do 200 i=1,nPunti
            k = k + 1
            ix = ksw(1,k)
            iy = ksw(2,k)
            ixv(i) = kscrx0 + ix
            iyv(i) = kscry0 + iy
  200    continue
         iz = nPunti
         ind = 13
         call graphs(ixv, iyv, iz, ind, Buff, iColor, iColor)
         iz = nPunti
         ind = 14
         call graphs(ixv, iyv, iz, ind, Buff, iColor, iColor)
  300 continue
cnew
      ix1 = ix1_save
cnew
      LungPuls = 70
      iAltPuls = iHB
      LW = ix2 - ix1 - 2 * Lht
      iXin = ix1 + Lht
      iYtop = iy2 - Lht - 1.5 * iAltPuls
      LCol = (LW - nBK * LungPuls) / (nBK + 1)
      nbi = nPulsTot(Livel - 1)
      nFocus(Livel) = jTipo + 1
      do 20 np = 1, nBK
         nb = nb + 1
         Lim(nb, 1) = iXin + (np - 1) * (LCol + LungPuls) + LCol
         Lim(nb, 2) = iYtop
         Lim(nb, 3) = Lim(nb, 1) + LungPuls
         Lim(nb, 4) = Lim(nb, 2) + iAltPuls
         iDepr(nb) = 1
         iRep(nb) = 0
         iAct(nb) = 1
         iFocus(nb) = 1
         ipu(nb) = nb
         if (nFocus(Livel) .eq. nb - nbi) then
            iBord = 2
         else
            iBord = 1
         end if
         call Tasto (nb, iBord, BK(np))
   20 continue
      nPulsTot(Livel) = nb
c ---
      iExitC = 0
      call Display_Mouse_Cursor
c ---
   50 call Sorcio(ix, iy, iExitC)
      if (iExitC .eq. -1) goto 50
      if (iExitC .EQ.-12) then
         iExitC = -11
      elseif (iExitC .le.1) then
         call Beep(100,100)
         goto 50
      end if
      iExitC = iExitC - 1      ! la barra del titolo!!!
      Livel = Livel - 1
      nPal = iPal(Livel)
c ---
      call Hide_Mouse_Cursor
      call ScreenSave(0, 0, kscrx, kscry, 0)
      call Display_Mouse_Cursor
c ---
      return
      end
c ----------------------------------------------------------------------
      subroutine InitialPlot
      character file*256
      character fname(15)*256,ext(15)*4,path*256
      common/dotdat/ fname,ext,path
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
c-- coordinats
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
c-- graphics
      common/screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /scale/ x11scale(2),x11disp(2),ragmed,DeltaX,DeltaY
c--
      common /bufferg/ ixv(1000),iyv(1000),kptr(1000),nptr,
     *                 ixp(107),iyp(107)
      common /fonte/ FntType,FntAscent,FntPixWidth,FntPixHeight,
     *               FntAvgWidth
      common /puls/Lim(190,4),iAct(190),iDepr(190),iRep(190),iFocus(190)
     *              ,ipu(190),iHB,iDeep,nFocus(5)
      common /parfin/ LimF(5,4), iPal(5), Livel, nPulsTot(5), iFull(5),
     *                iHConv, iwLMenu, iVP(5,4), Lhh(5), Lhs(5)
      common /contr/ NF,iFirstTime,Titolo,Ratio,ifCont,ifEdge,ifScale,
     *               kplty,ifDrRes,AngDef,PercTra,ViewDist,ifChangedXYZ
      common /GeneraC/ DeA(3), DeADef(3), nCell(3),
     *                 RB(3, 3, 48), T(3, 48),
     *                 Shf(3, 3), Tra(3, 20), nsy, NatInd, nt1
      common /atomi/ xyz(3,9800),NAT,RR(9800),iCol(9800),iOrd(9800),nv,
     *        MLU(9800), Lab(9800), RS(9800), ipix(3,9800),iEqui(9800)
     *       ,nOpEq(9800)
      common /Crt/ iBarre(99, 4),Lett(100),NumBar(99), iCheBarre(99, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PIG,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(9800,2), RI(3)
      character Lab*8, nt1*1, Titolo*80, Lett*1
      real MLU
      common /viewp/ jx1, jy1, jx2, jy2
      common /colori/ c, cs, csd, nPal, Palets, DefPals, nActPal
      integer c(4,11),cs(4,2,11),Palets(4,256),DefPals(4,256),
     *        csd(4,2,11)
      common /RotMou/ iAnchorX, iAnchorY, IfDrag, IcanDrag, iDragEnabled
     *               ,mEv_fsBtn
c ---
      character*256 sirtx,ffile,sirpal,iasun,ciffle
      character*160 Msg
*     character Inte*80
      common /sirtxt/ sirtx,jhelp,ffile,sirpal,jwrpal,iasun,ciffle
      common /WildRun1/ nWsymb,nWrand,kWstop,NoWild
      common /WildRun2/ nwild,nWDelay,kWDelay,iverbo,interv,errev(101)
      common /chm/ IfChangeHM, IfHelpEnabled, IfRotTran
      common /PlotOpt/ ifLabels, nRadType, ProbF, ifMonoCr, nColPal
      common /BackSt/ IfBackingStore
c
      if (kscreen.eq.0) return
c
      ix1 = 0
      iy1 = 0
      ix2 = kscrx
      iy2 = kscry
      call ViewPort2(ix1, iy1, ix2, iy2)
      k = Lung(path)
      if (k.gt.0) then
          file = path(1:k)//'SirWare.zeo'
      else
          file =            'SirWare.zeo'
      endif
      itype=2
      iform=1
      jop=jopen(kform,file,nlen,itype,iform,ier1)
      if (jop.lt.0) then
         ier=2222
         if (ier1.eq.6416) then
            write(Msg,301) file
         else
            write(Msg,300) ier1,file
         end if
  300    format(' Open error, code =',i5,' file is ',a)
  301    format(' File not found, file is: ',a)
         call screrr(ier,Msg,1)
      else
         rewind kform
         read(kform,'(i5)') NAT
         do 310 k = 1, NAT
            read(kform,320) lab(k), xyz(1,k), xyz(2,k), xyz(3,k),
     *                   MLu(k), RS(k), icol(k)
  310       continue
  320       format(a5,1x,5f10.5,i4)
         close(kform)
c
         nv = 0
         NATind = NAT
         call BuildBonds(99)
         do 330 JAT=1,NAT
        if (xyz(1,JAT)-RS(JAT) .LT. Rmin1) Rmin1 = xyz(1,JAT)-RS(JAT)
        if (xyz(1,JAT)+RS(JAT) .GT. RMAX1) RMAX1 = xyz(1,JAT)+RS(JAT)
        if (xyz(2,JAT)-RS(JAT) .LT. Rmin2) Rmin2 = xyz(2,JAT)-RS(JAT)
        if (xyz(2,JAT)+RS(JAT) .GT. RMAX2) RMAX2 = xyz(2,JAT)+RS(JAT)
  330     continue

         ViewDist = 60.06
!21-03-2000
         iptb = iPlotType
!         if (iPlotType.eq.0) then
            iPlotType = 2
!         end if
         iang = 0
         idum = iVP(Livel, 1)
         idum1 = DeltaX
         idum2 = iwLMenu
         iVP(Livel, 1) = Lhs(Livel)
         DeltaX = Lhs(Livel)
         iwLMenu = DeltaX
         call Disegna(1, iang)
         iVP(Livel, 1) = idum
         DeltaX = idum1
         iwLMenu = idum2
         iPlotType = iptb
      endif
      call manage_mouse_cursor(0)
      call Display_Mouse_Cursor
c
      return
      end
c ----------------------------------------------------------------------
      subroutine frm31
      return
      end
c ----------------------------------------------------------------------
      subroutine ResDraw
      return
      end
c ----------------------------------------------------------------------
      subroutine Upjrest(idum)
      idum = 0
      return
      end
c ----------------------------------------------------------------------
      subroutine TopMenu(idum1,idum2,idum3,idum4)
      dimension idum4(*)
      idum4(1) = idum1 + idum2 + idum3
      return
      end
c ----------------------------------------------------------------------
      subroutine dt_tc(ixC, iyC, iflag)
      iflag = ixC + iyC
      iflag = 0
      return
      end
c ----------------------------------------------------------------------
      subroutine ManRes(idummy,loop)
      idummy = 0
      loop = 0
      return
      end
c ----------------------------------------------------------------------
      subroutine scrext
      return
      end
c ----------------------------------------------------------------------
      subroutine scrsir
      return
      end
c ----------------------------------------------------------------------
      subroutine rietveld(ier)
      ier = 0
      return
      end
c ----------------------------------------------------------------------
      subroutine fourplo(ivet)
      dimension ivet(10)
      ivet(1) = 0
      return
      end
c ----------------------------------------------------------------------
      subroutine plottaN(ijjj,nnlim1,nnlim2,tthminp,tthmaxp,yyyymax,
     *                   iitype)
      ijjj    = 0
      nnlim1  = 0
      nnlim2  = 0
      tthminp = 0
      tthmaxp = 0
      yyyymax = 0
      iitype  = 0
      return
      end
c ----------------------------------------------------------------------
      subroutine stopriet
      return
      end
c-----------------------------------------------------------------------
      subroutine examin(kph,nuset,nhkl,iphiv,iphic,mmm,numbx,wtexa,shi)
c
      dimension nhkl(mmm),iphiv(mmm),iphic(mmm),wtexa(mmm)
      dimension shi(4)
c
      kph = 0
c
      return
      end
c-----------------------------------------------------------------------
      subroutine pherrdis(tirang,dij,ihkl,nrif,ic,ia,ib,shi,c,istep)
c
      integer ia(nrif),ib(nrif),ihkl(nrif)
      real c(nrif),dij(nrif),shi(4)
      character tirang*11
c
      istep = ia(1)+ib(1)+ihkl(1)+c(1)+dij(1)+shi(1)
      tirang = ' '
      return
      end
c-----------------------------------------------------------------------
      subroutine to_coord(kdstampa)
      i = kdstampa
c
      return
      end
c-----------------------------------------------------------------------
