c---------------------------------------------------
c--- This file contains compiler-dependent code  ---
c---       Search for the string "CHANGE"        ---
c---       in order to modify the program        ---
c---------------------------------------------------
      subroutine BeccaArg(file1,file2)
      character*256 file1,file2
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      character fname(15)*256,ext(15)*4,path*256
      common/dotdat/ fname,ext,path
      common /SWareRC/ SWRC, HOMEdir
      character*256 SWRC, Inte, NewL, DISPLAY, HOMEdir
c
c
c-- Get the value of HomeDir = $HOME
c
      call getenv('HOME',NewL)
      HOMEdir = NewL
c
c-- Get the value of the Display = $DISPLAY
c
      call getenv('DISPLAY',Inte)
      k3 = index(Inte,':')
      if (k3.gt.0) then
          if (k3.eq.1) then
              DISPLAY = 'Local'
          else if (Inte(1:k3-1).eq.'unix') then
              DISPLAY = 'Local'
          else
              DISPLAY = Inte(1:k3-1)
          endif
      else
          DISPLAY = Inte
      endif
c
c-- build  $HOME/SirWare.cfg string ( -> SWRC )
c
      k1 = Lung(path)
      k2 = Lung(NewL)
      k3 = Lung(DISPLAY)
      if (k1.eq.0) then
          if (k3.ne.0) then 
              Inte = NewL(1:k2)//'/SirWare.cfg'
     *            //'@'//DISPLAY(1:k3)
          else
              Inte = NewL(1:k2)//'/SirWare.cfg'
          endif
          path = NewL(1:k2)//'/'
      else
          if (k3.ne.0) then 
              Inte = path(1:k1)//'/SirWare.cfg'
     *            //'@'//DISPLAY(1:k3)
          else
              Inte = path(1:k1)//'/SirWare.cfg'
          endif
      endif
      SWRC = Inte
c
c-- check if $HOME/SirWare.cfg ( SWRC ) exist
c
      itype=2
      iform=1
      jop=jopen(kform,Inte,nlen,itype,iform,ierr)
      if (jop.lt.0) then
          ier = 0
          call GetPWD(file1,nfile1,ier)
c         Record # 1  = User HOME directory
c         Record # 2  = Sir97/Expo work file directory
c         Record # 3  = Structure name
c         Record # 4  = Output file name
c         Record # 5  = Proportional font name
c         Record # 6  = Non-proportional font name
          itype=0
          iform=1
          jop=jopen(kform,Inte,nlen,itype,iform,ierr)
          write(kform,'(a)') NewL(1:Lung(NewL))
          if (ier.eq.0) then
                write(kform,'(a)') file1(1:nfile1)
          else
                write(kform,'(a)') NewL(1:Lung(NewL))
          endif
          file1 = ' '
          file2 = ' '
          write(kform,'(6h          )')
          write(kform,'(6h          )')
          write(kform,'(1h*)')
          write(kform,'(1h*)')
          write(kform,'(13h  2    0    0)')
      endif
      close (kform)
c
      NumArgs = iargc()
           if (NumArgs .eq.2) then
               call GetArg(1,file1)
               call GetArg(2,file2)
      else if (NumArgs .eq.1) then
               call GetArg(1,file1)
               file2= ' '
        else
               file1= ' '
               file2= ' '
      end if
c
      return
      end
c-----------------------------------------------------------------------
      subroutine display_mouse_cursor
c
CHANGE
c-- P.C./386 version
C      call SetPtrVis(SHOW)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine hide_mouse_cursor
c
CHANGE
c-- P.C./386 version
C     call SetPtrVis(HIDE)
c
      return
      end
c-----------------------------------------------------------------------
      function if_mouse_there()
c
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      logical instal
c
      if (IfMouse .lt. 0) then
CHANGE
c-- P.C./386 version
C        instal = MouseInit()
         instal = .TRUE.
         if (instal) then
c        if (instal .gt. 0) then
            if_mouse_there = 1
            IfMouse = If_mouse_there
            ifMouse = 1
         else
            if_mouse_there = 0
            ifMouse = 0
         end if
      else
         if_mouse_there = 1
      end if
c
      return
      end
c-----------------------------------------------------------------------
      subroutine sirtime(string,lstring)
      character *(*) string
c
c-- if a TIME function is not available 
c-- tranform this subroutine in a dummy one
c-- leaving only the following lines
c--
c--              character *(*) string
c--              lstring=0
c--              return
c--              end
c
CHANGE
c----- code for Unix
      character time*26
c
c
      call sirtm(time)
      string( 1:3)='At '
      string( 4:11)=time(12:19)
      string(12:12)=' '
      lstring=12
CHANGE
c----- code for Vax-VMS
cVMS  character stringa_time*8
c
cVMS  call time(stringa_time)
cVMS  string( 1:3)='At '
cVMS  write(string( 4:11),'(a8)') stringa_time
cVMS  string(12:12)=' '
cVMS  lstring=12
CHANGE
c----- code for P.C. - DOS
C     integer *2 ihr,imin,isec,i100th
C     call GetTim(ihr, imin, isec, i100th)
C     write(string,'(3x,i2,1h:,i2,1h:,i2)') ihr, imin, isec
C     string( 1:3)='At '
C     string(12:12)=' '
C     lstring=12
c
      return
      end
c-----------------------------------------------------------------------
      subroutine sirdate(string,lstring)
	  character *(*) string
c
c-- if a DATE function is not available 
c-- tranform this subroutine in a dummy one
c-- leaving only the following lines
c--
c--              character *(*) string
c--              lstring=0
c--              return
c--              end
c
CHANGE
c----- code for Unix
      character stringa_data*26
c
      string=' '
      call sirtm(stringa_data)
      string( 1:11)=stringa_data( 1:11)
      string(12:16)=stringa_data(20:24)
      call shift(string,k)
      string(k+2:k+3)='at'
      string(k+5:k+12)=stringa_data(12:19)
      lstring=k+12
CHANGE
c----- code for Vax-VMS
cVMS  character stringa_time*8,stringa_data*9
c
cVMS  call time(stringa_time)
cVMS  call date(stringa_data)
cVMS  string( 1: 1)=' '
cVMS  string( 2:10)=stringa_data
cVMS  string(11:14)=' at '
cVMS  string(15:22)=stringa_time
cVMS  lstring=22
CHANGE
c----- code for P.C. - DOS
C     integer *2 iyr,imon,iday
C     integer *2 ihr,imin,isec,i100th
C     call GetDat(iyr, imon, iday)
C     write(string,'(3x,i2,1h/,i2,1h/,i2)') iday, imon, iyr
C     string(12:15)=' at '
C     call GetTim(ihr, imin, isec, i100th)
C     write(string,'(15x,i2,1h:,i2,1h:,i2)') ihr, imin, isec
C     lstring=23
c
c
      return
      end
c-----------------------------------------------------------------------
      subroutine graphs( ixv,iyv,iz,ind,str,icolor1,icolor2)
      common/xwi/ color,xo,yo,khead,Species,NumSpec,ihcopy,ipres,jpres
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /scale/ x11scale(2),x11disp(2),ragmed,deltax,deltay
      common /string/ x11string
 
      character Species(8)*2,x11string*260
      integer color, xo, yo, khead
      integer ixv(1000),iyv(1000)
      character str*(*)
c
c----- code for Unix
      if (ind.eq.-1.or.
     *    ind.eq. 1.or.
     *    ind.eq. 9.or.
CCC  *    ind.eq.90.or.
     *    ind.eq.81.or.
     *    ind.eq.15.or.
     *    ind.eq.31.or.
     *    ind.eq.16) then
          lstr=len(str)
          x11string(1:lstr) = str(1:lstr)
          x11string(lstr+1:lstr+1) = char(0)
          iz = lstr + 1
      endif
*NEW NEW
      if (ind.eq.90) then
          if (iz.le.0) iz = len(str)
          x11string = str(1:iz)
          iz = iz + 1
          x11string(iz:iz) = char(0)
      endif
*NEW NEW
      if (ind.eq.30) then
          if (iz.eq.0) then
              ixv(1)=0
              return
          endif
          x11string(1:iz) = str(1:iz)
          x11string(iz+1:iz+1) = char(0)
      endif
      call x11intf( ixv,iyv,iz,ind,icolor1,icolor2,     x11string )
c----- code for P.C. - DOS
C     call xwin( ixv,iyv,iz,ind,str,icolor1,icolor2)
c
*     if (jscreen.ne.0)then
*         indf=7
*         call x11intf( ixv,iyv,iz,indf,icolor1,icolor2,x11string)
*     endif
c
      return
      end
c-----------------------------------------------------------------------
code for jopen
      function jopen(ncsu,name,nlen,istat,iform,ier)
c--connect a unit to an external file
c  file properties:
c  sequential
c  formatted
c  ncsu = number identifies the unit
c  name = file name
c  nlen = maximum length in bytes for formatted records
c  istat = 0 means status unknown
c        = 1 means status scratch
c        = 2 means status old
c  iform = 1 means formatted
c        = 2 means unformatted
c  ier  = integer variable to receive a status indicator
c--
      character *(*) name
      character form(2)*11
c
      form(1)='formatted  '
      form(2)='unformatted'
      jopen=0
      jump=istat+1
      if(iform.eq.2)go to 5000
      go to (1000,2000,3000),jump
 1000 continue
c-- status = 'unknown'
cdg**machine specific open file (data general)
cdg   open(unit=ncsu,file=name,iostat=ier,err=9000,
cdg  * recfm='datasensitive',status='unknown',
cdg  1 access='sequential',blank='null',delimiter='exclude',
cdg  2 exclusive='no',form=form(iform),iointent='both',
cdg  3 maxrecl=nlen,mode='text',pad='yes')
cibm**machine specific open file (ibm)
      open(unit=ncsu,file=name,iostat=ier,err=9000,
     1 status='unknown',form=form(iform))
      go to 8000
 2000 continue
c-- status = 'scratch'
cdg**machine specific open file (data general)
cdg   open(unit=ncsu,iostat=ier,err=9000,
cdg  * recfm='datasensitive',status='scratch',
cdg  1 access='sequential',blank='null',delimiter='exclude',
cdg  2 exclusive='no',form=form(iform),iointent='both',
cdg  3 maxrecl=nlen,mode='text',pad='yes')
cibm**machine specific open file (ibm)
      open(unit=ncsu,iostat=ier,err=9000,
     1 status='scratch',form=form(iform))
      go to 8000
 3000 continue
c-- status = 'old'
cdg**machine specific open file (data general)
cdg   open(unit=ncsu,file=name,iostat=ier,err=9000,
cdg  * recfm='datasensitive',status='old',
cdg  1 access='sequential',blank='null',delimiter='exclude',
cdg  2 exclusive='no',form=form(iform),iointent='both',
cdg  3 maxrecl=nlen,mode='text',pad='yes')
cibm**machine specific open file (ibm)
      open(unit=ncsu,file=name,iostat=ier,err=9000,
     1 status='old',form=form(iform))
      go to 8000
5000  continue
      go to (1100,2100,3100),jump
 1100 continue
c-- status = 'unknown'
cdg**machine specific open file (data general)
cdg   open(unit=ncsu,file=name,iostat=ier,err=9000,
cdg  * status='unknown',form=form(iform),recfm='dynamic')
cibm**machine specific open file (ibm)
      open(unit=ncsu,file=name,iostat=ier,err=9000,
     1 status='unknown',form=form(iform))
      go to 8000
 2100 continue
c-- status = 'scratch'
cdg**machine specific open file (data general)
cdg   open(unit=ncsu,iostat=ier,err=9000,
cdg  * status='scratch',form=form(iform),recfm='dynamic')
cibm**machine specific open file (ibm)
      open(unit=ncsu,iostat=ier,err=9000,
     1 status='scratch',form=form(iform))
      go to 8000
 3100 continue
c-- status = 'old'
cdg**machine specific open file (data general)
cdg   open(unit=ncsu,file=name,iostat=ier,err=9000,
cdg  * status='old',form=form(iform),recfm='dynamic')
cibm**machine specific open file (ibm)
      open(unit=ncsu,file=name,iostat=ier,err=9000,
     1 status='old',form=form(iform))
 8000 continue
      rewind ncsu
      return
9000  jopen=-1
      return
      end
c-----------------------------------------------------------------------
code for kopen
      function kopen(ncsu,name,nlen,itype,ier)
c--connect a unit to an external file
c  file properties:
c  direct
c  unformatted
c  ncsu = number identifies the unit
c  name = file name
c  nlen = length in bytes for the records
c  itype = 0 means status unknown
c        = 1 means status scratch
c        = 2 means status old
c  ier  = integer variable to receive a status indicator
c--
      character*256 name
      kopen=0
      itype=itype+1
      goto(1000,2000,3000),itype
1000  continue
c  **machine specific open file 
      open(unit=ncsu,file=name,iostat=ier,err=9000,
     * status='unknown',access='direct',
cvax 1 recordtype='fixed',
     2 form='unformatted',recl=nlen)
      return
2000  continue
c  **machine specific open file 
cdg  file name is given by the compiler
      open(unit=ncsu,iostat=ier,err=9000,
     * status='scratch',access='direct',
cvax 1 recordtype='fixed',
     2 form='unformatted',recl=nlen)
      return
3000  continue
c  **machine specific open file 
cdg  file name is given by the compiler
      open(unit=ncsu,file=name,iostat=ier,err=9000,
     * status='old',access='direct',
cvax 1 recordtype='fixed',
     2 form='unformatted',recl=nlen)
      return
9000  kopen=-1
      return
      end
c-----------------------------------------------------------------------
code for Unix
      subroutine CosaSuccede(iflag,mEv_fsBtn,mEv_x, mEv_y,
     *                       iExitC,iSt,iEnd,nbi)
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /puls/Lim(190,4),iAct(190),iDepr(190),iRep(190),iFocus(190)
     *              ,ipu(190),iHB,iDeep,nFocus(5)
      common /parfin/ LimF(5,4), iPal(5), Livel, nPulsTot(5), iFull(5),
     *                iHConv, iwLMenu, iVP(5,4), Lhh(5), Lhs(5)
      common /Mickey/ WasUp,WasDown,Pressed,Released,Premuto,iTimePres,
     *                Attivo,nPulsPrec
      common /MouseXtra/ iCross,MouseVis,ixC,iyC,mxo,myo,mx1,my1,mx2,my2
      common /ccurs/ ifwatch, mcShape
      common /viewp/ jx1, jy1, jx2, jy2
      common /Brow/ ifBro,kBro,nBro,ifEditing
      integer WasUp,WasDown,Pressed,Released,Premuto,Attivo,nPulsPrec
      integer *4 iTimePres
      common /bufferg/ ixv(1000),iyv(1000),kptr(1000),nptr,
     *                 ixp(107),iyp(107)
      character *1 MsgB
c
      iflag = 0
      ind=4 
      call graphs(ixv, iyv, iz, ind, MsgB, iDum, iDum)
      if (iz.lt.0) then
          i=1
      endif
      if (iabs(iz).eq.1.or.WasDown.ne.0) then
          if (iz.gt.0) then
              mEv_fsBtn = 1
          else
              mEv_fsBtn = 2
          endif
      endif
      if (iz.eq.2) then
          mEv_fsBtn = 0
      endif
      mEv_x = ixv(1)
      mEv_y = iyv(1)
C     write(6,*) ixv(1),iyv(1),iz
      iflag = 1
c     
      if (iz.eq.0) iflag = 0  ! No action
      if (iz.eq.2) iflag = 3  ! button release
      if (iabs(iz).eq.3) iflag = 3  ! motion notify
      if (iz.eq.3) mEv_fsBtn = 1
      if (iz.eq.-3) mEv_fsBtn = 2
      if (iz.eq.5) iflag = 1  ! motion and button pressed
*     if (iflag.eq.1) write(6,*) ' mEv_fsBtn', mEv_fsBtn
      if (iz.eq.4) then
c        mEv_fsBtn = 0
         iKey = ixv(1)
         iz = 1
         if (iKey.gt.1000) then
             iflag = -iKey
             iKey = 0
             return
         endif
            if (iKey .eq. 36) then     ! HARD COPY...
               iExitC = -8
               iflag = 2 
               return
            end if
         if (iKey .eq. 27) then       ! ESCAPE
            iExitC = -27
            iflag = 2 
            return
         end if
         if (iKey .eq. 13) then         ! ENTER
            if (ifEditing .eq. 0) then
               iflag = 2
               iExitC = nFocus(Livel)
            else
               iflag = -iKey
            end if
            return
         end if
c ---
c ---  CTRL-A
c ---
         if (iKey .eq. 1) then
            if (Livel.gt.1) then
               write(0,*) ' Livel=',Livel,nPulsTot(Livel-1),
     *                                 nPulsTot(Livel)
            else
               write(0,*) ' Livel=',Livel,nPulsTot(Livel)
            end if
         end if
c ---
c ---  CTRL-C
c ---
         if (iKey .eq. 3) then
            ind = 0
            iz  = 0
            call graphs( ixv,iyv,iz,ind,MsgB,0,0)
            stop
         end if
c ---
c ---  CTRL-E
c ---
         if (iKey .eq. 5) then
            ind = 6
            iz = 1
            call graphs( ixv,iyv,iz,ind,MsgB,0,0)
            iflag = 2
            return
         end if
c ---
c ---  CTRL-L
c ---
         if (iKey .eq. 12) then
            iflag = -iKey
            return
         end if
c ---
c ---  CTRL-P   hard copy
c ---
         if (iKey .eq. 16) then
c           call HardCopy(iExitH)
            iFlag = -iKey
            return
         end if
c ---
*        if (iKey.ge.45.and.iKey.le.57 .or.   !  -./0123456789
*    *       iKey.ge.65.and.iKey.le.90 .or.   !  A...Z
*    *       iKey.ge.97.and.iKey.le.122 .or.  !  a...z
*    *       iKey.eq.96.or.iKey.eq.39.or.     !  '  or  '
*    *       iKey.eq.34.or.iKey.eq.63.or.     !  "  or  ?
*    *       iKey.eq. 8.or.iKey.eq.32.or.     !  BS or blank
*    *       iKey.eq.40.or.iKey.eq.41) then   !  (  or  )
         if (iKey.ge.32 .and. iKey.le.126 .or.
     *       iKey.eq.25 .or.  iKey.eq.8   ) then
             iflag = -iKey
             return
         end if
              
         if (iKey .eq. 9) then    ! TAB
            iExitC = -9
            iflag = iExitC
            if (nFocus(Livel) .gt. 0) then
               if (nFocus(Livel) .lt. iEnd-nbi) then
                  nf = nFocus(Livel) + 1
               else
                  nf = iSt-nbi
               end if
*              do while (iFocus(nf+nbi) .eq. 0)
*                 nf = nf + 1
*                 if (nf .gt. iEnd-nbi) nf = iSt-nbi
*              end do
  100          if (iFocus(nf+nbi) .eq. 0) then
                  nf = nf + 1
                  if (nf .gt. iEnd-nbi) nf = iSt-nbi
                  go to 100
               endif
               call SetFocus(ipu(nf+nbi))
            end if
         end if
      end if
c
      if (iflag.ge.1.and.iflag.le.3) then
         ixC = ixv(1)
         iyC = iyv(1)
         if (MouseVis.ne.0 .and. iCross .ne.0) then
            L = 1
            Lht = Lhs(L)
            if (ixC .ge. iVP(L,1)+Lht .and. ixC .le. iVP(L,3)-Lht .and.
     *          iyC .ge. iVP(L,2)+Lht .and. iyC .le. iVP(L,4)-Lht) then
                  if (kprog.lt.10) then
                      call CrossMouse(iflag)
                  else
                      call dt_tc(ixC, iyC, iflag)
                  endif
            else
                if (mxo.ne.0 .and. myo.ne.0) then
                   if (kprog.lt.10) call HideCross
                   call Display_Mouse_Cursor
                   MouseVis = 1
                   mxo = 0
                   myo = 0
                end if
                if (kprog.lt.10.and.kscrx.gt.640.and.mcShape.ne.0) then
                   call Move_My_Pointer
c                  call MCursor(mcShape, 1, ixC, iyC)
                end if
            end if
         elseif (MouseVis.ne.0) then
            if (kprog.lt.10.and.kscrx.gt.640.and.mcShape.ne.0) then
               call Move_My_Pointer
c              call MCursor(mcShape, 1, ixC, iyC)
            end if
         end if
      end if
c
      return
      end
c-----------------------------------------------------------------------
      subroutine CrossMouse(iflag)
c
      common /MouseXtra/ iCross,MouseVis,ixC,iyC,mxo,myo,mx1,my1,mx2,my2
      common /k1920/ ibu19,ibu20,k19,k20,ibu26,ibu27,k26,k27
      common /parfin/ LimF(5,4), iPal(5), Livel, nPulsTot(5), iFull(5),
     *                iHConv, iwLMenu, iVP(5,4), Lhh(5), Lhs(5)
 
      common /colori/ c, cs, csd, nPal, Palets, DefPals, nActPal
      integer c(4,11),cs(4,2,11),Palets(4,256),DefPals(4,256)
     *        , csd(4,2,11)
c
      if (MouseVis .eq. 1) then
         call Hide_Mouse_Cursor
         MouseVis = -1
      end if
      if (ixC.ne.mxo .or. iyC.ne.myo) then
         Lht = Lhs(1)
         if (mxo .ne. 0) then
            ibu19 = -k19
            ibu20 = k20
            ibu26 = k26
            call ScreenSave(mxo, iVP(1,2)+Lht, mxo, iVP(1,4)-Lht, 2)
         end if
         if (myo .ne. 0) then
            ibu19 = k19
            ibu20 = -k20
            ibu26 = k26
            call ScreenSave(iVP(1,1)+Lht, myo, iVP(1,3)-Lht, myo, 2)
         end if
         ibu19 = k19
         call ScreenSave(ixC, iVP(1,2)+Lht, ixC, iVP(1,4)-Lht, 1)
         ibu19 = -k19
         ibu20 = k20
         call ScreenSave(iVP(1,1)+Lht, iyC, iVP(1,3)-Lht, iyC, 1)
         ic = c(nPal,10)
         call Linea(ixC, iVP(1,2)+Lht, ixC, iVP(1,4)-Lht, ic)
         call Linea(iVP(1,1)+Lht, iyC, iVP(1,3)-Lht, iyC, ic)
      end if
c
      mxo = ixC
      myo = iyC
c
      call dt_tc(ixC, iyC, iflag)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine HideCross
c
      common /MouseXtra/ iCross,MouseVis,ixC,iyC,mxo,myo,mx1,my1,mx2,my2
      common /k1920/ ibu19,ibu20,k19,k20,ibu26,ibu27,k26,k27
      common /parfin/ LimF(5,4), iPal(5), Livel, nPulsTot(5), iFull(5),
     *                iHConv, iwLMenu, iVP(5,4), Lhh(5), Lhs(5)
      common /minmax/ XXmin,XXMax,YYmin,YYMax,iAdd
c
      Lht = Lhs(1)
      ibu19 = -k19
      ibu20 = k20
      ibu26 = k26
      call ScreenSave(mxo, iVP(1,2)+Lht, mxo, iVP(1,4)-Lht, 2)
c
      ibu19 = k19
      ibu20 = -k20
      ibu26 = k26
      call ScreenSave(iVP(1,1)+Lht, myo, iVP(1,3)-Lht, myo, 2)
c
      if (iAdd .eq. 1) then
         iAdd = 0
         Lht = Lhs(1)
         Lhhl = Lhh(1)
         if (iFull(Livel) .ne. 0) then
            Lht = 0
         end if
         ix1 = LimF(Livel, 1) + Lht
         ix2 = LimF(Livel, 3) - Lht
 
c         call Hide_Mouse_Cursor
         jy2 = iVP(Livel, 2) - 1
         iH2 = iHConv - 2
         call XBox (ix1+2, jy2-iH2, ix2-2, jy2-2, 1, 0)
c         call Display_Mouse_Cursor
      end if
c ---
      return
      end
c-----------------------------------------------------------------------
      subroutine Move_My_Pointer
c
      common /MouseXtra/ iCross,MouseVis,ixC,iyC,mxo,myo,mx1,my1,mx2,my2
      common /ccurs/ ifwatch, mcShape
      common /parfin/ LimF(5,4), iPal(5), Livel, nPulsTot(5), iFull(5),
     *                iHConv, iwLMenu, iVP(5,4), Lhh(5), Lhs(5)
 
      common /bufferg/ ixv(1000),iyv(1000),kptr(1000),nptr,
     *                 ixp(107),iyp(107)
      common /colori/ c, cs, csd, nPal, Palets, DefPals, nActPal
      integer c(4,11),cs(4,2,11),Palets(4,256),DefPals(4,256)
     *        , csd(4,2,11)
      character str
      icolor = 0
c
      if (ifWatch.ne.0) then
         ix1 = ixC - 7
         ix2 = ixC + 7
         iy1 = iyC - 11
         iy2 = iyC + 11
      else
         ix1 = ixC
         ix2 = ixC + 10
         iy1 = iyC
         iy2 = iyC + 17
      end if
c
      if (ixC.ne.mxo .or. iyC.ne.myo) then
         Lht = Lhs(1)
         if (mx1 .ne. 0) then
            ixv(1)=mx1
            ixv(2)=mx2
            iyv(1)=my1
            iyv(2)=my2
            iz = 2
            ind = 28
            call graphs( ixv,iyv,iz,ind,str,icolor,icolor)
         end if
         ixv(1)=ix1
         ixv(2)=ix2
         iyv(1)=iy1
         iyv(2)=iy2
         iz = 1
         ind = 28
         call graphs( ixv,iyv,iz,ind,str,icolor,icolor)
      end if
c
c     mxo = ixC
c     myo = iyC
      mx1 = ix1
      my1 = iy1
      mx2 = ix2
      my2 = iy2
c
      return
      end
c-----------------------------------------------------------------------
      subroutine RP(numcol, krgb)
c ---
      common /colori/ c, cs, csd, nPal, Palets, DefPals, nActPal
c ---
      integer  c(4,11),cs(4,2,11),Palets(4,256),DefPals(4,256)
     *         ,csd(4,2,11),Palet(256)
c 
      do 100 i=1, 256
         Palet(i) = Palets(nActPal, i)
  100 continue
c
      Palet(numcol+1) = krgb
      call RemapAP(Palet)
c
      return
      end
c-----------------------------------------------------------------------
*     subroutine RemapAP(Palet)
*     common /bufferg/ ixv(1000),iyv(1000),kptr(1000),nptr,
*    *                 ixp(107),iyp(107)
*     character str
*     integer Palet(256),r,g,b
c
*     j=0
*     rapporto =  65535.0 / 63.0
*     do 10 i = 1 , 16
*     ic = Palet(i)
*     call ExtRGB(ic, r, g, b)
*     ixv(j+1) = float(r) * rapporto
*     ixv(j+2) = float(g) * rapporto
*     ixv(j+3) = float(b) * rapporto
*     j = j + 3
*  10 continue
*     do 20 i = 1 , 16
*     ic = Palet(i)
*     call ExtRGB(ic, r, g, b)
*     ixv(j+1) = float(3*r/4) * rapporto
*     ixv(j+2) = float(3*g/4) * rapporto
*     ixv(j+3) = float(3*b/4) * rapporto
*     j = j + 3
*  20 continue
*     iz=32
*     icolor=0
*     icolor=0
*     ind = 5
*     call graphs( ixv,iyv,iz,ind,str,icolor,icolor)
*     return
*     end
c-----------------------------------------------------------------------
      subroutine RemapAP(Palet)
      common /bufferg/ ixv(1000),iyv(1000),kptr(1000),nptr,
     *                 ixp(107),iyp(107)
      character str
      integer Palet(256)
!
      numSfum = 13
      j=0
      ish = 16*3
      rapporto =  65535.0 / 63.0
      do 10 i = 1 , 16
         ic = Palet(i)
         call ExtRGB(ic, ir, ig, ib)
         j = (i-1) * 3
         ixv(j+1) = float(ir) * rapporto
         ixv(j+2) = float(ig) * rapporto
         ixv(j+3) = float(ib) * rapporto
         fact = 0.3
         nsf = 4
         do k=1,nsf
            fact = fact + (1.-fact)/(nsf-1)
            jj = j + k * ish
            ixv(jj+1) = float(ir) * fact * rapporto
            ixv(jj+2) = float(ig) * fact * rapporto
            ixv(jj+3) = float(ib) * fact * rapporto
            ifi=jj
         end do
         fact = 0
         do k=nsf+1,numSfum
            jj = j + k * ish
            ixv(jj+1)  = (float(ir) + (63 - ir) * fact) * rapporto
            ixv(jj+2)  = (float(ig) + (63 - ig) * fact) * rapporto
            ixv(jj+3)  = (float(ib) + (63 - ib) * fact) * rapporto
            ifi=jj
            fact = fact + 1./11.
         end do
         do k=numSfum+1, 15
            jj = ifi + ish
c            ixv(jj+1) = (63. * rapporto + ixv(jj+1)) / 2
c            ixv(jj+2) = (63. * rapporto + ixv(jj+2)) / 2
c            ixv(jj+3) = (63. * rapporto + ixv(jj+3)) / 2
            ixv(jj+1) = (63. * rapporto)
            ixv(jj+2) = (63. * rapporto)
            ixv(jj+3) = (63. * rapporto)
            ifi=jj
         end do
   10 continue
      iz=jj+3
      icolor=0
      ind = 5
      call graphs( ixv,iyv,iz,ind,str,icolor,icolor)
      return
      end
c ----------------------------------------------------------------------
      function iRGB(r, g, b)
      integer *4 r, g, b
      iRGB= ( b * 64 + g ) * 64 + r
      return
      end
c ----------------------------------------------------------------------
      subroutine ExtRGB(ic, r, g, b)
      integer *4 r, g, b
      r = mod( ic , 64 )
      k = ( ic - r ) / 64
      g = mod( k , 64 )
      b = k / 64
      return
      end
c-----------------------------------------------------------------------
      subroutine GetFileList(path,string,lstring,ier)
      character*200 Msg
      common /msgerr/ Msg
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /atomi/ xyz(3,9800),NAT,RR(9800),iCol(9800),iOrd(9800),nv,
     *        MLU(9800), Lab(9800), RS(9800), ipix(3,9800),iEqui(9800)
     *       ,nOpEq(9800)
      common /bufferg/ ixv(1000),iyv(1000),kptr(1000),nptr,
     *                 ixp(107),iyp(107)
      common /chm/ IfChangeHM, IfHelpEnabled, IfRotTran
      common /parfin/ LimF(5,4), iPal(5), Livel, nPulsTot(5), iFull(5),
     *                iHConv, iwLMenu, iVP(5,4), Lhh(5), Lhs(5)
      common /fonte/ FntType,FntAscent,FntPixWidth,FntPixHeight,
     *               FntAvgWidth
      common /puls/Lim(190,4),iAct(190),iDepr(190),iRep(190),iFocus(190)
     *              ,ipu(190),iHB,iDeep,nFocus(5)
      common /xdata/ It,Num(500),dummy(346750),dummbig(150000)
      character *8 Lab
c
      character *(*) path,string
      character *256 Buffer
      integer system
      character *5 este(2)
      character  It(500)*22
c 
      este(1) = '*.sir'
      este(2) = '*.exp'
c
      ier = 0
      kkprog = mod(kprog,10)
      if (kkprog.ne.1) kkprog=2
      if (lstring.le.0) then
          string = este(kkprog)
          lstring = 5
      else
         k1 = index(string,'*') + index(string,'?')
         if (k1.eq.0) then
             k1 = index(string,'.')
             Buffer = '*' // string(k1:)
             lstring = Lung(Buffer)
             string = Buffer(1:lstring)
         endif
      endif

      Buffer = 'ls ' // string(1:lstring) // ' > sirware.tmp' // char(0)
      ier=system(Buffer)
      if (ier.ne.0) then
          ier = -1
          Msg = 'Error getting files: ' 
     *       // path(1:Lung(path))
     *       // '/' // string
          call screrr(ier,Msg,1)
          return
      else
          Buffer = 'sirware.tmp'
          itype=2
          iform=1
          jop=jopen(jrel,Buffer,nlen,itype,iform,ierr)
          if (jop.lt.0) then
              ier = -1
              Msg = 'Error getting files: ' 
     *           // path(1:Lung(path))
     *           // '/' // string
              call screrr(ier,Msg,1)
              return
          else
              It(1) = '> coppercopperco.sir'
              iz = Lung(It(1))
              ind = 30
              icol0 = 0
              call graphs(ixv, iyv, iz, ind, It(1), icol0, icol0)
              LungIt = ixv(1)
              nnn = 0
              do 50 i=1,500
                 read(jrel,'(a)',end=100) Buffer
                 It(i) = ' '
                 It(i)(3:) = Buffer(1:Lung(Buffer))
                 nnn = nnn  + 1
   50         continue
              close(jrel,status='delete')
          endif
c
      endif
  100 continue
      if (nnn.lt.500) then
          close(jrel,status='delete')
      endif
      if (nnn.eq.0) then
          ier = -1
          Msg = 'Error getting files: ' 
     *       // path(1:Lung(path))
     *       // '/' // string
          call screrr(ier,Msg,1)
      else
          LungPuls = 70
c ---
          iActLis = 7
c ---
          Lht = Lhs(Livel+1)
          Lhhl = Lhh(Livel+1)
          IfChangeHM = 0
          ix1 = 141
          iy1 = 60
          iy2 = iy1 + 10 * 1.4 * FntPixHeight
     *        + Lhhl + 2 * Lht + iHB
          Buffer = 'Select input file'
          MultiSel = 0
          call PeekList (LungPuls,ix1,iy1,LungIt,iy2,Buffer,iActLis,Num,
     *                   nnn,It,NumUnDel,iExCode,0,MultiSel)
          if (iExCode.eq.1) then
              if (NumUnDel.eq.1) then
                  k = num(1)
                  string = It(k)(3:)
                  lstring = Lung(string)
              else
                  ier = -1
                  return
              endif
          else
              ier = -1
              return
          endif
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine GetPWD(string,lstring,ier)
      character*200 Msg
      common /msgerr/ Msg
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c
      character *(*) string
      character *256 Buffer
      integer system
c
      Buffer = 'pwd > sirware.tmp' // char(0)
      ier=system(Buffer)
      if (ier.eq.0) then
          Buffer = 'sirware.tmp'
          itype=2
          iform=1
          jop=jopen(jgrap,Buffer,nlen,itype,iform,ierr)
          if (jop.lt.0) then
              ier = -1
              Msg = 'Error getting working directory'
              call screrr(ier,Msg,1)
          else
              read(jgrap,'(a)',end=100) string
              lstring = Lung(string)
              if (lstring.le.0) go to 100
              close(jgrap,status='delete')
          endif
c
          return
      endif
  100 continue
      ier = -1
      Msg = 'Error getting working directory'
      call screrr(ier,Msg,1)
      close(jrel,status='delete')
c
      return
      end
c-----------------------------------------------------------------------
      subroutine FileImage(FName,ix1,iy1,ix2,iy2)
c
      character *(*) FName
      character *256 string
      integer system
c
      string='xwd -xy | xpr -rv -portrait -cutoff 5 -density 90| lp'
     *       //char(0)
      ier=system(string)
c
      return
      end
c-----------------------------------------------------------------------
      function iTimeNow()
c ---
      iTimeNow = MrCLOCK()
c ---
      return
      end
c ----------------------------------------------------------------------
      subroutine SaveFileImage(FName,ix1,iy1,ix2,iy2)
c
      character *(*) FName
c
      return
      end
c-----------------------------------------------------------------------
      subroutine LoadFileImage(FName,ix1,iy1)
c
      character *(*) FName
c
      return
      end
c ----------------------------------------------------------------------
      BLOCK DATA DEPEND
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /W95/ ifW95
      character *80 MessH,Messages(200)
      common /scmess/MessH,Messages
c**machine specific -
c
c     define input and output channels
c     ln    = card reader
c     lo    = line printer
c     jdir  = direct access structure file
c     iscra = direct access scratch file
c     jrel  = sequential scratch file
c     ifour = sequential scratch file
c     jfile = reflection input file ( could be equal to ln if no 'refl'
c                                    directive is used in normal)
c     jhost = fourier peaks file
c     jgrap = peaks coordinates file in moldraw/schakal/molplot format
c     kform = scattering factors file
      data    ln,   lo, jdir,iscra, jrel,ifour,jfile,jhost,jgrap,kform
cDOS *    /    1,    2,   30,   31,   32,   33,   34,   35,   36,  41/
     *    /    5,    6,   30,   31,   32,   33,   34,   35,   36,  41/
CHANGE
c     jout  =  0  peaks coordinates in shelx-93 format
c           =  1  peaks coordinates in crystals format
      data jout / 0 /
c
c**machine specific -
c     nlen  =  record lenght for direct access file expressed in bytes
c              *** warning *** for VAX/VMS implementation the record
c              lenght is expressed in integer words (i.e. nlen=nlen/4)
      data nlen/2048/
*     data nlen/ 512/
c**machine specific -
c     knwr   =  number of integer words in direct access file record
c              *** warning *** for VAX/VMS implementation the record
c              lenght and the number of words have the same value
c              (i.e. nlen=knwr)
      data knwr/512/
c     kenvir =  0 for standard implementation
c     kenvir =  1 for enraf-nonius environment
c     kenvir =  2 for m.s.c.       environment
c     kenvir =  3 for INCRYS       environment
      data kenvir/0/
c     kff    =  1 form-feeds are inserted to separate important things
c     kff    =  0 form-feeds are not inserted to save paper
      data kff/1/
CHANGE
c-- P.C./386 version
c386  data IfMouse /-1/
      data IfMouse / 1/
c     graphics common - define default behaviour of the window
c                     - kscreen = 1  window used  in default
c                     - kscreen = 0  no window  in default
c     graphics common - jscreen = 0  window closed
c                     - jscreen = 1  window already opened
c                     - jscreen = 2  window already opened
c                                    & atomic species defined
      data kscreen,jscreen/1,0/
c     graphics common - define dimension of the window
*VGA  data kscrx,kscry/639,479/
      data kscrx,kscry/720,525/
CHANGE
c     Environment
c     kprog =  1     SIR97      ( DOS )
c     kprog =  2     SIRPOW.97  ( DOS )
c     kprog =  3     MOLPLO     ( DOS )
c     kprog =  4     EXTRA      ( DOS )
c     kprog =  5     RIETVELD   ( DOS )
c     kprog = 11     SIR97      ( NON DOS )
c     kprog = 12     SIRPOW.97  ( NON DOS )
c     kprog = 13     MOLPLO     ( NON DOS )
c     kprog = 14     EXTRA      ( NON DOS )
c     kprog = 15     RIETVELD   ( NON DOS )
      data kprog/10/
      data ifW95/0/
      data MessH/' '/
      data Messages /200*' '/
c
      end
c ----------------------------------------------------------------------
      subroutine GetLab95(ix1,iy1,nome,file1,file2,iExitC)
c                     - kscreen = 0  no window
c ---
      character *1 Lett
      common /Crt/ iBarre(99, 4),Lett(100),NumBar(99), iCheBarre(99, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(9800,2), RI(3)
      common /PrecEd/ OldString, kx1o,ky1o,nPixXtotO,nCarIniO,ncAct,
     *                ixMouseO,iShiftLeft,iCanShift
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /bufferg/ ixv(1000),iyv(1000),kptr(1000),nptr,
     *                 ixp(107),iyp(107)
      common /colori/ c, cs, csd, nPal, Palets, DefPals, nActPal
      common /puls/Lim(190,4),iAct(190),iDepr(190),iRep(190),iFocus(190)
     *              ,ipu(190),iHB,iDeep,nFocus(5)
      common /parfin/ LimF(5,4), iPal(5), Livel, nPulsTot(5), iFull(5),
     *                iHConv, iwLMenu, iVP(5,4), Lhh(5), Lhs(5)
      common /fonte/ FntType,FntAscent,FntPixWidth,FntPixHeight,
     *               FntAvgWidth
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /lsq1/ nWeight,Dampi,nCycles,iCutoff,LsqType,ifDefault,iW12
      common /lsq2/ nPar,WPar(4),ifWr4,WParDef(20,4),nBlocks
      character fname(15)*256,ext(15)*4,path*256,NewL*256
      common/dotdat/ fname,ext,path
      common /Brow/ ifBro,kBro,nBro,ifEditing
      common /chm/ IfChangeHM, IfHelpEnabled, IfRotTran
      common /contr1/ ifGhost,ifDrHydr,FProb,ifHardC,ifHBridge,ifContour 
      common /SWareRC/ SWRC, HOMEdir
      character *256 SWRC, HOMEdir
*     integer chdir
c ---
      integer  c(4,11),cs(4,2,11),Palets(4,256),DefPals(4,256)
     *         ,csd(4,2,11)
      character *256 Inte, Msg
      dimension ift(4), nMaxChar(4)
      character *256 Para(6),Linea(6),OldString
      character *(*) nome, file1, file2
*     logical(4) status
c ---
      itype=1
      iform=1
      jop=jopen(jhost ,' ',nlen,itype,iform,ier)
      if (jop.lt.0) go to 9000
      kkprog = mod(kprog,10)
      ifReWrite = 0
      Livel = Livel + 1
      nPal = 2
      iPal(Livel) = nPal
      iFull(Livel) = 0
      Lht = Lhs(Livel)
      Lhhl = Lhh(Livel)
      Call Hide_Mouse_Cursor
      call ScreenSave(0, 0, kscrx, kscry, 1)
c ---
    1 nLines = 4
      Linea(1) = 'User HOME directory'
      if (kkprog.eq.1) then
          Linea(2) = 'Sir97 work-files directory'
      else
          Linea(2) = 'Expo work-files directory'
      endif
      Linea(3) = 'Input file name'
      Linea(4) = 'Output file name'
      ift(1) = 0
      ift(2) = 2
      ift(3) = 2
      ift(4) = 2
      nMaxChar(1) = 256
      nMaxChar(2) = 256
      nMaxChar(3) = 256
      nMaxChar(4) = 256
c
      Inte = SWRC
      itype=0
      iform=1
      jop=jopen(kform,Inte,nlen,itype,iform,ierr)
c     Linea(1) = User HOME directory
c     Linea(2) = Sir97/Expo work file directory
c     Linea(3) = Structure name
c     Linea(4) = Output file name
c     Linea(5) = Proportional font name
c     Linea(6) = Non Proportional font name
      read(kform,'(a)') Para(1)
      Para(1) = HOMEdir
      read(kform,'(a)') Para(2)
      ier = 0
      call GetPWD(NewL,nNewL,ier)
      read(kform,'(a)') Para(3)
      read(kform,'(a)') Para(4)
      read(kform,'(a)') Para(5)
      read(kform,'(a)') Para(6)
*         write(6,*) 'Read ',Para(1)
*         write(6,*) 'Read ',Para(2)
*         write(6,*) 'Read ',Para(3)
*         write(6,*) 'Read ',Para(4)
*         write(6,*) 'Read ',Para(5)
*         write(6,*) 'Read ',Para(6)
   10 read(kform,'(a)',end=20) NewL
      write(jhost,'(a)') NewL
      ifReWrite = ifReWrite + 1
      go to 10
   20 continue
      close(kform)
   15 LX = 19 * (iHB + 4)
      LX = 0.75 * kscrx
      ix1 = (kscrx - LX)/2
      ix2 = ix1 + LX
      if (kkprog.eq.1) then
          Inte = 'Define Sir97 input file name'
      else
          Inte = 'Define Expo input file name'
      endif
      Msg = ' '
      iCen = 1
      iPos = 2
      nFields = 4
      ifEditing = 1
    2 continue
      ier = 0
      nnBK = 4
      call GetLabN(ix1,iy1,ix2,Inte,Msg,iCen,iPos,nFields,
     *           nMaxChar, Linea, Para, ift, nnBK, iExitC)
      ifEditing = 0
      call xcmprp(Para(1),kk1)
      call xcmprp(Para(2),kk2)
      call xcmprp(Para(3),kk3)
      call xcmprp(Para(4),kk4)
      NewL = Para(2)(1:kk2) // char(0)
*     ier = chdir(NewL)
      call Sirchdir(NewL,ier)
*     write(*,*) ier,Newl
      if (ier.lt.0) then
          Inte = 'Illegal directory in: '//Para(2)
*         call manage_mouse_cursor(0)
          ier = 2222
          call screrr(ier,Inte,1)
*         call manage_mouse_cursor(1)
          go to 2
      end if
      if (kk3.eq.0.and.iExitC.ne.4) go to 999
      kk5 = Lung(Para(5))
      kk6 = Lung(Para(6))
      if (kk3.ne.0) then
          nome = Para(3)
          jsir = index(nome,'.')
          if (jsir.eq.0) then
             if (kkprog.eq.1) then
                 file1 = nome(1:kk3)//'.sir'
             else
                 file1 = nome(1:kk3)//'.exp'
             endif
             kk3 = kk3 + 4
          else
             file1=nome(1:kk3)
             k = jsir - 1
             nome = file1(1:k)
          endif
          if (kk4.eq.0) then
              Para(4) = nome
              kk4 = Lung(Para(4))
          endif
          file2 = Para(4)
          js = index(file2,'.')
          if (js.eq.0.and.kk4.gt.0) then
             file2 = Para(4)(1:kk4)//'.out'
          end if
          Para(3) = file1
          Para(4) = file2
      endif
      if (iExitC.eq.3) then      ! EDIT
          itype=2
          iform=1
          jop=jopen(kform,file1,nlen,itype,iform,ierr)
          if (jop.lt.0) then
              ier = 0
              call NewFile(file1,nome,ier)
              if (ier.lt.0) go to 2
          else
              close(kform)
          endif
          nome = file1
          IfChangeHMB = IfChangeHM
          IfChangeHM = 0
          ifBro = 1
          kBro = 7
          ifEditing = 1
          LivelB = Livel
          Livel = 1
          fname(1) = file1
          call Browser(iExBr)
          ifEditing = 0
          Livel = LivelB
          IfChangeHM = IfChangeHMB
*   dopo accept torna alla schermata precedente
*         if (iExBr .eq. 2) then
          goto 15
*         end if
      endif
      if (iExitC.eq.4) then      ! BROWSE
          call GetFileList(Para(2),Para(3),kk3,ier)
          if (ier .eq. 0) then
              js = index(Para(3),'.')
              Para(4) = Para(3)(1:js)//'out'
          end if
          go to 2
      endif
      
*     path = Para(1)(1:kk1)//'/'
      if (iExitC.ne.2) then
          Inte = SWRC
          itype=0
          iform=1
          jop=jopen(kform,Inte,nlen,itype,iform,ierr)
          write(kform,'(a)') Para(1)(1:kk1)
          write(kform,'(a)') Para(2)(1:kk2)
          write(kform,'(a)') Para(3)(1:Lung(Para(3)))
          write(kform,'(a)') Para(4)(1:Lung(Para(4)))
          write(kform,'(a)') Para(5)(1:kk5)
          write(kform,'(a)') Para(6)(1:kk6)
          write(kform,'(i3,2i5)') iPlotType,kscrx,kscry
*         write(6,*) 'Write ',Para(1)
*         write(6,*) 'Write ',Para(2)
*         write(6,*) 'Write ',Para(3)
*         write(6,*) 'Write ',Para(4)
*         write(6,*) 'Write ',Para(5)
*         write(6,*) 'Write ',Para(6)
          if (ifReWrite.gt.0) then
              rewind jhost
              do 300 i=1,ifReWrite
                 read(jhost,'(a)') NewL
                 write(kform,'(a)') NewL(1:Lung(NewL))
  300         continue
          endif
          close(jhost)
          close(kform)
      endif
      file1 = Para(3)(1:kk3)
      file2 = Para(4)(1:kk4)
  999 Livel = Livel - 1
      nPal = iPal(Livel)
      call Hide_Mouse_Cursor
c ---
      call ScreenSave(0, 0, kscrx, kscry, 0)
c ---
      call Display_Mouse_Cursor
      return
 9000 continue
      write(lo,9020) ier,nome(1:Lung(nome))
      ier=-1
      return
 9020 format(' *** error ***  open error #',i5,' on file ',a)
      end
c-----------------------------------------------------------------------
      subroutine winexit
      i = 0
c
      return
      end
c-----------------------------------------------------------------------
