c     generate complete hemisphere of reflexion data
      subroutine expand(numb2,mode,ier)
      character*200 Msg
      common /msgerr/ Msg

      character space*16
      dimension cfom(2250),ep(31000),i1(3),i2(3),kind(24),tab(15)
      dimension ipos(302),lh(60),lk(60),ll(60),ew(60),ed(60)
      common /Sir97_vs_Sir2004/ erre_to_stop
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common /xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),nzsav(500),occsav(500)
     *              ,dummpc(344000)
      common /atomo/ xyzo(5,500),nzo(500),bSav(1000)
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
cel
      common /neutro/ neutro,neuwei,vetint(500),nsyn
cel
      common /refl/ ih(100),g(2,100)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common / ureq1/ jpatt,jpunt(1501),ksacc,jseteq,jumpp,jmpsie,nsec 
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /kuse/ kuser1,kuser2,kuser3
      common /tape/ cell(6),neqv,icent,lat,natm,ts(3,24),is(2,3,24),nsym
     *             ,dumb(3)
      common /tran/ scale,mh(3),level,it4,xlim(3),kmap
      common /gggg/ scala_four
      common /misc/ t(3,3),dxmax(3),mcon,iwt,fom(11),pts,npseud
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/sf/al(4,8),bs(4,8),cl(8),nnw(8),nno(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common /restr/rescon(6),vres(6000),nres,wq,dmean,amean,nplane,mres
      common /WildRun1/ nWsymb,nWrand,kWstop,NoWild
      common /WildRun2/ nwild,nWDelay,kWDelay,iverbo,interv,errev(101)
      character *80 MessH,Messages(200)
      common /scmess/MessH,Messages
      common /phasinit/ cc(31000),wte1(31000),iphaze1(31000),percpick,
     *wte(31000),iphaze(31000),gSim(31000),jest,percest,fosogold
     *,vemin
*     common /newmap/ edri1(31000),edri2(31000),numb3   ! Dritan

      dimension vet(12),ivet(12)
      equivalence (vet(1),ivet(1))
      equivalence (iphaz(1),ep(1),cfom(1))
      equivalence (ih(1),lh(1)),(ih(61),lk(1)),(g(1,11),ll(1)),
     1  (g(1,41),ew(1)),(g(1,71),ed(1))
c
      mode1 = mode - 1
      nexp=0
      call inptf
      call ysfl07(nref,mm,idum1,npseud,idum3)
      if (jpatt.eq.0) then
          numb=mm
      else
          numb=nref
      endif
      if (mode.ne.1) numb=numb2
      if (numb.gt.31000) numb=31000
      if (jpatt.eq.0) call getref(ratio,mode,numb,ep)
c
c     temporary call to prepare common area
c     to manage atoms in special position
c
      call xspinb
      if (jpatt.eq.0) then
c
c     examine sets of phases in order of combined figure of merit unless
c     set is specified by the user
c
      if (mode.eq.1) then
          call srlin (16,lsn,lfw,llw,lpb,ll16)
          if (lfw.gt.0) then
              call ysfl16(cfom,ipos,nset)
            else
              write(Msg,140)
              ier = -1
              call screrr(ier,Msg,1)
              return
          endif
  140 format('No sets of phases available')
          if (numset.ge.1000) numset=nset-(numset-1000)
          if (numset.gt.0.and.numset.le.nset) goto 170
          if (numset.gt.0.and.numset.gt.nset) then
              write(Msg,150) numset,nset
              ier=-1
	        call screrr(ier,Msg,1)
              return
          endif
  150 format('Set ',i3,' has been required',
     *       ' but only ',i3,' sets are available')
          npos = 1
          do 160 j=1,nset
          if (cfom(j) .gt. cfom(npos)) npos = j
  160     continue
c     mark selected set
          cfom(npos) = cfom(npos)-100.0
          call ysup16(cfom,ipos,nset)
c   select set
  170     if (numset.gt.0) then
              no=numset
              nono=ipos(numset)
            else
              no=npos
              nono=ipos(npos)
          endif
          numset = no
          call snr16(nono,fom,ep,iphb)
      endif
  431 format(//,1h1, 78('+'),//,12x,
     1       '***   E-map interpretation  ***',//)
  432 format(//,1h , 78('+'),//,20x,
     1       '***   Fourier recycling section  ***',//, 9x,20a4)
  433 format(//,1h , 78('+'),//,19x,
     1       '***   Intermediate interpretation  ***',//)
  434 format(//,1h , 78('+'),//,20x,
     1 '***   Fourier recycling restarted  ***',//, 9x,
     3 '  In step B scale factor, atomic coordinates and isotropic',
     * /,13x,' thermal factors are refined via diagonal matrix.',
     4 //,23x,'Step      cycle       residual',/)
  435 format(//,1h , 78('+'),//,19x,
     1       '***   Final interpretation  ***',//,
     2       //, 1h ,20a4,//)
  436 format(/,10x,i5,' (',i3,'% of total ) reflections used with Fo > '
     4   ,f8.2,//,23x,'Step      cycle       residual',/)
  437 format(/,10x,i5,' (',i3,'% of total ) reflections used with Fo > '
     4   ,f4.2,' * sigma(Fo)',//,23x,'Step      cycle       residual',/)
  439 format(/,10x,i5,' (',i3,'% of total ) reflections used with Fo > '
     4   ,f8.2,//,23x,'Step      cycle       residual',/)
  737 format(2x,'I',i7,' (',i3,'% of total ) reflections used with Fo >'
     4   ,f5.2,' * sigma(Fo)',6x,'I',/,2x,'I',2x,
     3'In step B scale factor, atomic coordinates and isotropic',16x,
     *'I',/,2x,'I',2x,'thermal factors are refined via diagonal matrix.'
     *,24x,'I',/,2x,'+',74('-'),'+')
  738 format(2x,'I',i7,' (',i3,'% of total ) reflections used with Fo >'
     4   ,f12.2,11x,'I',/,2x,'I',2x,
     3'In step B scale factor, atomic coordinates and isotropic',16x,
     *'I',/,2x,'I',2x,'thermal factors are refined via diagonal matrix.'
     *,24x,'I',/,2x,'+',74('-'),'+')
c
      if (mode.ne.1)then
          if (mode.eq.2) then
              if (iverbo.ne.0)write(lo,432) itle
              perc=100.0*float(numb)/float(nref)
              iperc=nint(perc)
              if (iverbo.eq.0) then
                  if (nwild.le.0) then
                      if (ratio.lt.0.0) then
                          if (jest.eq.0) write(lo,738) numb,iperc,fosog
                      else
                          if (jest.eq.0) write(lo,737) numb,iperc,ratio
                      endif
                  endif
              else
                  if (ratio.lt.0.0) then
                      if (jest.eq.0) write(lo,439) numb,iperc,fosog
                  else
                      if (jest.eq.0) write(lo,437) numb,iperc,ratio
                  endif
              endif
          endif
          idisp=1
          call sfl15(natsn,idisp,interp)
          if (krecy.eq.1.and.iverbo.ne.0) write(lo,434) 
          if (krecy.gt.0) then
              nemap(1)=nats
              jlig=1
              if (nno(1).eq.1.and.neutro.eq.0) jlig=2
              jlig=jlig*100+1
              do 438 i=1,nats
              if (nz(i).ne.0.and.jrest.eq.0) nz(i)=jlig
  438         continue
          endif
          call pkl15(nats)
          if (krecy.eq.0) then
              call sftra(mode,numb,ep,ifBreak)
          else
              call sftrb(mode,numb,ep,ifBreak)
              krecy=krecy+1
          endif
          rfac=erre*100.0
          if ((mode-1+jest).eq.jrecyc.or.ifBreak.eq.1) then
*         write(lo,*) ' jrecyc prima di uscire da expand=',jrecyc
*    *    ,' mode-1+jest prima di uscire da expand=',mode-1+jest
              if (iverbo.ne.0) write(lo,435) itle
	        if (ifBreak.eq.1) then
	            ier = 9
                    call cp3015
                    call sfl15(nats,idisp,interp)
                    errem = erre
	        else
****                call frm31
                    if (kmap.eq.1) call CopyMap
	            ier = 1
	        endif
              return
          endif
          deltar=erreo-erre
          if (krecy.le.0) then
              deltar=1.0000
          endif
          if (krecy.le.0) then
              if (jest.eq.5) deltar= 0.0015
              if (deltar.lt.0.0025) then
                  if (jest.le.4) return
                  ksacc=mode-1+jest
                  if (iverbo.ne.0) write(lo,433)
                  if (deltar.lt.0.0) then
                      erreo = erre
                  endif
                  krecy=1
                  ier=1
                  return
              endif
          else
              if (deltar.lt.0.0) then
                  if (krecy.gt.3) then
                      if (iprin.gt.2) 
     *                write(lo,*) ' r-fac stop %',krecy
                      if (iverbo.ne.0) write(lo,435) itle
                      call cp3015
                      call sfl15(nats,idisp,interp)
                      ier=1
                      return
                 endif
             endif
      endif
      erreo=erre
      call cp1530 
      if (kmap.eq.1) call CopyMap
      endif
      do 185 i=1,numb
      wt(i)   = ep(i)
      e(i)    = e(i)*ep(i)
      iphaz(i)= iphb(i)
  185 continue
c
c-- richiamo subr. gestione psi-e
      if (mode.eq.1.and.jmpsie.eq.0) then
          call gpsie(numb,error,dalfa)
      endif
      if (mode.eq.1) numb2=numb
c
      endif 
      if (numb.eq.0) then
         write(lo,196)
         ier=-1
         return
      endif
  196 format(/,' *** error *** no reflections supplied')
      if (mode.eq.1) then
c-- psi-e informations
          if (iverbo.ne.0) then
              if (nexp.ne.0) then
                  if (knw.eq.0) then
                      write(lo,4500) nexp
                    else
                      write(lo,4510) error,dalfa,nexp
                  endif
                else 
                  write(lo,281)
              endif
          endif
      endif
 4500 format(/,19x,' number of added psi-e reflections  ',i6,/)
 4510 format(/,19x,'                  mean phase error  ',f9.2,/
     *         19x,'         weighted mean phase error  ',f9.2,/,
     *         19x,' number of added psi-e reflections  ',i6,/)
c                                                  ! Dritan
*     if (jpatt.eq.0) then                         ! Dritan
*                       numb3=numb                 ! Dritan
*                       do 199 i=1,numb            ! Dritan
*                       phase=dtor*float(iphaz(i)) ! Dritan
*                       ep(i)=e(i)*sin(phase)      ! Dritan
*                       e(i)=e(i)*cos(phase)       ! Dritan
*                       edri1(i)=ep(i)             ! Dritan
*                       edri2(i)=e(i)              ! Dritan
* 199                   continue                   ! Dritan
*                     endif                        ! Dritan
c                                                  ! Dritan
      if (jpatt.eq.0) then
                        do 199 i=1,numb
                        phase=dtor*float(iphaz(i))
                        ep(i)=e(i)*sin(phase)
                        e(i)=e(i)*cos(phase)
  199                   continue
                      endif
c
c     set default values of program parameters unless specified by user
c
c
c     calculate number of grid points for fourier map
c
  248 continue
      do 280 i=1,3
         np(i)=cell(i)/factr+0.5
         if (np(i).le.2*mh(i)) np(i)=2*mh(i)+1    ! Dritan
         if(i.eq.3) np(i)=np(i)+mod(np(i),2)
  250    ntest=np(i)
         do 270 j=2,5
  260       if(ntest.ne.(ntest/j)*j) go to 270
            ntest=ntest/j
            if(ntest.eq.1) go to 280
            go to 260
  270    continue
         np(i)=np(i)+1
         if(i.eq.3) np(i)=np(i)+1
         go to 250
  280 continue
      if (np(1).le.150) go to 282
      factr=factr+0.02
      go to 248
  282 if (mode.ne.1) go to 315
      if (iverbo.eq.0.and.nwild.gt.0) go to 315
      write(space,'(16a1)') (nt(i),i=1,16)
      call ucase(space(1:1))
      write(lo,900)
      write(lo,910) space
      write(lo,920) 
      write(lo,930) cell
      write(lo,920) 
      write(lo,940) np
      write(lo,920) 
      write(lo,950) mh
      write(lo,920) 
  900 format( 2x,'+',74('-'),'+')
  910 format( 2x,'I','  Space group symbol',26x,a16,12x,'I')
  920 format( 2x,'I',74x,'I')
  930 format( 2x,'I','  Unit cell parameters                      ',
     *                 3f8.3,'      I',/,
     *        2x,'I','                                            ',
     *                 3f8.3,'      I')
  940 format( 2x,'I','  Number of grid points along X, Y, Z        ',
     *                 i7,2i8,6x,'I')
  950 format( 2x,'I','  Maximum h, k, l value                      ',
     *                 i7,2i8,6x,'I')
  960 format( 2x,'I','  Number of independent reflections input',
     *                 13x,i6,14x,'I')
  970 format( 2x,'I','  Number of reflections in one hemisphere',
     *                 13x,i6,14x,'I')
  980 format( 2x,'I','  Grid spacing (in angstrom) approximately   ',
     *                  9x,f6.3,14x,'I')
  990 format( 2x,'I','  Scale                                      ',
     *                  9x,f6.3,14x,'I')
  281 format(///)
  315 if (np(1) .le. 150) go to 400
      write(lo,320)
  320 format (/,22x,'nx greater than 150. increase array inut in subro
     1utine outpuf of fft modul',/,
     2            22x,'or increase the grid value')
      ier=-1
      return
  400 continue
      if (iverbo.eq.1.or.nwild.le.0) then
          if (mode.eq.1) then
              write(lo,960) numb
              write(lo,920) 
          endif
      endif
      rewind jrel
c
c     generate one complete hemisphere of reflexions
c
      do 470 i=1,15
         tab(i)=sin(float(30*i)*dtor)
  470 continue
      nex = 0
      fsum=0.0
      ip5=256*(262144+512+1)
      nbatch=0
      if (jpatt.ne.0) then
          if (npseud.eq.0) then
              jind=4
          else
              jind=6
          endif
          if (jpatt.eq.2) jind=5
      endif
      if (krecy.eq.2) then
          write(lo,*) 'CREA IL FILE DEI RIFLESSI'
          write(77,*) numb
      endif
      do 800 jn=1,numb
      if (jpatt.eq.0) then
          i1(1)=ihkl(jn)/262144
          j=ihkl(jn)-262144*i1(1)
          i1(2)=j/512-256
          i1(3)=j-512*(i1(2)+256)-256
          if (krecy.eq.2) then
              write(77,*) i1,ep(jn),e(jn)
          endif
          eep=ep(jn)
          ee =e (jn)
      else
          eep=0.0
          call snr07(vet)
          i1(1)=ivet(1)
          i1(2)=ivet(2)
          i1(3)=ivet(3)
          if (jpatt.eq.3) then
              ee=vet(jind)*vet(jind+1)
          else
              ee=vet(jind)*vet(jind)
          endif
      endif
      do 700 j=1,neqv
         do 540 i=1,3
            i2(i)=0
  540    continue
         do 560 i=1,3
            do 550 k=1,2
               m=iabs(is(k,i,j))
               if(m.ne.0) i2(m)=i2(m)+i1(i)*isign(1,is(k,i,j))
  550       continue
  560    continue
         b1=1.0
         js=1
         if (i2(3)) 590,570,600
  570    if (i2(1)) 590,580,600
  580    if (i2(2)) 590,600,600
  590    b1=-1.0
         js=-1
  600    kind(j)=ip5+js*(262144*i2(1)+512*i2(2)+i2(3))
         do 610 i=1,3
            if (iabs(i2(i)).ge.np(i)/2) go to 700
            if (i2(i).gt.mh(i)) mh(i)=i2(i)
  610    continue
         if (j.eq.1) go to 630
         nd=j-1
         do 620 i=1,nd
            if(kind(j).eq.kind(i)) go to 700
  620    continue
  630    nbatch=nbatch+1
         nex=nex+1
         nu=0
         do 640 i=1,3
            nu=nu-i1(i)*int(ts(i,j)*12.0+0.1)
  640    continue
         nu=mod(nu,12)
         if (nu.le.0) nu=nu+12
         xc=tab(nu+3)
         xs=tab(nu)
         gr=xc*ee-xs*eep
         gi=(xs*ee+xc*eep)*b1
         fsum=fsum+sqrt(gr*gr+gi*gi)
         g(1,nbatch)=gr
         g(2,nbatch)=gi
         ih(nbatch)=kind(j)
         if (nbatch.lt.100) go to 700
         write(jrel) ih,g
c
c-- manage BREAK button
c
         if (mode1.ge.1) then
             ifBreak = ifBreakFun()
             if (ifBreak.eq.1) then
                 ier = 9
                 return
             endif
         endif
         nbatch=0
  700 continue
  800 continue
      if (nbatch.ne.0) write(jrel) ih,g
      scale=3000.0/fsum
      if (iverbo.eq.1.or.nwild.le.0) then
          if (mode.eq.1) then
              write(lo,970) nex
              write(lo,920) 
              write(lo,980) factr
              write(lo,920) 
              write(lo,990) scale
              write(lo,900)
          endif
      endif
      if(mode.eq.1.and.iverbo.ne.0) write(lo,431)
      if (it4 .gt. 0) write(lo,410) xlim,level
  410 format (///13x,43hfourier map to be printed from x =  0.0  to,
     1  f7.3, 15h,  y =  0.0  to, f7.3, 15h,  z =  0.0  to, f7.3,//,
     1 40x,33hpoints underlined if greater than,i5)
      return
      end
c--------------------------------------------------------------------------
      subroutine getref(ratio,mode,numb,ep)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000)
     *              ,dummpc(345000)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common /misc/ t(3,3),dxmax(3),mcon,iwt,fom(11),ptsss,npseud
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /crisTest/ ktest
      common /phasinit/ ee(31000),wte1(31000),iphaze1(31000),percpick,
     *wte(31000),iphaze(31000),gSim(31000),jest,percest,fosogold
     *,vemin
      dimension ep(31000)
      common /macrom/ ipub(31000),evet(31000)
      dimension vet(12),ivet(12)
      equivalence(vet(1),ivet(1))
c
c-- if pseudo exists the file  normalized e's are used
c-- ( not the renormalized e's used for invariants )
c
*     if (mode.eq.1) read(11,*) numb

*     tsigma=4.0
      scf=sqrt(sc)
      if (ksigma.gt.0.and.tsigma.gt.0.0) then
          ratio=tsigma
      else
          ratio=-1.0
          if (mode.le.2) then
              if (fomin.gt.0.0) fosog=fomin
          endif
          fsog= fosog
      endif
      if (npseud.eq.0) then
          jps=4
      else
          jps=6
      endif
      icont=0
      acont=0
      do 100 i=1,numb
      call snr07(vet)
      if (mode.eq.1) then
          icont=icont+1
          e(icont)=vet(jps)
          ee(icont)=vet(jps)
          ihkl(icont) = 262144*ivet(1) +512*ivet(2) 
     *                +ivet(3) +131328
      else
          fo=vet(5)
          iuse=0
          if (ratio.gt.0.0) then
              sigma=vet(9)
              a=ratio*sigma
              if (fo.gt.a) iuse=1
          else
              if (ktest.gt.0) then
                  if (vet(jps).gt.0.0) iuse=1
              else
                  if (fo.gt.fsog) iuse=1
              endif
          endif
          if (iuse.eq.1) then
              icont=icont+1
              if (icont.gt.31000) go to 110
              rho=rhof(p,ivet(1),ivet(2),ivet(3))
              rho=rho*rho
              e(icont)=fo*scf
              wt(icont)=rho
              ep(icont)=vet(jps)
              ihkl(icont) = 262144*ivet(1) +512*ivet(2) 
     *                    +        ivet(3) +131328
              iph=mod(ivet(8),2**15)
              iph=iph/32
              ipub(icont)=iph
              ee(icont)=vet(jps)
          endif
      endif
  100 continue
  110 continue
      numb=icont
c
      return
      end
c--------------------------------------------------------------------------
      subroutine sftra(mode,numb,ep,ifBreak)
c     structure factor and phases for fourier refinement 
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
cel
      common /neutro/ neutro,neuwei,vetint(500),nsyn
cel
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common /elettroni/ lproj, zeff(8), rminimo, kminimo, kaminimo
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/xbuil/ift1,ift2,ift3,nfl,npeahi,ngrup,nfrag,ngh,ngl
     1,dmax,dmin,g(18),dmn(9),dmx(9),dmnmx(9,9,2),angi(3),angs(3)
     2,l3dum,md,lclus,mclus,laddr,ldis,mddis,lang,lnegl,mnegl,nnegl
     3,ladcon,lcon,mcon,ncon,mdcon,ladinc,linc,minc,mdinc
     4,ive(9),ive3i(9),ive3s(9),ive15i(9),ive15s(9)
     5,icopk(9),icoel(9),icogr(500)
      common/xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),nzsav(500),occsav(500),
     *               fvar(500),q(500),qq(500),dummy(2500)
     *              ,dummpc(340000)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /WildRun2/ nwild,nWDelay,kWDelay,iverbo,interv,errev(101)
      common /parfin/ LimF(5,4), iPal(5), Livel, nPulsTot(5), iFull(5),
     *                iHConv, iwLMenu, iVP(5,4), Lhh(5), Lhs(5)
      common /puls/Lim(190,4),iAct(190),iDepr(190),iRep(190),iFocus(190)
     *              ,ipu(190),iHB,iDeep,nFocus(5)
      common /screen/ kscreen,jy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /piero/ BTot(3,3)
c
       common /phasinit/ ee(31000),wte1(31000),iphaze1(31000),percpick,
CRIST*jproa,wte(31000),iphaze(31000),gSim(31000),jest,percest,fosogold
     *wte(31000),iphaze(31000),gSim(31000),jest,percest,fosogold
     *,vemin
      dimension ep(31000)
      dimension on(8)
c
      BTot(1,1) = 101.0
      do 10 i=1,nk
         if (neutro.eq.0) then
             on(i) = no(i)
         else
             on(i) = zeff(i)
         endif
   10 continue
      jlig=1
      if (no(1).eq.1.and.neutro.eq.0) jlig=2
      anatm=0.0
      do 12 i=jlig,nk
   12 anatm=anatm+float(nw(i))
      anat=anatm
      kfrag=nemap(4)
c
c-- compute the number of peaks to consider
c
      totop=(icent+1)*nsym*pts
      delta=1.0/12.0
      sum=0.0
      enne=0.0
      jnats=0
      do 99 i=1,nats
         nzsav(i)=nz(i)
         occsav(i)=x(5,i)
         if (nz(i).eq.0) then
             jnats=jnats+1
         else
             occ=x(5,i)
             sum=sum+occ*totop
             if ((sum-anat).lt.delta) enne=enne+1.0
         endif
  99  continue
      bnats=float(nats-jnats)
      nenne=nint(enne)
      jnats=0
      j=nats
      do 991 i=1,nats
         if (nz(i).eq.0) go to 991
         if (jnats.ge.nenne) go to 991
         j=i
         jnats=jnats+1
  991 continue
      jnats=j
      denom=x(4,jnats)
      ii=0
      do 111 i=1,nats
         fvar(i)=1.0
         if (nz(i).eq.0) go to 111
         ii=ii+1
         b667=bnats-ii+1
         a667=b667/bnats
         a667=0.8*sqrt(a667)
         if (i.le.jnats) then
             if (nz(i).lt.0) fvar(i)=a667
         else
             fvar(i)=0.667*x(4,i)/denom
             if (nz(i).lt.0) fvar(i)=fvar(i)*a667
         endif
  111 continue
      c=x(4,1) 
      jfirst=iabs(nz(   1)/100)
      jnats=nats+1
  115 jnats=jnats-1
      jlast =iabs(nz(jnats)/100)
      if (jlast.eq.0) go to 115
      sog = on(jlast) / on(jfirst)
      sog = sog * 0.667
      iflag=0
      do 102 i=1,nats
      if (nz(i).eq.0) go to 102
      if (iflag.eq.0) then
          qq(i)=x(4,i)/c
          if (qq(i).lt.sog) then
              rife=x(4,i)
              iflag=1
              qq(i)=sog
          endif
      else
          qq(i)=sqrt(x(4,i)/rife)*sog
      endif
      nz(i)=iabs(nz(i)/100)
      if (kfrag.ne.0.and.mode.eq.2) go to 102
      q(i)=fvar(i)
      x(5,i)=x(5,i)*qq(i)*q(i)
      if (nz(i).gt.0) nz(i)=nk
Corig sogz=x(5,i)*no(nk)

      sogz=qq(i)*q(i)*no(nk)

      if (sogz.lt.1.0.and.neutro.eq.0) then
          nz(i)=0
          if (iprin.gt.2) write(lo,101) 
     *        i,occsav(i),x(4,i),q(i),qq(i),sog,sogz
                       endif
  101 format(' atom ',i3,' rejected',6f10.5)
  102 continue
      call pkl15(nats)
      nlsm=1
      iref=0
      call sftryyy(iref,mode,nlsm,numb,ep,scalan,ifBreak)
	if (ifBreak.eq.1) then
	    return
	endif
      do 300 i=1,nats
      if (nz(i).ne.0) nz(i)=nzsav(i)
      x(5,i)=occsav(i)
  300 continue    
c
c-- creates Labels and writes List 15
c
      iniz = 1
      ifin = nats
      call MakeLab(iniz,ifin)
      interp = 1
      call frm15(nats,interp)
c
c-- manage BREAK button
c
      mode1=mode-1
      if (mode1.eq.1.and.kscreen.ne.0) then
          L1 = 0
          L2 = iVP(Livel, 2)
          L3 = iVP(Livel, 1)
          L4 = iVP(Livel, 4)
          ic0 = 0
          call Rettangolo (L1, L2, L3, L4 - iHConv, ic0, ic0)
	    call manage_mouse_cursor(0)
	endif
      if (mode1.ge.1.and.kscreen.ne.0) then
          nb = 1          
          Lim(nb, 1) = 5
          Lim(nb, 2) = iVP(Livel, 4) - 1.5 * iHB
          Lim(nb, 3) = iwLMenu - 5
          Lim(nb, 4) = Lim(nb, 2) + iHB
          iDepr(nb) = 1
          iRep(nb) = 0
          iAct(nb) = 1
          iFocus(nb) = 1
          ipu(nb) = nb
          iBord = 1
          call Tasto (nb, iBord, 'Break')
          L1 = Lim(nb,1)
	    L2 = Lim(nb,2)
	    L3 = Lim(nb,3)
	    L4 = Lim(nb,4)
	endif
c
c-- plot
c
      mode1=mode-1+jest
      maxcyc = mode1
      errev(101) = mode1
      call scrf(numset,mode1,1,2)
      call to_coord(1)
c
      return
      end
c---------------------------------------------------------------------
      subroutine sftrb(mode,numb,ep,ifBreak)
c     structure factor and phases for fourier refinement 
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
cel
      common /neutro/ neutro,neuwei,vetint(500),nsyn
cel
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/xbuil/ift1,ift2,ift3,nfl,npeahi,ngrup,nfrag,ngh,ngl
     1,dmax,dmin,g(18),dmn(9),dmx(9),dmnmx(9,9,2),angi(3),angs(3)
     2,l3dum,md,lclus,mclus,laddr,ldis,mddis,lang,lnegl,mnegl,nnegl
     3,ladcon,lcon,mcon,ncon,mdcon,ladinc,linc,minc,mdinc
     4,ive(9),ive3i(9),ive3s(9),ive15i(9),ive15s(9)
     5,icopk(9),icoel(9),icogr(500)
      common/xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *             ,wt(31000),nzsav(500),occsav(500),
     *              fvar(500),q(500),qq(500),dummy(2500)
     *              ,dummpc(340000)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /WildRun2/ nwild,nWDelay,kWDelay,iverbo,interv,errev(101)
      common /piero/ BTot(3,3)
       common /phasinit/ ee(31000),wte1(31000),iphaze1(31000),percpick,
     *wte(31000),iphaze(31000),gSim(31000),jest,percest,fosogold
     *,vemin
      integer izpk(500)
      dimension vet(8),ivet(8)
      dimension ep(31000)
      equivalence(vet,ivet)
c
      BTot(1,1) = 101.0
      coef=1.35
      coefr=1.0/3.0
      call ysfl07(nrifl,nstr,mmmz,npseud,iy)
c
      delta=1.0/12.0
c-- compute the numer of peaks to consider
      totop=(icent+1)*nsym*pts
      jlig=1
      if (no(1).eq.1.and.neutro.eq.0) jlig=2
      anat=0.0
      do 12 i=jlig,nk
   12 anat=anat+float(nw(i))
c
c-- azzero il vettore contenente un flag (0=atomo escluso,1=preso)
c
      sum=0.0
      nne=0.0
      do 99 i=1,nats
         if (krecy.ge.1) nz(i)=jlig*100+1
         if (nz(i).eq.0) go to 99
         if (sum.le.anat) then
             occ=x(5,i)
             sum=sum+occ*totop
             if ((sum-anat).lt.delta) nne=nne+1
         endif
   99 continue
      jnats=0
      j=nats
      do 991 i=1,nats
         if (nz(i).eq.0) go to 991
         if (jnats.ge.nne) go to 991
         j=i
         jnats=jnats+1
  991 continue
      nne=j
      call label(nne)
      call muovi
      if (krecy.ne.1) call assbty
      hei=x(4,nne)
      kzo=iabs(nz(nne)/100)
      sum=1.0
      do 97 i=1,nne-1
         if (sum.gt.2.5) go to 992
         j=nne-i
         kz=iabs(nz(j)/100)
         if (kz.eq.kzo) then
             hei=hei+x(4,j)
             sum=sum+1.0
         endif
   97 continue
  992 continue
      hei=sum/hei
c
      do 98 i=1,nats
          nzsav(i)=nz(i)
          occsav(i)=x(5,i)
          if (nz(i).eq.0) go to 98
          xleg=1.000
          if (i.le.nne) then
              ww=1.00
              wws=1.00
          else
              ww=x(4,i)*hei*erre**coefr
              wws=ww*xleg
              if (wws.le.0.3.and.neutro.eq.0) then
                  ww=0.0
                  nz(i)=0
              endif
          endif
          x(5,i)=x(5,i)*xleg*ww
          nz(i)=iabs(nz(i)/100)
          if (iprin.gt.1) then
              if(nz(i).gt.0) then
                 write(lo,9999) i,nalf(nz(i)),(x(j,i),j=1,4),xleg,hei,
     *                          erre*100.0,coefr,ww,occsav(i),
     *                          x(5,i),wws
              else
                 write(lo,9998) i,(x(j,i),j=1,4),xleg,hei,erre*100.0,
     *                          coefr,ww,occsav(i),x(5,i),wws
              endif
          endif
   98 continue
 9999 format(i4,1h),2x,a2,2x,3f8.4,f8.1,4f10.3,f10.8,f6.2,f8.4,3f8.4)
 9998 format(i4,1h),6x,3f8.4,f8.1,4f10.3,f10.8,f6.2,f8.4,3f8.4)
c
      call pkl15(nats)
      nlsm=7
      iref=3
      call sftryyy(iref,mode,nlsm,numb,ep,scalan,ifBreak)
      if (ifBreak.eq.1) then
          return
      endif
      do 300 i=1,nats
         kfrag=mod(nzsav(i),100)
         if (nzsav(i).gt.0) then
             isg=1
         else
             isg=-1
         endif
         if (nz(i).ne.0) nz(i)=isg*(nz(i)*100+kfrag)
         x(5,i)=occsav(i)
  300 continue    
c--- bisogna riassemblare la molecola.
      kact=5
      call maincl(izpk,kact,iprin)
c
c-- creates Labels and writes List 15
c
      iniz = 1
      ifin = nats
      call MakeLab(iniz,ifin)
      interp = 1
      call frm15(nats,interp)
c
c-- plot
c
      mode1=mode-1+jest
      maxcyc=mode1
      errev(101) = mode1
c
      call scrf(numset,mode1,2,2)
      call to_coord(1)
c
      return
      end
c---------------------------------------------------------------------
      subroutine label(nne)
c
c-- subroutine to re-label peaks according only to
c-- the relative peak height and to the cell content
c-- if jall = 0 only heavy atoms (z=>11) are labelled
c-- if jall = 1 all atoms are labelled
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /atoms/ x(5,500),nz(500),idumx(21)
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
cel
      common /neutro/ neutro,neuwei,vetint(500),nsyn
      common /elettroni/ lproj, zeff(8), rminimo, kminimo, kaminimo
cel
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),izpk(500)
     *              ,dummpc(344500)
c-- nw(i) = number of atoms of the i-th specie
c-- no(i) = Z of atom of the i-th specie
c-- nkl   = number of non-hydrogen species
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
c
      dimension number(8),anumber(8)
C
      rap1s=0.6
      rap2s=1.4
      if (erre.lt.0.2) then
          rap1s=0.4
          rap2s=10000
      endif
      do 100 i=1,nne 
         if (nz(i).eq.0) then
             izpk(i)=0
         else
             izpki=iabs(nz(i))/100
             izpk(i)=nk-izpki+1
         endif
  100 continue
      jall=1
      t2=(icent+1)*nsym*pts
      jlig=0
      if (no(1).eq.1.and.neutro.eq.0) jlig=1
c--NEW
      nkl=nk-jlig
c--NEW
      j=nk+1
      do 1000 i=1,nk
         j=j-1
         number(i)=nw(j)
         kz=no(j)
         if (kz.gt.1) then
             anumber(i)=kz
         else
             if (neutro.eq.0) then
                 anumber(i)=0
             else
                 anumber(i)=zeff(j)
             endif
         endif
 1000 continue
c
      k=1
      heig1=x(4,1)
      z1  = anumber(1)
c
      do 1100 i=1,nne 
         if (izpk(i).eq.0) go to 1100
         do 1090 j=1,nkl
            if (number(j).eq.0) go to 1090
            k=j
            lasth=i-1
            numb=nint(x(5,i)*t2)
 1120       number(k)=number(k)-numb
            akz = anumber(k)
            heign = x(4,i)
            zn  = anumber(k)
            if (number(k).ge.0) then
               rap  = heig1 * zn / z1
               rap1 = rap * rap1s
               rap2 = rap * rap2s
               if ((heign.gt.rap1.and.heign.lt.rap2)
     *                              .or.akz.lt.0.01) then
                   izpk(i)=k
                   if (number(k).eq.0) k=k+1
                   go to 1100
               else
                   number(k)=number(k)+numb
               endif
            else
               number(k)=number(k)+numb
               k=k+1
               if (k.le.nkl) then
                   go to 1120
               else
                   go to 1400
               endif
            endif
 1090    continue
 1100 continue
      go to 1900
 1400 continue
 1900 continue
      do 2000 i=1,nne 
         if (izpk(i).eq.0) go to 2000
         if (nz(i).gt.0) then
             isg=1
         else
             isg=-1
         endif
         izpki=izpk(i)
         izpki=nk-izpki+1
         kfrag=mod(nz(i),100)
         nz(i)=isg*(izpki*100+kfrag)
 2000 continue
      return
      end
c---------------------------------------------------------------------
      subroutine pkl15(nats)
c
c-- deletes ghost peaks from atom list
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
c
      j=0
      do 200 i=1,nats
      if (nz(i).ne.0) j=j+1
  200 continue
      if (j.eq.0) return
      k=nemap(1)-j
      nemap(1)=j
      if (k.gt.0.and.iprin.gt.1) write(lo,*) k,' ghost(s) rejected'
      return
      end
c---------------------------------------------------------------------
      subroutine stopr(izpk,mode)
c
c-- terminates the recycling procedure
c
      common /Sir97_vs_Sir2004/ erre_to_stop
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
      common /atomo/ xyzo(5,500),nzo(500),bSav(1000)
      common/sf/al(4,8),bs(4,8),cl(8),nnw(8),nno(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /WildRun1/ nWsymb,nWrand,kWstop,NoWild
      common /WildRun2/ nwild,nWDelay,kWDelay,iverbo,interv,errev(101)
      common /neutro/ neutro,neuwei,vetint(500),nsyn
      common /elettroni/ lproj, zeff(8), rminimo, kminimo, kaminimo
      common /screen/ kscreen,jy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common/cris/numcri,jcran,maxtri,nstart,muset,nfixed,inumber,ifirst
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common/ylimi/nfl,lfl,nlx,idummy(4)
c
      common /data/ astore(30000)
      common /xdata/ store(500000)
      dimension istore(500000)
      equivalence(store,istore)
c--26 variables to store in the preable block of list 6
      common/xrefi/rr(7),rw(7),ss(7),shesd(2),difro(3)
      dimension izpk(500)
      character *80 Buff
c
c-- manage BREAK button
c
*     if (kscreen.ne.0) call manage_mouse_cursor(0)
c
c-- Wild procedure
c
      rfac = erreo*100
      if (neutro.ne.2) then
          rfacSog = 25.0
      else
          rfacSog =  1.0
      endif
      rfacSog = erre_to_stop
Cinib go to 1
      if (NoWild.eq.1) go to 1
      if (jrest.eq.0) then
          if (nwild.eq.0) nwild=1
          if (rfac.gt.rfacSog) then
              if (nwild.ge.0) then
                  ncnt = nset
                  if (inumber.ne.0) ncnt = nset + 1
                  if (nwild.lt.ncnt  ) then
                      nwild = nwild + 1
                      call wild2(rfac,kgo)
                      if (kgo.eq.1) return
                    else
                      if (neutro.ne.2) then
                          kfour=1
                          call wild1(kfour,kgo)
                          if (kgo.eq.1) return
                      else
                          iPdire=ipdir
                          call svcard(nAddComm,ier)
                          if (ier.lt.0) return
                          call upcard(nAddComm,'%fourier      ',14,ier)
                          if (ier.lt.0) return
                          write(Buff,'(7hset    ,i5)') iabs(kminimo)
                          call upcard(nAddComm,Buff         ,80,ier)
                          if (kminimo.lt.0) then
                              write(Buff,'(7hrecycle,i5)') kaminimo
                              call upcard(nAddComm,Buff         ,80,ier)
                              if (ier.lt.0) return
                          endif
                          call rscard(nAddComm,iPdire)
                          if (ier.lt.0) return
                          kgo = 1
                          return
                      endif
                  endif
              endif
          endif
      endif
    1 continue
c
c-----------------
c
      write(lo,435) itle
  435 format(//,1h , 78('+'),//,19x,
     1       '***   Final interpretation  ***',//,
     2       //, 9x,20a4,//)

      idisp=1
      call sfl15(nats,idisp,interp)
      iprsav=iprin
      if (iprin.eq.0) iprin=2
      do 100 i=1,nats
         nz(i) = iabs( nz(i) )
         nzo(i)=nz(i)
         do 100 j=1,4
            xyzo(j,i)=x(j,i)
  100 continue
      natsav=nats
      k=0
      do 200 i=nats,1,-1
         if (nz(i).ne.0) then
             k=i
             rife=x(4,i)
             go to 210
         endif
  200 continue
  210 continue
      rife=0.5*rife
      if (k.ne.0) then
          iniz=k+1
          do 300 i=iniz,nats
             if (x(4,i).gt.rife) k=k+1
  300     continue
          nats=k
      endif
      kaction=4
      call maincl(izpk,kaction,iprin)
      do 500 i=1,nats
         izpki=izpk(i)
         if (izpki.gt.0) then
             isg= 1
         else
             isg=-1
             izpki=-izpki
         endif
         kfrag=mod(izpki,100)
         if (kfrag.eq.99) kfrag=0
         if (nzo(i).ne.0) then
             nzz=nzo(i)/100
             nzz=nk-nzz+1
             izpk(i)=nzz*100+kfrag
             izpk(i)=isg*izpk(i)
         endif
  500 continue
      if (natsav.gt.nats) then
          do 510 i=nats+1,natsav
             nz(i)=0
             izpk(i)=-1
  510     continue
      endif
      nats=natsav
      krecy=2000
      kact=4
      call outpea(izpk,kact)
c
c-- prepare atom list for future use
c
      do 600 i=1,nats
         if (nzo(i).eq.0) nz(i)=0
  600 continue
      errem=erre
      interp=1
      call frm15(nats,interp)
      mode=0
      iprin=iprsav
c
c-- save in list 6 the last R value
c-- check if a list 6 exists
c
      call srlin(6,li,lj,lk,ll,lm)
      if (lj.gt.0) then
         call xfl06
         l6a=l6d
c--rewrite the preamble block
         ind=1
         call ydwnf(ld6p,ind,n6p)
         do 610 i=1,n6p
            store(nfl+i-1)=astore(i)
  610    continue
c        store(nfl+26)=rr(1)
         store(nfl+26)= errem*100.
         do 620 i=1,n6p
            astore(i)=store(nfl+i-1)
  620    continue
         call yupf(ld6p,ind,n6p)
         call xdump
      end if
      return
      end
c--------------------------------------------------------------------------
      subroutine sftryyy(iref,mode,nlsm,numb,ep,scalan,ifBreak)
c----
c     structure factor least squares
c
c     iref = 0 only structure factor computation
c     iref = 1 only B has to be refined
c     iref = 2 only X's have to be refined
c     iref = 3 B and X's have to be refined

      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
cel
      common /neutro/ neutro,neuwei,vetint(500),nsyn
      common /elettroni/ lproj, zeff(8), rminimo, kminimo, kaminimo
cel
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *      ,wt(31000),nzsav(500),occsav(500),hkle(4,24)
     *      ,deltaf(4,500),qvet(4,500),kcond(4,500),newvet(48,3)
     *      ,apd(4,500),bpd(4,500)
     *      ,dummpc(183760),dummbig(150000)
       common /phasinit/ ee(31000),wte1(31000),iphaze1(31000),percpick,
CRIST*jproa,wte(31000),iphaze(31000),gSim(31000),jest,percest,fosogold
     *wte(31000),iphaze(31000),gSim(31000),jest,percest,fosogold
     *,vemin
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icett,
     *         kpol,jsyt,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      common /restr/rescon(6),vres(6000),nres,wq,dmean,amean,nplane,mres
      common /restw/ dfr(3,500),qvr(3,500),kblock(500)
      common /WildRun2/ nwild,nWDelay,kWDelay,iverbo,interv,errev(101)
      common /macrom/ ipub(31000),evet(31000)
      common /parfin/ LimF(5,4), iPal(5), Livel, nPulsTot(5), iFull(5),
     *                iHConv, iwLMenu, iVP(5,4), Lhh(5), Lhs(5)
      common /puls/Lim(190,4),iAct(190),iDepr(190),iRep(190),iFocus(190)
     *              ,ipu(190),iHB,iDeep,nFocus(5)
      common /screen/ kscreen,jy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /crisTest/ ktest
      integer i1(3)
      dimension ep(31000),xo(11),xn(11),keyx(10),shi(4)
      dimension eprimoc(31000)
      character jstep, tirang * 11
c
c-- sets-up restrains ( if any ) in internal format
c
****  if (nres.gt.0) call respri
****  if (nres.gt.0) call setupr
c
      ifBreak = 0
      mode1=mode-1

c	call Beep(100,100)
      if (iref.ge.2) then
          iactn=2
          do 130 i=1,nats
             do 100 j=1,3
                xo(j)=x(j,i)
  100        continue
             k=kspecb(newvet,xo,xn,keyx,itype,iser,khead,iactn)
             iflk=0
             do 110 j=1,3
                ke=keyx(j)
                if (ke.ne.0.and.ke.ne.j) iflk=1
                kcond(j,i)=keyx(j)
  110        continue
             if (iflk.eq.1) then
                 do 120 j=1,3
                    kcond(j,i)=0
  120            continue
             endif
  130        continue
             if (kpol.ne.0) then 
                 jpol=kpol
                 i100=100
                 do 140 i=1,3
                    k=jpol/i100
                    if (k.ne.0) kcond(i,1)=0
                    jpol=jpol-k*i100
                    i100=i100/10
  140            continue
             endif
c
             do 148 i=1,nats
cel-- non affino le variabili in proiezione
                if (lproj.eq.1) kcond(1,i)=0
                if (lproj.eq.2) kcond(2,i)=0
                if (lproj.eq.3) kcond(3,i)=0
cel--
  148        continue
      endif
c
c     if (krecy.le.1) oscale=1.0
Corig if (mode1.eq.1.or.krecy.eq.1) oscale=1.0
      if (jrest.eq.0) then
          if (mode1.eq.1) oscale=1.0
      endif
      uno=1
      gof=100.0
      gofold=gof
      gofsold=gof
      if (nres.gt.0) then
          gofmin=-99.99
      else
          gofmin=0.5
      endif
      bt3=3.0*biso
cel-----controllo sulla soglia dei b termici---------
      if (neutro.eq.2.and.bt3.lt.3.0) bt3=3.0
cel-------------------------------------------------
      dump=0.5
      jlig=1
      if (no(1).eq.1.and.neutro.eq.0) jlig=2
           if (iref.eq.1) then
               k1=4
               k2=4
               jstep='B'
      else if (iref.eq.2) then
               k1=1
               k2=3
               jstep='C'
      else if (iref.eq.3) then
               k1=1
               k2=4
               jstep='B'
      else
               jstep='A'
      endif
c
      if (iref.eq.1.or.iref.eq.3) then
          do 150 i=1,nats
             kcond(4,i)=1
cel  vale solo per gli elettroni o anche per i neutroni?
c  eccoqui
cel-----affino il fattore termico dell'idrogeno!!!!!!!!!!!!!!!---
c           write(6,*) ' Bh minimizzato'
cel--non affino il fattore termico dell'idrogeno!!!!!!!!!!!!!!!---
cel----da usare quando e' in funzione htermica-------------------
             nzi= nz(i)
             if (nzi.ne.0) then
                 if (no(nz(i)).eq.1.and.neutro.eq.2) then
                     kcond(4,i)=0
c                    write(6,*) ' Bh non minimizzato'
                 endif
             endif
cel---------------------------------------------------------------
  150     continue
      endif
c
      jstop=0
      do 3000 nls=1,nlsm
      if (nls.eq.nlsm) iref=0
      scale=1.0/oscale
      if (gof.lt.gofmin) jstop=1
      if (jstop.eq.1.and.nls.ne.nlsm) go to 3000
      gof =0.0
      agof=0.0
      gofs=0.0
      sumfo=0.0
      sumfor=0.0
      sumfc=0.0
      sumdf=0.0
      sumdf2=0.0
      bison=0.0
      bisod=0.0
      if (iref.ge.1) then
          df1=0.0
          df2=0.0
          b11=0.0
          b22=0.0
          b12=0.0
          do 200 jj=1,nats
             do 180 k=1,3
                qvr(k,jj)=0.0
  180        dfr(k,jj)=0.0
             do 200 k=k1,k2
                deltaf(k,jj)=0.0
  200     qvet(k,jj)=0.0
      endif
      do 500 i=1,numb
      i1(1)=ihkl(i)/262144
      j=ihkl(i)-262144*i1(1)
      i1(2)=j/512-256
      i1(3)=j-512*(i1(2)+256)-256
c
c-- compute H*R and H*T
c
      do 250 j=1,nsym
         t=1000.0
         do 230 l=1,3
            t=t+float(i1(l))*tmat(j,l)
            hkle(l,j)=0
c
            do 240 k=1,3
  240       hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)
c
  230    continue
         hkle(4,j)=t
  250 continue
      fo=e(i)
      rho=wt(i)
      act=0.0
      bct=0.0
      do 300 ij=1,nk
         f(ij)=cl(ij)
         do 300 ii=1,4
            f(ij)=f(ij)+al(ii,ij)*exp(-bs(ii,ij)*rho)
  300 continue
      if (iref.ge.1) then
          do 350 jj=1,nats
             do 350 k=k1,k2
                apd(k,jj)=0.0
                bpd(k,jj)=0.0
  350     continue
      endif
c
c-- manage BREAK button
c
      if (mode1.gt.1) then
          ifBreak = ifBreakFun()
          if (ifBreak.eq.1) then
             return
          endif
      endif
      do 400 jj=1,nats
         if (nz(jj).eq.0) go to 400
         kz=nz(jj)
         fkz=f(kz)
         arg=-bfac(jj)*rho
         effe=pts*fkz*exp(arg)
         tfocc=effe*x(5,jj)
         tfocp=tfocc*twopi*float(icent+1)
         call sfacyyy(jj,contc,conts,tfocp,iref)
         contc=contc*tfocc
         conts=conts*tfocc
         act=act+contc
         bct=bct+conts
         if (kcond(4,jj).eq.1) then
             apd(4,jj)=-rho*contc
             bpd(4,jj)=-rho*conts
         endif
  400 continue
      args=act*act+bct*bct
      if (args.gt.0.000001) then
          fc=sqrt(args)
          if (nls.eq.nlsm) faze=rtod*atan2(bct,act)+360.0
          ac=act/fc
          bc=bct/fc
      else
          fc=0.0
          if(nls.eq.nlsm) faze=0.0
          ac=0.0
          bc=0.0
      endif
      ep(i)=fc
      sumfor=sumfor+fo
      fo=fo*scale
      df=fo-fc
      sumfo=sumfo+fo
      sumfc=sumfc+fc
      absdf=abs(df)
      sumdf=sumdf+absdf
      sumdf2=sumdf2+absdf*absdf
      if (iref.ge.1) then
c
c--  accumulation of l.s. normal equations
c
          fcs=fc*scale
          sw=-rho*fc
          b11=b11+fcs*fcs
          b22=b22+sw *sw
          b12=b12+fcs*sw
          df1=df1+df*fcs
          df2=df2+df*sw
          do 450 jj=1,nats
             do 450 k=k1,k2
                if (kcond(k,jj).eq.0) go to 450
             if (nz(jj).eq.0) go to 450
             dfdb=apd(k,jj)*ac+bpd(k,jj)*bc
             qvet(k,jj)=qvet(k,jj)+dfdb*dfdb
             deltaf(k,jj)=deltaf(k,jj)+dfdb*df
  450     continue
      else
c
c-- compute stuff for fourier
c
          iphap=mod(int(faze+0.5),360)
          if(iphap.eq.0) iphap=360
          iphb(i)=iphap
CRIST     if(jproa.eq.1) then
          iphaze(i)=iphap
CRIST     endif
      endif
  500 continue
c
c--  compute r-factor
c
      scalan=sumfc/sumfor
      ksca=0
      if (jrest.eq.0) then
          if (krecy.eq.0) ksca=1
      else
          if (krecy.eq.1) ksca=1
      endif
      if (ksca.eq.1) then
          oscale=1.0/scalan
          sumdf=0.0
          sumdf2=0.0
          sumfo=0.0
          do 510 i=1,numb
             absdf=abs(ep(i)-scalan*e(i))
             sumdf=sumdf+absdf
             sumdf2=sumdf2+absdf*absdf
             sumfo=sumfo+scalan*e(i)
  510     continue
      endif
      erre=sumdf/sumfo
      rfac=100.0*erre
      if (iprin.gt.2) then
          write(lo,540) mode1,rfac,nemap(1),nemap(2),nemap(3),
     *                  scale,gofold,gofsold,scalan,dg,biso,bt3
      else
          if (iref.eq.0) then
              if (mode1.gt.0) then
CRIST           if (jproa.eq.1) mode1=mode-1+jest
                mode1=mode-1+jest
                errev(mode1)=rfac
CRIST           if (jproa.eq.1)  mode1=mode-1
                mode1=mode-1
c          write(6,*) ' in sftryy ', mode1,rfac,x(4,1)
                if (iverbo.ne.0) then
                    if (nres.gt.0) then
                        write(lo,548) jstep,mode1,rfac,dmean,amean
                    else
                        write(lo,545) jstep,mode1,rfac
                    endif
                endif
              endif
          endif
      endif
  540 format(' cycle #',i3,' r-fac.=',f7.2,'%, ',
     *       i3,1h/,i3,1h/,i3,' atoms, ',7f9.4)
  545 format(25x,a1,i10,8x,f7.2,'%',' <>')
  548 format(25x,a1,i10,8x,f7.2,'%',2f10.3)
c
      if (iref.eq.0) go to 3000
c
c--  compute correction for scale factor
c
      denom =  b11 * b22 - b12 * b12        
      dbm=(b11*df2-b12*df1)/denom
      dbs=df2/b22
      dg =(b22*df1-b12*df2)/denom
      corr= dbm- dbs
c     
c--  compute new scale-factor
c
      oscale=oscale+dg
c     
c--  apply restrains ( if any )
c
****  if (nres.gt.0) call resapp
c
      nesub=nats-nemap(3)
      nrej=0
      nhtermica = 0
      do 600 jj=1,nats
         if (nz(jj).eq.0) go to 600
c
c-- manage BREAK button
c
         if (mode1.gt.1) then
             ifBreak = ifBreakFun()
             if (ifBreak.eq.1) then
                 return
             endif
         endif
cel
         if (no(nz(jj)).eq.1) nhtermica = 1
cel
         kz=nz(jj)
         do 550 k=k1,k2
         if (kcond(k,jj).eq.0) go to 550
         if (abs(qvet(k,jj)).lt.0.001) go to 550
         shift=deltaf(k,jj)/qvet(k,jj)
         if (k.le.3) then
             shiftr = ( deltaf(k,jj) + dfr(k,jj) )
     *              / ( qvet(k,jj) + qvr(k,jj) )
             xnew=x(k,jj)+shiftr*dump
             if (iprin.gt.2) write(lo,2000) nalf(nz(jj)),jj,
     *           x(k,jj),shift,shiftr,xnew,deltaf(k,jj),dfr(k,jj),
     *           qvet(k,jj),qvr(k,jj)
             x(k,jj)=xnew
         else
             ashift=(shift+corr)*dump
             bnew=bfac(jj)+ashift
             if (iprin.gt.2) write(lo,2001) nalf(nz(jj)),jj,
     *           bfac(jj),shift,ashift,bnew,dbm,dbs,corr
c
c-- reset occupancy factor if thermal factor is negative
c
             if (neutro.eq.2) then
                 if (bnew.lt.0.0.and.biso.gt.0.0) bnew=0.1
             else
                 if (bnew.lt.0.0) bnew=0.1
             endif
c
c-- reject atom if thermal factor is too large
c
             if (nls.gt.1) then
                 if (bnew.gt.bt3) then
                     if (kz.eq.jlig.and.nesub.gt.0) then
                         nesub=nesub-1
                         nrej=nrej+1
                         nz(jj)=0
                     endif
                 endif
             endif
             if (nz(jj).ne.0) then
                 bison=bison+bnew*no(nz(jj))
                 bisod=bisod+no(nz(jj))
                 gof=gof+abs(ashift)
                 gofs=gofs+ashift
                 agof=agof+1.0
             endif
             bfac(jj)=bnew
         endif
  550 continue
  600 continue
c
         if(nhtermica.eq.1) call htermica
c
 2000 format(2x,a2,i3,4f8.5,4f10.1,f8.3)
 2001 format(2x,a2,i3,7f10.5)
      if (iref.eq.2) go to 3000
      gof =gof /agof
      gofs=gofs/agof
      if (nls.eq.1) gof=10+gof
      biso=bison/bisod
c
c     bt3=3.0*biso
c
      if (nrej.gt.0) call pkl15(nats)
      if (gof.gt.gofold) then
          gofold=gof
          gofsold=gofs
          gof=0.0
      else
          gofold=gof
          gofsold=gofs
      endif
 3000 continue
croc----------------------------------
      do 3050 i=1,numb
         dummpc(i) = ep(i)
 3050 continue
croc----------------------------------
c
c-- compute fourier coefficients and weights
c
      if (mode1.gt.0) then
          do 3100 i=1,numb
             fo=e(i)*scalan
             fc=ep(i)
             gSim(i) = fc
c
c-- new: coeff.= 2 Fo - Fc
c--      weight= 1
c
CRIST   if(jproa.eq.0) then
CRIST                   e(i)= 2.0*fo - fc
CRIST                 else
      
             den = fo / ee(i)
             e(i)= 2.0*ee(i) - fc/den
CRIST                 endif
             ep(i)=1.0
 3100     continue
      else
          do 3200 i=1,numb
             e(i)=e(i)*scalan
 3200     continue
      endif
      kph = 2
      nuset = mode-1+jest
      izero = 0
      call examin(kph,nuset,ihkl,ipub,iphb,numb,izero,ep,shi)
      if (ktest.gt.0) then
          tirang = ' E(obs)'
          istep = 1
          call pherrdis(tirang,evet,ihkl,numb,izero,ipub,iphb,
     *                  shi,ep,istep)
          tirang = ' Rho   '
          istep = 1
          call pherrdis(tirang,wt,ihkl,numb,izero,ipub,iphb,
     *                  shi,ep,istep)
          do 3400 i=1,numb
             i1(1) = ihkl(i) / 262144
             j = ihkl(i) - 262144 * i1(1)
             i1(2) = j / 512 - 256
             i1(3) = j - 512 * ( i1(2) + 256 ) - 256
             rho = wt(i)
             call cmult(i1,eps,multi)
             sumff = 0.0
             do 3300 ij=1,nk
                f(ij)=cl(ij)
                do 3250 ii=1,4
                   f(ij)=f(ij)+al(ii,ij)*exp(-bs(ii,ij)*rho)
 3250           continue
                sumff=sumff+nw(ij)*(f(ij)**2)
 3300        continue
c
c--     Sim = D1 ( gSim )
c--    gSim =  2 * E(obs) * E(Calc) 
c-- E(Calc) =  F(calc) / den
c--     den =  eps * pts * coef * sig
c--     sig =  sqrt( sigma ** 2 ) )
c
             coef = 1.0
             sig = sqrt( exp(-2.0*bt*rho) * sumff )
             den = coef * eps * pts * sig
             gSim(i) =       evet(i) * gSim(i) / den
 3400     continue
          tirang = ' G(Sim)'
          istep = 1
          call pherrdis(tirang,gSim,ihkl,numb,izero,ipub,iphb,
     *                  shi,ep,istep)
      endif
CRIST if (jproa.eq.1) then
c     tirang = ' E(obs)'
c     call pherrdis_new(tirang,ee,ihkl,numb,1,ipub,iphb,shi,ep,10,3.0)
c     tirang = ' Rho   '
c     call pherrdis_new(tirang,wt,ihkl,numb,1,ipub,iphb,shi,ep,10,0.0)
          do 3500 i=1,numb
             i1(1) = ihkl(i) / 262144
             j = ihkl(i) - 262144 * i1(1)

             i1(2) = j / 512 - 256
             i1(3) = j - 512 * ( i1(2) + 256 ) - 256
             rho = wt(i)
             call cmult(i1,eps,multi)
             sumff = 0.0
             do 3450 ij=1,nk
                f(ij)=cl(ij)
                do 3420 ii=1,4
                   f(ij)=f(ij)+al(ii,ij)*exp(-bs(ii,ij)*rho)
 3420           continue
                sumff=sumff+nw(ij)*(f(ij)**2)
 3450        continue
c
c--     Sim = D1 ( gSim )
c--    gSim =  2 * E(obs) * E(Calc)
c-- E(Calc) =  F(calc) / den
c--     den =  eps * pts * coef * sig
c--     sig =  sqrt( sigma ** 2 ) )

c
             coef = 1.0
             sig = sqrt( exp(-2.0*bt*rho) * sumff )
*            den = coef * eps * pts * sig
             den = coef * eps       * sig
             eprimoc(i)=gSim(i)/(den * sqrt(0.33))
             gSim(i) =(2*    ee(i) * gSim(i) ) / ( 0.33 * den)
             if (wte1(i).le.0.0) wte(i)=bes(gSim(i))
 3500     continue
      return
      end
c------------------------------------------------------------
c      kph = 2
c      nuset = mode1
c      izero = 0
c      call examin(kph,nuset,ihkl,ipub,iphb,numb,izero,ep,shi)
c      return
c     end
c------------------------------------------------------------
c     structure factor calculation
      subroutine sfacyyy(jj,contc,conts,tfocp,iref)
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
      common/xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *      ,wt(31000),nzsav(500),occsav(500),hkle(4,24)
     *      ,deltaf(4,500),qvet(4,500),kcond(4,500),newvet(48,3)
     *      ,apd(4,500),bpd(4,500)
     *      ,dummpc(183760),dummbig(150000)
      common/trig/sint(450),pi,twopi,dtor,rtod
      dimension cost(360)
      equivalence (sint(91),cost(1))
c
      at=0.0
      bt=0.0
      do 1000 j=1,nsym
      arg=amod(hkle(1,j)*x(1,jj)
     *        +hkle(2,j)*x(2,jj)
     *        +hkle(3,j)*x(3,jj)
     *        +hkle(4,j),1.0)
      iarg=int(360.0*arg+0.5)+1
      if(iarg.eq.361) iarg=1
      at=at+cost(iarg)
      bt=bt+sint(iarg)
      if (iref.ge.2) then
                       do 900 k=1,3
                                 hkltf=hkle(k,j)*tfocp
                                 apd(k,jj)=apd(k,jj)-hkltf*sint(iarg)
                                 if (icent.eq.0) 
     *                           bpd(k,jj)=bpd(k,jj)+hkltf*cost(iarg)
  900                  continue
                     endif
 1000 continue
      if (icent.eq.0) then
                        contc=at
                        conts=bt
                      else
                        contc=2.0*at
                        conts=0.0
                      endif
      return
      end
c--------------------------------------------------------------------------
      subroutine assbty
c
c  assign to atoms the thermal factor list according to previous atom list
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),nzsav(500),occsav(500),
     *               fvar(500),q(500),bnew(500),dummy(2500)
     *              ,dummpc(340000)
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
      common /atomo/ xyzo(5,500),nzo(500),bSav(1000)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent
     *        ,kpol,jsys,latx,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      dimension xn(3),xo(3),xeq(3),vet(2),s(3)
c
      idisp=1
      call sfl30(natso,idisp,idumm,interp)
              if (iprin.gt.2) then
      write(lo,*) ' vecchia lista '
      do 1 i=1,natso
      nzzo=iabs(nzo(i)/100)
      if (nzzo.eq.0) then
	  write(lo,'(2x,2x,i5,f8.1,3f10.3)')
     *          i,xyzo(4,i),(xyzo(j,i),j=1,3)
                     else
	  write(lo,'(2x,a2,i5,f8.1,3f10.3)')
     *          nalf(nzzo),i,xyzo(4,i),(xyzo(j,i),j=1,3)
                     endif
    1 continue
      write(lo,*) ' nuova lista '
                          endif
      do 5 j=1,nats
          if (iprin.gt.2) then
          nzzo=iabs(nz(j)/100)
          if (nzzo.gt.0) then
	  write(lo,'(2x,a2,i5,f8.1,3f10.3)')
     *    nalf(nzzo),j,x(4,j),(x(k,j),k=1,3)
                         else
	  write(lo,'(2x,2x,i5,f8.1,3f10.3)')
     *               j,x(4,j),(x(k,j),k=1,3)
                         endif
                          endif
      q(j)=0.0
   5  bnew(j)=biso
      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1
      do 100 i=1,natso
      if (nzo(i).eq.0) go to 100
      nzo(i)=iabs(nzo(i)/100)
      do 10 j=1,3
   10 xo(j)=xyzo(j,i)
      distm=9999
      jpunt=0
      do 90 j=1,nats
      if (nz(j).eq.0) go to 90
      if (q(j).gt.0.5) go to 90
      do 20 k=1,3
   20 xn(k)=x(k,j)
      do 50 kt=1,ncentr
        do 50 ifi=1,ifin
          coef=vet(ifi)
          do 50 k=1,noper
            call xequi(xo,k,coef,xeq,kt)
            call xdist(xn,xeq,d,s)
            if (d.lt.distm.and.d.lt.ddmin) then
                                             distm=d
                                             jpunt=j
                                           endif
   50 continue
   90 continue
c
      if (jpunt.ne.0) then
                        q(jpunt)=i
                        nzn=iabs(nz(jpunt)/100)
                        if (nzo(i).eq.nzn) then
                                             bnew(jpunt)=bfac(i)
                                           else
                                             z1=no(nzo(i))
                                             z2=no(nzn)
                                             bmod=bfac(i)*z1/z2
                                             bmod=(bmod+biso)/2.0
                                             bnew(jpunt)=bmod
c
c-- proviamo ad assegnare il b medio calcolato
c
                                             bnew(jpunt)=biso
c
              if (iprin.gt.2)
     *  write(lo,98) nalf(nzo(i)),i    ,z1,bfac(i),(xyzo(jj,i),jj=1,5),
     *               nalf(nzn)   ,jpunt,z2,bmod   ,(x(jj,jpunt),jj=1,5)
   98 format(' Era ',a2,i4,f5.0,f7.3,5f8.3,10h  e sara' ,
     *                       a2,i4,f5.0,f7.3,5f8.3)        
                                           endif
                      endif
c
  100 continue
      if (iprin.gt.2) then
      do 110 j=1,nats
      if (nz(j).eq.0) go to 110
      nzn=iabs(nz(j)/100)
      i=nint(q(j))
      if (i.gt.0) then
                    write(lo,92) nalf(nzn),j,(x(k,j),k=1,3),bnew(j),
     *                          nalf(nzo(i)),i,(xyzo(k,i),k=1,3),bfac(i)
                       else
                    write(lo,92) nalf(nzn),j,(x(k,j),k=1,3),bnew(j)
                       endif
  110 continue
                      endif
      do 120 j=1,nats
      bfac(j)=bnew(j)
c
c-- assign old coordinates to new peaks
c
      i=q(j)
      if (i.gt.0) then
                    do 115 jj=1,3
  115               x(jj,j)=xyzo(jj,i)
                    x(5,j)=xyzo(5,i)
                  endif
  120 continue
   92 format(2x,a2,i4,4f10.3,10x,a2,i4,4f10.3,10x)
      return
      end
c--------------------------------------------------------------------------
      subroutine muovi
c
c  assign to atoms the thermal factor list according to previous atom list
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),nzsav(500),occsav(500),
     *               fvar(500),q(500),bnew(500),dummy(2500)
     *              ,dummpc(340000)
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
      common /atomo/ xyzo(5,500),nzo(500),bSav(1000)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent
     *        ,kpol,jsys,latx,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common /elettroni/ lproj, zeff(8), rminimo, kminimo, kaminimo
      common /data/  store (30000)
      dimension xn(3),xo(3),xeq(3),vet(2),s(3)
      character*8 reject
c
c-- get informations about covalent radii
c
*     call yfl03
*     m3=l3
*     do 24  i= 1,n3
*     radii(i,1) = store(m3+15)
*     m3=m3+md3
*  24 continue

c
      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1
      do 100 i=1,nats-1
      if (nz(i).eq.0) go to 100
      nzi=iabs(nz(i)/100)
      do 10 j=1,3
   10 xo(j)=x(j,i)
      distm=9999
      jpunt=0
      do 90 j=i+1,nats
      if (nz(j).eq.0) go to 90
      do 20 k=1,3
   20 xn(k)=x(k,j)
      do 50 kt=1,ncentr
        do 50 ifi=1,ifin
          coef=vet(ifi)
          do 50 k=1,noper
            call xequi(xo,k,coef,xeq,kt)
            call xdist(xn,xeq,d,s)
            if (d.lt.distm) then
                              distm=d
                              jpunt=j
                            endif
   50 continue
   90 continue
c
      if (jpunt.ne.0) then
          nzj=iabs(nz(jpunt)/100)
          reject='        '
          drej=radii(nzi,1)+radii(nzj,1)-0.5
*         if (distm.lt.drej.and.lproj.eq.0) then
          if (distm.lt.drej) then
              nz(jpunt)=0
              reject='rejected'
          endif
      endif
      if (iprin.gt.0)
     *write(lo,91) nalf(nzi),i,nalf(nzj),jpunt,drej,distm,reject
   91 format(2(1h ,a2,i4),2f10.4,2x,a8)
c
  100 continue
      if (iprin.gt.0)
     *write(lo,'(5(i4,1h),i5,5x))') (i,nz(i),i=1,nats)
      return
      end
c--------------------------------------------------------------------------
      subroutine CopyMap
      character*200 Msg
      common /msgerr/ Msg
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /tape/ cell(6),neqv,icent,lat,natm,ts(3,24),is(2,3,24),nsym
     *             ,dumb(3)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /tran/ scale,mh(3),level,it4,xlim(3),kmap
c-- file names and extensions
      character name*256
      character fname(15)*256,ext(15)*4,path*256
      common/dotdat/ fname,ext,path
      dimension nstore(200)
c
      nnx = np(1)
      nny = np(2)
      nnz = np(3)
c
      itype = 0
      iform = 2
      k = index ( fname(1), '.' )
      name = fname(1)(1:k) // 'map'
      nlenM = nnx * nlen / knwr
      jop=kopen(kform ,name,nlenM,itype,ier)
      if (jop.lt.0) go to 9000
c
      rewind jrel
***   read(jrel) itle,numset,cell,neqv,icent,lat,natm,ts,is
***   read(jrel) nnx,nnz,nny
***** read(jrel) neqv,nnx,nnz,nny
c
***   write(kform) itle,numset,cell,neqv,icent,lat,natm,ts,is
***** write(kform) neqv,nnx,nnz,nny
c
      irec = 0
      do 800 ky = 1, nny
         do 700 kz = 1, nnz
            read(jrel)   ( nstore(i), i = 1 , nnx )
            irec = irec + 1
            write(kform,rec=irec) ( nstore(i), i = 1 , nnx )
  700       continue
  800 continue
      close(kform)
      return
c
 9000 continue
      write(Msg,9020) ier,name(1:Lung(name))
      ier=1111
      call screrr(ier,Msg,1)
 9020 format(' Open error, code =',i5,' file is ',a,
     *      '. Fourier Map expected')
      return
      end
c--------------------------------------------------------------------------
      subroutine htermica
c
c  assign to  H atoms the thermal factor of the nearest one
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),nzsav(500),occsav(500),
     *               fvar(500),q(500),bnew(500),dummy(2500)
     *              ,dummpc(340000)
      common /atoms/ x(5,500),nz(500),ngp,ninf(10),nag(10)
      common /atomo/ xyzo(5,500),nzo(500),bSav(1000)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent
     *        ,kpol,jsys,latx,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common /data/  store (30000)
      dimension xn(3),xo(3),xeq(3),vet(2),s(3)
      dimension jrocco(500)
c
      binum=0.0
      biden=0.0
      do 5 i=1,nats
       jrocco(i)=0
       if(nz(i).ne.0) then
          binum=binum+bfac(i)*no(nz(i))
          biden=biden+no(nz(i))
       endif
    5 continue
c  assegno agli idrogeni non legati il biso medio attuale
      biassh=binum/biden
c
      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1
      do 100 i=1,nats
      nzi = nz(i)
      if (nzi.ne.1) go to 100
      do 10 j=1,3
   10 xo(j)=x(j,i)
      distm=9999
      jpunt=0
      do 90 j=1,nats
      if (i.eq.j) go to 90
      nzj = nz(j)
      if (nzj.le.1) go to 90
      do 20 k=1,3
   20 xn(k)=x(k,j)
      do 50 kt=1,ncentr
        do 50 ifi=1,ifin
          coef=vet(ifi)
          do 50 k=1,noper
            call xequi(xo,k,coef,xeq,kt)
            call xdist(xn,xeq,d,s)
cel ho valutato che la distanza massima puo' essere costantemente
cel uguale a 1.2 A
cel         distanzaleg = radii(nzi,1) + radii(nzj,1) + 0.5
            distanzaleg = 1.2
            if (d.lt.distm.and.d.lt.distanzaleg) then
                distm=d
                jpunt=j
            endif
   50 continue
   90 continue
      if (jpunt.gt.0) then
          bfac(i)=bfac(jpunt)
          jrocco(i)=1 
      endif
  100 continue
      do 110 i=1,nats
        if(nz(i).eq.1.and.jrocco(i).ne.1) then
          bfac(i)=biassh
        endif                               
  110 continue
c
      return
      end
c--------------------------------------------------------------------------
      function ifBreakFun()
      common /screen/ kscreen,jy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /puls/Lim(190,4),iAct(190),iDepr(190),iRep(190),iFocus(190)
     *              ,ipu(190),iHB,iDeep,nFocus(5)
      common /Brekke/ ifBrekke,ixBr,iyBr
      common /W95/ ifW95
c
c     call beep(100,100)
      ifBreakFun = 0
      if (kscreen.eq.0) return
      L1 = Lim(1,1)
      L2 = Lim(1,2)
      L3 = Lim(1,3)
      L4 = Lim(1,4)
      if (ifW95.eq.0) then
          call CosaSuccede(iflag,mEv_fsBtn,ixBr,iyBr,
     *                     iExitC,iSt,iEnd,nbi)
          if (iflag.eq.1) then
              ifBrekke = 1
          else
              ifBrekke = 0
          endif
      endif
      if (ifBrekke.eq.1) then
          if (ixBr.ge.L1.and.ixBr.le.L3.and.
     *        iyBr.ge.L2.and.iyBr.le.L4) then
              iDef = 0
              call ChangeTasto(iDef,L1,L2,L3,'Break')
              call manage_mouse_cursor(1)
              ifBreakFun = 1
          endif
      endif
c
c     call beep(100,100)
      return
      end
c-----------------------------------------------------------------------
      subroutine makemap(nsize,numb,mode,ier)
c
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/xdata/x(160000),dummpc(340000)
c
      call expand2(numb,ier)
      if (ier.ne.0) return
      call pp1(x,nsize,np(1),np(2),np(3),mode,ier)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine expand2 (numb,ier)
      dimension i1(3),i2(3),kind(24),tab(15)
      dimension lh(60),lk(60),ll(60),ew(60),ed(60)
      dimension e1(31000),ep1(31000)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common /ureq1/ jpatt,dummu(1506)
      common /tape/ cell(6),neqv,icent,lat,natm,ts(3,24),is(2,3,24),nsym
     *             ,dumb(3)
      common /tran/ scale,mh(3),level,it4,xlim(3),kmap
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/rc/p(6),cx(9),nref,nrefc,dum(7)
      common /refl/ ih(100),g(2,100)
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *      ,wt(31000),nzsav(500),occsav(500),hkle(4,24)
     *      ,deltaf(4,500),qvet(4,500),kcond(4,500),newvet(48,3)
     *      ,apd(4,500),bpd(4,500)
     *      ,dummpc(183760),dummbig(150000)
      common/phasinit/evera(31000),wte1(31000),iphaze1(31000),percpick,
     *wte(31000),iphaze(31000),gSim(31000),jest,percest,fosogold
     *,vemin
c
      dimension vat(512),ivat(512)
      equivalence (vat(1),ivat(1))
      equivalence (ih(1),lh(1)),(ih(61),lk(1)),(g(1,11),ll(1)),
     1  (g(1,41),ew(1)),(g(1,71),ed(1))
c
      ifat1=(2*ihx(3)+1)*(2*ihx(2)+1)
      ifat2=(2*ihx(3)+1)
      ifatx=ihx(1)*ifat1+ihx(2)*ifat2+ihx(3)
c
      do 100 i=1,numb
         e1(i)= evera(i)*wte(i)
         phase=dtor*float(iphaze(i))
         ep1(i)=e1(i)*sin(phase)
         e1(i)=e1(i)*cos(phase)
  100 continue
c
c     generate one complete hemisphere of reflexions
c
      rewind jrel
c
      do 150 i=1,15
         tab(i)=sin(float(30*i)*dtor)
  150 continue
      nex = 0
      fsum=0.0
      ip5=256*(262144+512+1)
      nbatch=0
      do 800 jn=1,numb
         call unpack(ihkl(jn),i1(1),i1(2),i1(3))
         eep=ep1(jn)
         ee =e1 (jn)
         indr=i1(1)*ifat1+i1(2)*ifat2+i1(3)
         indrr=iabs(indr)
         do 700 j=1,neqv
            do 540 i=1,3
  540       i2(i)=0
            do 560 i=1,3
               do 550 k=1,2
                  m=iabs(is(k,i,j))
                  if(m.ne.0) i2(m)=i2(m)+i1(i)*isign(1,is(k,i,j))
  550          continue
  560       continue
            b1=1.0
            js=1
            if (i2(3)) 590,570,600
  570       if (i2(1)) 590,580,600
  580       if (i2(2)) 590,600,600
  590       b1=-1.0
            js=-1
  600       kind(j)=ip5+js*(262144*i2(1)+512*i2(2)+i2(3))
            do 610 i=1,3
               if (iabs(i2(i)).ge.np(i)/2) go to 700
               if (i2(i).gt.mh(i)) mh(i)=i2(i)
  610       continue
            if (j.eq.1) go to 630
            nd=j-1
            do 620 i=1,nd
              if (kind(j).eq.kind(i)) go to 700
  620       continue
  630       nbatch=nbatch+1
            nex=nex+1
            nu=0
            do 640 i=1,3
  640       nu=nu-i1(i)*int(ts(i,j)*12.0+0.1)
            nu=mod(nu,12)
            if (nu.le.0) nu=nu+12
            xc=tab(nu+3)
            xs=tab(nu)
            gr=xc*ee-xs*eep
            gi=(xs*ee+xc*eep)*b1
            arg=gr*gr+gi*gi
            if (arg.gt.0.0) fsum=fsum+sqrt(arg)
            g(1,nbatch)=gr
            g(2,nbatch)=gi
            ih(nbatch)=kind(j)
            if(nbatch.lt.100) go to 700
            write(jrel) ih,g
c
c-- manage BREAK button
c
*           if (mode1.ge.1) then
                ifBreak = ifBreakFun()
                if (ifBreak.eq.1) then
                    ier = 9
                    return
                endif
*           endif
            nbatch=0
  700    continue
  800 continue
      if (nbatch.ne.0) write(jrel) ih,g
  951 continue   
      scale=1.0
c
      return
      end
c-----------------------------------------------------------------------
      subroutine sceltaref(numb)
c
      common /xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),izpk(500)
     *              ,dummpc(194500),dummbig(150000)
      common /phasinit/ ee(31000),wte1(31000),iphaze1(31000),percpick,
     *wte(31000),iphaze(31000),gSim(31000),jest,percest,fosogold
     *,vemin
      common /macrom/ ipub(31000),evet(31000)
      common /conue/ shi(4)
      dimension Psort(31000)
c
      ncond=0
      do 1000 j=1,numb
        if (wte1(j).le.0.0) then
          ncond=ncond+1
          Psort(ncond)=gSim(j)
        endif
 1000 continue 
c
      call sortall(-1,Psort,ncond)
      ncond1=nint(ncond*percest)
      ncond1=min0(ncond1,numb)
      if (ncond1.le.1) ncond1=1
      sog=Psort(ncond1)
c
      do 2000 j=1,numb
        if (gSim(j).lt.0.5) wte(j)=0.0
        if (wte1(j).le.0.0) then
         if (gSim(j).lt.sog.or.gSim(j).lt.0.5) wte(j)=0.0
        endif
 2000 continue
c
      return
      end
