c------------------------------------------------------------------
c     prepare coordinate file to use in other programs
c           output code(jout)          meaning
c                        0             standard shelx output
c                        1             standard crystals output
c
      subroutine export(ier)
      character cff
      character fname(15)*256,ext(15)*4,path*256
      character nome*256
      common/dotdat/ fname,ext,path
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /xdata/ store(500000)
      common /dd/ a2,b2,c2,ab,ac,bc,bterm,wscale
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common /atoms/ x(5,500),nz(500),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
*     common /misc/ t(3,3),dxmax(3),mconx,iwt,fom(11),ptss
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
*     common /tab3/ ijt(6,2),iit(6),numpr(29),ktlsq(28)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *        kpol,jsys,lat,indv(32),mpv(64),jspini,dmins,ncawu,ncwu
      common/sym/isn(2,3,24),tsn(3,24),nnsym,pts,ksys,ncent,latt,s3s2,
     *          emme,s3s2p
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /screen/ kscreen,jy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /nmenu/ wBut,xBut,Item,Menu,nActMenu,LivMenu,nbt,lmar
      integer wBut(600), xBut(600), Menu(190, 2), LivMenu(10)
      character * 20 Item(600)
      dimension izpk(500)
*     dimension xo(11),xn(11),key(10),newvet(48,3)
c
      if (jfile.eq.ln) jfile = 34
c
c-- do not consider the 19-th position in Menu = 'Rietveld'
c
      if (mod(kprog,10).eq.1) Menu(1,2) = 18
c
c-- do not consider the RIDE button if there are not Hydrogens
c
      ifH = 0
      do 5 i=1,nk
         if (no(i).eq.1) then
             ifH = 1
         endif
    5 continue
c
c-- do not consider the RIDE button in any case ( at the moment )
c
	ifH = 0
c
      iSta = Menu(35,1)
      iEnd = Menu(35,2)
      nTasti = iEnd - iSta + 1
      if (nTasti.eq.7.and.ifH.eq.0) then
          Menu(35,2) = Menu(35,2) - 1
          wBut(iEnd-2) = wBut(iEnd-1)
          wBut(iEnd-1) = wBut(iEnd  )
          xBut(iEnd-2) = xBut(iEnd-1)
          xBut(iEnd-1) = xBut(iEnd  )
          Item(iEnd-2) = Item(iEnd-1)
          Item(iEnd-1) = Item(iEnd  )
      endif
c
      if (icomat.eq.1) then
          write(cff,'(i1)') kff
          write(lo,10) cff,itle
      else
*         write(lo,15) itle
      endif
c
      call srlin (15,lsn,lixx,ljxx,lkxx,llxx)
      call to_coord(1)
      if (lixx.gt.0) then
          call xspinb
          idisp=1
          call sfl15(nats,idisp,interp)
      else
          write(lo,20)
          ier=-1
          return
      endif
c
c-- open file to update atoms
c
      k = index(fname(1),'.bin')
      nome = fname(1)(1:k) // 'upd'
      itype=1
      iform=1
      jop=jopen(jhost ,nome,nlen,itype,iform,ier)
      if (jop.lt.0) go to 9000
      rewind jhost
c
      call lastplot(rfac)
c
      close(jhost)
c
      if (jrest.ne.0) then
          return
      endif
c
   10 format(///,a1 ,78('+'),//,
     1 39h SIR97 : Menu routine                  ,26x,14hRelease  97.01
     2 ,//,1h ,20a4,/,1h ,78('+'),/)
   15 format(///,1h ,78('-'),/,
     1 39h SIR97 : Menu routine                  ,26x,14hRelease  97.01
     2 ,//,1h ,20a4,//)
      call direxp(igraph,numset,kcompl,numcalc,ier)
      if (ier.lt.0) return
  20  format(/,' *** error *** No coordinates in direct access file',/)
c----
      call srlin (7,lsn,lixx,ljxx,lkxx,llxx)
      if (lixx.gt.0) then
          call ysfl07(nref,mmm,mmmz,npseud,iy)
          bterm=bt
          wscale=sc
       else
          errem =0.0
       endif
  30  format(/,' *** error *** No reflections in direct access file',/)
c
c-- if m.s.c. environment ..........(kenvir = 2)
c-- if enraf-nonius environment ....(kenvir = 1)
      nome = fname(3)
      itype=0
      iform=1
      jop=jopen(jhost,nome,nlen,itype,iform,ierr)
      if (jop.lt.0) go to 9000
c
      rfac=errem*100.0
      if (rfac.gt.0.0) write(lo,35) nats,rfac
      if (rfac.gt.0.0) write(*,'(f7.2,1h%)') rfac
      if (kenvir.ne.0) then
          if (kenvir.eq.1) then
              call outenr(izpk)
              write(lo,80) fname(3)(1:Lung(fname(4)))
          endif
          if (kenvir.eq.2) then
              call outmsc(izpk)
              write(lo,85) fname(3)(1:Lung(fname(4)))
          endif
      else
c
          write(lo,40)
          if (jout.eq.0) then
              call outshe
              write(lo,70) fname(3)(1:Lung(fname(4)))
          else
              call outcry(kcompl)
              write(lo,75) fname(3)(1:Lung(fname(4)))
          endif
          if (igraph.eq.1) then
              write(lo,50) fname(4)(1:Lung(fname(4)))
              call outmold
          endif
          if (igraph.eq.2) then
              write(lo,60) fname(4)(1:Lung(fname(4)))
              call outsha
          endif
          if (igraph.eq.4) then
              write(lo,68) fname(4)(1:Lung(fname(4)))
              call outxyz
          endif
      endif
croc------------------------------------------------
c--           calcolo fattori di struttura
c---------------------------------------------------
c  questa chiamata serve a produrre il file
c   *.hkc degli f calcolati
c
      if(numcalc.eq.1) call calcfc
c
croc------------------------------------------------
      return
c
   35 format(//,3x,'Final R value using',i4,' atoms is ',f7.2,'%')
   40 format(///,'   Atoms informations files produced:',//,
     *           '   Format        File Name ',/)
   50 format(    '   MOLDRAW       ',a)
   60 format(    '   SCHAKAL       ',a)
   68 format(    '   Cartesian     ',a)
   70 format(    '   SHELX-93      ',a)
   75 format(    '   CRYSTALS      ',a)
   80 format(    '   MolEN         ',a)
   85 format(    '   TeXan         ',a)
 9000 write(lo,9010) ierr,nome
 9010 format(' *** error ***  open error, code =',i5,' file is ',a)
      end
c
c---------------------------------------------------------------------
      subroutine direxp(igraph,numset,kcompl,numcalc,ier)
      character line*80,dire*80,diret*80
      character blank,digit*12,card(100)*80
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /chara/ blank,digit,card
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      character fname(15)*256,ext(15)*4,path*256
      common/dotdat/ fname,ext,path
*Elettroni
      common /neutro/ neutro,neuwei,vetint(500),nsyn
      common /crisTest/ ktest
*Elettroni
      dimension vet(40),ivet(40)
c
c-- set default values
c
*Elettroni
      neutro=0
*Elettroni
      kcompl=0
      numcalc = 0
      igraph=2
      iprin=0
      mset=numset
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 8000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
c-- directives with alphanumeric parameters
*Elettroni
      if (dire(1:4).eq.'neut') then
          neutro=1
          go to 100
          endif
*Elettroni
      if (dire(1:4).eq.'crys') then
          jout=1
          if (lenp.gt.0) fname(3)=line
          go to 100
          endif
      if (dire(1:4).eq.'comp') then
          jout=1
          kcompl=1
          go to 100
          endif
      if (dire(1:4).eq.'shel') then
          jout=0
          if (lenp.gt.0) fname(3)=line
          go to 100
          endif
      if (dire(1:4).eq.'texa') then
          jout=-1
          kenvir= 2
          if (lenp.gt.0) fname(3)=line
          go to 100
          endif
      if (dire(1:4).eq.'mole') then
          jout=-1
          kenvir= 1
          if (lenp.gt.0) fname(3)=line
          go to 100
          endif
      if (dire(1:4).eq.'mold') then
          igraph=1
          if (lenp.gt.0) fname(4)=line
          go to 100
          endif
      if (dire(1:4).eq.'scha') then
          igraph=2
          if (lenp.gt.0) fname(4)=line
          go to 100
          endif
*     if (dire(1:4).eq.'molp') then
*         igraph=3
*         if (lenp.gt.0) fname(4)=line
*         go to 100
*         endif
cro------------------------------------------
      if (dire(1:4).eq.'calc') then
          numcalc=1
          go to 100
          endif
cro------------------------------------------
      if (dire(1:3).eq.'xyz' ) then
          igraph=4
          if (lenp.gt.0) fname(4)=line
          go to 100
          endif
c-- directives with numeric parameters
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 8000
      if (dire(1:3).eq.'pri') then
          if (iv.ne.1) go to 9000
          iprin = ivet(1)
          go to 100
        endif
 7900 ier=-1
      write(lo,'(22h error in directive : ,a80)') diret
 8000 continue
      return
 9000 continue
      ier=-1
      write(lo,'(22h error in directive : ,a80)') diret
      return
      end
c-------------------------------------------------------------------
c-- crystals output
c
      subroutine outcry(kcompl)
      character fname(15)*256,ext(15)*4,path*256
      common/dotdat/ fname,ext,path
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /atoms/ x(5,500),nz(500),idumx(21)
      common /xdata/ store(500000)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /misc/ t(3,3),dxmax(3),mconx,iwt,fom(11),pts,npseud
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *        kpol,jsys,lat,indv(32),mpv(64),jspini,dmins,ncawu,ncwu
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/rc/p(6),cx(9),dumm(9)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori
      common /ellips/ Ell(3,3,500), semax(3,500), cd(3,3,500)
      common /gian/ IsoAniso(500),kFix(11,500),iEquiv(11,3,500)
     *            , nab(10, 500), nParBl(10,10), dummgia(84900)
      common /atoml/ aLab(500)
      character*8 aLab,aLabb
      dimension vet(12),ivet(12)
      equivalence (vet(1),ivet(1))
c
      if (kcompl.eq.1) then
          write(jhost,20) itle
          write(jhost,30) (cx(i),i=1,6)
          write(jhost,40) (nt(i),i=1,16)
          write(jhost,50) (nalf(i),nw(i),i=1,nk)
          write(jhost,60) fname(2)
          rfac=errem*100.0
          write(jhost,70) (itle(i),i=1,19),nats,
     *                    numset,rfac,fosog
      endif
   20 format('#title ',20a4)
   30 format('#quickstart ',/,'cell ',3f8.3,3f8.2)
   40 format('spacegroup ',16a1)
   50 format('content ',8(a2,i4,2x))
   60 format('file ',a,/,'format (3f4.0,2f8.2) ',/,'end')
   70 format('# ',19a4,/,'# number of atoms = ',i5,' for set no. ',i5,
     *'  final R value = ',f7.2,'%',
     *       /,'# ',/,'#list 28 ',/,'minima /fo/ = ',f10.3,/,'end ')
c
c-- crystals output  -  list 5
c
      write(jhost,80)  1.0 / sqrt(sc)
   80 format('#list 5 ',/,
     1       'overall scale = ', f10.5, /
     *       'read natom = 0',/,
     *       'end',/,
     *       '#edit ')
      call srlin (5,lsn,ifLi5,ljxx,lkxx,llxx)   
      if (ifLi5.gt.0) then
          call toMolPlo1(a,b,c,alf,bet,gam)
          alf=pi/180*alf
          bet=pi/180*bet
          gam=pi/180*gam
          v=a*b*c
          v=v*sqrt(sin(alf)**2+sin(bet)**2+sin(gam)**2-2+
     *      2*cos(alf)*cos(bet)*cos(gam))
          astar=b*c*sin(alf)/v
          bstar=a*c*sin(bet)/v
          cstar=a*b*sin(gam)/v
          nfl = 1
          call xfl01
          call xfl05
          nats = n5
          l5a = l5
          do 334 i=1,n5
             if (store(l5a+10).gt.0.000001) then
                 IsoAniso(i) = 1
                 Ell(1,1,i) = store(l5a+ 5)
                 Ell(1,2,i) = store(l5a+ 6)
                 Ell(2,1,i) = store(l5a+ 6)
                 Ell(1,3,i) = store(l5a+ 7)
                 Ell(3,1,i) = store(l5a+ 7)
                 Ell(2,2,i) = store(l5a+ 8)
                 Ell(2,3,i) = store(l5a+ 9)
                 Ell(3,2,i) = store(l5a+ 9)
                 Ell(3,3,i) = store(l5a+10)
             else
                 IsoAniso(i) = 2
             endif
             l5a = l5a + md5
  334     continue
      end if
c
      denom=8.0*pi*pi
      isel=0
      occ = 1.0
      do 110 i=1,nats
         itp=iabs(nz(i)/100)
         if (itp.ne.0) then
             itp=nalf(itp)
             uiso=bfac(i)/denom
             L = Lung(aLab(i))
             call NoBrac2(aLab(i), L, aLabb)
             if (IsoAniso(i) .eq. 1) then
                write(jhost,95) aLabb, occ, uiso, (x(j,i),j=1,3)
                write(jhost,97) Ell(1,1,i),Ell(2,2,i),Ell(3,3,i),
     *                          Ell(2,3,i),Ell(1,3,i),Ell(1,2,i)
             else
                write(jhost,95) aLabb, occ, uiso, (x(j,i),j=1,3)
             end if
         else
             isel=1
             uiso=bt/denom
             write(jhost,100) i,occ   ,uiso,(x(j,i),j=1,3)
         endif
   95 format('atom ',a8,5x,5f10.4)
   97 format('cont ',6f10.6)
  100 format('atom q ', i4,5x,5f10.4)
  110 continue
      if (isel.eq.1) write(jhost,'(18hselect type ne q  )')
c
c-- crystals output  -  list 12
c
      if (kcompl.eq.1) write(jhost,120)
  120 format(3hend,/,8h#list 12,/,18hblock x's  u[iso]  )
      write(jhost,140)
  140 format('end ',/,'#use last')
      return
      end
c
c---------------------------------------------------------------------
c-- shelx output
      subroutine outshe
      character fmt*4,line*6,linl*80,xyz(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /atoms/ x(5,500),nz(500),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *        kpol,jsys,lat,indv(32),mpv(64),jspini,dmins,ncawu,ncwu
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/rc/p(6),cx(9),dumm(9)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /gian/ IsoAniso(500),kFix(11,500),iEquiv(11,3,500)
     *            , nab(10, 500), nParBl(10,10), dummgia(84900)
      common /ellips/ Ell(3,3,500), semax(3,500), cd(3,3,500)
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori
      common /pippo/ asta(3),alf,bet,gam,sas,sbs,sgs,alfs,bets,gams,v
      common /xdata/ store(500000)
      common /atoml/ aLab(500)
      character*8 aLab
      character*8 str
      dimension x2(5),kpunt(8),nwsx(8),nalfsx(8)
      dimension abc(3),ang(3),latsx(7)
      dimension istore(160000)
      equivalence (store(1),istore(1))
      data xyz/'X','Y','Z'/
      data latsx / 1,5,6,7,2,4,3 /
c
c
      write(jhost,100) (itle(i),i=1,18)
  100 format('TITL    ',18a4)
      do 110 i=1,3
         abc(i)=cx(i)
         ang(i)=cx(i+3)
  110 continue
      ilat=latsx(lat)
      if (icent.eq.0) then
          ilat=-ilat
          nop2=noper
        else
          nop2=noper*2
      endif
      wl=0.71069
      p005=0.005
      write(jhost,120) wl,abc,ang,nop2,(p005,i=1,6)
  120 format('CELL  ',f8.5,2x,6f9.3,/,
     *       'ZERR  ',i8,2x,6f9.3)
      write(jhost,130) ilat
  130 format('LATT ',2i2)
c
c procedura che scrive la parte relativa alla simmetria del file
c di input a shelx
      if (noper.gt.1) then
          do 170  k=2,noper
             linl(1:4)='SYMM'
             do 140 i=5,80
  140           linl(i:i)=' '
             ip=6
             do 160 j=1,3
                iplus=0
                if (tmat(k,j).gt.0.001) then
                   write(linl(ip:),'(f8.5)') tmat(k,j)
                   ip=ip+8
                   iplus=1
                endif
                do 150 i=1,3
                   ii=kmat(k,j,i)
                   if (ii.ne.0) then
                       if (ii.lt.0) then
                           linl(ip:ip)='-'
                           ip=ip+1
                         else
                           if (iplus.eq.1) then
                                 linl(ip:ip)='+'
                              ip=ip+1
                           endif
                       endif
                       write(linl(ip:ip),'(a1)') xyz(i)
                       ip=ip+1
                       iplus=1
                   endif
 150            continue
             if (j.lt.3) then
                 write(linl(ip:ip),'(a1)') ','
                 ip=ip+1
                 iplus=0
             endif
 160         continue
             write(jhost,'(a)') linl(1:Lung(linl))
             ip=1
             iplus=0
 170      continue
      endif
      do 180 i=1,nk
         nalfsx(i) = 0
         nwsx  (i) = 0
         kpunt (i) = 0
  180 continue
c
c-- find out carbon position
c
      ish = 0
      do 190 i=1,nk
         if (no(i).eq.6) then
             ish = ish + 1
             kpunt(i) = ish
             nalfsx(ish) = nalf(i)
             nwsx(ish) = nw(i)
         endif
  190 continue
c
c-- find out hydrogen position
c
      do 195 i=1,nk
         if (no(i).eq.1) then
             ish = ish + 1
             kpunt(i) = ish
             nalfsx(ish) = nalf(i)
             nwsx(ish) = nw(i)
         endif
  195 continue
      do 200 i=1,nk
         if (kpunt(i).eq.0) then
             ish = ish + 1
             kpunt(i) = ish
             nalfsx(ish) = nalf(i)
             nwsx(ish) = nw(i)
         endif
  200 continue
      write(linl(1:38),210) (nalfsx(i),i=1,nk)
      call ucase(linl(1:38))
      write(jhost,'(a)') linl(1:38)
  210 format('SFAC  ',8(2x,a2))
      write(jhost,220) (nwsx(i),i=1,nk)
  220 format('UNIT  ',8i4)
      write(jhost,240)
  240 format('MERG      2',/,
     *       'OMIT      4',/,
     *       'L.S.      4',/,
     *       'LIST      1',/,
     *       'FMAP      2',/,
     *       'PLAN     25',/,
     *       'FVAR    1.0')
c -------
      call srlin (5,lsn,ifLi5,ljxx,lkxx,llxx)   
      if (ifLi5.gt.0) then
          call toMolPlo1(a,b,c,alf,bet,gam)
          alf=pi/180*alf
          bet=pi/180*bet
          gam=pi/180*gam
          v=a*b*c
          v=v*sqrt(sin(alf)**2+sin(bet)**2+sin(gam)**2-2+
     *      2*cos(alf)*cos(bet)*cos(gam))
          astar=b*c*sin(alf)/v
          bstar=a*c*sin(bet)/v
          cstar=a*b*sin(gam)/v
          asta(1)=astar
          asta(2)=bstar
          asta(3)=cstar
          nfl = 1
          call xfl01
          call xfl05
          nats = n5
          biso = store(l5o+1)
          l5a = l5
          p1 = 2.*PI*PI
          dp1 = 2.*p1
          do 334 i=1,n5
             if (store(l5a+10).gt.0.000001) then
                 IsoAniso(i) = 1
                 Ell(1,1,i) = store(l5a+ 5)/(p1*asta(1)*asta(1))
                 Ell(1,2,i) = store(l5a+ 6)/(dp1*asta(1)*asta(2))
                 Ell(2,1,i) = store(l5a+ 6)/(dp1*asta(2)*asta(1))
                 Ell(1,3,i) = store(l5a+ 7)/(dp1*asta(1)*asta(3))
                 Ell(3,1,i) = store(l5a+ 7)/(dp1*asta(3)*asta(1))
                 Ell(2,2,i) = store(l5a+ 8)/(p1*asta(2)*asta(2))
                 Ell(2,3,i) = store(l5a+ 9)/(dp1*asta(2)*asta(3))
                 Ell(3,2,i) = store(l5a+ 9)/(dp1*asta(3)*asta(2))
                 Ell(3,3,i) = store(l5a+10)/(p1*asta(3)*asta(3))
             else
                IsoAniso(i) = 2
             endif
             l5a = l5a + md5
  334     continue
      end if
c -------
      denom=8.0*pi*pi
      do 260 i=1,nats
         izpki=iabs(nz(i))/100
         if (izpki.ne.0) then
             izpk2=kpunt(izpki)
             uiso=bfac(i)/denom
             do 245 j=1,3
                x2(j)=x(j,i)
  245        continue
             x2(4)=x(5,i)+10.0
             line = ' '
             L = Lung(aLab(i))
             if (L .gt. 6) then
                L = 6
             end if
             call NoBrac(aLab(i), L, line)
             call ucase(line)
             if (IsoAniso(i).eq.1) then
                 write(jhost,291) line,izpk2,(x2(j),j=1,4),ell(1,1,i),
     *           ell(2,2,i),ell(3,3,i),ell(2,3,i),ell(1,3,i),ell(1,2,i)
             else
                 write(jhost,290) line,izpk2,(x2(j),j=1,4),uiso
             endif
         endif
  260 continue
  270 format(a2)
  280 format(2h(i,i1,1h))
  290 format(a4,i5,5f10.5)
  291 format(a4,i5,6f10.5,' ='/5x,4f10.5)
      write(jhost,300)
  300 format('           ',/,
     *       'HKLF      4',/,
     *       'END        ')
      uiso=bt/denom
      do 360 i=1,nats
         izpki=iabs(nz(i))/100
         if (izpki.eq.0) then
             izpki=1
             do 345 j=1,3
  345        x2(j)=x(j,i)
             line(1:2)='Q '
             line(3:4)='  '
             x2(4)=x(5,i)+10.0
             in=2
             if (i.gt.99) in=3
             write(fmt,280) in
             write(line(5-in:4),fmt) i
             do 350 j=1,4
             if (line(j:j).eq.' ') line(j:j)='0'
  350        continue
             if (IsoAniso(i).eq.1) then
                 write(jhost,291) line,izpki,(x2(j),j=1,4),ell(1,1,i),
     *           ell(2,2,i),ell(3,3,i),ell(2,3,i),ell(1,3,i),ell(1,2,i)
             else
                 write(jhost,290) line,izpki,(x2(j),j=1,4),uiso
             endif
         endif
  360 continue
      return
      end
c---------------------------------------------------------------------
      subroutine NoBrac2(LabV, L, LabN)
      character *8 LabV,LabN
      j = 0
      LabN = ' '
      do 10 i=1,L
         if (LabV(i:i).ne.'(' .and. LabV(i:i).ne.')') then
            LabN(i:i) = LabV(i:i)
         else
            LabN(i:i) = ' '
         end if
   10 continue
      L = j
      return
      end
c---------------------------------------------------------------------
c
c subroutine for m.s.c. environment
      subroutine outmsc(izpk)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /atoms/ x(5,500),nz(500),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      dimension izpk(500)

      write(jhost,75)nats,numset,(kstory(i),i=1,5)
   75 format(20h SIR97 Release 97.01,i5,20h  peaks for set no. ,i5,5i5)
      do 80 i=1,nats
      kheig=nint(x(4,i))
      izpki=izpk(i)
      if (izpki.gt.0)
     *write(jhost,78) nalf(izpki),i,
     *(x(j,i),j=1,3),kheig
   78 format(a2,i5,3f10.5,i7)
   80 continue
      return
      end
c
c---------------------------------------------------------------------
c-- subroutine for enraf-nonius environment .....
      subroutine outenr(izpk)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /atoms/ x(5,500),nz(500),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      dimension xo(11),xn(11),key(10),newvet(48,3),izpk(500)
c
      write(jhost,75)nats,numset
   75 format(20h SIR97 Release 97.01,i5,20h  peaks for set no. ,i5,5i5)
      denom=8.0*pi*pi
      do 90 i=1,nats
      do 81 j=1,3
   81 xo(j)=x(j,i)
      iser=i
      itype=nalf(izpk(i))
      if (itype.eq.0) go to 90
      k=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
      occ=1.0/float(key(10))
      kheig=nint(x(4,i))
      izpki=izpk(i)
      uiso=bfac(i)/denom
      if (izpki.gt.0)
     *   write(jhost,85) nalf(izpki),i,occ,uiso,
     *   (x(j,i),j=1,3),kheig,(key(j),j=1,9)
   85 format(1h ,a2,i3,5f8.5,i7,9i3)
   90 continue
      return
      end
c----------------------------------------------------------------------
c     prepare input file for MOLDRAW
c
      subroutine outmold
      character line*5,space*16
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      character fname(15)*256,ext(15)*4,path*256
      common/dotdat/ fname,ext,path
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /xdata/ store(160000),dummpc(340000)
      common /atoms/ x(5,500),nz(500),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/rc/p(6),cx(9),dumm(9)
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *        kpol,jsys,lat,indv(32),mpv(64),jspini,dmins,ncawu,ncwu
      dimension ivet(9)
      dimension istore(160000)
      equivalence (store(1),istore(1))
c
      itype=0
      iform=1
      jop=jopen(jgrap,fname(4),nlen,itype,iform,ier)
      if (jop.lt.0) go to 9000
      write(jgrap,1040) (itle(i),i=1,17),(cx(i),i=1,6)
 1040 format('TITLE',/,17a4,/,'CELL',/,6f10.3,/,'COSYMB')
      ind=1
      mdm=6
      do 1030 i=1,nats
      icveti=nz(i)
      if (nz(i).lt.0) then
                           kfrag=10000+i
                           icveti=0
                        else
                           kfrag=mod(icveti,100)*1000+i
                        endif
      iz=icveti/100
      istore(ind)=iz
      istore(ind+1)=i
      store(ind+2)=x(1,i)
      store(ind+3)=x(2,i)
      store(ind+4)=x(3,i)
      store(ind+5)=kfrag
      ind=ind+mdm
 1030 continue
      ind=1
      jump=6
      call sortz(ind,nats,mdm,jump)
      do 1100 i=1,nats
      do 1105 n=1,5
      line(n:n)=' '
 1105 continue
      if (istore(ind).ne.0) then
                               write(line(1:2),'(a2)') nalf(istore(ind))
                               call ucase(line)
                             else
                               line(1:1)='H'
                             endif
      write(line(3:5),'(i3)') istore(ind+1)
      call xcmprp(line,k)
      write(jgrap,1120) i,line,(store(ind+j),j=2,4)
 1120 format(i4,2x,a5,3f10.3)
      ind=ind+mdm
 1100 continue
      write(space,'(16a1)') nt
      call ucase(space)
      call xcmprp(space,k)
      write(jgrap,1110) space
 1110 format('   0  0         0         0         0',/,
     *       'GROUP',/,a16,/,'SYMNUM')
      iss=-1
      do 1180 ii=1,icent+1
      iss=-iss
      do 1170 k=1,noper
      l=0
      do 1160 i=1,3
      do 1160 j=1,3
      l=l+1
 1160 ivet(l)=nint(soper(i,j,k))*iss
      write(jgrap,1190) (soper(i,4,k),i=1,3),ivet
 1170 continue
 1180 continue
 1190 format(3f10.5,3(3i4,4x))
      write(jgrap,1200)
 1200 format('  -1.       -1.       -1.        0   0   0       0   0   0
     *       0   0   0 ')
      close (jgrap)
      return
 9000 write(lo,9010) ier,fname(4)
 9010 format(' *** error ***  open error, code =',i5,' file is ',a)
      return
      end
c-----------------------------------------------------------------------
c     prepare input file for SCHAKAL
c
      subroutine outsha
      character line*5
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      character fname(15)*256,ext(15)*4,path*256
      common/dotdat/ fname,ext,path
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /data/ store(30000)
      common /atoms/ x(5,500),nz(500),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/rc/p(6),cx(9),dumm(9)
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *        kpol,jsys,lat,indv(32),mpv(64),jspini,dmins,ncawu,ncwu
      dimension ivet(12),vet(12)
      dimension istore(30000)
      equivalence (store(1),istore(1))
      equivalence (vet(1),ivet(1))
c
      itype=0
      iform=1
      jop=jopen(jgrap,fname(4),nlen,itype,iform,ier)
      if (jop.lt.0) go to 9000
      write(jgrap,1040) (itle(i),i=1,17),(cx(i),i=1,6)
 1040 format('TITLE',3x,17a4,/,'CELL',3x,6f10.3)
      ind=1
      mdm=6
      do 1030 i=1,nats
      icveti=nz(i)
      if (icveti.eq.0) go to 1030
      if (nz(i).le.0) icveti=0
      iz=icveti/100
      istore(ind)=iz
      istore(ind+1)=i
      store(ind+2)=x(1,i)
      store(ind+3)=x(2,i)
      store(ind+4)=x(3,i)
      do 1105 n=1,5
      line(n:n)=' '
 1105 continue
      if (icveti.gt.0) then
                         write(line(1:2),'(a2)') nalf(istore(ind))
                       else
                         write(line(1:2),'(2hH )')
                       endif
      call ucase(line)
      write(line(3:5),'(i3)') istore(ind+1)
      call xcmprp(line,k)
      write(jgrap,1120) line,(store(ind+j),j=2,4)
 1120 format('ATOM',3x,a5,3f10.3)
      ind=ind+mdm
 1030 continue
      write(jgrap,'(a3)') 'END'
      close (jgrap)
      return
 9000 write(lo,9010) ier,fname(4)
 9010 format(' *** error ***  open error, code =',i5,' file is ',a)
      return
      end
c---------------------------------------------------------------------
c     prepare input file for XYZ
c
      subroutine outxyz
      character line*5
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      character fname(15)*256,ext(15)*4,path*256
      common/dotdat/ fname,ext,path
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /data/ store(30000)
      common /atoms/ x(5,500),nz(500),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/rc/p(6),cx(9),dumm(9)
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
     *         ,radii(8,2),nomeat(3,8)
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *        kpol,jsys,lat,indv(32),mpv(64),jspini,dmins,ncawu,ncwu
      dimension ivet(12),vet(12),amat(3,3),xyz(3),r(3)
      dimension istore(30000)
      equivalence (store(1),istore(1))
      equivalence (vet(1),ivet(1))
c
      itype=0
      iform=1
      jop=jopen(jgrap,fname(4),nlen,itype,iform,ier)
      if (jop.lt.0) go to 9000
      write(jgrap,100) nats,(itle(i),i=1,20)
  100 format(i5,/,20a4)
      alfa=cx(4)*dtor
      beta=cx(5)*dtor
      gamm=cx(6)*dtor
      a1=cos(alfa)
      a2=cos(beta)
      a3=cos(gamm)
      b1=sin(alfa)
      b2=sin(beta)
      b3=sin(gamm)
      amat(1,1) =  cx(1) * b2
      amat(1,2) = -cx(2) * b1 * a3
      amat(1,3) =  0.0
      amat(2,1) =  0.0
      amat(2,2) =  cx(2) * b1 * b3
      amat(2,3) =  0.0
      amat(3,1) =  cx(1) * a2
      amat(3,2) =  cx(2) * a1
      amat(3,3) =  cx(3)
      do 400 i=1,nats
      do 200 j=1,3
  200 r(j)=x(j,i)
      call molt1(amat,r,xyz)
      icveti=iabs(nz(i))/100
      if (icveti.eq.0) then
                          line(1:2)='q '
                        else
                          write(line(1:2),'(a2)') nalf(icveti)
                        endif
      call ucase(line(1:2))
      write(jgrap,300) line(1:2),(xyz(k),k=1,3)
  300 format(a2,3x,3f15.7)
  400 continue
      close (jgrap)
      return
 9000 write(lo,9010) ier,fname(4)
 9010 format(' *** error ***  open error, code =',i5,' file is ',a)
      return
      end
